#ifndef SKY_GPIO_H_
#define SKY_GPIO_H_

typedef enum{
	GPIO_DIR = 0x00,
	GPIO_DATA = 0x04,
	EGPIO_DIR = 0x08,
	EGPIO_DATA = 0x0C,
	EGPIO_INT_TYPE = 0x10,
	EGPIO_INT_STS = 0x14,
}SKY_GPIO_REG;

extern void *sky_gpio_mem;

#define SKY_GPIO_ADDR	 			0xC1FC0000
#define SKY_GPIO_ADDR_LEN	 		0x18

#define GPIO_W32(reg, val32)			writel(val32, sky_gpio_mem+(reg))
#define GPIO_R32(reg)					readl(sky_gpio_mem+(reg))

#endif
