/*
	This file include terawins t-con parameters and fonts.
*/

#include "arc_pgu.h"
#include "arc_tcon.h"

#if USE_TERAWINS_TCON

#ifndef NULL
#define NULL						0
#endif
#if 1
int TerawinsInitCmdPage0[][2]=
{
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{
	{  END_CMD, END_CMD  },
};

#else
// 37 MHz RGB666
int TerawinsInitCmdPage0[][2]=
{	/* Addr, Val */
    {  0x30, 0x03  },
    {  0x31, 0x70  },//RGB666
    {  0x32, 0x3f  },
    {  0x33, 0x3f  },
    {  0x34, 0x00  },
    {  0x35, 0xbc  },
    {  0x36, 0xbc  },//    {  0x36, 0x34  },
    {  0x37, 0x40  },
    {  0x38, 0x50  },
    {  0x39, 0x10  },
    {  0x3a, 0x20  },
    {  0x3b, 0x03  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },//    {  0x3f, 0x10  },

	/* Flowbee@960608. */
    {  0x50, 0x00  },//    {  0x50, 0x30  },

    {  0x60, 0x00  },
    {  0x61, 0x88  },
    {  0x62, 0x18  },
    {  0x63, 0x04  },//High Pass Filter   {  0x63, 0x0f  }, //mod by Eric 2007-09-20
    {  0x64, 0x04  },//    {  0x64, 0x03  },//Low Pass Filter    {  0x64, 0x04  },
    {  0x65, 0x08  },
    {  0x66, 0x88  },
    {  0x67, 0x1e  },
	{  0x68, 0x7d  },//	{  0x68, 0x7d  },//Contrast    {  0x68, 0x55  },//pwm
	{  0x69, 0x6c  },//Bright    {  0x69, 0x73  },//    {  0x69, 0x72  },
    {  0x6a, 0x00  },
    {  0x6b, 0x7f  },
    {  0x6c, 0x82  },
    {  0x6d, 0x00  },
    {  0x6e, 0x10  },
    {  0x6f, 0x00  },

    {  0x72, 0x0b  },//Still    {  0x72, 0x0b  },//Video    {  0x72, 0xd1  },
    {  0x73, 0x20  },//Still    {  0x73, 0x20  },//Video    {  0x73, 0x1f  },
    {  0x74, 0x00  },
    {  0x75, 0x20  },
    {  0x76, 0x00  },
    {  0x77, 0x00  },
    {  0x78, 0x00  },
    {  0x79, 0x00  },
    {  0x7a, 0x00  },
    {  0x7b, 0x00  },
    {  0x7c, 0x00  },
    {  0x7d, 0x10  },
    {  0x7e, 0x80  },
    {  0x7f, 0x80  },

    {  0x85, 0x1f  },//27MHz    {  0x85, 0x1f  },//54MHz    {  0x85, 0x14  },

    {  0x90, 0x04  },//Dither_video    {  0x90, 0x05  },//Still    {  0x90, 0x04  },
    {  0x91, 0x87  },//on    {  0x91, 0x07  },//off    {  0x91, 0x87  },
    {  0x92, 0x00  },
    {  0x93, 0x00  },
    {  0x94, 0x00  },
    {  0x95, 0x00  },
    {  0x96, 0x00  },
    {  0x97, 0x00  },
    {  0x98, 0x00  },
    {  0x99, 0x02  },
    {  0x9a, 0x40  },
    {  0x9b, 0x00  },
    {  0x9c, 0x00  },
    {  0x9d, 0x10  },
    {  0x9e, 0x80  },
    {  0x9f, 0x80  },

    {  0xb0, 0x20  },
    {  0xb1, 0x00  },

    {  0xb2, 0x0e  },//27MHz    {  0xb2, 0x0e  },//54MHz    {  0xb2, 0x17  },

    {  0xb3, 0x00  },
    {  0xb4, 0x25  },
    {  0xb5, 0x03  },
    {  0xb6, 0x59  },//960828    {  0xb6, 0x58  },
    {  0xb7, 0x02  },

    {  0xb8, 0xff  },//27MHz    {  0xb8, 0x86  },//54MHz    {  0xb8, 0xcb  },
    {  0xb9, 0x04  },//27MHz    {  0xb9, 0x05  },//27MHz    {  0xb9, 0x04  },

    {  0xba, 0x6d  },
    {  0xbb, 0x02  },
    {  0xbc, 0x20  },
    {  0xbd, 0x00  },
    {  0xbe, 0x04  },
    {  0xbf, 0x00  },

	{  0xc0, 0x01  },//RGB666
    {  0xc1, 0x08  },
    {  0xc2, 0x12  },//on    {  0xc2, 0x00  },//off    {  0xc2, 0x12  },
    {  0xc3, 0x00  },
    {  0xc4, 0x00  },
    {  0xc5, 0x60  },
    {  0xc6, 0x05  },
    {  0xc7, 0x00  },

    {  0xc8, 0x36  },//27MHz    {  0xc8, 0x3c  },//54MHz    {  0xc8, 0x19  },

    {  0xc9, 0x02  },
    {  0xca, 0x02  },
    {  0xcb, 0x00  },
    {  0xcc, 0x00  },
    {  0xcd, 0x00  },
    {  0xce, 0x00  },
    {  0xcf, 0x00  },

    {  0xd0, 0x00  },
    {  0xd1, 0x00  },
    {  0xd2, 0x00  },
    {  0xd3, 0x00  },
    {  0xd4, 0x00  },
    {  0xd5, 0x00  },
    {  0xd6, 0x00  },
    {  0xd7, 0x00  },
    {  0xd8, 0x00  },
    {  0xd9, 0x00  },
    {  0xda, 0x00  },
    {  0xdb, 0x00  },
    {  0xdc, 0x25  },
    {  0xdd, 0x03  },
    {  0xde, 0x58  },
    {  0xdf, 0x02  },

    {  0xe0, 0xb1  },
    {  0xe1, 0x00  },//Billionton
    {  0xe2, 0x00  },
    {  0xe3, 0x00  },
    {  0xe4, 0x00  },
    {  0xe5, 0x00  },
    {  0xe6, 0x07  },
    {  0xe7, 0x80  },
    {  0xe8, 0x00  },// pwm
    {  0xe9, 0x7d  },// pwm
    {  0xea, 0x07  },
    {  0xeb, 0x80  },
    {  0xec, 0xc0  },
    {  0xed, 0x00  },//    {  0xed, 0x10  },
    {  0xee, 0x00  },
    {  0xef, 0x00  },
	{  END_CMD, END_CMD  },
};

int TerawinsInitCmdPage1[][2]=
{	/* Addr, Val */
    {  0x20, 0x28  },
    {  0x21, 0x7b  },
    {  0x22, 0xc5  },
    {  0x23, 0x03  },
    {  0x24, 0x0c  },
    {  0x25, 0xc5  },
    {  0x26, 0x03  },
    {  0x27, 0xb9  },
    {  0x28, 0x03  },
    {  0x29, 0x29  },
    {  0x2a, 0x00  },
    {  0x2b, 0x06  },//Still    {  0x2b, 0x06  },//Video    {  0x2b, 0x07  },
    {  0x2c, 0x18  },
    {  0x2d, 0x03  },
    {  0x2e, 0x00  },
    {  0x2f, 0x00  },

    {  0x30, 0x00  },
    {  0x31, 0x90  },
    {  0x32, 0x03  },
    {  0x33, 0x35  },
    {  0x34, 0x00  },
    {  0x35, 0x02  },
    {  0x36, 0x80  },
    {  0x37, 0x02  },
    {  0x38, 0x00  },
    {  0x39, 0x00  },
    {  0x3a, 0x00  },
    {  0x3b, 0x00  },
    {  0x3c, 0x00  },
    {  0x3d, 0x00  },
    {  0x3e, 0x00  },
    {  0x3f, 0x00  },

    {  0xb0, 0x95  },
    {  0xb1, 0x00  },
    {  0xb2, 0xe8  },//    {  0xb2, 0xe0  },
    {  0xb3, 0x95  },//    {  0xb3, 0x91  },//    {  0xb3, 0x8e  },//    {  0xb3, 0x74  },
    {  0xb4, 0x00  },//    {  0xb4, 0x32  },
    {  0xb5, 0x68  },
    {  0xb6, 0x95  },
    {  0xb7, 0x81  },
    {  0xb8, 0xc0  },
    {  0xb9, 0x00  },
    {  0xba, 0x00  },
    {  0xbb, 0x00  },
    {  0xbc, 0x00  },
    {  0xbd, 0x00  },
    {  0xbe, 0x00  },
    {  0xbf, 0x00  },

    {  0xd0, 0x30  },
    {  0xd1, 0x00  },
    {  0xd2, 0x08  },//    {  0xd2, 0x0a  },
    {  0xd3, 0x01  },
    {  0xd4, 0x01  },
    {  0xd5, 0x37  },//Still    {  0xd5, 0x37  },//Video    {  0xd5, 0x3b  },
    {  0xd6, 0x00  },
    {  0xd7, 0x25  },//Still    {  0xd7, 0x25  },//Video    {  0xd7, 0x20  },
    {  0xd8, 0x03  },//    {  0xd8, 0x02  },
    {  0xd9, 0x11  },//960824    {  0xd9, 0x12  },
    {  0xda, 0x00  },
    {  0xdb, 0x58  },
    {  0xdc, 0x02  },
    {  0xdd, 0x00  },
    {  0xde, 0x03  },//    {  0xde, 0x02  },
    {  0xdf, 0x0c  },
	{  END_CMD, END_CMD  },
};
#endif

int Terawins640x480Page0[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
#if defined(GUI_STYLE_COMTEK)
    {  0x68, 0x55  },
#endif
    {  0x72, 0x93  },
    {  0x73, 0x19  },
    {  0x75, 0x19  },
    {  0x85, 0x24  },
    {  0x90, 0x05  },//Dither
    {  0xb2, 0x63  },
    {  0xb8, 0xe4  },//    {  0xb8, 0x4f  },
    {  0xb9, 0x03  },//    {  0xb9, 0x04  },
	{  END_CMD, END_CMD  },
};

int Terawins640x480Page1[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
    {  0x2b, 0x07  },
    {  0xd5, 0x88  },
    {  0xd7, 0x20  },
    {  0xd9, 0x19  },
	{  END_CMD, END_CMD  },
};


int Terawins720x480Page0[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
#if defined(GUI_STYLE_COMTEK)
    {  0x68, 0x55  },
#endif
    {  0x72, 0x79  },
    {  0x73, 0x1c  },
    {  0x75, 0x1d  },
    {  0x85, 0x00  },
    {  0x90, 0x05  },//Dither
    {  0xb2, 0x40  },
    {  0xb8, 0x82  },//    {  0xb8, 0xfe  },
    {  0xb9, 0x04  },//    {  0xb9, 0x04  },
	{  END_CMD, END_CMD  },
};

int Terawins720x480Page1[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
    {  0x2b, 0x07  },
    {  0xd5, 0x64  },
    {  0xd7, 0x20  },
    {  0xd9, 0x0d  },
	{  END_CMD, END_CMD  },
};

int Terawins720x576Page0[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};

int Terawins720x576Page1[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
	{  END_CMD, END_CMD  },
};


#ifndef LCD1024_800
int Terawins800x600Page0[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
#if defined(GUI_STYLE_COMTEK)
    {  0x68, 0x55  },
#endif
    {  0x72, 0x0b  },//    {  0x72, 0x0b  },//    {  0x72, 0xd1  },
    {  0x73, 0x20  },//    {  0x73, 0x20  },//    {  0x73, 0x1f  },
    {  0x75, 0x20  },
    {  0x90, 0x04  },//No dither
    {  0x85, 0x1f  },//27MHz    {  0x85, 0x1f  },//54MHz    {  0x85, 0x14  },
    {  0xb2, 0x0e  },//27MHz    {  0xb2, 0x0e  },//54MHz    {  0xb2, 0x17  },
    {  0xb8, 0xff  },//27MHz    {  0xb8, 0x86  },//54MHz    {  0xb8, 0xcb  },
    {  0xb9, 0x04  },//27MHz    {  0xb9, 0x05  },//54MHz    {  0xb9, 0x04  },
	{  END_CMD, END_CMD  },
};

int Terawins800x600Page1[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
    {  0x2b, 0x06  },
    {  0xd5, 0x37  },//    {  0xd5, 0x37  },//    {  0xd5, 0x3b  },
    {  0xd7, 0x25  },
    {  0xd9, 0x11  },//960824    {  0xd9, 0x12  },
	{  END_CMD, END_CMD  },
};
#else
int Terawins800x600Page0[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
    {  0x70, 0x20  },
    {  0x71, 0x00  },
    {  0x72, 0x00  },
    {  0x73, 0x12  },
    {  0x74, 0x00  },
    {  0x75, 0x16  },
    {  0x90, 0x04  },
    {  0x81, 0x00  },
    {  0x82, 0x00  },
    {  0x85, 0x0a  },
    {  0xb0, 0x1a  },
    {  0xb2, 0x3d  },
    {  0xb8, 0x00  },
    {  0xb9, 0x05  },
    {  0xba, 0x04  },
    {  0xbb, 0x03  },
    {  0xbc, 0x20  },
    {  0xbd, 0x00  },
    {  0xbe, 0x04  },
    {  0xbf, 0x00  },
    {  0xbf, 0x00  },
    {  0xc8, 0x1e  },
    {  0xc9, 0x01  },
    {  0xca, 0x01  },
    {  0xe0, 0xb0  },
    {  END_CMD, END_CMD  },
};

int Terawins800x600Page1[SCALE_TABLE_NUM][2]=
{	/* Addr, Val */
    {  0x2b, 0x06  },
    {  0xd0, 0x30  },
    {  0xd5, 0x66  },//    {  0xd5, 0x37  },//    {  0xd5, 0x3b  },
    {  0xd6, 0x00  },
    {  0xd7, 0x01  },
    {  0xd8, 0x03  },
    {  0xd9, 0x18  },//960824    {  0xd9, 0x12  },
    {  0xda, 0x00  },
    {  0xdb, 0x58  },
    {  0xdc, 0x02  },
	{  END_CMD, END_CMD  },
};

#endif

int *TerawinsCmdTbl[TERAWINS_END*2]=
{
	(&(TerawinsInitCmdPage0[0][0])),
	(&(TerawinsInitCmdPage1[0][0])),
	(&(Terawins640x480Page0[0][0])),
	(&(Terawins640x480Page1[0][0])),
	(&(Terawins720x480Page0[0][0])),
	(&(Terawins720x480Page1[0][0])),
	(&(Terawins720x576Page0[0][0])),
	(&(Terawins720x576Page1[0][0])),
	(&(Terawins800x600Page0[0][0])),
	(&(Terawins800x600Page1[0][0])),
};

//-- Font table (12 x 18)
/* --------------------------------------------------------------------- */

#if 1
static unsigned char font_000[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_001[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_002[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_003[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_004[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_005[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
//-- SandGrass: 0x05 ~ 0x08
static unsigned char font_006[]={ //
0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0x39,0xF0,0x39,0xF0,0x39,0xF0,0x38,0xF0,0x1C,0x70,0x1E,
0x70,0x0E,0x30,0x07,0x30,0x03,0x30,0x03,0xB0,0x01,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00
};
static unsigned char font_007[]={ //
0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xC0,0xFF,0xC0,0xFF,0xC0,0xFF,0xC0,0xFF,0x80,0xFF,0x80,0xFF,
0x00,0xFF,0x00,0xFE,0x00,0xFC,0x00,0xFC,0x00,0xF8,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0
};
static unsigned char font_008[]={ //(null)
0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xB0,0x01,0x30,0x03,0x30,0x03,0x70,0x06,0x70,0x0E,
0xF0,0x1C,0xF0,0x1C,0xF0,0x38,0xF0,0x39,0xF0,0x39,0xC0,0x39,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF
};
static unsigned char font_009[]={ //(null)
0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF8,0x00,0xFC,0x00,0xFC,0x00,0xFE,0x00,0xFF,
0x80,0xFF,0x80,0xFF,0xC0,0xF9,0xC0,0xF9,0xC0,0x81,0xC0,0x01,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF
};

/* --------------------------------------------------------------------- */
//-- Invalid sign: 0x09 ~ 0x11
static unsigned char font_00A[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x10,0x00,0x70,0x00,0xF0,0x01,0xF0,0x03,0xF0,0x07,0xF0,0x0F,0xE0,0x1F,0xC0,0x3F,0x80,0x3F
};
static unsigned char font_00B[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0x10,0x80,0x00,0x00,0x00,0x00,0x10,0x00
};
static unsigned char font_00C[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x80,0x00,0xE0,0x00,0xF8,0x00,0xFC,0x00,0xFE,0x00,0xFF,0x80,0x7F,0xC0,0xFF,0xC0,0xFF
};
static unsigned char font_00D[]={ //(null)
0x00,0x7F,0x00,0x7E,0x00,0xFC,0x00,0xFC,0x00,0xF8,0x00,0xF8,0x00,0xF8,0x00,0xF8,0x00,0xF8,
0x00,0xF8,0x00,0xF8,0x10,0xF8,0x30,0xF8,0x70,0xF8,0xF0,0xFC,0xF0,0xFD,0xF0,0x7F,0xF0,0x7F
};
static unsigned char font_00E[]={ //(null)
0x30,0x00,0x70,0x00,0xF0,0x00,0xF0,0x01,0xF0,0x03,0xF0,0x07,0xF0,0x0F,0xF0,0x1F,0xF0,0x3F,
0xE0,0x7F,0xC0,0xFF,0x80,0xFF,0x00,0xFF,0x00,0xFE,0x00,0xFC,0x00,0xF8,0x00,0xF0,0x00,0xE0
};
static unsigned char font_00F[]={ //(null)
0xE0,0xFF,0xE0,0xFF,0xF0,0xFF,0xF0,0xFB,0xF0,0xF1,0xF0,0xE1,0xF0,0xC1,0xF0,0x81,0xF0,0x01,
0xF0,0x01,0xF0,0x01,0xF0,0x01,0xF0,0x01,0xF0,0x01,0xF0,0x03,0xF0,0x03,0xE0,0x07,0xE0,0x0F
};
static unsigned char font_010[]={ //(null)
0xF0,0x3F,0xF0,0x3F,0xF0,0x1F,0xF0,0x0F,0xF0,0x07,0xF0,0x03,0xF0,0x01,0x70,0x00,0x10,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_011[]={ //(null)
0x00,0xC0,0x00,0x80,0x00,0x00,0x10,0x80,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_012[]={ //(null)
0xC0,0x1F,0xC0,0x3F,0x80,0x7F,0x00,0xFF,0x00,0xFE,0x00,0xFC,0x00,0xF8,0x00,0xE0,0x00,0x80,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

/* --------------------------------------------------------------------- */
static unsigned char font_013[]={ //Volume bar
0x00,0x00,0x00,0x00,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,
0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_014[]={ //Volume empty bar
0x00,0x00,0x00,0x00,0xC0,0x3F,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,
0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0xC0,0x3F,0x00,0x00,0x00,0x00
};

#else
static unsigned char font_000[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_001[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_002[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_003[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_004[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

//-- SandGrass: 0x05 ~ 0x08
static unsigned char font_005[]={ //
0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0x39,0xF0,0x39,0xF0,0x39,0xF0,0x38,0xF0,0x1C,0x70,0x1E,
0x70,0x0E,0x30,0x07,0x30,0x03,0x30,0x03,0xB0,0x01,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00
};
static unsigned char font_006[]={ //
0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xC0,0xFF,0xC0,0xFF,0xC0,0xFF,0xC0,0xFF,0x80,0xFF,0x80,0xFF,
0x00,0xFF,0x00,0xFE,0x00,0xFC,0x00,0xFC,0x00,0xF8,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0
};
static unsigned char font_007[]={ //(null)
0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xB0,0x01,0x30,0x03,0x30,0x03,0x70,0x06,0x70,0x0E,
0xF0,0x1C,0xF0,0x1C,0xF0,0x38,0xF0,0x39,0xF0,0x39,0xC0,0x39,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF
};
static unsigned char font_008[]={ //(null)
0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF8,0x00,0xFC,0x00,0xFC,0x00,0xFE,0x00,0xFF,
0x80,0xFF,0x80,0xFF,0xC0,0xF9,0xC0,0xF9,0xC0,0x81,0xC0,0x01,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF
};

/* --------------------------------------------------------------------- */
//-- Invalid sign: 0x09 ~ 0x11
static unsigned char font_009[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x10,0x00,0x70,0x00,0xF0,0x01,0xF0,0x03,0xF0,0x07,0xF0,0x0F,0xE0,0x1F,0xC0,0x3F,0x80,0x3F
};
static unsigned char font_00A[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0x10,0x80,0x00,0x00,0x00,0x00,0x10,0x00
};
static unsigned char font_00B[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x80,0x00,0xE0,0x00,0xF8,0x00,0xFC,0x00,0xFE,0x00,0xFF,0x80,0x7F,0xC0,0xFF,0xC0,0xFF
};
static unsigned char font_00C[]={ //(null)
0x00,0x7F,0x00,0x7E,0x00,0xFC,0x00,0xFC,0x00,0xF8,0x00,0xF8,0x00,0xF8,0x00,0xF8,0x00,0xF8,
0x00,0xF8,0x00,0xF8,0x10,0xF8,0x30,0xF8,0x70,0xF8,0xF0,0xFC,0xF0,0xFD,0xF0,0x7F,0xF0,0x7F
};
static unsigned char font_00D[]={ //(null)
0x30,0x00,0x70,0x00,0xF0,0x00,0xF0,0x01,0xF0,0x03,0xF0,0x07,0xF0,0x0F,0xF0,0x1F,0xF0,0x3F,
0xE0,0x7F,0xC0,0xFF,0x80,0xFF,0x00,0xFF,0x00,0xFE,0x00,0xFC,0x00,0xF8,0x00,0xF0,0x00,0xE0
};
static unsigned char font_00E[]={ //(null)
0xE0,0xFF,0xE0,0xFF,0xF0,0xFF,0xF0,0xFB,0xF0,0xF1,0xF0,0xE1,0xF0,0xC1,0xF0,0x81,0xF0,0x01,
0xF0,0x01,0xF0,0x01,0xF0,0x01,0xF0,0x01,0xF0,0x01,0xF0,0x03,0xF0,0x03,0xE0,0x07,0xE0,0x0F
};
static unsigned char font_00F[]={ //(null)
0xF0,0x3F,0xF0,0x3F,0xF0,0x1F,0xF0,0x0F,0xF0,0x07,0xF0,0x03,0xF0,0x01,0x70,0x00,0x10,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_010[]={ //(null)
0x00,0xC0,0x00,0x80,0x00,0x00,0x10,0x80,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,0xF0,0xFF,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_011[]={ //(null)
0xC0,0x1F,0xC0,0x3F,0x80,0x7F,0x00,0xFF,0x00,0xFE,0x00,0xFC,0x00,0xF8,0x00,0xE0,0x00,0x80,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};

/* --------------------------------------------------------------------- */
static unsigned char font_012[]={ //Volume bar
0x00,0x00,0x00,0x00,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,
0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0xC0,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_013[]={ //Volume empty bar
0x00,0x00,0x00,0x00,0xC0,0x3F,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,
0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0x40,0x20,0xC0,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_014[]={ //(null)
0x00,0x00,0x60,0x00,0xE0,0x00,0xA0,0x41,0x30,0x23,0x20,0x7E,0x60,0x4C,0xA0,0x4C,0x20,0x4F,
0x20,0x4F,0xA0,0x4C,0x60,0x7E,0x20,0x13,0xB0,0x21,0xE0,0x40,0x60,0x00,0x00,0x00,0x00,0x00
};

#endif

#if 1
static unsigned char font_015[]={ //(null)

0x00,0x00,0x00,0x00,0xE0,0xFF,0x20,0x00,0x20,0x3F,0x20,0x3F,0x20,0x3F,0x20,0x3F,0x20,0x3F,

0x20,0x3F,0x20,0x3F,0x20,0x3F,0x20,0x3F,0x20,0x3F,0x20,0x00,0xE0,0xFF,0x00,0x00,0x00,0x00

};

static unsigned char font_016[]={ //(null)

0x00,0x00,0x00,0x00,0xF0,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xF0,0xFF,0x00,0x00,0x00,0x00

};

static unsigned char font_017[]={ //(null)

0x00,0x00,0x00,0x00,0xF0,0xFF,0x00,0x00,0xE0,0x7F,0xE0,0x7F,0xE0,0x7F,0xE0,0x7F,0xE0,0x7F,

0xE0,0x7F,0xE0,0x7F,0xE0,0x7F,0xE0,0x7F,0xE0,0x7F,0x00,0x00,0xF0,0xFF,0x00,0x00,0x00,0x00

};

static unsigned char font_018[]={ //(null)

0x00,0x00,0x00,0x00,0x70,0x00,0x60,0x00,0x60,0x00,0xE0,0x07,0xE0,0x07,0xE0,0x07,0xE0,0x07,

0xE0,0x07,0xE0,0x07,0xE0,0x07,0xE0,0x07,0x60,0x00,0x60,0x00,0x70,0x00,0x00,0x00,0x00,0x00

};

static unsigned char font_019[]={ //(null)

0x00,0x00,0x00,0x00,0x00,0xF0,0x00,0x70,0x00,0x70,0x00,0x70,0x00,0x70,0x00,0x70,0x00,0x70,
0x00,0x70,0x00,0x70,0x00,0x70,0x00,0x70,0x00,0x70,0x00,0x70,0x00,0xF0,0x00,0x00,0x00,0x00
};
#else
static unsigned char font_015[]={ //Volume
0x00,0x00,0x60,0x00,0xe0,0x00,0xa0,0x01,0x20,0x03,0x20,0x7e,0x20,0x4c,0x20,0x4c,0x20,0x4c,
0x20,0x4c,0x20,0x4c,0x20,0x7e,0x20,0x03,0xa0,0x01,0xe0,0x00,0x60,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_016[]={ //Volume
0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x02,0x00,0x11,0x80,0x08,0x80,0x44,0x80,0x24,0x80,0x24,
0x80,0x44,0x80,0x08,0x00,0x11,0x00,0x02,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_017[]={ //Brightness ICON
0x00,0x00,0x10,0x00,0x10,0x00,0x10,0x03,0xb0,0x03,0xf0,0x01,0xc0,0x00,0x80,0x01,0x80,0x0f,
0x80,0x0f,0x80,0x01,0xc0,0x00,0xf0,0x01,0xb0,0x03,0x10,0x03,0x10,0x00,0x10,0x00,0x00,0x00
};
static unsigned char font_018[]={ //Brightness ICON
0x00,0x00,0x00,0x80,0x00,0x80,0x00,0x8c,0x00,0xdc,0x00,0xf8,0x00,0x30,0x00,0x18,0x00,0x1f,
0x00,0x1f,0x00,0x18,0x00,0x30,0x00,0xf8,0x00,0xdc,0x00,0x8c,0x00,0x80,0x00,0x80,0x00,0x00
};
static unsigned char font_019[]={ //Contrast ICON
0x00,0x00,0x00,0x00,0x30,0x00,0xf0,0x00,0xc0,0x01,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0xc0,0x01,0xf0,0x00,0x30,0x00,0x00,0x00,0x00,0x00
};
#endif
static unsigned char font_01A[]={ //Contrast ICON
0x00,0x00,0x00,0x00,0x00,0xc0,0x00,0xf0,0x00,0xf8,0x00,0xfc,0x00,0xfc,0x00,0xfe,0x00,0xfe,
0x00,0xfe,0x00,0xfe,0x00,0xfc,0x00,0xfc,0x00,0xf8,0x00,0xf0,0x00,0xc0,0x00,0x00,0x00,0x00
};
static unsigned char font_01B[]={ //Phase ICON
0x00,0x00,0x00,0x00,0xf0,0x3f,0xf0,0x3f,0x00,0x30,0xa0,0x32,0xa0,0x32,0xa0,0x32,0xa0,0x32,
0xa0,0x32,0xa0,0x32,0xa0,0x32,0xa0,0x32,0x00,0x30,0xf0,0x3f,0xf0,0x3f,0x00,0x00,0x00,0x00
};
static unsigned char font_01C[]={ //Phase ICON
0x00,0x00,0x00,0x00,0xc0,0xff,0xc0,0xff,0xc0,0x00,0xc0,0x44,0xc0,0x44,0xc0,0x44,0xc0,0x44,
0xc0,0x44,0xc0,0x44,0xc0,0x44,0xc0,0x44,0xc0,0x00,0xc0,0xff,0xc0,0xff,0x00,0x00,0x00,0x00
};
static unsigned char font_01D[]={ //
0x00,0x00,0x00,0x00,0xF0,0x01,0x00,0x02,0x30,0x04,0x30,0x08,0x80,0x09,0x80,0x09,0x10,0x08,
0x60,0x08,0xC0,0x06,0xF0,0x01,0x00,0x03,0x00,0x06,0x00,0x0c,0x00,0x08,0x00,0x00,0x00,0x00
};
static unsigned char font_01E[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x00,0x10,0x00,0x08,0x00,0x64,0x00,0x62,0x00,0x01,
0x00,0x19,0x00,0x19,0x00,0x01,0x00,0x8D,0x00,0x41,0x00,0x22,0x00,0x1C,0x00,0x00,0x00,0x00
};
static unsigned char font_01F[]={ //Color ICON
0x00,0x00,0x00,0x00,0xf0,0x3f,0xf0,0x3f,0x00,0x30,0x30,0x30,0x20,0x30,0x30,0x30,0x20,0x33,
0x00,0x34,0x80,0x35,0x80,0x34,0x00,0x33,0x00,0x30,0xf0,0x3f,0xf0,0x3f,0x00,0x00,0x00,0x00
};
static unsigned char font_020[]={ //Color ICON -> change to space.
//0x00,0x00,0x00,0x00,0xc0,0xff,0xc0,0xff,0xc0,0x00,0xc0,0x80,0xc0,0x40,0xc0,0x80,0xc0,0x5c,
//0xc0,0x12,0xc0,0x1c,0xc0,0x12,0xc0,0x1c,0xc0,0x00,0xc0,0xff,0xc0,0xff,0x00,0x00,0x00,0x00
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_021[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_022[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_023[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x12,0x00,0x12,0x00,0x12,0x00,0x7F,0x00,0x24,0x00,0x24,
0x00,0xFE,0x00,0x48,0x00,0x48,0x00,0x48,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_024[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x10,0x00,0x38,0x00,0x54,0x00,0x54,0x00,0x50,0x00,0x38,
0x00,0x14,0x00,0x14,0x00,0x54,0x00,0x38,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_025[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x40,0x48,0x80,0x48,0x00,0x31,0x00,0x02,0x00,0x04,
0xC0,0x08,0x20,0x11,0x20,0x21,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_026[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x24,0x00,0x24,0x00,0x24,0x00,0x18,0x00,0x28,
0x00,0x44,0x00,0x45,0x00,0x42,0x00,0x3D,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_027[]={ //
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x20,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_028[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x0C,
0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x06,0x00,0x03,0x00,0x00,0x00,0x00
};
static unsigned char font_029[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0C,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x03,
0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x00,0x00,0x00
};
static unsigned char font_02A[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x20,0x22,0x40,0x12,0x80,0x0A,
0x00,0x07,0xE0,0x3F,0x00,0x07,0x80,0x0A,0x40,0x12,0x20,0x22,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_02B[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,
0xE0,0x7F,0xE0,0x7F,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_02C[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x07,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_02D[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0xE0,0x7F,0xE0,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_02E[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_02F[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x00,0x00,0x00
};
static unsigned char font_030[]={ //Digital 0
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0xe0,0x61,0x60,0x63,
0x60,0x66,0x60,0x6c,0x60,0x78,0x60,0x70,0xe0,0x60,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_031[]={ //Digital 1
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0e,0x00,0x1e,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x80,0x1f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_032[]={ //Digital 2
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x0f,0xc0,0x1f,0xe0,0x38,0x60,0x30,0xe0,0x00,
0xc0,0x01,0x80,0x03,0x00,0x07,0x00,0x0e,0x00,0x1c,0xe0,0x3f,0xe0,0x3f,0x00,0x00,0x00,0x00
};
static unsigned char font_033[]={ //Digital 3
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x60,0x00,
0xc0,0x03,0xc0,0x03,0x60,0x00,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_034[]={ //Digital 4
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0x03,0xc0,0x07,0xc0,0x0e,0xc0,0x1c,0xc0,0x38,
0xc0,0x70,0xc0,0x60,0xc0,0x60,0xe0,0x7f,0xe0,0x7f,0xc0,0x00,0xc0,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_035[]={ //Digital 5
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x7f,0xe0,0x7f,0x00,0x60,0x00,0x60,0x80,0x7f,
0xc0,0x7f,0xe0,0x00,0x60,0x00,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_036[]={  //Digital 6
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x00,0x60,
0x80,0x6f,0xc0,0x7f,0xe0,0x70,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_037[]={ //Digital 7
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x7f,0xe0,0x7f,0xe0,0x00,0xc0,0x01,0x80,0x03,
0x00,0x07,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_038[]={ //Digital 8
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0xc0,0x30,
0xc0,0x3f,0xe0,0x7f,0xe0,0x70,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_039[]={ //Digital 9
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0xe0,0x70,
0xe0,0x3f,0xe0,0x1f,0x60,0x00,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_03A[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x07,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_03B[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x07,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x00,0x07,0x00,0x03,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_03C[]={ //(null)
0x00,0x00,0x00,0x00,0xC0,0x00,0x80,0x01,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,
0x00,0x60,0x00,0x30,0x00,0x18,0x00,0x0C,0x00,0x06,0x00,0x03,0x80,0x01,0xC0,0x00,0x00,0x00
};
static unsigned char font_03D[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xE0,0x7F,0xE0,0x7F,
0x00,0x00,0x00,0x00,0xE0,0x7F,0xE0,0x7F,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_03E[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x18,0x00,0x0C,0x00,0x06,0x00,0x03,0x80,0x01,0xC0,0x00,
0x60,0x00,0xC0,0x00,0x80,0x01,0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x18,0x00,0x30,0x00,0x00
};
static unsigned char font_03F[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x19,0xC0,0x30,0xC0,0x30,0xC0,0x00,
0x80,0x01,0x00,0x03,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_040[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x1F,0x60,0x70,0x30,0xC0,0x10,0x8F,0x90,0x99,
0x90,0xB1,0x90,0xB1,0xB0,0xB3,0xE0,0x9F,0x00,0x80,0xE0,0xE0,0x80,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_041[]={ // A
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0f,0x80,0x1f,0xc0,0x39,0xe0,0x70,
0x60,0x60,0xe0,0x7f,0xe0,0x7f,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_042[]={ // B
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x7f,0xc0,0x7f,0xe0,0x30,0x60,0x30,0xc0,0x30,
0xc0,0x3f,0xe0,0x3f,0xe0,0x30,0x60,0x30,0xe0,0x30,0xc0,0x7f,0x80,0x7f,0x00,0x00,0x00,0x00
};
static unsigned char font_043[]={ // C
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x00,0x60,
0x00,0x60,0x00,0x60,0x00,0x60,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_044[]={ // D
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x7f,0xc0,0x7f,0xe0,0x60,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0xe0,0x60,0xc0,0x7f,0x80,0x7f,0x00,0x00,0x00,0x00
};
static unsigned char font_045[]={ // E
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x7f,0xe0,0x7f,0x00,0x60,0x00,0x60,0x00,0x60,
0xc0,0x7f,0xc0,0x7f,0x00,0x60,0x00,0x60,0x00,0x60,0xe0,0x7f,0xe0,0x7f,0x00,0x00,0x00,0x00
};
static unsigned char font_046[]={ // F
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x7f,0xe0,0x7f,0x00,0x60,0x00,0x60,0x00,0x60,
0xc0,0x7f,0xc0,0x7f,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_047[]={ // G
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x00,0x60,
0xe0,0x63,0xe0,0x63,0x60,0x60,0xe0,0x60,0xe0,0x71,0xe0,0x3f,0x60,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_048[]={ // H
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
0xe0,0x7f,0xe0,0x7f,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_049[]={ // I
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0x80,0x1f,0x00,0x06,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x80,0x1f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_04A[]={ // J
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x0f,0xe0,0x0f,0x80,0x01,0x80,0x01,0x80,0x01,
0x80,0x01,0x80,0x01,0x80,0x01,0x80,0x61,0x80,0x73,0x00,0x3f,0x00,0x1e,0x00,0x00,0x00,0x00
};
static unsigned char font_04B[]={ // K
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xc0,0x60,0xc0,0x61,0x80,0x63,0x00,0x67,0x00,0x6e,
0x00,0x7c,0x00,0x7c,0x00,0x6e,0x00,0x67,0x80,0x63,0xc0,0x61,0xc0,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_04C[]={ // L
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,
0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0xe0,0x7f,0xe0,0x7f,0x00,0x00,0x00,0x00
};
static unsigned char font_04D[]={ // M
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x70,0xe0,0x79,0xe0,0x7f,0x60,0x6f,0x60,0x66,
0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_04E[]={ // N
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x70,0x60,0x78,0x60,0x7c,
0x60,0x6e,0x60,0x67,0xe0,0x63,0xe0,0x61,0xe0,0x60,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_04F[]={ // O
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_050[]={ // P
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x7f,0xc0,0x7f,0xe0,0x60,0x60,0x60,0xe0,0x60,
0xc0,0x7f,0x80,0x7f,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_051[]={ // Q
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x60,0x67,0xe0,0x73,0xc0,0x3f,0xe0,0x1e,0x60,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_052[]={ // R
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x7f,0xc0,0x7f,0xe0,0x60,0x60,0x60,0xe0,0x60,
0xc0,0x7f,0x80,0x7f,0x00,0x6e,0x00,0x67,0x80,0x63,0xc0,0x61,0xe0,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_053[]={ // S
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x1f,0xc0,0x3f,0xe0,0x70,0x60,0x60,0x00,0x70,
0x80,0x3f,0xc0,0x1f,0xe0,0x00,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_054[]={ // T
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x7f,0xe0,0x7f,0x00,0x06,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_055[]={ // U
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0xe0,0x70,0xc0,0x3f,0x80,0x1f,0x00,0x00,0x00,0x00
};
static unsigned char font_056[]={ // V
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x60,0xe0,0x70,0xc0,0x39,0x80,0x1f,0x00,0x0f,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_057[]={ // W
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,0x60,
0x60,0x60,0x60,0x66,0x60,0x6f,0xe0,0x7f,0xe0,0x79,0xe0,0x70,0x60,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_058[]={ // X
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0xe0,0x70,0xc0,0x39,0x80,0x1f,
0x00,0x0f,0x00,0x0f,0x80,0x1f,0xc0,0x39,0xe0,0x70,0x60,0x60,0x60,0x60,0x00,0x00,0x00,0x00
};
static unsigned char font_059[]={ // Y
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,0x60,0x60,0xe0,0x70,0xc0,0x30,0xc0,0x39,
0x80,0x19,0x80,0x1f,0x00,0x0f,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_05A[]={ // Z
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xe0,0x7f,0xe0,0x7f,0xe0,0x00,0xc0,0x01,0x80,0x03,
0x00,0x07,0x00,0x0e,0x00,0x1c,0x00,0x38,0x00,0x70,0xe0,0x7f,0xe0,0x7f,0x00,0x00,0x00,0x00
};
static unsigned char font_05B[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30,
0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x3C,0x00,0x00,0x00,0x00
};
static unsigned char font_05C[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x00,0x18,0x00,0x18,0x00,0x0C,0x00,0x0C,0x00,0x0C,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_05D[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x03,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00,
0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x03,0x00,0x00,0x00,0x00
};
static unsigned char font_05E[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x0F,0x80,0x19,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_05F[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_060[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};
static unsigned char font_061[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x61,
0x80,0x01,0x80,0x01,0x80,0x3F,0x80,0x61,0x80,0x61,0x80,0x61,0xC0,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_062[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x3F,0x80,0x39,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0x80,0x39,0x00,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_063[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x19,
0xC0,0x30,0x00,0x30,0x00,0x30,0x00,0x30,0xC0,0x30,0x80,0x19,0x00,0x0F,0x00,0x00,0x00,0x00
};
static unsigned char font_064[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x0F,0xC0,0x19,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x19,0xC0,0x0F,0x00,0x00,0x00,0x00
};
static unsigned char font_065[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x19,
0xC0,0x30,0xC0,0x30,0xC0,0x3F,0x00,0x30,0xC0,0x30,0x80,0x19,0x00,0x0F,0x00,0x00,0x00,0x00
};
static unsigned char font_066[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x03,0x00,0x06,0x00,0x06,0x80,0x1F,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_067[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x0F,0xC0,0x19,0xC0,0x30,0xC0,0x30,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x19,0xC0,0x0F,0xC0,0x00,0xC0,0x00,0x80,0x01,0x00,0x1F
};
static unsigned char font_068[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x3F,0x80,0x39,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0x00,0x00,0x00,0x00
};
static unsigned char font_069[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_06A[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x0C
};
static unsigned char font_06B[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x00,0x30,0x00,0x30,0x80,0x31,0x00,0x33,
0x00,0x36,0x00,0x3C,0x00,0x3C,0x00,0x36,0x00,0x33,0x80,0x31,0xC0,0x30,0x00,0x00,0x00,0x00
};
static unsigned char font_06C[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_06D[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0xF9,0x60,0xEF,
0x30,0xC6,0x30,0xC6,0x30,0xC6,0x30,0xC6,0x30,0xC6,0x30,0xC6,0x30,0xC6,0x00,0x00,0x00,0x00
};
static unsigned char font_06E[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x39,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0x00,0x00,0x00,0x00
};
static unsigned char font_06F[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0x80,0x19,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0x80,0x19,0x00,0x0F,0x00,0x00,0x00,0x00
};
static unsigned char font_070[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,0x39,0xC0,0x30,0xC0,0x30,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0x80,0x39,0x00,0x3F,0x00,0x30,0x00,0x30,0x00,0x30,0x00,0x30
};
static unsigned char font_071[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x0F,0xC0,0x19,0xC0,0x30,0xC0,0x30,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x19,0xC0,0x0F,0xC0,0x00,0xC0,0x00,0xC0,0x00,0xC0,0x00
};
static unsigned char font_072[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x00,0x00,0x0B,0x00,0x0E,
0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x00,0x00,0x00
};
static unsigned char font_073[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x1F,0x80,0x31,
0x00,0x30,0x00,0x30,0x00,0x1F,0x80,0x01,0x80,0x01,0x80,0x31,0x00,0x1F,0x00,0x00,0x00,0x00
};
static unsigned char font_074[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x06,0x00,0x06,0x00,0x06,0x80,0x1F,0x00,0x06,
0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x06,0x80,0x06,0x00,0x03,0x00,0x00,0x00,0x00
};
static unsigned char font_075[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x30,0xC0,0x30,
0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x30,0xC0,0x19,0xC0,0x0F,0x00,0x00,0x00,0x00
};
static unsigned char font_076[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x30,0xC0,0x30,
0x80,0x19,0x80,0x19,0x00,0x0F,0x00,0x0F,0x00,0x06,0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00
};
static unsigned char font_077[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xC0,0x30,0xC6,
0x60,0x66,0x60,0x66,0xC0,0x3F,0xC0,0x3F,0x80,0x19,0x80,0x19,0x80,0x19,0x00,0x00,0x00,0x00
};
static unsigned char font_078[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x30,0x80,0x19,
0x80,0x19,0x00,0x0F,0x00,0x06,0x00,0x0F,0x80,0x19,0x80,0x19,0xC0,0x30,0x00,0x00,0x00,0x00
};
static unsigned char font_079[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xC0,0x30,0xC0,0x30,
0x80,0x19,0x80,0x19,0x00,0x0F,0x00,0x0F,0x00,0x06,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x38
};
static unsigned char font_07A[]={ //(null)
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x3F,0x80,0x01,
0x00,0x03,0x00,0x06,0x00,0x0C,0x00,0x0C,0x00,0x18,0x00,0x30,0x80,0x3F,0x00,0x00,0x00,0x00
};
static unsigned char font_07B[]={ //Enter
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x00,0x60,0x00,0x60,0x00,
0x60,0x10,0x60,0x30,0xE0,0x7F,0xE0,0x7F,0x00,0x30,0x00,0x10,0x00,0x00,0x00,0x00,0x00,0x00
};

unsigned char *AllFonts[]={
font_000,font_001,font_002,font_003,font_004,font_005,font_006,font_007,font_008,font_009,
font_00A,font_00B,font_00C,font_00D,font_00E,font_00F,font_010,font_011,font_012,font_013,
font_014,font_015,font_016,font_017,font_018,font_019,font_01A,font_01B,font_01C,font_01D,
font_01E,font_01F,font_020,font_021,font_022,font_023,font_024,font_025,font_026,font_027,
font_028,font_029,font_02A,font_02B,font_02C,font_02D,font_02E,font_02F,font_030,font_031,
font_032,font_033,font_034,font_035,font_036,font_037,font_038,font_039,font_03A,font_03B,
font_03C,font_03D,font_03E,font_03F,font_040,font_041,font_042,font_043,font_044,font_045,
font_046,font_047,font_048,font_049,font_04A,font_04B,font_04C,font_04D,font_04E,font_04F,
font_050,font_051,font_052,font_053,font_054,font_055,font_056,font_057,font_058,font_059,
font_05A,font_05B,font_05C,font_05D,font_05E,font_05F,font_060,font_061,font_062,font_063,
font_064,font_065,font_066,font_067,font_068,font_069,font_06A,font_06B,font_06C,font_06D,
font_06E,font_06F,font_070,font_071,font_072,font_073,font_074,font_075,font_076,font_077,
font_078,font_079,font_07A,font_07B, NULL,
};


/* --------------------------------------------------------------------- */
unsigned short terawins_osd_color_table[16] =
{
	/* OSD color LUT. */
	//-- Null, Red, Green, Blue
	0x0000,  // 0: Transparant
  	0x0000,
	0x0fff,  // 2: White
	0x0fff,

  	0x0c11,  // 4: Red
	0x0c11,
	0x00f0,  // 6: Green
	0x00f0,

  	0x011c,  // 8: Blue
  	0x011c,
  	0x0f40,  // A: Orange
  	0x0f40,

  	0x0ddd,  // C: Gray
  	0x0ddd,
  	0x0000,	 // E: Black
  	0x0000,
};


/* --------------------------------------------------------------------- */
//== Font info
unsigned char font_index = FONT_12x18;	// index of font type.
struct _font_info font_info[FONT_END] = {
//-- font_size, width, height, font_nums
	{0x0000,    10,    16,     0},	// 10x16
	{0x0009,    12,    18,     0},	// 12x18
	{0x0013,    16,    24,     0},	// 16x24
};

//== OSD info
struct _terawins_osd_info video_speed =
{
	1,					// osd on
	1,					// num of line
	18,					// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR6,			// foreground color
	BG_COLOR0,			// background color
	1,					// double size of line
	0,
	0,
};

struct _terawins_osd_info battery_state =
{
	1,					// osd on
	1,					// num of line
	54,					// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR6,			// foreground color
	BG_COLOR0,			// background color
	1,					// double size of line
	0,
	0,
};

struct _terawins_osd_info icon =
{
	1,					// osd on
	3,					// num of line
	300,				// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR12,			// foreground color
	BG_COLOR0,			// background color
	0,					// double size of line
	0,
	0,
};

struct _terawins_osd_info audio_channels =
{
	1,					// osd on
	1,					// num of line
	372,				// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR3,			// foreground color
	BG_COLOR7,			// background color
	0,					// double size of line
	0,
	0,
};


struct _terawins_osd_info subtitle =
{
	1,					// osd on
	3,					// num of line
	438,				// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR3,			// foreground color
	BG_COLOR0,			// background color
	1,					// double size of line
	0,
	0,
};

struct _terawins_osd_info mute_vol =
{
	1,					// osd on
	1,					// num of line
	546,				// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR3,			// foreground color
	BG_COLOR7,			// background color
	0,					// double size of line
	0,
	0,
};

struct _terawins_osd_info video_time =
{
	1,					// osd on
	1,					// num of line
	564,				// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR3,			// foreground color
	BG_COLOR0,			// background color
	1,					// double size of line
	0,
	0,
};

struct _terawins_osd_info blank =
{
	1,					// osd on
	1,					// num of line
	0,					// start line of the frame (multiples of 18)
	0,					// row num of the osd area
	0,					// ram address
	0,					// blink
	FG_COLOR0,			// foreground color
	BG_COLOR0,			// background color
	1,					// double size of line
	0,
	0,
};

struct _terawins_osd_info* terawins_osd[] =
{
	&video_speed,
	&battery_state,
	&icon,
	&subtitle,
	&mute_vol,
	&video_time,
	&audio_channels,
	NULL,
};


char valid_icon[] =
{
	//-- Row 1
	(0x06), (0x07), (0x00),
	//-- Row 2
	(0x08), (0x09), (0x00),
	//-- Row 3
	(0x00), (0x00), (0x00),
};

char invalid_icon[] =
{
	//-- Row 1
	(0x0a), (0x0b), (0x0c),
	//-- Row 2
	(0x0d), (0x0e), (0x0f),
	//-- Row 3
	(0x10), (0x11), (0x12),
};

char mute_icon[] =
{
	'M', 'U', 'T', 'E',
};

char vol_icon[] =
{
	'V', 'O', 'L', ' ',
};


char audio_channels_icon[3][2] =
{
	{'L','R'},
	{'L','L'},
	{'R','R'}
};


#endif	//~#if USE_TERAWINS_TCON


