#include "events.h"
#include <sys/time.h>
#include <unistd.h>
#include <signal.h>

//------------------------------------------------------------------------------------------------
//static char InAudioChannelsProcess = 0;

void audio_channels_timeout_handler(int sig)
{
	signal(sig,SIG_DFL);
#if defined(USE_DESC_LCD) && defined(USE_TERAWINS_TCON)
	tcon_clear_audio_channels();
#endif
	SaveUserSetupToMem();
	InAudioChannelsProcess = 0;
	//PRINTF("[audio_channels_timeout_handler]\n");
}
	
void FLDR_FV_EscEvent()
{
#ifdef SET_VID_SKY_PRIO
	SkyPrio = getpriority(PRIO_PROCESS, 0);
  	setpriority(PRIO_PROCESS, 0, SkyPrio - VID_SKY_PRIO_LVL);
#endif
	
//	if (InAudioChannelsProcess)
//	{
//		InAudioChannelsProcess = 0;
//		SaveUserSetupToMem();
//	}
	
	ELMachines[active_index].Shutdown(0);
	active_index = prev_active_index;
	pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);/* Flowbee. */
	ELMachines[active_index].Display();
}

void FLDR_FV_ZoomEvent()
{	
	struct itimerval t;    	

//	t.it_value.tv_sec = 0;
//	setitimer(ITIMER_REAL, &t, NULL);
	
	t.it_interval.tv_usec = 0;    
	t.it_interval.tv_sec = 0;    
	t.it_value.tv_usec = 0;    
	t.it_value.tv_sec = 5;
	setitimer( ITIMER_REAL, &t, NULL);
	
	if (InAudioChannelsProcess==0)
	{
		InAudioChannelsProcess = 1; 
		signal(SIGALRM, audio_channels_timeout_handler);				
	}
//	else
	{
		setup->aud_chnl_idx++;
		setup->aud_chnl_idx %= 3;
	}
	
#if defined(USE_DESC_LCD) && defined(USE_TERAWINS_TCON)
	terawins_show_audio_channels(setup->aud_chnl_idx);
#endif
	SetAudioChannel(setup->aud_chnl_idx);	
}
	
