#include "generalevents.h"
///080521
#include "events.h"
///
#include <sys/soundcard.h>
//------------------------------------------------------------------------------------------------
Uint8 prev_active_index, isVideoPausedBySetup = 0;
COORD posOfMute = {30, 20, 60 , 28}, posOfVol = {0, 0, 211, 28};
//------------------------------------------------------------------------------------------------
void TurnOnOverlayMode()
{
	#if USE_TERAWINS_TCON
	return;
	#endif

	/* Flowbee@960510. */
	if((slide_state == SLIDE_IN_TR2JPEG) && (active_index == SS_ACTIVE)){
		if(isMutePressed){
			tr_state = IN_MUTE;
		}
		else if(isVolumePressed){
			tr_state = IN_VOLUME;
		}
		else{
			tr_state = IN_START;
		}
	}
	else{
		if(isMutePressed){
			jpeg_state = IN_MUTE;
		}
		else if(isVolumePressed){
			jpeg_state = IN_VOLUME;
		}
		else{
			jpeg_state = IN_START;
		}
		if(!(active_index == CAL_ACTIVE && prev_active_index == FI_ACTIVE))
			pgu_set_alpha(setup->sys_alpha);

		pgu_enable_overlay(1);
		osd_parser();
	}
}
//------------------------------------------------------------------------------------------------
void TurnOffOverlayMode(int signum)
{
	int isReallyTurningOff = TRUE;
	//info
	if(isInfoPressed)//turn off info_display forcely
		isInfoPressed = FALSE;
	
	//called by alarm
	if(signum != -1)
	{
		//called by disapearing volume alarm
		if(isVolumePressed)
		{
			isVolumePressed = FALSE;
			#if USE_TERAWINS_TCON
			tcon_clear_mute_vol();
			#endif
			if(isMutePressed)//muting at the same time
			{
				DrawMute();
				isReallyTurningOff = FALSE;
			}
		}
	}
	//mute
	if(isMutePressed)
	{
		if(signum == -1)//turning off mute by user
		{
			isMutePressed = FALSE;
			#if USE_TERAWINS_TCON
			tcon_clear_mute_vol();
			#endif
		}
		else//keeping mute
			isReallyTurningOff = FALSE;
	}
	//setup
	if(isSetupPressed)
		isReallyTurningOff = FALSE;
		
	if(isReallyTurningOff){
//		if ((active_index != SS_ACTIVE) || (slide_state != SLIDE_IN_TR2JPEG)){
			/* Flowbee@960613. */
			if( !((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)) ){
				if(active_index == FV_ACTIVE || active_index == FLDR_FV_ACTIVE)//clean for time display - bk @ 070822
				{
#ifdef VIDEO_TIME_DISPLAY_MOD
					memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
#else
					unsigned long buf_w, w, h;
					pgu_get_yuv_resolution(&buf_w, &w, &h);
					memset(RGB0 + ((Uint16)(buf_w))  * 2 * posOfVol.y, 0, RGB_VOLBUFF_SIZE);
#endif
				}
				else
					pgu_enable_tv_osd(0);//hw osd
				pgu_enable_overlay(0);//sw osd - TODO - need testing if undef USE_TERAWINS_TCON
			}
#ifdef USE_DESC_TV
			else
			{
				//SetRGBuffMSB(0, ELMachines[active_index].frame.rgbtemplate, 0, ELMachines[active_index].frame.framecoord.x, ELMachines[active_index].frame.framecoord.y, ELMachines[active_index].frame.framecoord.width, ELMachines[active_index].frame.framecoord.height);
				//SetRGBuffBlockMSB(0, ELMachines[active_index].frame.rgbtemplate, 0, posOfMute.x, posOfMute.y, posOfMute.width, posOfMute.height, WHITE_555);
				//SetRGBuffBlockMSB(0, ELMachines[active_index].frame.rgbtemplate, 0, posOfVol.x, posOfVol.y, posOfVol.width, posOfVol.height, WHITE_555);
				SetRGBuffBlockMSB(0, RGB0, 0, posOfMute.x, posOfMute.y, posOfMute.width, posOfMute.height, WHITE_555);
				SetRGBuffBlockMSB(0, RGB0, 0, posOfVol.x, posOfVol.y, posOfVol.width, posOfVol.height, WHITE_555);
			}
#endif
//		}
	}
/*
	if((active_index == SS_ACTIVE) && (slide_state == SLIDE_IN_TR2JPEG)){
		tr_state = IN_START;
	}
	else if((active_index == SS_ACTIVE) && (slide_state == SLIDE_IN_JPEG)){
		jpeg_state = IN_START;
	}
	else{
		tr_state = IN_START;
		jpeg_state = IN_START;		
	}
*/
}
//------------------------------------------------------------------------------------------------
#ifdef FAKEPOWER

void PowerOnOffMode()
{
	if(!isPowerOn)
	{//can not change the order of the following codes
		isPowerOn = TRUE;
		
#ifndef TV_AUTO_CARDREADER_MODE_OFF
		//power on to usb2pc mode
		if(dev_mnted_enbled_flags.usb2pconn)
		{
			hasEnteredCardReaderMode = TRUE;
			isCardReaderOn = TRUE;
			SelectedDev = DEVICE_CARD_READER_NAME;
			DS_EnterEvent();
		}
#endif
		
		//show it on the display
		pgu_start_pgu();
#ifdef USE_DESC_LCD
		TurnBacklightPGU(1);
#endif
		MSG("Power On!\n");
	}
	else
	{
		//turn off the power
		isPowerOn = FALSE;
		
		// shutdown current state to DS
#ifdef USE_DESC_LCD
		TurnBacklightPGU(0);
#endif
		pgu_stop_pgu();
		if(active_index == USB2PC_CONN_ACTIVE)
			USB2PC_CONN_EscEvent();
		else
			DetectEvent();
		
		//turn off the display
		pgu_stop_pgu();
		MSG("Power Off!\n");
	}
}

  #ifdef LEADTEK_TV
#define GIOP_DATA_REG					1
#define CARDSLOT_READ_GPIO_BITDATA	6
#define CARDSLOT_WRITE_GPIO_BITDATA	7

typedef struct _sGPIO
{
	unsigned int _reg;
	unsigned int _mask_bit;
	unsigned int _data;
}
GPIO;

/**
 * LED Off(High): retrurn 0; LED On(Low): return 1
 */
int GetLEDOnOff()
{
	int  fd, NumOfGPIO = 9;
	GPIO myGPIO;
	
	// open device handle
	if((fd = open("/dev/slot0", O_RDWR)) == -1)
	{
		PRINTF("open \"/dev/slot0\" to control LED failed\n");
		return;
	}
	
	myGPIO._reg		= GIOP_DATA_REG;
	myGPIO._mask_bit	= 1 << NumOfGPIO;
	ioctl(fd, CARDSLOT_READ_GPIO_BITDATA, &myGPIO);
	close(fd);
	
	return !(myGPIO._data >>  NumOfGPIO);
}

/**
 * LED Off(High): retrurn 0; LED On(Low): return 1
 */
void SetLEDOnOff()
{
	int  fd, NumOfGPIO = 9;
	GPIO myGPIO;
	
	// open device handle
	if((fd = open("/dev/slot0", O_RDWR)) == -1)
	{
		PRINTF("open \"/dev/slot0\" to control LED failed\n");
		return;
	}
	
	myGPIO._reg		= GIOP_DATA_REG;
	myGPIO._mask_bit	= 1 << NumOfGPIO;
	myGPIO._data		= (!isPowerOn) << NumOfGPIO;
	ioctl(fd, CARDSLOT_WRITE_GPIO_BITDATA, &myGPIO);
	close(fd);
}
  #endif
#endif
//------------------------------------------------------------------------------------------------
void SetSoundDeviceVolume(int v)
{
	int mixer_fd, vol;//mixer file descriptor
	
	//open /dev/mixer
	if((mixer_fd = open("/dev/mixer", O_RDONLY, 0)) == -1)
	{
		perror("open /dev/mixer error");
		DMSG("Fail to Set Volume");
		return;
		//exit(1);
	}
	
#ifdef FASHIONSTAR
	if(v == 0)
		SetGPIOMute(0);
	else
		SetGPIOMute(1);
#endif
	//set volume
	vol = (((Uint16)v) * 10 << 8) | (v * 10);
	ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_PCM), &vol);
	
	close(mixer_fd);
}
//------------------------------------------------------------------------------------------------
// Raymond 2008/01/22
#include <linux/soundcard.h>
int GetAudioDelay(void)
{
	int mixer_fd, delay = 0;//mixer file descriptor
	
	//open /dev/mixer
	if((mixer_fd = open("/dev/mixer", O_RDONLY, 0)) < 0 )
	{
		perror("open /dev/mixer_fd error");
		DMSG("Fail to open /dev/mixer_fd");
		return 0;
		//exit(1);
	}
	
	ioctl(mixer_fd, SNDCTL_DSP_GETODELAY, &delay);
	
	close(mixer_fd);

	return delay;
}
//------------------------------------------------------------------------------------------------
void SetGPIOMute(int enable)
{
	int mixer_fd;//mixer file descriptor

	//open /dev/mixer
	if((mixer_fd = open("/dev/mixer", O_RDONLY, 0)) == -1)
	{
		perror("open /dev/mixer error");
		DMSG("Fail to Set Volume");
		return;
		//exit(1);
	}

	// set GPIO mute
	// 0 for mute, 1 for unmate
	ioctl(mixer_fd, MIXER_WRITE(SOUND_MIXER_SPEAKER), &enable);
	close(mixer_fd);
}
//------------------------------------------------------------------------------------------------
// General Event Callbacks
//------------------------------------------------------------------------------------------------
void ImageEvent()
{
	// modified by Xenia, for pressing "Photo" key
	// goto "Photo" mode with the first device DPF can reach
	if (active_index == DS_ACTIVE)
	{
		//disable hot key function when DS_ACTIVE & HD, NAS selected - bk @ 080108
		if(
				!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
			||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
		)
			return;
		
		ELMachines[active_index].Shutdown(0);
///080521
		MakeIAVList();

		if(!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
		{
			active_index = USB2PC_CONN_ACTIVE;
		}
	#ifdef BLUETOOTH_MOD
		else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
		{
			ForkBTProcesses();//TODO: in the future, it will integrated with bt setup
			active_index = BT_ACTIVE;
		}
	#endif
		else
		{
			active_index = I_ACTIVE;
		}
		isSSImgPrcsForked = FALSE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
///
	}
	else
	{
		///080507 - for hotkey define
		if(ImgCount == 0)
		{
			PRINTF("No Image in %s.\n", SelectedDev);
			return;
		}
		SelectedMT = ICONText4MT[photo];
		ELMachines[MT_ACTIVE].frame.active_icon_index = photo;
		///
		
		ELMachines[active_index].Shutdown(1);
		active_index = I_ACTIVE;
		isSSImgPrcsForked = FALSE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
//------------------------------------------------------------------------------------------------
void AudioEvent()
{
	// modified by Xenia, for pressing "Music" key
	// goto "Music" mode with the first device DPF can reach
	if (active_index == DS_ACTIVE)
	{
		//disable hot key function when DS_ACTIVE & HD, NAS selected - bk @ 080108
		if(
				!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
			||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
		)
			return;
		
		ELMachines[active_index].Shutdown(0);

///080521
		MakeIAVList();

        if(!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
		{
			active_index = USB2PC_CONN_ACTIVE;
		}
#ifdef BLUETOOTH_MOD
		else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
		{
			ForkBTProcesses();//TODO: in the future, it will integrated with bt setup
			active_index = BT_ACTIVE;
		}
#endif
		else
		{
			active_index = A_ACTIVE;
		}
		isSSAudPrcsForked = FALSE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
///
	}
	else
	{
		///080507 - for hotkey define
		if(AudCount == 0)
		{
			PRINTF("No Audio in %s.\n", SelectedDev);
			return;
		}
		SelectedMT = ICONText4MT[music];
		ELMachines[MT_ACTIVE].frame.active_icon_index = music;
		///
		
		ELMachines[active_index].Shutdown(1);
		active_index = A_ACTIVE;
		isSSAudPrcsForked = FALSE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
//------------------------------------------------------------------------------------------------
void VideoEvent()
{
	// modified by Xenia, for pressing "Video" key
	// goto "Video" mode with the first device DPF can reach
	if (active_index == DS_ACTIVE)
	{
		//disable hot key function when DS_ACTIVE & HD, NAS selected - bk @ 080108
		if(
				!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
			||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
		)
			return;
		
		ELMachines[active_index].Shutdown(0);

///080521
		MakeIAVList();

		if(!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
		{
			active_index = USB2PC_CONN_ACTIVE;
		}
#ifdef BLUETOOTH_MOD
		else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
		{
			ForkBTProcesses();//TODO: in the future, it will integrated with bt setup
			active_index = BT_ACTIVE;
		}
#endif
		else
		{
			active_index = V_ACTIVE;
		}
		isVidPrcsForked = FALSE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
///
	}
	else
	{
		///080507 - for hotkey define
		if(VidCount == 0)
		{
			PRINTF("No Video in %s.\n", SelectedDev);
			return;
		}
		SelectedMT = ICONText4MT[video];
		ELMachines[MT_ACTIVE].frame.active_icon_index = video;
		///
		
		ELMachines[active_index].Shutdown(1);
		active_index = V_ACTIVE;
		isVidPrcsForked = FALSE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
//------------------------------------------------------------------------------------------------
void SlideShowEvent()
{
	if(ImgCount != 0)
	{
		//modified by bk@070409 - modified for AutoSlideShow
		if(active_index == DS_ACTIVE)//slideshow from DS_ACTIVE - set SelectedDev to DEVICE_AUTOSS_NAME
			SelectedDev = DEVICE_AUTOSS_NAME;//modified by Richard Li @ 05/04/2007
		ELMachines[active_index].Shutdown(1);
		active_index = SS_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	else
	{
		if(active_index == FV_ACTIVE || active_index == FLDR_FV_ACTIVE)
			return;
		
		FRAME* elmf;
		Uint16 x, y, w, h;
		
		elmf = &ELMachines[active_index].frame;
		x = desc->MiscTextCoord[6].x;
		y = desc->MiscTextCoord[6].y;
		h = g_pFontDB_Local->FontSize;
		w = GetFontStringWidth(g_pFontDB_Local, FrameText[setup->Language][9]);
		x -= ((++w) >> 1);


///070827 AѤ@I(]IwQ(רDrawRepeatMode))
		pid_t pid;
		int status;
		char strH[LEN_M], strW[LEN_M];
		sprintf(strH, "%d", elmf->framecoord.height);
		sprintf(strW, "%d", elmf->framecoord.width);
		pid = fork();
		switch(pid)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to Load Background Jpg Fail!");
				break;
				//exit(1);
			case 0:
				//child process
				execl("/sky/skyview", "skyview", "-rgb", "0", "-x", strW, "-y", strH, elmf->fname, NULL);
				_EXIT;
			default:
				//parent process
				waitpid(pid, &status, 0);
				if(WIFEXITED(status))
				{
					DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)RGB0, x, y, w, h);
					memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
				}
				break;
		}
///
		///070827
		//DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->bkgrdbuff, x, y, w, h);
		///
		FontTextOutFormat(g_pFontDB_Local, (Uint16 *)RGB1, desc->MiscTextCoord[6].x, desc->MiscTextCoord[6].y, FrameText[setup->Language][9], RED_1555, DT_CENTER);
		///070827
		RGBlock2YUVBlock(RGB1, 1, x, y ,w, h);
		//RGB2YUV(1, 1);
		///

		///070904 Ȱ
		sleep(2);
		DrawFocusedICON(RGB1, 0);
		///
		
		osd_parser();
	}
}
//------------------------------------------------------------------------------------------------
#if NET_DISABLE
extern unsigned char wifi_down;
extern unsigned char cifs_down;
#endif
#ifdef NET_MOD
extern Uint8 isGWSet;		//0: none; bit_1(1): got mac; bit_2(2): wired; bit_3(4):wireless;
#endif
void DetectEvent()
{
	//if(active_index == DS_ACTIVE || active_index == MT_ACTIVE ||
	//   active_index == I_ACTIVE || active_index == A_ACTIVE || active_index == V_ACTIVE)
	SavePrevMountedDeviceStatus();
#ifdef NET_MOD
	if((isGWSet & 1)!=0)	//connected
	{
		if(
		(!strcmp(SelectedDev, DEVICE_NAS_NAME)) &&
		(active_index == SS_ACTIVE || active_index == I_ACTIVE || active_index == A_ACTIVE || active_index == V_ACTIVE))
			return;
		else
		{
			KillNetSocket();
			ForkNETSocket();
		}
	}
#endif
#if NET_DISABLE
	wifi_down = cifs_down = 0;
#endif
	CloseSystem();
	InitSystem(INITSYS_CALL_BY_NORMAL);
}
//------------------------------------------------------------------------------------------------
void InfoEvent()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	if(!isSetupPressed)
	{
		if(!isInfoPressed)
		{
			///070814
			char s[LEN_XL] = {0};
			///
	
			/* Flowbee. */
			if(isVolumePressed)
			{
				isVolumePressed = FALSE;
				#if USE_TERAWINS_TCON
				tcon_clear_mute_vol();
				#endif
				alarm(0);
			}
			
			///070814
			//memcpy(RGB0, elmf->osdbuff, RGB_FRAMEBUFF_SIZE);
			///
			
			isInfoPressed = TRUE;

			///070814
			switch (active_index)
			{
				case I_ACTIVE:
				case FI_ACTIVE:
					GetPath(s);
					strcat(s, ELMachines[I_ACTIVE].frame.CurrImgListPos->fname);
					DrawEXIF(s);
//#ifdef BATTERY_MOD
//					DrawBattery();
//#endif
					break;
				case A_ACTIVE:
					GetPath(s);
					strcat(s, elmf->CurrAudListPos->fname);
					DrawID3Tag(s);
//#ifdef BATTERY_MOD
//					DrawBattery();
//#endif
					break;
				case V_ACTIVE:
					GetPath(s);
					strcat(s, elmf->CurrVidListPos->fname);
					DrawVideoInfo(s);
//#ifdef BATTERY_MOD
//					DrawBattery();
//#endif
					break;
//#ifdef BATTERY_MOD
//				case CAL_ACTIVE:
//					DrawBattery();
//					return;				
//#endif
				default:
#ifdef BATTERY_MOD
//					DrawBattery();
#else
					isInfoPressed = FALSE;
#endif
					break;
			}
			///
			
#ifdef BATTERY_MOD
			DrawBattery();
#else
			if(isInfoPressed == FALSE)//only battery info display, but BATTERY_MOD is not difined
				return;
#endif
			
			pgu_set_alpha(setup->sys_alpha);//bk@20070521
			pgu_enable_overlay(1);
			/* Flowbee@960407. */
			osd_parser();			
		}
		else
		{
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
#ifdef BATTERY_MOD
			//Battery Display OFF by Richard 2008/02/26
			terawins_clear_battery();
#endif
			isInfoPressed = FALSE;
			pgu_enable_overlay(0);

			//add by bk@070517 - copy from SetupEvent(). When pressed off INFO, checking mute, volume display status
			if(active_index == A_ACTIVE)
			{
				if(isMutePressed)
				{
					DrawMute();		
					#if USE_TERAWINS_TCON

					#else
					pgu_enable_overlay(1);
					osd_parser();
					#endif
				}
			}

			if(isVolumePressed)
			{
				DrawVolume();
				#if USE_TERAWINS_TCON

				#else
				pgu_enable_overlay(1);
				osd_parser();
				#endif
			}
		}
	}
}
//------------------------------------------------------------------------------------------------
void SetupEvent()
{
	Uint8 j;
	Uint8 bReDraw = 0;	//bReDraw == 1 ܻݭne

	if(!isInfoPressed)
	{
		if(!isSetupPressed)
		{
			/*Flowbee@960505. */
			if(isMutePressed || isVolumePressed)
			{
				#if USE_TERAWINS_TCON
				tcon_clear_mute_vol();
				#else
				pgu_enable_overlay(0);
				#endif
			}
			//bk@070508
			if(active_index == FV_ACTIVE)
			{
				if(!isVideoPaused)
				{
					FV_PlayPauseEvent();
					isVideoPausedBySetup = TRUE;
				}
				else
					isVideoPausedBySetup = FALSE;
			}
			//bk@080630
			if(active_index == A_ACTIVE && isOnlyAudPrcsForked)
			{
				A_StopEvent();
				isMusicStopPressed = FALSE;
			}
			isSetupPressed = TRUE;
			prev_active_index = active_index;
			active_index = SETUP_L1_ACTIVE;
			ELMachines[active_index].Init();
			ELMachines[active_index].Display();
			/* Flowbee@960407. */
			//osd_parser();			
		}
		else
		{
			pgu_enable_overlay(0);
			///070814
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
			///
		
			isSetupPressed = FALSE;
 			//shoutdown any current state machine(L1, L2 or L3) without saving setting value and go back to prev_active_index machine
			ELMachines[active_index].Shutdown(0);
			active_index = prev_active_index;
			//move down by bk @ 070703
			//if(!(isLanguageChanged || (setup->del_idx == 1 && isUserConfirmed)))
			//	DrawFocusedICON(RGB0);

			//bk@070508
			if(active_index == FV_ACTIVE)//if prev_active_index is FV_ACTIVE, video must be paused
			{
				if(isVideoPausedBySetup)//paused by setup
				{
					FV_PlayPauseEvent();
					isVideoPausedBySetup= FALSE;
				}
				else//paused by user, keep pauseing
					;
			}
			/* Flowbee */
			if(active_index == A_ACTIVE || active_index == FV_ACTIVE)
			{
				if(isMutePressed)
				{
					DrawMute();		
					#if USE_TERAWINS_TCON

					#else
					pgu_enable_overlay(1);
					osd_parser();
					#endif
				}
			}
			//rebuild images, audio lists after formatting flash - bk @ 080320
			if(active_index == DS_ACTIVE && isFlashFormatted)
			{
				FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
				SearchFileByDevice(MT_PHOTO | MT_MUSIC, Mounted_Device);
				isFlashFormatted = FALSE;
				//bReDraw = 1;
			}

			if(isVolumePressed)
			{
				DrawVolume();
				#if USE_TERAWINS_TCON

				#else
				pgu_enable_overlay(1);
				osd_parser();
				#endif
			}

			//󴫻yɧsr
			if (isLanguageChanged)
			{
				//isLanguageChanged = FALSE;
				switch (active_index)
				{
					case DS_ACTIVE:
				///080324
				#ifdef NET_MOD
					case NET_DS_ACTIVE:
				#endif
				/// 
						InitFrameTextMessage(FrameText[setup->Language][7], &(desc->MiscTextCoord[4]));
						//DSDisplay();
						bReDraw = 1;
						break;
					case MT_ACTIVE:
						InitFrameTextMessage(FrameText[setup->Language][8], &(desc->MiscTextCoord[5]));
						//MTDisplay();
						bReDraw = 1;
						break;
					case FI_ACTIVE:
					case I_ACTIVE:
						InitFrameTextMessage(FrameText[setup->Language][0], &(desc->MiscTextCoord[0]));
						//ImgDisplay();
						bReDraw = 1;
						break;
					case A_ACTIVE:
						InitFrameTextMessage(FrameText[setup->Language][1], &(desc->MiscTextCoord[1]));
						//AudDisplay();
						bReDraw = 1;
						break;
					case V_ACTIVE:
						InitFrameTextMessage(FrameText[setup->Language][2], &(desc->MiscTextCoord[2]));
						//VidDisplay();
						bReDraw = 1;
						break;
					case FLDR_ACTIVE:
						InitFrameTextMessage(FrameText[setup->Language][4], &(desc->MiscTextCoord[24]));
						//FldrDisplay();
						bReDraw = 1;
						break;
#ifdef BLUETOOTH_MOD
					case BT_ACTIVE:
						InitFrameTextMessage(FrameText[setup->Language][29], &(desc->MiscTextCoord[39]));
						//BTDisplay();
						bReDraw = 1;
						break;
#endif
					default:
						break;
				}
			}
			
			//memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);//comment out by bk@070407 - because mute display condition checks in Display()
			//redrawing - for delete or change langauge
			if(setup->del_idx == 1 && isUserConfirmed)
			{
				switch(active_index)
				{
					case I_ACTIVE:
						if(ImgCount > 0)
						{
							//ImgDisplay();
							bReDraw = 1;
						}
						else
							I_EscEvent();
						break;
					case A_ACTIVE:
						if(AudCount > 0)
						{
							//AudDisplay();
							bReDraw = 1;
						}
						else
							A_EscEvent();
						break;
					case V_ACTIVE:
						if(VidCount > 0)
						{
							//VidDisplay();
							bReDraw = 1;
						}
						else
							V_EscEvent();
						break;
					case FI_ACTIVE:
						if(ImgCount > 0)
						{
							//FImgDisplay();
							bReDraw = 1;
						}
						else
						{
							ELMachines[active_index].Shutdown(1);
							active_index = MT_ACTIVE;
							ELMachines[active_index].Init();
							ELMachines[active_index].Display();
						}
						break;
					//Rɮ׫sFolder ViewA
					case FLDR_ACTIVE:
						//UpdateFLDR();
						//FldrDisplay();
						bReDraw = 1;
						break;
#ifdef BLUETOOTH_MOD
					case BT_ACTIVE:
						//UpdateBTFldrDisplay();
						//BTDisplay();
						bReDraw = 1;
						break;
#endif
					default:
						break;
				}
				isLanguageChanged = FALSE;
			}
			else
			{
				DrawFocusedICON(RGB1, 0);
			}

			//󴫭֭ƼҦɧsr
			if (isAudioRepeatModeChanged)
			{
				switch(active_index)
				{
					case A_ACTIVE:
						//AudDisplay();
						bReDraw = 1;
						break;
					default:
						break;
				}
				isAudioRepeatModeChanged = FALSE;
			}

			///
			//Dynamically sorting by Richard@10/03/2007
/*			
			if(isSortingMethodChanged)
			{
				switch(active_index)
				{
					case DS_ACTIVE:
						setup->HomepageMode = DS_ACTIVE;
						break;
					case MT_ACTIVE:
						setup->HomepageMode = MT_ACTIVE;
						break;
					case I_ACTIVE:
						setup->HomepageMode = I_ACTIVE;
						break;
					case A_ACTIVE:
						setup->HomepageMode = A_ACTIVE;
						break;
					case V_ACTIVE:
						setup->HomepageMode = V_ACTIVE;
						break;
				}
				DetectEvent();
				isSortingMethodChanged = FALSE;
			}
*/
			if(isSortingMethodChanged)
			{
				FRAME *elmf;
				char cwd[LEN_XL];

				elmf = &ELMachines[active_index].frame;
				FreeList(MT_PHOTO | MT_MUSIC | MT_VIDEO);
				switch(active_index)
				{
					case DS_ACTIVE:
						SearchFileByDevice(MT_PHOTO | MT_MUSIC, Mounted_Device);
						//DSDisplay();
						bReDraw = 1;
						break;
					case MT_ACTIVE:
						SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
						//MTDisplay();
						bReDraw = 1;
						break;
					case I_ACTIVE:
						SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
						elmf->active_icon_index = 0;
						elmf->CurrImgListPos = ImageList->next;
						//ImgDisplay();
						bReDraw = 1;
						break;
					case A_ACTIVE:
						SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
						elmf->active_icon_index = 0;
						elmf->CurrAudListPos = AudioList->next;
						//AudDisplay();
						bReDraw = 1;
						break;
					case V_ACTIVE:
						SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
						elmf->active_icon_index = 0;
						elmf->CurrVidListPos = VideoList->next;
						//VidDisplay();
						bReDraw = 1;
						break;
					case FLDR_ACTIVE:
						getcwd(cwd, LEN_XL);
						SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
						chdir(cwd);
						FolderList_Free(&FolderList);
						FolderList = FolderList_Build(".");
						FldrDisplay();
						break;
					case FI_ACTIVE:
						SearchFileByDevice(MT_PHOTO | MT_MUSIC | MT_VIDEO, Selected_Device);
						ELMachines[I_ACTIVE].frame.active_icon_index = 0;
						ELMachines[I_ACTIVE].frame.CurrImgListPos = ImageList->next;
						FI_EscEvent();	//^ I_ACTIVE
						break;
					default:
						break;
				}
				isSortingMethodChanged = FALSE;
			}

			//ݭneNe

		#ifdef WINGUI
			if ((setup->display_full_screen_idx)&&((active_index==FI_ACTIVE)/*||(active_index==SS_ACTIVE)||(active_index==FLDR_FI_ACTIVE)*/))
				bReDraw = 1;
		#endif
			
			if (bReDraw)
			{
				ELMachines[active_index].Display();
			}
			
			//reload user setting by bk @ 070518
			setup->cpy_idx = 0;
			setup->del_idx = 0;
			setup->reset_idx = 0;
			isUserConfirmed = FALSE;
			LoadUserSetupFromMem();

			if(isUSetupNeededSaving)
				SaveUserSetup();

			if(isAutoPwrSttngChngd)
			{
				SaveAutoPwrSetupToRTC();
				isAutoPwrSttngChngd = FALSE;
			}
		}
	}
}
//------------------------------------------------------------------------------------------------
void SetupEscEvent()
{
	if(active_index == SETUP_L1_ACTIVE)
	{
		SetupEvent();
/*
		pgu_enable_overlay(0);
		isSetupPressed = FALSE;
		ELMachines[active_index].Shutdown(0);
		active_index = prev_active_index;
		//bk @ 0070709
		//if (!isLanguageChanged)
		//	DrawFocusedICON(RGB0);
		
		//bk@070508
		if(active_index == FV_ACTIVE)//if prev_active_index is FV_ACTIVE, video must be paused
		{
			if(isVideoPausedBySetup)//paused by setup
			{
				FV_PlayPauseEvent();
				isVideoPausedBySetup= FALSE;
			}
			else//paused by user, keep pauseing
				;
		}
		//Flowbee
		if(active_index == A_ACTIVE || active_index == FV_ACTIVE)
		{
			if(isMutePressed)
			{
				DrawMute();		
				#if USE_TERAWINS_TCON

				#else
				pgu_enable_overlay(1);
				osd_parser();
				#endif
			}
//			else if(isVolumePressed)
//			{
//				DrawVolume();
//				#if USE_TERAWINS_TCON
//
//				#else
//				pgu_enable_overlay(1);
//				osd_parser();
//				#endif
//			}
		}
		if(isVolumePressed)
		{
			DrawVolume();
			#if USE_TERAWINS_TCON

			#else
			pgu_enable_overlay(1);
			osd_parser();
			#endif
		}
//		//for delete - redrawing by bk@070419
//		if(setup->del_idx == 1 && isUserConfirmed)
//		{
//			switch(active_index)
//			{
//				case I_ACTIVE:
//					ImgDisplay();
//					break;
//				case A_ACTIVE:
//					AudDisplay();
//					break;
//				case V_ACTIVE:
//					VidDisplay();
//					break;
//				case FI_ACTIVE:
//					FImgDisplay();
//					break;
//				///070625 Rɮ׫sFolder ViewA
//				case FLDR_ACTIVE:
//					UpdateFLDR();
//					break;
//				///
//				default:
//					break;
//			}
//		}

		///070610 󴫻yɧsr
		if (isLanguageChanged)
		{
			isLanguageChanged = FALSE;
			switch (active_index)
			{
				case DS_ACTIVE:
					InitFrameTextMessage(FrameText[setup->Language][7], &(desc->MiscTextCoord[4]));
					DSDisplay();
					break;
				case MT_ACTIVE:
					InitFrameTextMessage(FrameText[setup->Language][8], &(desc->MiscTextCoord[5]));
					MTDisplay();
					break;
				case I_ACTIVE:
					InitFrameTextMessage(FrameText[setup->Language][0], &(desc->MiscTextCoord[0]));
					ImgDisplay();
					break;
				case A_ACTIVE:
					InitFrameTextMessage(FrameText[setup->Language][1], &(desc->MiscTextCoord[1]));
					AudDisplay();
					break;
				case V_ACTIVE:
					InitFrameTextMessage(FrameText[setup->Language][2], &(desc->MiscTextCoord[2]));
					VidDisplay();
					break;
				case FLDR_ACTIVE:
					FldrDisplay();
					break;
				default:
					break;
			}
		}else//bk @ 070709
			DrawFocusedICON(RGB0);
		///
		///070625 󴫭֭ƼҦɧsr
		if (isAudioRepeatModeChanged)
		{
			isAudioRepeatModeChanged = FALSE;
			DrawRepeatMode();
		}
		///		
		
//		reload user setting by bk @070518
//		setup->cpy_idx = 0;
//		setup->del_idx = 0;
//		setup->reset_idx = 0;
//		isUserConfirmed = FALSE;
//		LoadUserSetupFromMem();
		
		if(isUSetupNeededSaving)
			SaveUserSetup();
*/
	}
	else if(active_index == SETUP_L2_ACTIVE)
	{
		/* Flowbee */
		//pgu_enable_overlay(0);
		
//		//reload user setting by bk @070518
//		setup->cpy_idx = 0;
//		setup->del_idx = 0;
//		setup->reset_idx = 0;
//		isUserConfirmed = FALSE;
//		LoadUserSetupFromMem();
		
		ELMachines[active_index].Shutdown(0);
		active_index = SETUP_L1_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	else if(active_index == SETUP_L3_ACTIVE)
	{
		/* Flowbee */
		//pgu_enable_overlay(0);

		//reload user setting by bk @070518
		setup->cpy_idx = 0;
		setup->del_idx = 0;
		setup->reset_idx = 0;
		setup->flsh_fmt_idx = 0;
		isUserConfirmed = FALSE;
		LoadUserSetupFromMem();
		
		ELMachines[active_index].Shutdown(0);
		active_index = SETUP_L2_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
//------------------------------------------------------------------------------------------------
void CalEvent()
{
	///071012 SRTCNҰCalendar
	if (!isRTCWorking)
	{
		return;
	}
	///

	///070817 1080iȮɨSFull Image Calendar
	if (active_index == FI_ACTIVE && GetDisplayIndex() == DISP_HDTV)
	{
		return;
	}
	///

	static char *prev_selecteddev;

	if(!isInfoPressed && !isSetupPressed)
	{
		if(!isCalPressed)
		{
			//if(active_index != FI_ACTIVE)
			if(active_index == DS_ACTIVE)
			{
				prev_selecteddev = SelectedDev;
				SelectedDev = DEVICE_AUTOSS_NAME;
			}
			//bk @ 071022 - stop music
			if(active_index == FLDR_ACTIVE)
			{
				FLDR_StopEvent();
			}
#ifdef BLUETOOTH_MOD
			else if(active_index == BT_ACTIVE)
			{
				BT_StopEvent();
			}
#endif
			/* Flowbee@960613. */
			if(isVolumePressed){
				isVolumePressed = FALSE;
				#if USE_TERAWINS_TCON
				tcon_clear_mute_vol();
				#else
				TurnOffOverlayMode(-1);//turn off overlay.
				#endif
				alarm(0);//disable the alarm.
			}
			prev_active_index = active_index;
			active_index = CAL_ACTIVE;
			ELMachines[active_index].Init();
			ELMachines[active_index].Display();
			isCalPressed = TRUE;
			osd_parser();
		}
		else
		{
			/* Flowbee@960613. */
			if(isMutePressed)
				MuteEvent();
			if(isVolumePressed)
			{
				isVolumePressed = FALSE;
				#if USE_TERAWINS_TCON
				tcon_clear_mute_vol();
				#else
				TurnOffOverlayMode(-1);//turn off overlay.
				#endif
				alarm(0);//disable the alarm.
			}

			//if alarm ringing, stop the ring
			if(isCalAlarmRinging == 1)
			{
				//kill audio process
				KillCalAlarmProcess();
				isCalAlarmRinging = 0;
//				setup->alarm_setup_idx = SETUP_OFF;
//				SaveUserSetupToMem();
//				LoadUserSetupFromMem();
			}

			///070827
			//ELMachines[active_index].Display();
			///
			
			ELMachines[active_index].Shutdown(0);//shutdown CAL_ACTIVE
			if(prev_active_index == DS_ACTIVE)
				SelectedDev = prev_selecteddev;
			active_index = prev_active_index;

			///070827 fix XslideshowYLɮ׵e|
			if(active_index != FI_ACTIVE)
				ELMachines[active_index].Display();
				//DrawFocusedICON(RGB1);
			///

			if(active_index == FI_ACTIVE)
			{
				pgu_enable_overlay(0);
				pgu_switch_to_buffer(1 - yuv_idx);
			}
			else
			{
				pgu_switch_to_buffer(1);
			}
			isCalPressed = FALSE;
		}
	}
}
//------------------------------------------------------------------------------------------------

///070605 Folderƥ
void FolderEvent()
{
	// modified by Xenia, for pressing "Folder" key
	// goto "Folder" mode with the first device DPF can reach
	if(active_index == DS_ACTIVE)
	{
		ELMachines[active_index].Shutdown(0);
///080521
		MakeIAVList();

		if(!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
		{
			active_index = USB2PC_CONN_ACTIVE;
		}
#ifdef BLUETOOTH_MOD
		else if(!strcmp(SelectedDev, DEVICE_BT_NAME))
		{
			ForkBTProcesses();//TODO: in the future, it will integrated with bt setup
			active_index = BT_ACTIVE;
		}
#endif
		else
		{
			active_index = FLDR_ACTIVE;
		}
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
///
	}
	else
	{
		ELMachines[active_index].Shutdown(1);
		active_index = FLDR_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}
///

//------------------------------------------------------------------------------------------------
void MuteEvent()
{
#if 1	
	if(!isMutePressed)
	{

		/* Flowbee@960629 */
		#if USE_TERAWINS_TCON
		if (isVolumePressed){
			isVolumePressed = FALSE;
			tcon_clear_mute_vol();
			alarm(0);//disable the alarm.
		}

		if (isInfoPressed){
			isInfoPressed = FALSE;
			TurnOffOverlayMode(-1);//turn off overlay.
		}
		
		#else
		/* Flowbee */
		if (isVolumePressed || isInfoPressed){
			isVolumePressed = FALSE;
			isInfoPressed = FALSE;
			TurnOffOverlayMode(-1);//turn off overlay.
			alarm(0);//disable the alarm.
		}
		#endif
		//draw
		SetSoundDeviceVolume(0);
		/* Flowbee@960613. */
		if((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)){
			FRAME *elmf;
			elmf = &ELMachines[active_index].frame;
			SetRGBuffMSB(0, RGB0, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		}
		DrawMute();
		isMutePressed = TRUE;
///070821
#ifdef USE_DESC_TV
		if (GetDisplayIndex() != DISP_HDTV)
#endif
///
			TurnOnOverlayMode();
	}
	else
	{
		//must Reset device driver volume value
		SetSoundDeviceVolume(volume);
	#if 0	// Flowbee@960505
 		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
		TurnOffOverlayMode(-1);
	#else
		TurnOffOverlayMode(-1);
		if(!((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)))
		{
#ifdef VIDEO_TIME_DISPLAY_MOD
			memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
#else
			unsigned long buf_w, w, h;	
			pgu_get_yuv_resolution(&buf_w, &w, &h); 			
 			memset(RGB0 + buf_w * 2 * posOfMute.y, 0, RGB_VOLBUFF_SIZE);
#endif
		}
	#endif
	}
	
	DrawVolume4WinaccordMusicPage();
	DrawVolume4KingstonMusicPage();
	
#else
	//set_ir_value((unsigned long)0x6D);
 	int timer = 6;
	
	if(!isMutePressed)
	{
		isMutePressed = TRUE;
		isInfoPressed = FALSE;
		isVolumePressed = FALSE;
		
		//draw
		DrawMute();
		SetSoundDeviceVolume(0);
		TurnOnOverlayMode();
 	}
	else
	{
		//must Reset device driver volume value
		SetSoundDeviceVolume(volume);
 		memset(RGB0, 0, RGB_FRAMEBUFF_SIZE);
		TurnOffOverlayMode(-1);
	}
#endif
 }
//------------------------------------------------------------------------------------------------
void PlusEvent()
{
	int timer = 6;

	/* Flowbee@960629. */
#if USE_TERAWINS_TCON
	if (isMutePressed){
		isMutePressed = FALSE;
		tcon_clear_mute_vol();
	}
	if (isInfoPressed){
		isInfoPressed = FALSE;
		TurnOffOverlayMode(-1);
	}
#else
	if (isMutePressed || isInfoPressed){
		isMutePressed = FALSE;
		isInfoPressed = FALSE;
		TurnOffOverlayMode(-1);
	}
#endif
	//draw
#ifdef LEADTEK
	if(volume < 10)
#else
	if(isVolumePressed && volume < 10)
#endif
	{
		volume++;
		SetSoundDeviceVolume(volume);
		/* Flowbee@960613. */
		if((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)){
			FRAME *elmf;
			elmf = &ELMachines[active_index].frame;
			SetRGBuffMSB(0, RGB0, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		}
		DrawVolume();
		SaveUserSetupToMem();//save the volume value
		/* Flowbee@960408. */
		osd_parser();	
	}

	if(!isVolumePressed)
	{
		//if(isMutePressed)
		SetSoundDeviceVolume(volume);//set the volume when press the volume
		
		/* Flowbee@960613. */
		if((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)){
			FRAME *elmf;
			elmf = &ELMachines[active_index].frame;
			SetRGBuffMSB(0, RGB0, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		}
		DrawVolume();
		isVolumePressed = TRUE;	
///070821
#ifdef USE_DESC_TV
		if (GetDisplayIndex() != DISP_HDTV)
#endif
///
			TurnOnOverlayMode();
	}

	DrawVolume4WinaccordMusicPage();
	DrawVolume4KingstonMusicPage();
	
	alarm(timer);
	signal(SIGALRM, TurnOffOverlayMode);
/*
	//set_ir_value((unsigned long)0x2A);
 	int timer = 6;
	
	//draw
	if(isVolumePressed && volume < 10)
	{
		volume++;
		SetSoundDeviceVolume(volume);
	}
	DrawVolume();
	if(!isVolumePressed)
	{
 		if(isMutePressed)
			SetSoundDeviceVolume(volume);
		
		TurnOnOverlayMode();
		isVolumePressed = TRUE;
	}
	isMutePressed = FALSE;
	isInfoPressed = FALSE;
	
	alarm(timer);
	signal(SIGALRM, TurnOffOverlayMode);
*/	
}
//------------------------------------------------------------------------------------------------
void MinusEvent()
{
	int timer = 6;
	
	/* Flowbee@960629. */
	#if USE_TERAWINS_TCON
	if (isMutePressed){
		isMutePressed = FALSE;
		tcon_clear_mute_vol();
	}
	if (isInfoPressed){
		isInfoPressed = FALSE;
		TurnOffOverlayMode(-1);
	}
	#else
	if (isMutePressed || isInfoPressed){
		isMutePressed = FALSE;
		isInfoPressed = FALSE;
		TurnOffOverlayMode(-1);
	}
	#endif
	//draw
#ifdef LEADTEK
	if(volume > 0)
#else
	if(isVolumePressed && volume > 0)
#endif
	{
		volume--;
		SetSoundDeviceVolume(volume);
		/* Flowbee@960613. */
		if((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)){
			FRAME *elmf;
			elmf = &ELMachines[active_index].frame;
			SetRGBuffMSB(0, RGB0, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		}
		DrawVolume();
		SaveUserSetupToMem();//save the volume value
		/* Flowbee@960408. */
		osd_parser();			
	}
	
	if(!isVolumePressed)
	{
 		//if(isMutePressed)
		SetSoundDeviceVolume(volume);//set the volume when press the volume
		
		/* Flowbee@960613. */
		if((active_index == CAL_ACTIVE) && (prev_active_index == FI_ACTIVE)){
			FRAME *elmf;
			elmf = &ELMachines[active_index].frame;
			SetRGBuffMSB(0, RGB0, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height, WHITE_555);
		}
		DrawVolume();
		isVolumePressed = TRUE;
///070821
#ifdef USE_DESC_TV
		if (GetDisplayIndex() != DISP_HDTV)
#endif
///
		TurnOnOverlayMode();
	}
	
	DrawVolume4WinaccordMusicPage();
	DrawVolume4KingstonMusicPage();
	
	alarm(timer);
	signal(SIGALRM, TurnOffOverlayMode);
	
/*
	//set_ir_value((unsigned long)0x2F);
 	int timer = 6;
	
	//draw
	if(isVolumePressed && volume > 0)
	{
		volume--;
		SetSoundDeviceVolume(volume);
	}
	DrawVolume();
	if(!isVolumePressed)
	{
 		if(isMutePressed)
			SetSoundDeviceVolume(volume);
		
		TurnOnOverlayMode();
		isVolumePressed = TRUE;
	}
	isMutePressed = FALSE;
	isInfoPressed = FALSE;
	
	alarm(timer);
	signal(SIGALRM, TurnOffOverlayMode);
*/	
}
