#ifndef _MACHINE_SHUTDOWN_HEADER_
#define _MACHINE_SHUTDOWN_HEADER_
#include "skydemo.h"
//------------------------------------------------------------------------------------------------
void KillImageProcess();
void KillAudioProcess();
void KillTrProcess();
void KillVideoProcess();
#ifdef BLUETOOTH_MOD
void KillBTProcesses();
#endif
#ifdef NET_MOD
void KillRSSProcess();
#endif
void KillFldrAudioProcess();
void KillFldrVideoProcess();

void FreeBackgroundBuff();
void ResetBackgroundInfo();
void FreeICONBuffer();
void FreeICONS();
void FreeOSDBuffer();
void FreeRGBTemplateBuffer();
void FreeVolumeBuffer();

void DSShutDown();
void MTShutDown();
void SetupL1ShutDown();
void SetupL2ShutDown();
void SetupL3ShutDown();
void ImgShutDown();
void FImgShutDown();
void AudShutDown();
void VidShutDown();
void FVidShutDown();
void SSShutDown();
void USB2PConnShutDown();
void NoStorageShutDown();
void ConfirmShutDown();
void CalShutDown();
void FldrShutDown();

///070629
void FWUpgradeInit();
///
#ifdef BLUETOOTH_MOD
void BTShutDown();
#endif
void FldrFIShutDown();
void FldrFVShutDown();
void CloseOSD();
#ifdef NET_MOD
///080321
void NetDSShutDown();

//rywu20080516
#ifdef SUPPORT_RSS
void RSSShutDown();
#endif

#endif
#ifdef HD_AUTOCP_MOD
void HDAutoCPShutDown();
#endif
#ifdef IP_CAM_MOD
void IPCamShutDown();
#endif
void ExtraShutdown();
void MachineShutDown(Uint8 extra);
//------------------------------------------------------------------------------------------------
#endif
