#include "monitordevs.h"
#include "ir.h"
//------------------------------------------------------------------------------------------------
void HandleDeviceInOut()
{
	Uint8 new_num_enabled_dev;

	//MSG("Checking Device IN or OUT...\n");
	SavePrevMountedDeviceStatus();
	num_mounted_dev = RenewDeviceMountedStatus(num_mounted_dev);
	//DPRINTF("***num_mounted_dev = %d\n", num_mounted_dev);

	//DPRINTF("num_enabled_dev = %d\n", num_enabled_dev);
	new_num_enabled_dev = RenewUSB2PCConn(num_mounted_dev);
	//DPRINTF("new_num_enabled_dev = %d\n", new_num_enabled_dev);

#ifdef BLUETOOTH_MOD
	new_num_enabled_dev = new_num_enabled_dev + (isBTDonglePlugged()? 1 : 0);
#endif

//#ifdef IP_CAM_MOD
//	new_num_enabled_dev = RenewIPCamStatus(new_num_enabled_dev);
//#endif

#ifdef NET_MOD
	//DPRINTF("num_enabled_dev = %d\n", num_enabled_dev);
	//DPRINTF("new_num_enabled_dev = %d\n", new_num_enabled_dev);
	RenewNetDongle(&new_num_enabled_dev);
	//DPRINTF("***new_num_enabled_dev = %d\n", new_num_enabled_dev);
#endif

	if(new_num_enabled_dev < num_enabled_dev)
	{
		pgu_enable_overlay(0);
		//MSG("Device OUT occurred!\n");
		//DMSG("new_num_enabled_dev < old_num_enabled_dev\n");
		//DPRINTF("%d < %d\n", new_num_enabled_dev, num_enabled_dev);
#if 0
		if(active_index == DS_ACTIVE)
		{
			CloseSystem();
			InitSystem();
		}
		else// some media type is playing!!!
		{
			if((!strcmp(SelectedDev, DEVICE_AUTOSS_NAME)) ||
			    (!strcmp(SelectedDev, DEVICE_HD_NAME) && !dev_mnted_enbled_flags.hd) ||
			    (!strcmp(SelectedDev, DEVICE_SDMMC_NAME) && !dev_mnted_enbled_flags.sdmmc) ||
			    (!strcmp(SelectedDev, DEVICE_CF_NAME) && !dev_mnted_enbled_flags.cf) ||
			    (!strcmp(SelectedDev, DEVICE_xD_NAME) && !dev_mnted_enbled_flags.xdsm) ||
			    (!strcmp(SelectedDev, DEVICE_MS_NAME) && !dev_mnted_enbled_flags.msx) ||
			    (!strcmp(SelectedDev, DEVICE_USB_NAME) && !dev_mnted_enbled_flags.usb) ||
			    (!strcmp(SelectedDev, DEVICE_CARD_READER_NAME) && !dev_mnted_enbled_flags.usb2pconn))
			{
				CloseSystem();
				InitSystem();
			}
			else
				num_enabled_dev = new_num_enabled_dev;
		}
#else
		//modified for new card io rule by bk @ 070626
		//when USB2PC_CONN_ACTIVE, it will unmount all ds, so it will go into this condition
		if(active_index == USB2PC_CONN_ACTIVE)
		{
			num_enabled_dev = new_num_enabled_dev;
		}
		else
		{
			CloseSystem();
			InitSystem(INITSYS_CALL_BY_NORMAL);
		}
#endif
	}
	if(new_num_enabled_dev > num_enabled_dev)
	{
		pgu_enable_overlay(0);
		//MSG("Device IN occurred!\n");
		//DMSG("new_num_enabled_dev > old_num_enabled_dev\n");
		//DPRINTF("%d > %d\n", new_num_enabled_dev, num_enabled_dev);
#if 0
		if(active_index == DS_ACTIVE)
		{
			CloseSystem();
			InitSystem();
		}
		else
			num_enabled_dev = new_num_enabled_dev;
#else
		//modified for new card io rule by bk @ 070626
		if(active_index == USB2PC_CONN_ACTIVE)
		{
			num_enabled_dev = new_num_enabled_dev;
		}
		else
		{
			CloseSystem();
			InitSystem(INITSYS_CALL_BY_NORMAL);
			
			//rywu20080603 fix bug of no invoking netSocket after booting
			//p.s. netSocket should be invoked after system booting, no matter it is forced IP or DHCP.
#ifdef NET_MOD
			if (isSocketCreated == FALSE)
            {
                ForkNETSocket();
            }
#endif
		}
#endif
	}
}
//------------------------------------------------------------------------------------------------
void MonitorDevices()
{
//#define open
#ifdef open
	static Uint8 pass = 0;
	pass++;
	if(!(pass % 10))
	{
#endif
		HandleDeviceInOut();
#ifdef open
		pass = 0;
	}
#endif
}
