#include <linux/reboot.h>//rywu20080709
#include "monitormisc.h"
#include "parser.h"

///080507
#include "types.h"
#ifdef WEB_APP_MOD
#include "webapp.h"
#endif
///
//------------------------------------------------------------------------------------------------
static volatile sig_atomic_t isAlarmSignalFired = FALSE;
static volatile sig_atomic_t isPwrSavAlarmSet = FALSE;
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
extern Uint8 isGWSet;
#endif

#ifdef SUPPORT_RSS
extern void framechannel_thread(RSS_SESSION_INFO_ID rss_session);
#endif

/**
  *	refresh Calendar Display every minute, and control the pgu power saving status
  */
void RefreshCalDisplay(Sint8 mns)
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	COORD posOfAnlgClck, posOfDate, posOfDgtlClck, posOfClndr;
	///070815
	Uint8* dest = RGB1;
	if (prev_active_index == FI_ACTIVE) dest = RGB0;
	///

	if (prev_active_index == FI_ACTIVE)
	{
		posOfAnlgClck.x = desc->MiscTextCoord[34].x - 100;
		posOfAnlgClck.y = desc->MiscTextCoord[34].y - 100;
		posOfAnlgClck.width = 201;
		posOfAnlgClck.height = 201;
		posOfDate = desc->MiscTextCoord[32];
		//posOfDgtlClck	= desc->MiscTextCoord[35];
		//posOfClndr = desc->MiscTextCoord[33];
	}
	else
	{
		posOfAnlgClck.x = desc->MiscTextCoord[15].x - 100;
		posOfAnlgClck.y = desc->MiscTextCoord[15].y - 100;
		posOfAnlgClck.width = 201;
		posOfAnlgClck.height = 201;
		posOfDate = desc->MiscTextCoord[26];
		posOfDgtlClck	= desc->MiscTextCoord[10];
		posOfClndr = desc->MiscTextCoord[11];
	}

	//memset(elmf->rgbtemplate, 0, RGB_FRAMEBUFF_SIZE);
	//DrawFrameBackground(elmf->rgbtemplate);
	//DrawFrameTextMessage(elmf->rgbtemplate, BLACK_1555);

	///070814
	DrawCalendarTime(dest, 0, mns);
	//DrawCalendarTime(RGB0/*elmf->rgbtemplate*/, 0, mns);
	///

	if(prev_active_index == FI_ACTIVE)
	{
		//pgu_set_alpha(setup->cal_alpha);
		//pgu_enable_overlay(1);
		//SetRGBuffMSB(0, elmf->rgbtemplate, 1, elmf->framecoord.x, elmf->framecoord.y, elmf->framecoord.width, elmf->framecoord.height);

		///070814
		SetRGBuffBlockMSB(0, dest, 1, posOfDate.x, posOfDate.y, posOfDate.width, posOfDate.height, WHITE_555);
		SetRGBuffBlockMSB(0, dest, 1, posOfAnlgClck.x, posOfAnlgClck.y, posOfAnlgClck.width, posOfAnlgClck.height, WHITE_555);
		//SetRGBuffBlockMSB(0, RGB0/*elmf->rgbtemplate*/, 1, posOfDate.x, posOfDate.y, posOfDate.width, posOfDate.height, WHITE_555);
		//SetRGBuffBlockMSB(0, RGB0/*elmf->rgbtemplate*/, 1, posOfAnlgClck.x, posOfAnlgClck.y, posOfAnlgClck.width, posOfAnlgClck.height, WHITE_555);
		///

		//SetRGBuffBlockMSB(0, elmf->rgbtemplate, 1, posOfDgtlClck.x, posOfDgtlClck.y, posOfDgtlClck.width, posOfDgtlClck.height, WHITE_555);
		//SetRGBuffBlockMSB(0, elmf->rgbtemplate, 1, posOfClndr.x, posOfClndr.y, posOfClndr.width, posOfClndr.height, WHITE_555);
		//
//		if(isMutePressed)
//			DrawMute();
//		if(isVolumePressed)
//			DrawVolume();
//		osd_parser();
	}
	else
	{
		//comment and modified for updating block by bk @ 070608
		////RBG->YUV for TV encoder
		//memcpy(RGB0, elmf->rgbtemplate, RGB_FRAMEBUFF_SIZE);
		///* Flowbee */
		//RGB2YUV(0, 0);
//		if(isMutePressed)
//			DrawMute();
//		if(isVolumePressed)
//			DrawVolume();
//		osd_parser();
//
//		if(!(isVolumePressed || isMutePressed)){
//			pgu_switch_to_buffer(0);
//		}
	}

	#if USE_TERAWINS_TCON

	#else
	if(isMutePressed)
		DrawMute();
	#ifndef WINGUI
	if(isVolumePressed)
		DrawVolume();
	#endif
	#endif

///070821
#ifdef USE_DESC_TV
	if (GetDisplayIndex() != DISP_HDTV)
#endif
///
		osd_parser();
}
//------------------------------------------------------------------------------------------------
void RefreshAudioPlayingTime()
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	Sint16 t;
	static Sint16 preT = -1, x = 0, y = 0, w = 0, h = 0;
	char time[LEN_M];

	if(active_index == A_ACTIVE)
	{
		x = desc->MiscTextCoord[37].x;
		y = desc->MiscTextCoord[37].y;
	}
	else//active_index == FLDR_ACTIVE || active_index == BT_ACTIVE
	{
		x = desc->MiscTextCoord[42].x;
		y = desc->MiscTextCoord[42].y;
	}
	h = g_pFontDB_Local->FontSize;
	//
	t = get_mplayer_play_time();
	if(preT != t)
	{
		sprintf(time, "%2d:%02d", t / 60, t % 60);
		w = GetFontStringWidth(g_pFontDB_Default, time);
		//erase
		DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate, x - w, y, w, h);
		//
		if(isOnlyAudPrcsForked || isFldrAudPrcsForked)
		{
			#ifdef LEADTEK
			FontTextOutFormat(g_pFontDB_Default, (Uint16 *)RGB1, x, y, time, LTK_ORANGE, DT_RIGHT);
			#else
			#ifndef DARK_BLUE_DESIGN
			FontTextOutFormat(g_pFontDB_Default, (Uint16 *)RGB1, x, y, time, BLUE_1555, DT_RIGHT);
			#else
			FontTextOutFormat(g_pFontDB_Default, (Uint16 *)RGB1, x, y, time, MUSIC_DURATION, DT_RIGHT);
			#endif
			#endif
			RGBlock2YUVBlock(RGB1, 1, x - w, y, w, h);

			if (isInfoPressed)
			{
				RGBlock2YUVBlock(RGB1, 0, x - w, y, w, h);
			}
		}
		//
		preT = t;
	}

	//display for stop, end
	if(!(isOnlyAudPrcsForked || isFldrAudPrcsForked))
	{
		strcpy(time, "--:--");
		w = GetFontStringWidth(g_pFontDB_Default, time);
		DuplicateBlockBitmap((Uint16 *)RGB1, (Uint16 *)elmf->rgbtemplate, x - w, y, w, h);
		#ifndef DARK_BLUE_DESIGN
		FontTextOutFormat(g_pFontDB_Default, (Uint16 *)RGB1, x, y, time, BLUE_1555, DT_RIGHT);
		#else
		FontTextOutFormat(g_pFontDB_Default, (Uint16 *)RGB1, x, y, time, MUSIC_DURATION, DT_RIGHT);
		#endif
		RGBlock2YUVBlock(RGB1, 1, x - w, y, w, h);

		if (isInfoPressed)
		{
			RGBlock2YUVBlock(RGB1, 0, x - w, y, w, h);
		}
	}
}
//------------------------------------------------------------------------------------------------
void RefreshVideoPlayingTime()
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	static Sint16 preT= -1;
	Sint16 t, d, displayType;
	Uint16 x, y, w, h, i;
	Uint32 offset = 0;
	unsigned long   buf_w, resW, resH;
	char time[LEN_L];//time (duration)
	static char duration[LEN_M];

	Uint16 FONT_HEIGHT = g_pFontDB_Default->FontSize;
///070831
#ifdef USE_DESC_TV
	if (g_pFontDB_Default->bScaleDown)
	{
		FONT_HEIGHT >>= 1;
	}
#endif
///

	t = get_mplayer_play_time();
	if(preT != t)
	{
		//get duration
		d = get_mplayer_play_duration();
		sprintf(duration, " (%02d:%02d:%02d)", d / 3600 , (d % 3600) / 60, d % 60);
		//format time, and concate duration
#ifdef USE_DESC_LCD	//adding spaces for centralization if displaying on LCD
		sprintf(time, "     %02d:%02d:%02d", t / 3600 , (t % 3600) / 60, t % 60);
#else
		sprintf(time, "%02d:%02d:%02d", t / 3600 , (t % 3600) / 60, t % 60);
#endif
		strcat(time, duration);

		//display
		displayType = GetDisplayIndex();
		if(
				displayType == DISP_800x600_LCD
			|| 	displayType == DISP_800x480_LCD
			|| 	displayType == DISP_1024x600_LCD
			|| 	displayType == DISP_800x480_LCD_25MHZ
		)
		{
			//pgu_clear_mplayer_time();
			//
			if(isVidPrcsForked || isFldrVidPrcsForked)
				tcon_show_time(time);
		}else
		{
			pgu_get_yuv_resolution(&buf_w, &resW, &resH);
			w = GetFontStringWidth(g_pFontDB_Default, time);
			h = FONT_HEIGHT;
			x = (buf_w - w) >> 1;
			if(resH < 450)
				y = y = resH - h - 2;
			else
				y = resH - h - 14;
			//clean
			offset = (y * buf_w + x) << 1;
			for(i = 0; i < h; i++)
			{
				memset(RGB0 + offset, 0, w << 1);
				offset += (buf_w << 1);
			}
			//
			//marked, because of checking by isVideoForked
			//if(isVidPrcsForked || isFldrVidPrcsForked)
				FontTextOutAlign(g_pFontDB_Default, (Uint16 *)RGB0, (Uint16)buf_w, x, y, 0, time, WHITE_1555);
			//
			pgu_enable_tv_osd(1);
		}

		preT = t;
	}
}
//------------------------------------------------------------------------------------------------
void MonitorCalAlarm()
{
#define ALARM_TIMES		3//larger than 0
	static struct timeval ctv, atv;
	static Uint8 timesOfAlarm = 0;
	time_t t;
	struct tm tm;
	FileInfo finfo;
	int prio, interval = 0, intervalTime = 10, alarmTime = intervalTime >> 1;
	time_t diff = 0;
	char *s = CAL_ALARM_DEFAULT_RING, *userRing = CAL_ALARM_USER_RING;

	if(setup->alarm_setup_idx == SETUP_ON)
	{
		if(isCalAlarmRinging != -1)
		{
			gettimeofday(&ctv, NULL);
			if(ctv.tv_sec > 86400 + atv.tv_sec)
				gettimeofday(&atv, NULL);
			diff = ctv.tv_sec - atv.tv_sec;
			interval = (diff / (intervalTime * 60)) + 1;
		}

		if(isCalAlarmRinging == -1)//today is not playable
		{
			time(&t);
			memcpy(&tm, localtime(&t), sizeof(tm));
			if((tm.tm_hour == setup->alarm_hour) && (tm.tm_min == setup->alarm_minute) && tm.tm_sec < 2)//time's up
			{
				gettimeofday(&atv, NULL);
				isCalAlarmRinging = 0;
			}

			timesOfAlarm = 0;
		}
		else if(isCalAlarmRinging == 0)//today is playable
		{
			if(interval > ALARM_TIMES)//today is not playable
			{
				isCalAlarmRinging = -1;
				timesOfAlarm = 0;
				return;
			}

			if(timesOfAlarm < interval)
			{
				isCalAlarmRinging = 1;
				timesOfAlarm ++;
			}else if(timesOfAlarm == interval)//this interval's alarm has played
				;
			else if(timesOfAlarm > interval)//unreasonable, set the status that today is not playable
			{
				isCalAlarmRinging = -1;
				timesOfAlarm = 0;
				return;
			}

			//time's up
			if(isCalAlarmRinging == 1)
			{
				//turn on volume if mute
				if(isMutePressed)
					MuteEvent();

				//kill audio process if audio playing
				KillAudioProcess();
				isSSAudPrcsForked = FALSE;

				//select the ring (default or user)
				if(MediaParser(userRing, &finfo) == PlayableMusic)
					s = userRing;

				//playing alarm
				pid_aud = fork();
				switch(pid_aud)
				{
					case -1:
						perror("Fork failed!");
						DPRINTF("Fork to Play Alarm Ring '%s' for Calendar Fail!\n", s);
						break;
						//exit(1);
					case 0:
						//child process
						execl("/sky/mplayer", "mplayer", "-acache", "-arcdemo", "-really-quiet", "-novideo", "-loop", "10", s, NULL);
						_EXIT;
					default:
						//parent process
						//isSSAudPrcsForked = TRUE;
						prio = getpriority(PRIO_PROCESS, (int)pid_aud);
			  			setpriority(PRIO_PROCESS, (int)pid_aud, prio - 15);
						break;
				}

				//Draw Alarm Info
				if(prev_active_index != FI_ACTIVE)
					DrawAlarmInfo(RGB1, 0);
				else
					DrawAlarmInfo(RGB0, 0);
			}
		}
		else if(isCalAlarmRinging == 1)//ringing, check if end of the ring (no one pressed to stop)
		{
			if(waitpid(pid_aud, &sts_aud, WNOHANG))//end of the ring
			{
				isCalAlarmRinging = 0;
//				setup->alarm_setup_idx = SETUP_OFF;
//				SaveUserSetupToMem();
//				LoadUserSetupFromMem();

				//Draw Alarm Info
				if(prev_active_index != FI_ACTIVE)
					DrawAlarmInfo(RGB1, 0);
				else
					DrawAlarmInfo(RGB0, 0);
			}
			else//stop the alarm automatic when half of the interval (To avoid too long user defined alarm)
			{
				if((interval * intervalTime - alarmTime) * 60 < diff)
					Cal_EnterEvent();
			}
		}

		//system("date");PRINTF("=%d=%ld=%d=%d=\n", isCalAlarmRinging, diff, interval, timesOfAlarm);
	}
}
//------------------------------------------------------------------------------------------------
Uint8 CheckIfOnPwrSavMode()
{
	if(setup->PowerSavingMode != 0)
	{
		if(!isBacklightPGUTurnedOn)
		{
			if(!TurnBacklightPGU(1))
			{
				//DMSG("Turn ON the Backlight and PGU successfully!\n");
				isBacklightPGUTurnedOn = TRUE;
				isPwrSavAlarmSet = FALSE;
				//modified to renew caldisplay by bk@070426
				if(isCalPressed)
					RefreshCalDisplay(0);
			}
			return 1;
		}
		else
		{
			if(!isVolumePressed)
			{
				alarm(0);
				//DMSG("Backlight & PGU alarm is clear!\n");
				isPwrSavAlarmSet = FALSE;
			}
			return 0;
		}
	}
	return 0;
}
//------------------------------------------------------------------------------------------------
void BL_PGU_SignalHandler(int sig)
{
	isAlarmSignalFired = TRUE;
}
//------------------------------------------------------------------------------------------------
void MonitorPwrSavAlarm()
{
	struct sigaction act;

	if(setup->PowerSavingMode != 0 && isBacklightPGUTurnedOn && !isVolumePressed)
	{
		if(!isPwrSavAlarmSet)
		{
			isPwrSavAlarmSet = TRUE;
			//set alarm
			alarm(setup->PowerSavingMode * 60);//Off(0) or 5 or 15 or 30 mins
			//DMSG("Backlight & PGU alarm is set!\n");
			//PRINTF("After %d mins to turn off the backlight and pgu!\n", setup->PowerSavingMode);

			//register signal handler for backlight and pgu
			memset(&act, 0, sizeof(act));
			act.sa_handler = BL_PGU_SignalHandler;
			sigemptyset(&act.sa_mask);
			act.sa_flags = 0;
			sigaction(SIGALRM, &act, NULL);
		}
		if(isAlarmSignalFired)
		{
			isAlarmSignalFired = FALSE;
			if(!TurnBacklightPGU(0))
			{
				//DMSG("Turn OFF the Backlight and PGU successfully!\n");
				isBacklightPGUTurnedOn = FALSE;
			}
		}
	}
}
//------------------------------------------------------------------------------------------------
void MonitorCalTime()
{
	static Uint8 c = 0;

	//modified to renew caldisplay by bk@070426
	if(active_index == CAL_ACTIVE && isCalPressed)//CAL_ACTIVE
	{
		c = (c + 1) % 3;
		if(c == 0)
		{
			RefreshCalDisplay(0);
			MonitorCalAlarm();
		}
	}
}
//------------------------------------------------------------------------------------------------
void MonitorAutoPwrOff()
{
	static Uint8 c = 0;
	Uint8 isTimeUp = FALSE;
	time_t t;
	struct tm tm;
	pid_t pid;
	int status;

	if(setup->autopwr_setup_idx == SETUP_ON)
	{
		c = (c + 1) % 10;
		if(c == 0)
		{
			time(&t);
			memcpy(&tm, localtime(&t), sizeof(tm));
		#if defined(GUI_STYLE_COMTEK)
			if((isCalSaveSetupFlag==0)&&(tm.tm_hour==setup->cal_autopwr_off_hour[tm.tm_wday] && tm.tm_min==setup->cal_autopwr_off_minute[tm.tm_wday])){
				isCalSaveSetupFlag = 1; //Working.
				if(setup->cal_program_download[tm.tm_wday]==TRUE)
					SaveCalProgDownload();
				SaveUserSetup();
				SaveCalAutoPwrOnSetupToRTC(tm); //Save power on
				isCalSaveSetupFlag = 2; //OK.
			}
			else if(isCalSaveSetupFlag==2){
				isTimeUp = TRUE;
			}
		#else
			if(tm.tm_hour == setup->autopwr_off_hour && tm.tm_min == setup->autopwr_off_minute)//time's up
				isTimeUp = TRUE;
		#endif
		}
//		if(
//				active_index == SETUP_L1_ACTIVE ||
//				active_index == SETUP_L2_ACTIVE ||
//				active_index == SETUP_L3_ACTIVE
//			)
//				isTimeUp = FALSE;
   		if(isTimeUp && active_index != SETUP_L1_ACTIVE && active_index != SETUP_L2_ACTIVE
				&& active_index != SETUP_L3_ACTIVE && active_index != USB2PC_CONN_ACTIVE
				&& active_index != CONFIRM_ACTIVE)//not writing file issue
		{
			UmountAllDevices();
			pid = fork();
			switch(pid)
			{
				case -1:
					perror("fork failure!");
					DMSG("Fork to Power Off Fail!");
					break;
					//_EXIT;
				case 0:
					//child process
					execl("/sbin/sysctl", "sysctl", "-w", "skrtc.off=1", NULL);
					_EXIT;
				default:
					//parent process
					waitpid(pid, &status, 0);
					//PRINTF("Time to power off!!!\n");
					break;
			}
		}
		//else
		//	BP;
	}else
		isTimeUp = FALSE;
}
//------------------------------------------------------------------------------------------------
void MonitorAudioTime()
{
	static Uint8 c = 0;
	//CANNOT take out if(active_index == A_ACTIVE) because there is a ghost image of showing pass-by time
	//when pressing setup menu in audio mode
	if(
		active_index == A_ACTIVE
		|| active_index == FLDR_ACTIVE
#ifdef BLUETOOTH_MOD
		|| active_index == BT_ACTIVE
#endif
	  )
	{
//		c = (c + 1) % 8;
//		if(c == 0)
			RefreshAudioPlayingTime();
	}
}
//------------------------------------------------------------------------------------------------
void MonitorVideoTime()
{
	//marked, because of checking by isVideoForked
	//if(active_index == FV_ACTIVE)//Full Video Active
	if(setup->vid_time_dsply_idx == SETUP_ON)//display video time
		RefreshVideoPlayingTime();
}
//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
void MonitorBTAction()//tx, rx, del, ftp
{
	static Uint8 counter = 60;//usage for msg disappearing
	COORD *pos = &(desc->MiscTextCoord[40]);
	FRAME *elmf;
	char status[LEN_L];
	FLIST *tmpList;

	pos->height = g_pFontDB_Local->FontSize;
	elmf = &ELMachines[BT_ACTIVE].frame;

	if(!isBTPrcsForked)//shared memory is not ready
		return;

	if(!isBTPrcssBusy)
	{
		if(BTActNum != smbt->sn)//new action
		{
			//BTActNum = smbt->sn;
			isBTPrcssBusy = TRUE;

			//erase the old msg
			if(active_index == BT_ACTIVE)
			{
				DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->rgbtemplate, pos->x, pos->y, pos->width, pos->height);
				RGBlock2YUVBlock(RGB1, 1, pos->x, pos->y, pos->width, pos->height);
			}

			counter = 0;
		}else//action finish
		{
			if(counter < 60)
				counter++;
			else if(counter == 60)
			{
				//erase
				if(active_index == BT_ACTIVE)
				{
					DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->rgbtemplate, pos->x, pos->y, pos->width, pos->height);
					RGBlock2YUVBlock(RGB1, 1, pos->x, pos->y, pos->width, pos->height);
				}

				counter++;
			}
		}
	}

	if(isBTPrcssBusy && !strcmp(SelectedDev, DEVICE_BT_NAME))//bt is busy && bt folder view, draw bt status
	{
		memset(status, 0, LEN_L);
		strcpy(status, "");
		switch(smbt->dir)
		{
			case BT_DIR_SEND:
				strcat(status, FrameText[setup->Language][30]);
				break;
			case BT_DIR_RECV:
				strcat(status, FrameText[setup->Language][31]);
				break;
			case BT_DIR_DEL:
				strcat(status, FrameText[setup->Language][32]);
				break;
		}
		strcat(status, ": ");

		if(smbt->dir == BT_DIR_SEND || smbt->dir == BT_DIR_RECV)//Tx or Rx
		{
			if(smbt->status == BT_STATE_ABORT)//action complete - abort
			{
				strcat(status, FrameText[setup->Language][33]);
				isBTPrcssBusy = FALSE;
				BTActNum = smbt->sn;

				//rebuild the list if the driver kill the file
				FolderList_Free(&FolderList);
				FolderList = FolderList_Build(".");
				elmf->active_icon_index = 0;
				if(active_index == BT_ACTIVE)
					BTDisplay();

				if(smbt->dir == BT_DIR_SEND)//Tx
					waitpid(pid_bt_orz, &sts_orz, 0);//while(waitpid(pid_bt_orz, &sts_orz, 0) <= 0);//used for call by fork, not system
			}else if(smbt->status == BT_STATE_FAIL)//action complete - fail
			{
				strcat(status, FrameText[setup->Language][34]);
				isBTPrcssBusy = FALSE;
				BTActNum = smbt->sn;

				//rebuild the list if the driver kill the file
				FolderList_Free(&FolderList);
				FolderList = FolderList_Build(".");
				elmf->active_icon_index = 0;
				if(active_index == BT_ACTIVE)
					BTDisplay();

				if(smbt->dir == BT_DIR_SEND)//Tx
					waitpid(pid_bt_orz, &sts_orz, 0);//while(waitpid(pid_bt_orz, &sts_orz, 0) <= 0);//used for call by fork, not system
			}else if(smbt->status == 100)//action complete - success
			{
				strcat(status, "100%");
				isBTPrcssBusy = FALSE;
				BTActNum = smbt->sn;

				//update folder
				chdir(BT_PATH);
				FolderList_Free(&FolderList);
				FolderList = FolderList_Build(".");
				tmpList = FolderList;
				elmf->active_icon_index = 0;
				while(FolderList)
				{
					if(((FolderList->attribute & Mask_IsDir) == 0) && !strcasecmp(smbt->name, FolderList->fname))
						break;
					else
						FolderList = FolderList->next;
				}
				if(!FolderList)
					FolderList = tmpList;

				//display
				if(smbt->dir == BT_DIR_RECV)//receive
				{
					if(active_index == FLDR_FI_ACTIVE)
						FLDR_FI_EscEvent();
					else if(active_index == FLDR_FV_ACTIVE)
						FLDR_FV_EscEvent();
					else if(active_index == BT_ACTIVE)
						BTDisplay();
					BT_EnterEvent();
				}else//send
				{
					if(active_index == BT_ACTIVE)
						BTDisplay();
				}

				if(smbt->dir == BT_DIR_SEND)//Tx
					waitpid(pid_bt_orz, &sts_orz, 0);//used for call by fork, not system
			}
			else if(0 <= smbt->status && smbt->status < 100)//progress, 0~99
			{
				char prcntg[15];
				memset(prcntg, 0, 15);
				sprintf(prcntg, "%d%%", smbt->status);
				strcat(status, prcntg);
			}
		}
		else//delete
		{
			strcat(status, smbt->name);
			isBTPrcssBusy = FALSE;
			BTActNum = smbt->sn;

			FolderList_Free(&FolderList);
			FolderList = FolderList_Build(".");
			elmf->active_icon_index = 0;
			if(active_index == BT_ACTIVE)
				BTDisplay();
		}

		strcat(status, "!");
		DPRINTF("%s\n", status);

		//msg display
		if(active_index == BT_ACTIVE)
		{
			DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->rgbtemplate, pos->x, pos->y, pos->width, pos->height);
			FontTextOutAlign(g_pFontDB_Local, (WORD*)RGB1, OUTPUT_XRES,
				pos->x, pos->y, pos->width, (BYTE*)status, BLUE_1555);
			RGBlock2YUVBlock(RGB1, 1, pos->x, pos->y, pos->width, pos->height);
		}
	}
}
//------------------------------------------------------------------------------------------------
void MonitorScanningOPushDvcs()//monitor scanning opush devices status
{
	if(isBTPrcsForked)//must be in BT_ACTIVE
	{
		if(isBTScanningOPush)//just scanning Object Push Devices
		{
			if(smbtop->complete)//scanning finished, update device list
			{
				DMSG("Scanning Object Push Devices is finished!\n");
				{//important!!! the order can't be changed!!!
					//reset the flag
					smbtop->complete = FALSE;
					isBTScanningOPush = FALSE;
					SaveBTDeviceList();

					//display
					currBTDvcIdx = 0;
					if(active_index == BT_ACTIVE)
						UpdateBTDvcDisplay();
					while(waitpid(pid_bt_orz, &sts_orz, 0) <= 0);//used for call by fork, not system
					//system("date");//TODO: for scanning test
				}
			}
			//else
			//	;//waiting for scanning finished
		}//else	;//no scanning, bye-bye
	}//else ;//no in BT_ACTIVE, bye-bye
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef TV_SWITCH_MOD
Uint8 MonitorTVSwitch()
{
#ifdef LBC	//for LBC
	Uint32 DataArray[2] = {1, -1}, DataArray4EGPIO[2] = {3, -1}
			, GPIO = 0, EGPIO = 4, valOfGPIO = 0, valOfEGPIO= 0;

	ioctl(tv_switch_fd, GET_GPIO_REG, DataArray);
	ioctl(tv_switch_fd, GET_GPIO_REG, DataArray4EGPIO);
	valOfGPIO = (DataArray[1] & (1 << GPIO)) >> GPIO;
	valOfEGPIO = (DataArray4EGPIO[1] & (1 << EGPIO)) >> EGPIO;

	if(0)
	{
		PRINTF("GPIO(%d): %d; EGPIO(%d):%d =>:%s - %x - %x\n",
			GPIO,
			valOfGPIO,
			EGPIO,
			valOfEGPIO,
			(valOfEGPIO? "VGA" : (valOfGPIO? "CVBS" : "YPbPr")),
			DataArray[1],
			DataArray4EGPIO[1]
		);
	}

	return (valOfEGPIO? CVBS : (valOfGPIO? CVBS : YPbPr));//TODO - force set VGA to CVBS temporarily
#else
#ifndef TV_SWITCH_GPIO
	#define TV_SWITCH_GPIO		0//set default define to medialink's value
#endif
	//the 1st array is used for GPIO. 2nd array is used for EGPIO
	Uint32 DataArray[2][2] = {{ 1, -1 }, { 3, -1 }}, ret;

	ioctl(tv_switch_fd, GET_GPIO_REG, DataArray[0]);

	//check 1st GPIO define, it must check
	if(DataArray[0][1] & (1 << TV_SWITCH_GPIO))
		ret = YPbPr;
	else
		ret = CVBS;
	//printf("0x%04x; ", DataArray[0][1]);
	//printf("GPIO(%d): %d; ", TV_SWITCH_GPIO, (DataArray[0][1] & (1 << TV_SWITCH_GPIO)) >> TV_SWITCH_GPIO);

	//check 2nd GPIO define, now is used for foxconn
#ifdef TV_SWITCH_GPIO2
	if(ret == CVBS)
	{
		if(DataArray[0][1] & (1 << TV_SWITCH_GPIO2))
			ret = CVBS_PAL;
	}
	//printf("GPIO(%d): %d; ", TV_SWITCH_GPIO2, (DataArray[0][1] & (1 << TV_SWITCH_GPIO2)) >> TV_SWITCH_GPIO2);
#else
  #ifdef TV_CVBS_OUTPUT_IS_576I
	if(ret == CVBS)
		ret = CVBS_PAL;
  #endif
#endif

	//printf("%s\n", (ret == YPbPr)? "YPbPr" : (ret == CVBS_PAL)? "PAL" : "NTSC");

	return ret;
#endif
}
//------------------------------------------------------------------------------------------------
//xsTVXҦ,HѤU}skydemo_X
//YPbPr -> NTSC -> PAL
void SWTVSwitch()
{
	//get the next value
	if(TVIF == YPbPr)
		TVIF = CVBS;
	else if(TVIF == CVBS)
		TVIF = CVBS_PAL;
	else
		TVIF = YPbPr;
	
	//save output mode to TV_OUT_MODE_FILE_NAME
	SaveUserTVOutModeSetup();
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
//------------------------------------------------------------------------------------------------
//rywu20080516++
#ifdef SUPPORT_RSS
int MonitorExtraInfo(EXTRA_CONTROL_ID extra_control)//rywu20080709 change to int
{
	unsigned char message;
	//rywu20080709++
	int ret =0;
	int current_time;
	char str[80];
	//rywu20080709--

	//printf("<skedemo> MonitorExtraInfo -->\n");
	//You may use this function to monitor anything about network device.
	if (rss_session->is_rss_struct_ready != 0)//rywu20080709 if (rss_session != 0)
	{
	    //when link status is changing, extra_control->link_status_changed will be set to 1.
	    //rss_session->inform_rss_link_status is triggered when rss client is first initializing.
		if (extra_control->link_status_changed || rss_session->inform_rss_link_status)
		{
		    DBG_MSG("<skedemo> MonitorExtraInfo --> %d vs %d\n", extra_control->link_status_changed, rss_session->inform_rss_link_status);

		    //inform sky_rss of link status at beginning.
		    if (rss_session->inform_rss_link_status == 1)
            {
                sleep(2);
            }
		    rss_session->inform_rss_link_status = 0;

			rss_session->rss_link_status = extra_control->link_status;

			//for link status
			message = IPC_NETWORK_AVAILABLE;
			if (rss_session->rss_link_status == LINK_STATUS_DOWN)
			{
				message = IPC_NETWORK_UNAVAILABLE;
			}

			if (rss_session->is_sky_rss_running == 1)
            {
			//If there is a lot of message, we can consider to use a message
			//block here. Then pass it one time.
			//send out message to rss client
			DBG_MSG("<skedemo> MonitorExtraInfo(link status %d) -->\n", message);
			tx_msg_to_rss_client(rss_session, message);
    		}
		}

		//rywu20080709 reboot system once these 2 threads stop.
		current_time = (int)time((time_t *)NULL);
		if (rss_session->message_time_tag > 0)
        {
            if ((current_time - rss_session->message_time_tag) > 30)
            {
                system("killall curl");
                system("sync;sync");
                printf("skydemo : reboot(1)\n");
                reboot(LINUX_REBOOT_CMD_RESTART);
            }
        }
		if (rss_session->slideshow_time_tag > 0)
        {
            if ((current_time - rss_session->slideshow_time_tag) > 30)
            {
                system("killall curl");
                system("sync;sync");
                printf("skydemo : reboot(2)\n");
                reboot(LINUX_REBOOT_CMD_RESTART);
            }
        }
	}

	//it needs to reset status every time to maintain message validity
	if (extra_control->link_status_changed)
	{
		extra_control->link_status_changed = 0;
	}

    //printf("<skedemo> MonitorExtraInfo <--\n");
	usleep(5);
    return ret;//rywu20080709 return;
}
#endif //#ifdef SUPPOT_RSS
//rywu20080516--
//------------------------------------------------------------------------------------------------
void MonitorNetConfig()
{
	if(active_index != USB2PC_CONN_ACTIVE){
		return;
	}

	typedef struct{
		Uint8 flag;
		ULint32 addr;
		ULint32  len;
	}NET_CONFIG;

	#define ARCPGUFB_GET_NET_CONFIG_INFO	0xffff0070
	#define ARCPGUFB_SET_NET_CONFIG_INFO	0xffff0071
	#define MEM_RANGE						0x2000000
	#define NETSET_PROFILE					"/tmp/conf/rt73sta.dat"

	#define ARCPGUFB_GET_NAS_CONFIG_INFO			0xffff0072
	#define ARCPGUFB_SET_NAS_CONFIG_INFO			0xffff0073
	#define ARCPGUFB_GET_RSS_FLICKR_CONFIG_INFO	0xffff0074
	#define ARCPGUFB_SET_RSS_FLICKR_CONFIG_INFO	0xffff0075
	#define ARCPGUFB_GET_RSS_PICASA_CONFIG_INFO	0xffff0076
	#define ARCPGUFB_SET_RSS_PICASA_CONFIG_INFO	0xffff0077
	#define ARCPGUFB_GET_RSS_FC_CONFIG_INFO		0xffff0078
	#define ARCPGUFB_SET_RSS_FC_CONFIG_INFO		0xffff0079
	#define NETSET_SHAREFILE					"/tmp/conf/mountNet"
	#define NETSET_FLICKR_XML				"/tmp/conf/flickr_channels.xml"
	#define NETSET_PICASA_XML				"/tmp/conf/picasa_channels.xml"
	#define NETSET_FRAME_CHANNEL_XML		"/tmp/conf/fc_channels.xml"

	NET_CONFIG netConfig;
	int fd;
	Uint8 *ptr;
	static FILE *p_file;

	if((fd = open("/dev/fb0", O_RDONLY)) != -1){
		//NET Config
		ioctl(fd, ARCPGUFB_GET_NET_CONFIG_INFO, &netConfig);
		if(netConfig.flag){
			ptr = (unsigned char *)mmap(0, MEM_RANGE, PROT_READ, MAP_SHARED, fd, 0);
			if((long)ptr == -1){
				error("fd error");
			}
			if(!(p_file = fopen(NETSET_PROFILE, "w"))){
				DPRINTF("Open /tmp/conf/rt73sta.dat error\n");
			}
			else{
				fwrite((ptr + netConfig.addr), sizeof(char), netConfig.len, p_file);
				sync();
 				fclose(p_file);
 				munmap (ptr, MEM_RANGE);
 				USB2PConnDisplay();
 			}
 			memset(&netConfig, 0, sizeof(NET_CONFIG));
			ioctl(fd, ARCPGUFB_SET_NET_CONFIG_INFO, &netConfig);
		}

		//NAS Config
		ioctl(fd, ARCPGUFB_GET_NAS_CONFIG_INFO, &netConfig);
		if(netConfig.flag == 1){
			ptr = (unsigned char *)mmap(0, MEM_RANGE, PROT_READ, MAP_SHARED, fd, 0);
			if((long)ptr == -1){
				error("fd error");
			}
			if(!(p_file = fopen(NETSET_SHAREFILE, "w"))){
				DPRINTF("Open /tmp/conf/mountNet error\n");
			}
			else{
				fwrite((ptr + netConfig.addr), sizeof(char), netConfig.len, p_file);
				sync();
 				fclose(p_file);
 				munmap (ptr, MEM_RANGE);
 			}
 			memset(&netConfig, 0, sizeof(NET_CONFIG));
			ioctl(fd, ARCPGUFB_SET_NAS_CONFIG_INFO, &netConfig);
		}
		else if(netConfig.flag == 2){
			system("rm -f /tmp/conf/mountNet");
		}

		//RSS Flickr Config
		ioctl(fd, ARCPGUFB_GET_RSS_FLICKR_CONFIG_INFO, &netConfig);
		if(netConfig.flag == 1){
			ptr = (unsigned char *)mmap(0, MEM_RANGE, PROT_READ, MAP_SHARED, fd, 0);
			if((long)ptr == -1){
				error("fd error");
			}
			if(!(p_file = fopen(NETSET_FLICKR_XML, "w"))){
				DPRINTF("Open /tmp/conf/flickr_channels.xml error\n");
			}
			else{
				fwrite((ptr + netConfig.addr), sizeof(char), netConfig.len, p_file);
				sync();
 				fclose(p_file);
 				munmap (ptr, MEM_RANGE);
 			}
 			memset(&netConfig, 0, sizeof(NET_CONFIG));
			ioctl(fd, ARCPGUFB_SET_RSS_FLICKR_CONFIG_INFO, &netConfig);
		}
		else if(netConfig.flag == 2){
			system("rm -f /tmp/conf/flickr_channels.xml");
		}

		//RSS Picasa Config
		ioctl(fd, ARCPGUFB_GET_RSS_PICASA_CONFIG_INFO, &netConfig);
		if(netConfig.flag == 1){
			ptr = (unsigned char *)mmap(0, MEM_RANGE, PROT_READ, MAP_SHARED, fd, 0);
			if((long)ptr == -1){
				error("fd error");
			}
			if(!(p_file = fopen(NETSET_PICASA_XML, "w"))){
				DPRINTF("Open /tmp/conf/picasa_channels.xml error\n");
			}
			else{
				fwrite((ptr + netConfig.addr), sizeof(char), netConfig.len, p_file);
				sync();
 				fclose(p_file);
 				munmap (ptr, MEM_RANGE);
 			}
 			memset(&netConfig, 0, sizeof(NET_CONFIG));
			ioctl(fd, ARCPGUFB_SET_RSS_PICASA_CONFIG_INFO, &netConfig);
		}
		else if(netConfig.flag == 2){
			system("rm -f /tmp/conf/picasa_channels.xml");
		}

		//RSS Frame Channel Config
		ioctl(fd, ARCPGUFB_GET_RSS_FC_CONFIG_INFO, &netConfig);
		if(netConfig.flag == 1){
			ptr = (unsigned char *)mmap(0, MEM_RANGE, PROT_READ, MAP_SHARED, fd, 0);
			if((long)ptr == -1){
				error("fd error");
			}
			if(!(p_file = fopen(NETSET_FRAME_CHANNEL_XML, "w"))){
				DPRINTF("Open /tmp/conf/fc_channels.xml error\n");
			}
			else{
				fwrite((ptr + netConfig.addr), sizeof(char), netConfig.len, p_file);
				sync();
 				fclose(p_file);
 				munmap (ptr, MEM_RANGE);
 			}
 			memset(&netConfig, 0, sizeof(NET_CONFIG));
			ioctl(fd, ARCPGUFB_SET_RSS_FC_CONFIG_INFO, &netConfig);
		}
		else if(netConfig.flag == 2){
			system("rm -f /tmp/conf/fc_channels.xml");
		}

		close(fd);
	}
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef HD_AUTOCP_MOD
void MonitorHDCopyStatus()
{
	static Uint8 count= 0;
	//
	FRAME *elmf;
	long prgrss = 0L, freeSizeOfCurrHD = 0L;
	Uint16 *dest = (Uint16*)RGB1, cx = 0, cy = 0, FONT_HEIGHT = 26;
	char s[LEN_M];

	if(count == 0)
	{
		if(StsOfCpData2HD == 1 && pid_hd_cp != 0)
		{
			elmf = &ELMachines[active_index].frame;
			if (g_pFontDB_Local)
				FONT_HEIGHT = g_pFontDB_Local->FontSize;

			cx = updateRegion.x + (updateRegion.width >> 1);
			cy = updateRegion.y;

			freeSizeOfCurrHD = GetPathFreeSize(HD_PATH);
			prgrss = (freeSizeOfHD - freeSizeOfCurrHD) * 100 / (sizeOfCard? sizeOfCard : 1);
			//TODO: used for debug
			//printf("sizeOfCard: %ld; freeSizeOfHD: %ld; freeSizeOfCurrHD: %ld; Copied: %ld; %%: %ld\n", sizeOfCard, freeSizeOfHD, freeSizeOfCurrHD, freeSizeOfHD - freeSizeOfCurrHD, prgrss);

			if(waitpid(pid_hd_cp, &sts_hd_cp, WNOHANG) > 0)//free zombie
			{
				StsOfCpData2HD = -1;
				system("sync");
			}
			if(prgrss <= 100)
			{
				memset(s, '\0', LEN_M);
				sprintf(s, "%d%%", prgrss);

				DuplicateBlockBitmap(dest, (Uint16*)elmf->bkgrdbuff, updateRegion.x, cy, updateRegion.width, FONT_HEIGHT);
				FontTextOutFormat(g_pFontDB_Local, dest, cx, cy, s, RED_1555, DT_CENTER);
				RGBlock2YUVBlock((Uint8*)dest, 1, updateRegion.x, cy, updateRegion.width, FONT_HEIGHT);
			}
		}
	}
	count = (count + 1) % 8;
}
#endif
//------------------------------------------------------------------------------------------------
#if defined(GUI_STYLE_COMTEK)
void RefreshProgDownDisplay(int filenum, char *file, Sint8 CurPercent)
{
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;
	Uint8* dest = RGB1;
	char string[100];
	Uint16 FONT_HEIGHT = 26, FONT_WIDTH = 13;

	if(g_pFontDB_Default){
		FONT_HEIGHT = g_pFontDB_Default->FontSize;
		FONT_WIDTH = GetFontStringWidth(g_pFontDB_Default, "0");
	}

	memset(string, 0, 100);

	if((filenum==-1) && (CurPercent==0)){ //display auto power off
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 120, 50, 560, FONT_HEIGHT);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 120, 50, "Program download finish, Power off now", BLUE_1555);
	}
	else if((filenum==-1) && (CurPercent==-1)){ //FTP_LOCAL_ERROR
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 120, 50, 560, FONT_HEIGHT);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 120, 50, "Program download fail, LOCAL ERROR", BLUE_1555);
	}
	else if((filenum==-1) && (CurPercent==-2)){ //FTP_NO_PROFILE
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 120, 50, 560, FONT_HEIGHT);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 120, 50, "Program download fail, NO PROFILE", BLUE_1555);
	}
	else if((filenum==-1) && (CurPercent==-3)){ //FTP_PROFILE_ERROR
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 120, 50, 560, FONT_HEIGHT);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 120, 50, "Program download fail, PROFILE ERROR", BLUE_1555);
	}
	else if((filenum==-1) && (CurPercent==-4)){ //FTP_DOWNLOAD_NO_FINISH
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 120, 50, 560, FONT_HEIGHT);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 120, 50, "Program download fail, NO FINISH", BLUE_1555);
	}
	else if((filenum==-1) && (CurPercent==-5)){ //FTP_LOST_SERVER
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 120, 50, 560, FONT_HEIGHT);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 120, 50, "Program download fail, LOST SERVER", BLUE_1555);
	}
	else if(CurPercent == 100){
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 170, 100+(filenum-1)*(FONT_HEIGHT+10), 600, FONT_HEIGHT);

		sprintf(string, "File%02d : %s ... download OK.", filenum, file);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 50, 100+(filenum-1)*(FONT_HEIGHT+10), string, BLUE_1555);
	}
	else{
		DuplicateBlockBitmap((Uint16 *)dest, (Uint16 *)elmf->bkgrdbuff, 140, 100+(filenum-1)*(FONT_HEIGHT+10), 550, FONT_HEIGHT);
		if(CurPercent != 0)
			DrawRectBitmap((Uint16 *)dest, 140, 100+(filenum-1)*(FONT_HEIGHT+10), 4*CurPercent, FONT_HEIGHT, YELLOW_1555);

		sprintf(string, "File%02d : ", filenum);
		FontTextOut(g_pFontDB_Default, (Uint16*)dest, 20, 100+(filenum-1)*(FONT_HEIGHT+10), string, BLUE_1555);

		sprintf(string, "%02d%%", CurPercent);
		FontTextOut(g_pFontDB_Default, (Uint16 *)dest, 600, 100+(filenum-1)*(FONT_HEIGHT+10), string, GREEN_1555);
	}

	RGBlock2YUVBlock((Uint8*)dest, 1, 0, 0, OUTPUT_XRES, OUTPUT_YRES);

}
#endif
