#include "monitormprocess.h"
#include "skyinit.h"
///080506
#include "types.h"
#ifdef WEB_APP_MOD
#include "webapp.h"
#endif
///
//------------------------------------------------------------------------------------------------
Uint32 PraiseLord = 0;
Uint32 flg4GetNewTrDoneTime = 0;
struct timeval TrDoneTime, TrStartTime;
#ifdef NET_MOD
extern Uint8 isGWSet;		//0: none; bit_1(1): got mac; bit_2(2): wired; bit_3(4):wireless;
extern unsigned int net_slideshow;
#endif
extern Uint32 isSSPrcsStoppedwSIGSTOP;
//------------------------------------------------------------------------------------------------
void HandleSSImage()
{
	FRAME *elmf;
	char effect[3];
	double diff_t = 0.0;
	
	elmf = &ELMachines[active_index].frame;
	if(waitpid(pid_img, &sts_img, WNOHANG))
	{
		//Image has been decoded, then doing transition effect!
		if(!isSSTrPrcsForked)
		{
			/* Flowbee */
			slide_state = SLIDE_IN_TR;
			osd_parser();
			slide_state = SLIDE_IN_TR2JPEG;
			tr_state = jpeg_state;

			gettimeofday(&TrStartTime, NULL);
			if(timercmp(&TrStartTime, &TrDoneTime, >))
			{
				if(TrStartTime.tv_sec == TrDoneTime.tv_sec)
				{
					diff_t = ((double)TrStartTime.tv_usec - (double)TrDoneTime.tv_usec) / 1000000.0;
				}
				else//TrStartTime.tv_sec > TrDoneTime.tv_sec
				{
					if(TrStartTime.tv_usec > TrDoneTime.tv_usec)
					{
						diff_t = ((double)TrStartTime.tv_sec - (double)TrDoneTime.tv_sec) +
								((double)TrStartTime.tv_usec - (double)TrDoneTime.tv_usec) / 1000000.0;
					}
					else if(TrStartTime.tv_usec == TrDoneTime.tv_usec)
					{
						diff_t = (double)TrStartTime.tv_sec - (double)TrDoneTime.tv_sec;
					}
					else//TrStartTime.tv_usec < TrDoneTime.tv_usec
					{
						diff_t = ((double)TrStartTime.tv_sec - 1 - (double)TrDoneTime.tv_sec) +
								((double)TrStartTime.tv_usec + 1000000.0 - (double)TrDoneTime.tv_usec) / 1000000.0;
					}
				}
				//PRINTF("SSIntervalTime = %d\n", setup->SSIntervalTime);
				//PRINTF("TrStartTime.tv_sec = %d\n", TrStartTime.tv_sec);
				//PRINTF("TrDoneTime.tv_sec = %d\n\n", TrDoneTime.tv_sec);
				//PRINTF("diff_t = %f\n\n", diff_t);
			}
			if(diff_t >= (double)setup->SSIntervalTime)
			{
				pid_tr = fork();
				switch(pid_tr)
				{
					case -1:
						perror("Fork failed!");
						DMSG("Fork to TR Fail");
						break;
						//exit(1);
					case 0:
						sprintf(effect, "%d", setup->ss_effect_idx);
						execl("/sky/tr", "tr", "-s", "0", "-d", "1",  "-t", effect, NULL);
						_EXIT;
					default:
						flg4GetNewTrDoneTime = 0;
						isSSTrPrcsForked = TRUE;
						PraiseLord = 0;
						break;
				}
			}
		}
	}
}
//------------------------------------------------------------------------------------------------
void HandleSSAudio()
{
	FRAME *elmf;
	static int count = 0;

	elmf = &ELMachines[active_index].frame;

	if(!GetAudioDelay())
		count++;
	else
		count = 0;
	
	if(count == 500 && !isSSPrcsStoppedwSIGSTOP)
	{
		PRINTF("Buffer has been empty for 500 times!");
		count = 0;
		isSSAudPrcsForked = isSSTrPrcsForked = FALSE;
		elmf->CurrAudListPos = elmf->CurrAudListPos->next;
		if(elmf->CurrAudListPos != NULL)
			DecodeSSAUD();
		else
		{
			elmf->CurrAudListPos = AudioList->next;
			DecodeSSAUD();
		}		

		return;
	}
	
	{
		if(waitpid(pid_aud, &sts_aud, WNOHANG) && waitpid(pid_tr, &sts_tr, WNOHANG))
		{
			//Audio has been decoded,
			isSSAudPrcsForked = isSSTrPrcsForked = FALSE;
			//then playing next one if has
			elmf->CurrAudListPos = elmf->CurrAudListPos->next;
			if(elmf->CurrAudListPos != NULL)
				DecodeSSAUD();
			else
			{
				elmf->CurrAudListPos = AudioList->next;
				DecodeSSAUD();
			}
		}
	}
}
//------------------------------------------------------------------------------------------------
void HandleSSTr()
{
	FRAME *elmf;
	
	elmf = &ELMachines[active_index].frame;

	if(!PraiseLord && waitpid(pid_tr, &sts_tr, WNOHANG))
	{
		//TR is done!
		isSSTrPrcsForked = FALSE;

		#if USE_TERAWINS_TCON

		#else
		/* Flowbee */
		slide_state = SLIDE_IN_JPEG;		
		if(jpeg_state != tr_state)
		{
			if(jpeg_state != IN_START)
			{
				pgu_enable_overlay(0);
			}
			jpeg_state = tr_state;			
			if(isMutePressed || isVolumePressed)
			{
				pgu_enable_overlay(1);
				osd_parser();
			}
		}
		else if(isVolumePressed)
		{
			osd_parser();
		}
		#endif

		PraiseLord = 1;
		elmf->CurrImgListPos = elmf->CurrImgListPos->next;
		switch(setup->ss_rpt_idx)
		{
			case SETUP_ON:
#ifdef NET_MOD
				if(isGWSet!=0 )
					net_slideshow = 1;
				else
					net_slideshow = 0;
#endif
				if(elmf->CurrImgListPos != NULL)
				{
					DecodeSSIMG();
				}
				else
				{
					elmf->CurrImgListPos = ImageList->next;
					DecodeSSIMG();
				}
				break;
			case SETUP_OFF:
				if(elmf->CurrImgListPos != NULL)
				{
					DecodeSSIMG();
				}
				else
				{
					SS_EscEvent();
				}
				break;
		}
	}
}
//------------------------------------------------------------------------------------------------
void HandleOnlyAudio()
{
	FRAME *elmf;

	elmf = &ELMachines[active_index].frame;
	
	if(waitpid(pid_aud, &sts_aud, WNOHANG))
	{
		//Audio Only has been decoded.
		isOnlyAudPrcsForked = FALSE;
		switch(setup->aud_rpt_idx)
		{
			case SETUP_AV_REPEAT_OFF:
				A_StopEvent();
				break;
			case SETUP_AV_REPEAT_SINGLE:
				DrawFocusedICON(RGB1, 0);
				break;
			case SETUP_AV_REPEAT_ONELOOP:
				if(elmf->active_icon_index == AudCount - 1)
					A_StopEvent();
				else
					A_DownEvent();
				break;
			case SETUP_AV_REPEAT_CONTI:
				A_DownEvent();
				break;	
		}
	}
}
//------------------------------------------------------------------------------------------------
void HandleVideo()
{
	FRAME *elmf;
	
	elmf = &ELMachines[V_ACTIVE].frame;
	
	if(waitpid(pid_vid, &sts_vid, WNOHANG))
	{
		//Video has been decoded
		isVidPrcsForked = FALSE;
		switch(setup->vid_rpt_idx)
		{
			case SETUP_AV_REPEAT_OFF:
				FV_StopEvent();
				break;
			case SETUP_AV_REPEAT_SINGLE:
#ifdef SET_VID_SKY_PRIO
				SkyPrio = getpriority(PRIO_PROCESS, 0);
				setpriority(PRIO_PROCESS, 0, SkyPrio - VID_SKY_PRIO_LVL);
#endif
				FVidDisplay();
				break;
			case SETUP_AV_REPEAT_ONELOOP:
				if(elmf->active_icon_index == VidCount - 1)
					FV_StopEvent();
				else
				{
#ifdef SET_VID_SKY_PRIO
					SkyPrio = getpriority(PRIO_PROCESS, 0);
					setpriority(PRIO_PROCESS, 0, SkyPrio - VID_SKY_PRIO_LVL);
#endif
					FV_NextEvent();
				}
				break;
			case SETUP_AV_REPEAT_CONTI:
#ifdef SET_VID_SKY_PRIO
				SkyPrio = getpriority(PRIO_PROCESS, 0);
				setpriority(PRIO_PROCESS, 0, SkyPrio - VID_SKY_PRIO_LVL);
#endif
				FV_NextEvent();
				break;	
		}
	}
}
//------------------------------------------------------------------------------------------------
void HandleFldrAudio()
{
	if(waitpid(pid_fldr_aud, &sts_fldr_aud, WNOHANG))
	{
		//Audio Only has been decoded.
		KillFldrAudioProcess();
		isFldrAudPrcsForked = FALSE;
	}
}
//------------------------------------------------------------------------------------------------
void HandleFldrVideo()
{
	if(waitpid(pid_fldr_vid, &sts_fldr_vid, WNOHANG))
	{
#ifdef SET_VID_SKY_PRIO
		SkyPrio = getpriority(PRIO_PROCESS, 0);
  		setpriority(PRIO_PROCESS, 0, SkyPrio - VID_SKY_PRIO_LVL);
#endif
		//Video has been decoded
		ELMachines[active_index].Shutdown(0);
		active_index = prev_active_index;
		pgu_reset_buf_resolution(OUTPUT_XRES, OUTPUT_YRES);/* Flowbee. */
		ELMachines[active_index].Display();
	}
}
//------------------------------------------------------------------------------------------------
void MonitorMultimediaProcesses()
{
	pid_t pid = -1;
	
	if(isSSImgPrcsForked)
	{
		pid = pid_tr;
		HandleSSImage();
		//tr end before pause key pressed
		if(pid_tr != pid && isSSPrcsStoppedwSIGSTOP)
		{
			kill(pid_tr, SIGSTOP);
		}
	}
	if(isSSAudPrcsForked)
	{
		pid = pid_aud;
		HandleSSAudio();
		//aud end before pause key pressed
		if(pid_aud != pid && isSSPrcsStoppedwSIGSTOP)
		{
			kill(pid_aud, SIGSTOP);
		}
	}
	if(isSSTrPrcsForked)
	{
		pid = pid_img;
		HandleSSTr();
		//img end before pause key pressed
		if(pid_img != pid && isSSPrcsStoppedwSIGSTOP)
		{
			kill(pid_img, SIGSTOP);
		}
	}
	if(isOnlyAudPrcsForked)
	{
		//MonitorAudioTime();
		HandleOnlyAudio();
	}
	if(isVidPrcsForked)
	{
		HandleVideo();
#ifdef VIDEO_TIME_DISPLAY_MOD
		if(isVidPrcsForked)
			MonitorVideoTime();
#endif
	}
	if(isFldrAudPrcsForked)
	{
		//MonitorAudioTime();
		HandleFldrAudio();
	}
	if(isFldrVidPrcsForked)
	{
		HandleFldrVideo();
#ifdef VIDEO_TIME_DISPLAY_MOD
		if(isFldrVidPrcsForked)
			MonitorVideoTime();
#endif
	}
}
