#include "events.h"
//------------------------------------------------------------------------------------------------
// Media Type callbacks																			    
//------------------------------------------------------------------------------------------------
void MT_LeftEvent()
{
	FRAME *elmf;
	int idx;

	elmf = &ELMachines[active_index].frame;
	
	DrawFocusedICON(RGB1, -1);
	///071012
	ITEM_DATA *pItem = &(elmf->item_data);
	pItem->curr_item--;
	if (pItem->curr_item < 0)
		pItem->curr_item += pItem->total_item;
	*((int*)pItem->pvalue) = pItem->index[pItem->curr_item];
	/*
	idx = elmf->active_icon_index - 1;
	if(idx < 0)
		idx += MAX_NUM_MTICON;
	elmf->active_icon_index = idx;
	*/
	///
	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void MT_RightEvent()
{
	FRAME *elmf;
	int idx;

	elmf = &ELMachines[active_index].frame;

	DrawFocusedICON(RGB1, -1);
	///071012
	ITEM_DATA *pItem = &(elmf->item_data);
	pItem->curr_item++;
	pItem->curr_item %= pItem->total_item;
	*((int*)pItem->pvalue) = pItem->index[pItem->curr_item];
	/*
	idx = elmf->active_icon_index + 1;
	elmf->active_icon_index = idx % MAX_NUM_MTICON;
	*/
	///
	DrawFocusedICON(RGB1, 1);
}
//------------------------------------------------------------------------------------------------
void MT_UpEvent()
{
	MT_LeftEvent();
}
//------------------------------------------------------------------------------------------------
void MT_DownEvent()
{
	MT_RightEvent();
}
//------------------------------------------------------------------------------------------------
void MT_PlayPauseEvent()
{
	MT_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void MT_EnterEvent()
{
	if(!strcmp(SelectedMT, ICONText4MT[photo]))
	{
		if(ImgCount != 0)
			ImageEvent();
	}	
	else if(!strcmp(SelectedMT, ICONText4MT[music]))
	{
		if(AudCount != 0 && !isFlashMusicUsed)
			AudioEvent();
	}	
	else if(!strcmp(SelectedMT, ICONText4MT[video]))
	{
#ifdef NET_MOD
		if(strcmp(SelectedDev, DEVICE_NAS_NAME))
#endif
		{
			if(VidCount != 0)
				VideoEvent();
		}
	}
	else if(!strcmp(SelectedMT, ICONText4MT[calendar]))
	{
		CalEvent();
	}
	else if(!strcmp(SelectedMT, ICONText4MT[folder]))
	{
		//Folder
		FolderEvent();
	}
	else if(!strcmp(SelectedMT, ICONText4MT[setupmenu]))
	{
		SetupEvent();
	}
}
//------------------------------------------------------------------------------------------------
#if NET_DISABLE
extern unsigned char wifi_down;
extern unsigned char cifs_down;
extern pid_t dhcp_pid;
extern int dhcpsts;
#endif
void MT_EscEvent()
{
	SavePrevMountedDeviceStatus();
#if NET_DISABLE
	wifi_down = cifs_down = 0;
	if (dhcp_pid > 0)
	{
		KILL(dhcp_pid);
		waitpid(dhcp_pid, &dhcpsts, 0);
		dhcp_pid = 0;
	}
	usleep(100);						//tyhuang: wait system ip layer down
#endif
	CloseSystem();
	#ifdef WINGUI
	isExitPressed = TRUE;
	#endif
	InitSystem(INITSYS_CALL_BY_NORMAL);
}
