#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libcurl/curl.h"

#define TEMP_FILE "/tmp/curl.image"//rywu20080704

int main(int argc, char** argv) 
{
    FILE *p_file;
    FILE *data_file;
    CURL *handle;
	CURLcode ret = 0;
	char url[256];
	char file_name[256];
	int timeout;
	char str[80];
	char command[256];//rywu20080704
	
	strcpy(url, argv[1]);
	strcpy(file_name, argv[2]);
	timeout = atoi(argv[3]);
	//printf("url = %s, file name = %s, timeout = %d\n", url, file_name, timeout);

    p_file = fopen(TEMP_FILE, "w+");//rywu20080704 p_file = fopen(file_name, "w+");
    if(p_file == 0) 
    {
        printf("can't open file to download image\n");
        return -1;
    }
    
    handle = curl_easy_init();
    if (timeout > 0)
    {
        curl_easy_setopt(handle, CURLOPT_TIMEOUT, timeout);
    }
    curl_easy_setopt(handle, CURLOPT_FOLLOWLOCATION, 1);
    curl_easy_setopt(handle, CURLOPT_URL, url);
    curl_easy_setopt(handle, CURLOPT_WRITEDATA, p_file);
    ret = curl_easy_perform(handle);
    curl_easy_cleanup(handle);
    	
    fclose(p_file);
    
    if (ret == CURLE_OK)//rywu20080709
    {
        //rywu20080704++
        sprintf(command, "mv %s %s", TEMP_FILE, file_name);
        system(command);
        system("sync;sync");
        //rywu20080704--
    }
    
    data_file = fopen("/tmp/curl_working", "w+");
    if(data_file != 0) 
    {
        sprintf(str, "%d\n", (int)ret);
        fputs(str, data_file);
        fclose(data_file);
    }       
    
    return ret;
}

