/********************************************************************
	created:	2008/04/18
	filename: 	skyform.c
	file base:	skyform
	file ext:	c
	author:		
	purpose:	إߪ浲c
*********************************************************************/

#include "skyform.h"

#ifdef _SKY_FORM_H_

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include "skydemo.h"

#include "types.h"
#ifdef WEB_APP_MOD
#include "webapp.h"
#endif

/*
int main(int argc, char* argv[])
{
	SKYFORM *pForm = NULL;

	pForm = SKYFORM_CreateForm("c:\\testform.txt");

	SKYFORM_ReleaseForm(&pForm);

	return 0;
}
*/

//--------------------------------------------------//
//		FORMVIEW ܵc						//
//--------------------------------------------------//
FORMVIEW* FORMVIEW_Create(SKYFORM *pForm)
{
	//if (!pForm) return NULL;
	FORMVIEW *pView = NULL;
	BYTE bSuccess = 0;

	for (;;)
	{
		if (!(pView = (FORMVIEW*)malloc(sizeof(FORMVIEW)))) break;
		memset(pView, 0, sizeof(FORMVIEW));

		pView->pForm = pForm;

		//lrΨsX(YFormS]wsXAhw]0)
		pView->pFontDB = Create_FontDB(desc->FontFileName[NUM_OF_FONT_FILE-1]);
		if (!pView->pFontDB) break;
		if (pView->pForm && pView->pForm->Coding)
		{
			/*
			pView->pFontDB->cd_utf8_2_local = iconv_open(pView->pForm->Coding, "UTF-8");
			if (pView->pFontDB->cd_utf8_2_local == (iconv_t)-1) break;
			if (pView->pFontDB->CharSet != UCS2_CODING)
			{
				pView->pFontDB->cd_local_2_ucs2 = iconv_open("UCS-2LE", pView->pForm->Coding);
				if (pView->pFontDB->cd_local_2_ucs2 == (iconv_t)-1) break;
			}
			*/
			///080510
			if (  strcasecmp(pView->pForm->Coding, "UTF-8") == 0
				||
				  strcasecmp(pView->pForm->Coding, "UTF8") == 0
			   )
			{
				pView->default_use_utf = 8;
			}
			///
		}

		if (!(pView->pBuf = SB_Open(SKYBUFFER_BASE_DEFAULT_SIZE))) break;

		bSuccess = 1;
		break;
	}

	if (!bSuccess)
	{
		FORMVIEW_Close(&pView);
		return NULL;
	}
	return pView;
}

FORMVIEW* FORMVIEW_CreateEmptyView()
{
	FORMVIEW *pView = NULL;
	BYTE bSuccess = 0;
	for (;;)
	{
		if (!(pView = (FORMVIEW*)malloc(sizeof(FORMVIEW)))) break;
		memset(pView, 0, sizeof(FORMVIEW));

		if (!(pView->pBuf = SB_Open(SKYBUFFER_BASE_DEFAULT_SIZE))) break;

		bSuccess = 1;
		break;
	}

	if (!bSuccess)
	{
		FORMVIEW_Close(&pView);
		return NULL;
	}
	return pView;
}

void FORMVIEW_Close(FORMVIEW **ppView)
{
	if (!ppView || !*(ppView)) return;

	if ((*ppView)->pFontDB)
	{
		Release_FontDB(&((*ppView)->pFontDB));
	}

	if ((*ppView)->pBuf)
	{
		SB_Close(&((*ppView)->pBuf));
	}

	free(*(ppView));
	*ppView = NULL;
}

FORMVIEW_CELL* FORMVIEW_AddField(FORMVIEW *pView, WORD doc_table_index, WORD doc_field_index)
{
	if (  !pView  || !pView->pBuf
		||
		  !pView->pForm || !pView->pForm->Table
		|| 
		  doc_table_index >= pView->pForm->nTable
		||
		  doc_field_index >= pView->pForm->Table[doc_table_index].nField
	   )
	{
		return NULL;
	}

	FORMVIEW_CELL *pNewFieldCell = NULL;

	//YCsbAsW@C
	if (!pView->field_row)
	{
		pView->field_row = (FORMVIEW_ROW*)SB_Alloc(pView->pBuf, sizeof(FORMVIEW_ROW));
		if (!pView->field_row) return NULL;
	}

	pNewFieldCell = FORMVIEW_AddEmptyCell(pView, pView->field_row);
	if (!pNewFieldCell) return NULL;
	//]w
	pNewFieldCell->key = pView->pForm->Table[doc_table_index].Field[doc_field_index];

	//pe
	//TODO:

	return pNewFieldCell;
}

FORMVIEW_ROW* FORMVIEW_AddDataRow(FORMVIEW *pView, WORD doc_table_index, WORD doc_item_index)
{
	if (  !pView || !pView->pBuf || !pView->field_row
		||
		  !pView->pForm || !pView->pForm->Table
		||
		  doc_table_index >= pView->pForm->nTable
		||
		  doc_item_index >= pView->pForm->Table[doc_table_index].nItem
	   )
	{
		return NULL;
	}

	int i, j;
	FORMVIEW_CELL *pFieldCell = NULL;
	FORMVIEW_CELL *pDataCell = NULL;
	SKYFORM_TABLE *pTable = &(pView->pForm->Table[doc_table_index]);

	FORMVIEW_ROW *pNewRow = FORMVIEW_AddEmptyDataRow(pView);
	if (!pNewRow) return NULL;

	pFieldCell = pView->field_row->cell_list;
	pDataCell = pNewRow->cell_list;
	for (i=0; i<pView->field_row->nCell; i++)
	{
		//YAANNdocȶJ
		for (j=0; j<pTable->nField; j++)
		{
			if (pFieldCell->key == pTable->Field[j])
			{
				pDataCell->key = pFieldCell->key;
				pDataCell->value = pTable->Value[j][doc_item_index];
				break;
			}
		}

		pFieldCell = pFieldCell->next;
		pDataCell = pDataCell->next;
	}

	return pNewRow;
}

FORMVIEW_ROW* FORMVIEW_AddEmptyDataRow(FORMVIEW *pView)
{
	if (!pView || !pView->pBuf) return NULL;

	int i;
	FORMVIEW_ROW *pTailRow = NULL;
	FORMVIEW_ROW *pNewRow = NULL;

	//sW@C
	pNewRow = (FORMVIEW_ROW*)SB_Alloc(pView->pBuf, sizeof(FORMVIEW_ROW));
	if (!pNewRow) return NULL;

	if (pView->field_row)
	{
		for (i=0; i<pView->field_row->nCell; i++)
		{
			if (!FORMVIEW_AddEmptyCell(pView, pNewRow)) return NULL;
		}
	}

	if (pView->datarow_list)	//brow_list
	{
		//C
		if (!(pTailRow = pView->datarow_list->prev))
		{
			while (pTailRow->next) pTailRow = pTailRow->next;
		}
		pTailRow->next = pNewRow;
		pNewRow->prev = pTailRow;
	}
	else	//datarow_listsb
	{
		pView->datarow_list = pNewRow;
	}

	//]C
	pView->datarow_list->prev = pNewRow;

	//]Cƶq
	pView->nDataRow++;

	return pNewRow;
}

FORMVIEW_CELL* FORMVIEW_AddEmptyCell(FORMVIEW *pView, FORMVIEW_ROW *pRow)
{
	if (!pView || !pView->pBuf || !pRow) return NULL;

	FORMVIEW_CELL *pNewCell = NULL, *pTail = NULL;
	pNewCell = (FORMVIEW_CELL*)SB_Alloc(pView->pBuf, sizeof(FORMVIEW_CELL));
	if (!pNewCell) return NULL;

	if (pRow->cell_list)	//bC᭱
	{
		//pTailC
		if (!(pTail = pRow->cell_list->prev))
		{
			pTail = pRow->cell_list;
			while(pTail->next) pTail = pTail->next;
			pRow->cell_list->prev = pTail;
		}
		pTail->next = pNewCell;
		pNewCell->prev = pTail;
	}
	else	//cell_list٤sbApNewCellĤ@
	{
		pRow->cell_list = pNewCell;
	}

	//s]wC
	pRow->cell_list->prev = pNewCell;

	//]ƶq
	pRow->nCell++;

	return pNewCell;
}

//ŪFORMVIEWxs
FORMVIEW_ROW* FORMVIEW_GetDataRow(FORMVIEW *pView, WORD data_row_index)
{
	FORMVIEW_ROW *pRow = pView->datarow_list;
	int i;	

	if (  !pView
		||
		  !(pRow = pView->datarow_list)
		||
		  data_row_index >= pView->nDataRow
	   )
	{
		return NULL;
	}

	for (i=0; i<data_row_index; i++)
	{
		if (!(pRow = pRow->next)) return NULL;
	}

	return pRow;
}

FORMVIEW_CELL* FORMVIEW_GetDataCell(FORMVIEW *pView, WORD data_row_index, WORD data_cell_index)
{
	FORMVIEW_ROW *pRow = NULL;
	FORMVIEW_CELL *pCell = NULL;
	int i;

	if (  !(pRow = FORMVIEW_GetDataRow(pView, data_row_index))
		||
		  !(pCell = pRow->cell_list)
		||
		  data_cell_index >= pRow->nCell
	   )
	{
		return NULL;
	}

	for (i=0; i<data_cell_index; i++)
	{
		if (!(pCell = pCell->next)) return NULL;
	}

	return pCell;
}


int FORMVIEW_DataFocus_PrevLine(FORMVIEW *pView)
{
	if (!pView || !pView->datarow_list || !pView->nDataRow)
	{
		return -1;
	}

	WORD total_rows_per_page = pView->nLinePerPage * pView->nRowPerLine;
	int old_row_index = pView->curr_row_index;

	pView->curr_row_index -= pView->nRowPerLine;

	//wĤ@A^̤U
	if (pView->curr_row_index < 0)
	{
		int i;
		pView->curr_row_index += (pView->nDataRow+pView->nRowPerLine-1)/pView->nRowPerLine*pView->nRowPerLine;
		pView->lead_row_index += pView->curr_row_index/pView->nRowPerLine*pView->nRowPerLine;
		for (i=1; i<pView->nLinePerPage; i++)
		{
			if (pView->lead_row_index >= pView->nRowPerLine)
				pView->lead_row_index -= pView->nRowPerLine;
			else
				break;
		}
		
		FORMVIEW_DrawData(pView, 1);
	}
	//WLe
	else if (pView->curr_row_index < pView->lead_row_index)
	{
		pView->lead_row_index -= pView->nRowPerLine;
		FORMVIEW_DrawData(pView, 1);
	}
	//`VU
	else
	{
		//٭e@row
		FORMVIEW_DrawDataRow(pView, pView->curr_row_index + pView->nRowPerLine, 1);
		//eثe쪺row
		FORMVIEW_DrawDataRow(pView, pView->curr_row_index, 1);
	}

	return 0;
}

int FORMVIEW_DataFocus_NextLine(FORMVIEW *pView)
{
	if (!pView || !pView->datarow_list || !pView->nDataRow)
	{
		return -1;
	}

	WORD total_rows_per_page = pView->nLinePerPage * pView->nRowPerLine;
	int old_row_index = pView->curr_row_index;

	pView->curr_row_index += pView->nRowPerLine;

	//w̫@A^̤W
	if (pView->curr_row_index >= pView->nDataRow)
	{
		pView->lead_row_index = 0;
		pView->curr_row_index -= (pView->nDataRow/pView->nRowPerLine*pView->nRowPerLine);
		FORMVIEW_DrawData(pView, 1);
	}
	//WLe
	else if (pView->curr_row_index - pView->lead_row_index >= total_rows_per_page)
	{
		pView->lead_row_index += pView->nRowPerLine;
		FORMVIEW_DrawData(pView, 1);
	}
	//`VU
	else
	{
		//٭e@row
		FORMVIEW_DrawDataRow(pView, pView->curr_row_index - pView->nRowPerLine, 1);
		//eثe쪺row
		FORMVIEW_DrawDataRow(pView, pView->curr_row_index, 1);
	}

	return 0;
}

int FORMVIEW_DrawData(FORMVIEW *pView, BYTE draw_yuv)
{
	if (!pView) return -1;

	WORD *destrgb = NULL;
	COORD crdData = {0};
	FRAME *elmf = &ELMachines[active_index].frame;
	//T{تbuffer
	if (pView->dest_rgb == 0) destrgb = (WORD*)RGB0;
	else if (pView->dest_rgb == 1) destrgb = (WORD*)RGB1;
	else return -1;
	if (pView->dest_yuv > 1) return -1;	//uebyuv0yuv1

	//eưϰI
	if (elmf->bkgrdbuff)
	{
		crdData.x = pView->crdView.x + pView->crdData.x;
		crdData.y = pView->crdView.y + pView->crdData.y;
		crdData.width = pView->crdData.width;
		crdData.height = pView->crdData.height;
		DuplicateBlockBitmap(destrgb, (Uint16*)elmf->bkgrdbuff,
							 crdData.x, crdData.y,
							 crdData.width, crdData.height);
	}

	//eo@ƦC
	if (pView->datarow_list)
	{
		WORD total_rows_per_page = pView->nLinePerPage * pView->nRowPerLine;
		int i;
	
		for (i=0; i<total_rows_per_page; i++)
		{
			if (0 != FORMVIEW_DrawDataRow(pView, pView->lead_row_index + i, 0))
			{
				break;
			}
		}
	}

	if (draw_yuv)
	{
		//Kyuv buffer
		RGBlock2YUVBlock((Uint8*)destrgb, pView->dest_yuv,
						 crdData.x, crdData.y,
						 crdData.width, crdData.height);
	}

	return 0;
}

int FORMVIEW_DrawDataCell(FORMVIEW *pView, WORD data_row_index, WORD data_cell_index, BYTE draw_yuv)
{
	if (!pView) return -1;

	FORMVIEW_CELL *pCell = NULL;
	COORD crdCell = {0}, crdRow = {0}, crdTemp = {0};
	SKYFORM_VALUE *pValue = NULL;
	WORD *destrgb = NULL;
	int scroll;
	WORD display_index = 0;

	if (!(pCell = FORMVIEW_GetDataCell(pView, data_row_index, data_cell_index))) return -1;

	//T{تbuffer
	if (pView->dest_rgb == 0) destrgb = (WORD*)RGB0;
	else if (pView->dest_rgb == 1) destrgb = (WORD*)RGB1;
	else return -1;
	if (pView->dest_yuv > 1) return -1;	//uebyuv0yuv1

	display_index = data_row_index - pView->lead_row_index;
	crdRow.x = pView->crdView.x + pView->crdData.x
				+ pView->crdDataRow[display_index].x;
	crdRow.y = pView->crdView.y + pView->crdData.y
				+ pView->crdDataRow[display_index].y;
	crdRow.width = pView->crdDataRow[display_index].width;
	crdRow.height = pView->crdDataRow[display_index].height;

	memcpy(&crdCell, &(pView->crdDataCell[data_cell_index]), sizeof(COORD));

	scroll = (int)pCell->scroll;

	if (!pCell->invisible && (pValue = pCell->value))
	{
		memcpy(&crdTemp, &crdCell, sizeof(COORD));
		while (pValue)
		{
			if (   scroll-- <= 0
				&& crdTemp.x < crdRow.width
				&& crdTemp.y < crdRow.height
			   )
			{
				if (pCell->value->format == SKYFORM_FORMAT_STRING)
				{
					if (pView->pFontDB)
					{
						FontTextOutW(pView->pFontDB, pValue->data,
									 pView->default_use_utf,
									 pCell->color, destrgb, OUTPUT_XRES,
									 crdRow.x + crdTemp.x, crdRow.y + crdTemp.y,
									 crdTemp.width, crdTemp.height
									);
						crdTemp.y += pView->pFontDB->FontSize;
					}
				}
				else if (pCell->value->format == SKYFORM_FORMAT_FILENAME)
				{
					if (pView->pFontDB)
					{
						FontTextOutFileName(pView->pFontDB, pValue->data,
											pView->default_use_utf, 0,
											pCell->color, destrgb, OUTPUT_XRES,
											crdRow.x + crdTemp.x, crdRow.y + crdTemp.y,
											crdTemp.width, crdTemp.height
										   );
						crdTemp.y += pView->pFontDB->FontSize;
					}
				}
			}
			pValue = pValue->next;
		}

		if (draw_yuv)
		{
			//Kyuv buffer
			RGBlock2YUVBlock((Uint8*)destrgb, pView->dest_yuv,
							 crdRow.x + crdCell.x, crdRow.y + crdCell.y,
							 crdCell.width, crdCell.height);
		}
	}

	return 0;
}


int FORMVIEW_DrawDataRow(FORMVIEW *pView, WORD row_index, BYTE draw_yuv)
{
	if (  !pView || !pView->datarow_list
		||
		  row_index >= pView->nDataRow
		||
		  row_index < pView->lead_row_index
		||
		  row_index - pView->lead_row_index >= pView->nLinePerPage*pView->nRowPerLine
	   )
	{
		return -1;
	}

	FRAME *elmf = &ELMachines[active_index].frame;
	int i;
	FORMVIEW_ROW *pRow = NULL;
	FORMVIEW_CELL *pCell = NULL;
	COORD crdRow = {0};
	COORD *pcrdCell = NULL;
	//Uint16 right, bottom;
	WORD *destrgb = NULL;
	WORD display_index = 0;

	//rowbWǤεy
	display_index = row_index - pView->lead_row_index;
	crdRow.x = pView->crdView.x + pView->crdData.x + pView->crdDataRow[display_index].x;
	crdRow.y = pView->crdView.y + pView->crdData.y + pView->crdDataRow[display_index].y;
	crdRow.width = pView->crdDataRow[display_index].width;
	crdRow.height = pView->crdDataRow[display_index].height;

	//T{تbuffer
	if (pView->dest_rgb == 0) destrgb = (WORD*)RGB0;
	else if (pView->dest_rgb == 1) destrgb = (WORD*)RGB1;
	else return -1;
	if (pView->dest_yuv > 1) return -1;	//uebyuv0yuv1

	//row_index
	pRow = FORMVIEW_GetDataRow(pView, row_index);

	//KIHighlight
	if (row_index == pView->curr_row_index)	//Ϋ쪺
	{
		DrawRectBitmap(destrgb,
					   crdRow.x, crdRow.y, crdRow.width, crdRow.height,
					   HIGHTLIGHT_1555);
	}
#ifdef WEB_APP_EZPEER
	else if (  g_WebApp.ez_is_aud_forked
			 &&
			   row_index == pView->curr_playing_row_index
			)
	{
		DrawRectBitmap(destrgb,
					   crdRow.x, crdRow.y, crdRow.width, crdRow.height,
					   PURPLE_1555);
	}
#endif
	else	//@
	{
		if (elmf->bkgrdbuff)
		{
			DuplicateBlockBitmap(destrgb, (Uint16*)elmf->bkgrdbuff,
								 crdRow.x, crdRow.y,
								 crdRow.width, crdRow.height);
		}
	}

	for (i=0; i<pRow->nCell; i++)
	{
		FORMVIEW_DrawDataCell(pView, row_index, i, 0);
	}
	/*
	pCell = pRow->cell_list;
	for (i=0; i<pRow->nCell; i++)
	{
		pcrdCell = &(pView->crdDataCell[i]);

		if (  !pCell->invisible
			&&
			  pCell->value
			&&
			  pcrdCell->x < crdRow.width
			&&
			  pcrdCell->y < crdRow.height
		   )
		{
			//ܳr
			if (pView->pFontDB)
			{
				if (pCell->value->format == SKYFORM_FORMAT_STRING)
				{
					FontTextOutW(pView->pFontDB, pCell->value->data,
								 pView->default_use_utf,
								 pCell->color, destrgb, OUTPUT_XRES,
								 crdRow.x + pcrdCell->x, crdRow.y + pcrdCell->y,
								 pcrdCell->width, pcrdCell->height
								);
				}
				else if (pCell->value->format == SKYFORM_FORMAT_FILENAME)
				{
					FontTextOutFileName(pView->pFontDB, pCell->value->data,
										pView->default_use_utf, 0,
										pCell->color, destrgb, OUTPUT_XRES,
										crdRow.x + pcrdCell->x, crdRow.y + pcrdCell->y,
										pcrdCell->width, pcrdCell->height
									   );
				}
			}
		}
	
		pCell = pCell->next;
	}
	*/

	if (draw_yuv)
	{
		//Kyuv buffer
		RGBlock2YUVBlock((Uint8*)destrgb, pView->dest_yuv,
						 crdRow.x, crdRow.y,
						 crdRow.width, crdRow.height);
	}

	return 0;
}

int FORMVIEW_DrawFieldRow(FORMVIEW *pView, BYTE draw_yuv)
{
	if (!pView || !pView->field_row)
	{
		return -1;
	}

	FRAME *elmf = &ELMachines[active_index].frame;
	int i;
	FORMVIEW_ROW *pRow = NULL;
	FORMVIEW_CELL *pCell = NULL;
	COORD crdRow = {0};
	COORD *pcrdCell = NULL;
	WORD *destrgb = NULL;

	//rowbWǤεy
	crdRow.x = pView->crdView.x + pView->crdFieldRow.x;
	crdRow.y = pView->crdView.y + pView->crdFieldRow.y;
	crdRow.width = pView->crdFieldRow.width;
	crdRow.height = pView->crdFieldRow.height;

	//T{تbuffer
	if (pView->dest_rgb == 0) destrgb = (WORD*)RGB0;
	else if (pView->dest_rgb == 1) destrgb = (WORD*)RGB1;
	else return -1;
	if (pView->dest_yuv > 1) return -1;	//uebyuv0yuv1

    pRow = pView->field_row;
	pCell = pRow->cell_list;
	for (i=0; i<pRow->nCell; i++)
	{
		pcrdCell = &(pView->crdFieldCell[i]);

		if (  !pCell->invisible
			&&
			  pCell->key
			&&
			  pcrdCell->x < crdRow.width
			&&
			  pcrdCell->y < crdRow.height
		   )
		{
			FontTextOutW(g_pFontDB_Local, pCell->key,
						 pView->default_use_utf,
						 pCell->color, destrgb, OUTPUT_XRES,
						 crdRow.x + pcrdCell->x, crdRow.y + pcrdCell->y,
						 pcrdCell->width, pcrdCell->height
						);
		}
	
		pCell = pCell->next;
	}

	if (draw_yuv)
	{
		//Kyuv buffer
		RGBlock2YUVBlock((Uint8*)destrgb, pView->dest_yuv,
						 crdRow.x, crdRow.y,
						 crdRow.width, crdRow.height);
	}
	return 0;
}

int FORMVIEW_DataCell_ScrollUp(FORMVIEW *pView, WORD row_index, WORD cell_index)
{
	FORMVIEW_CELL *pCell = NULL;
	if (!(pCell = FORMVIEW_GetDataCell(pView, row_index, cell_index))) return -1;

	if (pCell->scroll > 0) pCell->scroll--;

	FORMVIEW_DrawDataRow(pView, row_index, 1);
	return pCell->scroll;
}

int FORMVIEW_DataCell_ScrollDown(FORMVIEW *pView, WORD row_index, WORD cell_index)
{
	FORMVIEW_CELL *pCell = NULL;
	SKYFORM_VALUE *pValue = NULL;
	int i = 0;
	if (!(pCell = FORMVIEW_GetDataCell(pView, row_index, cell_index))) return -1;

	pValue = pCell->value;
	while (pValue && (++i) <= pCell->scroll)
	{
		pValue = pValue->next;
	}
	if (pValue) pCell->scroll++;
	
	FORMVIEW_DrawDataRow(pView, row_index, 1);
	return pCell->scroll;
}

int FORMVIEW_ArrangeMultiLineCell(FORMVIEW *pView, WORD row_index, WORD cell_index)
{
	if (   !pView || !pView->datarow_list
		|| !pView->pFontDB
		|| row_index >= pView->nDataRow
		|| cell_index >= pView->datarow_list->nCell
	   )
	{
		return -1;
	}

	COORD *pcrdCell;
	FORMVIEW_CELL *pCell = NULL;
	SKYFORM_VALUE *pValue = NULL, *pNextValue = NULL;
	SKYFORM_VALUE *pValueTail = NULL;
	SKYFORM_VALUE *pNewValue = NULL;
	SKYFORM_VALUE *pNewValueHead = NULL, *pNewValueTail = NULL;
	BYTE *pTemp = NULL;
	int Len = 0;

	if (!(pCell = FORMVIEW_GetDataCell(pView, row_index, cell_index))) return -1;

	pcrdCell = &(pView->crdDataCell[cell_index]);
	if (!pcrdCell->width || !pcrdCell->height) return -1;

	pValue = pCell->value;
	while (pValue)
	{
		pNextValue = pValue->next;

		if (pValue->data && pValue->format == SKYFORM_FORMAT_STRING)
		{
			Len = CutFontTextByWidth(pView->pFontDB, pValue->data, pView->default_use_utf, pcrdCell->width);
			if (Len < strlenW(pValue->data, pView->default_use_utf))
			{
				pNewValueHead = NULL;
				pNewValueTail = NULL;
				pTemp = pValue->data;
				do
				{
					pNewValue = (SKYFORM_VALUE*)SB_Alloc(pView->pBuf, sizeof(SKYFORM_VALUE));
					pNewValue->format = SKYFORM_FORMAT_STRING;
					if (!(pNewValue->data = (BYTE*)SB_nString(pView->pBuf, pTemp, Len))) break;

					if (pNewValueHead)	//b᭱
					{
						pNewValueTail = pNewValueHead->prev;
						pNewValueTail->next = pNewValue;
						pNewValue->prev = pNewValueTail;
						pNewValueTail = pNewValue;
					}
					else	//list
					{
						pNewValueHead = pNewValue;
						pNewValueTail = pNewValue;
					}
					pNewValueHead->prev = pNewValueTail;

					pTemp += Len;
				}
				while (0 < (Len = CutFontTextByWidth(pView->pFontDB, pTemp, pView->default_use_utf, pcrdCell->width)));

				//sCNValue
				pNewValueTail = pNewValueHead->prev;
				pNewValueHead->prev = pValue->prev;
				pNewValueTail->next = pNextValue;
				if (pValue == pCell->value)	//nb}Y
					pCell->value = pNewValueHead;
				else
					pValue->prev->next = pNewValueHead;
	
				if (!pNextValue)	//nb
					pCell->value->prev = pNewValueTail;
				else
					pNextValue->prev = pNewValueTail;
			}
		}	//if (pValue->data

		pValue = pNextValue;
	}

	return 0;
}


/*--------------------------------------------------*/
/*			SKYFORM xΪ浲c					*/
/*--------------------------------------------------*/
SKYFORM* SKYFORM_CreateFormFromFile(char *srcfile)
{
	FILE *fid = NULL;
	SKYFORM *pForm = NULL;
	SKYFORM_TAG tag = {0};
	SKYFORM_TABLE *pCurrTable = NULL;
	int i;
	SKYFORM_VALUE **arrpValue, *pValue, *pNewValue;
	//char** arrValue;
	BYTE bSuccess = 0, bFail = 0;
	if (!srcfile) return NULL;
	fid = fopen(srcfile, "r");
	if (!fid) return NULL;

	for (;;)
	{
		//tmŪSKYFORM
		if (!(pForm = (SKYFORM*)malloc(sizeof(SKYFORM)))) break;
		memset(pForm, 0, sizeof(SKYFORM));
		if (!(pForm->pBuf = SB_Open(SKYBUFFER_BASE_DEFAULT_SIZE))) break;

		//CŪ@檺ƶitag
		while (!bFail && SKYFORM_ParseTag(fid, &tag) >= 0)
		{
			switch (tag.type)
			{
			case SKYFORM_TAG_DATATYPE:	//[D]ƫA
				if (!(pForm->DataType = SB_String(pForm->pBuf, tag.value)))
				{
					bFail = 1;
				}
				break;

			case SKYFORM_TAG_CODING:	//[C]sX覡
				if (!(pForm->Coding = SB_String(pForm->pBuf, tag.value)))
				{
					bFail = 1;
				}
				break;

			case SKYFORM_TAG_SUBJECT:	//[S]DD
				if (!(pForm->Subject = SB_String(pForm->pBuf, tag.value)))
				{
					bFail = 1;
				}
				break;

			case SKYFORM_TAG_KEY:		//[K()]
				if (tag.nIndex == 0)	//l
				{
					if (pForm->nKey == 0 && pForm->Key == NULL)
					{
						pForm->nKey = (WORD)atoi(tag.value);

						if (!(pForm->Key = (char**)SB_Alloc(pForm->pBuf, pForm->nKey*sizeof(char*))))
						{
							bFail = 1;
						}
					}
				}
				else if (tag.nIndex == 1)	//
				{
					if (tag.index[0] < pForm->nKey)
					{
						if (!(pForm->Key[tag.index[0]] = SB_String(pForm->pBuf, tag.value)))
						{
							bFail = 1;
						}
					}
				}
				break;

			case SKYFORM_TAG_TABLE:		//[T()]
				if (tag.nIndex == 0)	//Mwƥ
				{
					if (pForm->nTable == 0 && pForm->Table == NULL)
					{
						pForm->nTable = (WORD)atoi(tag.value);
						if (!(pForm->Table = (SKYFORM_TABLE*)SB_Alloc(pForm->pBuf, pForm->nTable*sizeof(SKYFORM_TABLE))))
						{
							bFail = 1;
						}
					}
				}
				else if (tag.nIndex == 1)	//檺W
				{
					if (  tag.index[0] < pForm->nTable
						&&
						  (WORD)atoi(tag.value) < pForm->nKey
					   )
					{	
						pCurrTable = &(pForm->Table[tag.index[0]]);
						pCurrTable->Name = pForm->Key[(WORD)atoi(tag.value)];
					}
				}
				break;

			case SKYFORM_TAG_FIELD:		//[F()]
				if (pCurrTable)
				{
					if (tag.nIndex == 0)	//ƥ
					{
						if (pCurrTable->nField == 0 && pCurrTable->Field == NULL)
						{
							pCurrTable->nField = (WORD)atoi(tag.value);
							if (!(pCurrTable->Field = (char**)SB_Alloc(pForm->pBuf, pForm->nKey*sizeof(char*))))
							{
								bFail = 1;
							}
						}
					}
					else if (tag.nIndex == 1)
					{
						if (  tag.index[0] < pCurrTable->nField
							&&
							  (WORD)atoi(tag.value) < pForm->nKey
						   )
						{
							pCurrTable->Field[tag.index[0]] = pForm->Key[(WORD)atoi(tag.value)];
						}
					}
				}
				break;

			case SKYFORM_TAG_ITEM:		//[I]
				if (pCurrTable)
				{
					if (pCurrTable->nItem == 0)
					{
						pCurrTable->nItem = (WORD)atoi(tag.value);
					}
				}
				break;

			case SKYFORM_TAG_VALUE:		//[V()]Ʀr
				if (pCurrTable)
				{
					if (  tag.nIndex == 2
						&&
						  tag.index[0] < pCurrTable->nField
						&&
						  tag.index[1] < pCurrTable->nItem
					   )
					{
						if (pCurrTable->Value)
						{
						}
						else	//Ŷ|tm
						{
							//1st dimension(base)
							if (!(arrpValue = (SKYFORM_VALUE**)SB_Alloc(pForm->pBuf, pCurrTable->nField*pCurrTable->nItem*sizeof(SKYFORM_VALUE*))))
							{
								bFail = 1;
								break;
							}
							//2nd dimension
							if (!(pCurrTable->Value = (SKYFORM_VALUE***)SB_Alloc(pForm->pBuf, pCurrTable->nField*sizeof(SKYFORM_VALUE**))))
							{
								bFail = 1;
								break;
							}
							//link matrix
							for (i=0; i<pCurrTable->nField; i++)
							{
								pCurrTable->Value[i] = arrpValue + i * pCurrTable->nItem;
							}
						}

						//sWValue
						if (  !(pNewValue = (SKYFORM_VALUE*)SB_Alloc(pForm->pBuf, sizeof(SKYFORM_VALUE)))
							||
							  !(pNewValue->data = (BYTE*)SB_String(pForm->pBuf, tag.value))
						   )
						{
							bFail = 1;
							break;
						}
						pNewValue->format = SKYFORM_FORMAT_STRING;	//]w]榡r
					
						if (!(pCurrTable->Value[tag.index[0]][tag.index[1]]))	//s
						{
							pCurrTable->Value[tag.index[0]][tag.index[1]] = pNewValue;
						}
						else	//¸ƤwsbAb᭱
						{
							pValue = pCurrTable->Value[tag.index[0]][tag.index[1]];
							//̫@(Ĥ@prev)
							if (pValue->prev) pValue = pValue->prev;
							//sƱb̫@᭱
							pValue->next = pNewValue;
							pNewValue->prev = pValue;
						}
						//]wsC
						pCurrTable->Value[tag.index[0]][tag.index[1]]->prev = pNewValue; 
					}
				}
				break;
			
			//case FORM_TAG_IGNORE:
			default:
				break;
			}
		}
		if (!bFail) bSuccess = 1;
		break;
	}

	fclose(fid);

	if (!bSuccess)
	{
		SKYFORM_ReleaseForm(&pForm);
		return NULL;
	}

	return pForm;
}

void SKYFORM_ReleaseForm(SKYFORM **ppForm)
{
	if (!ppForm || !(*ppForm)) return;
	SB_Close(&((*ppForm)->pBuf));
	free(*ppForm);
	*ppForm = NULL;
}

int SKYFORM_ParseTag(FILE *fid, SKYFORM_TAG *pTag)
{
	//ŪJƦsboRA}CAsIsɷ|QM
	static char buf[SKYFORM_TAG_MAX_LINE_LEN] = {0};

	char *Tag, *TagEnd, *Index, *Comma;
	char TagLetter[2] = {0};
	WORD idx;

	if (!fid || !pTag)
	{
		return -1;
	}

	//MbufferApTag->type
	memset(buf, 0, SKYFORM_TAG_MAX_LINE_LEN);

	//YŪŪɮ׵NX
	if (!fgets(buf, SKYFORM_TAG_MAX_LINE_LEN, fid))
	{
		return -1;
	}

	///080510 YNh
	if (buf[strlen(buf)-1] == '\n')
	{
		buf[strlen(buf)-1] = '\0';
	}
	///

	//TaglȬFORM_TAG_IGNORE = 0
	memset(pTag, 0, sizeof(SKYFORM_TAG));

	for (;;)
	{
		//Ĥ@ӦrAO'['~~
		if (1 != sscanf(buf, "%1s", TagLetter)) break;
		if (TagLetter[0] != '[') break;

		//'['k
		if (!(Tag = strstr(buf, "["))) break;
		Tag = Tag + 1;

		//']'
		if (!(TagEnd = strstr(Tag, "]"))) break;
		//ҥkݳ]r굲
		*TagEnd = '\0';

		//Tagr(AĤ@Ӧr)
		if (1 != sscanf(Tag, "%1s", TagLetter)) break;
		Tag = strstr(Tag, TagLetter);

		switch (TagLetter[0])
		{
		case 'D':
			pTag->type = SKYFORM_TAG_DATATYPE;	break;
		case 'C':
			pTag->type = SKYFORM_TAG_CODING;	break;
		case 'S':
			pTag->type = SKYFORM_TAG_SUBJECT;	break;
		case 'K':
			pTag->type = SKYFORM_TAG_KEY;		break;
		case 'T':
			pTag->type = SKYFORM_TAG_TABLE;		break;
		case 'F':
			pTag->type = SKYFORM_TAG_FIELD;		break;
		case 'I':
			pTag->type = SKYFORM_TAG_ITEM;		break;
		case 'V':
			pTag->type = SKYFORM_TAG_VALUE;		break;
		default:
			pTag->type = SKYFORM_TAG_IGNORE;	break;
		}

		//䤣쥿TTagNX
		if (pTag->type == SKYFORM_TAG_IGNORE) break;

		//Valuemb']'k
		pTag->value = TagEnd + 1;

		//쥪A(k
		if (!(Index = strstr(Tag, "("))) break;
		Index = Index + 1;

		//ŪĤ@Ӿindex
		if (1 != sscanf(Index, "%d", &idx)) break;
		pTag->index[pTag->nIndex++] = idx;

		//rIk
		if (!(Comma = strstr(Index, ","))) break;
		Index = Comma + 1;

		//ŪĤGӾindex
		if (1 != sscanf(Index, "%d", &idx)) break;
		pTag->index[pTag->nIndex++] = idx;
		break;	//for(;;)
	}

	return 0;
}

/*--------------------------------------------------*/
/*			SKYBUFFER iܰʦȦsŶ				*/
/*--------------------------------------------------*/
SKYBUFFER* SB_Open(DWORD BlockSize)
{
	SKYBUFFER *pBuf = (SKYBUFFER*)malloc(sizeof(SKYBUFFER));
	if (!pBuf) return NULL;
	memset(pBuf, 0, sizeof(SKYBUFFER));
	if (BlockSize)
	{
		//TOBlockSize4
		if (BlockSize & 0x01) BlockSize += 0x01;
		if (BlockSize & 0x02) BlockSize += 0x02;
		pBuf->BlockSize = BlockSize;
	}
	else
	{
		pBuf->BlockSize = SKYBUFFER_BASE_DEFAULT_SIZE;
	}
	return pBuf;
}

void SB_Close(SKYBUFFER **ppBuf)
{
	if (!ppBuf || !(*ppBuf)) return;
	SB_Free(*ppBuf);
	*ppBuf = NULL;
}

BYTE* SB_Alloc(SKYBUFFER *pBuf, DWORD size)
{
	if (!pBuf || size==0) return NULL;
	
	BYTE* pReturn = NULL;
	SKYBUFFER_BASE_BLOCK* pTempBlock;

	//TOCtmƭBYTE(4)
	if (size & 0x01) size += 0x01;
	if (size & 0x02) size += 0x02;

	//Ŷ
	if (  pBuf->pCurrBlock
		&& 
		  pBuf->pCurrBlock->pos + size <= pBuf->pCurrBlock->size
	   )
	{
	}
	//ŶάŦC
	else
	{
		//l@ӷsblock
		pTempBlock = (SKYBUFFER_BASE_BLOCK*)malloc(sizeof(SKYBUFFER_BASE_BLOCK));
		if (!pTempBlock) return NULL;
		memset(pTempBlock, 0, sizeof(SKYBUFFER_BASE_BLOCK));

		//Mwbase size
		if (size <= pBuf->BlockSize)
		{
			pTempBlock->size = pBuf->BlockSize;
		}
		else
		{
			pTempBlock->size = size;
		}

		//tbaseŶ(b4ƦmקKalignmentD)
		pTempBlock->base = (BYTE*)malloc(pTempBlock->size);
		if (!pTempBlock->base)
		{
			free(pTempBlock);
			return NULL;
		}
		memset(pTempBlock->base, 0, pTempBlock->size);
		
		if (pBuf->pCurrBlock)	//Ŷ
		{
			pBuf->pCurrBlock->next = pTempBlock;	
		}
		else					//Ĥ@}buffer
		{
			pBuf->pHeadBlock = pTempBlock;	
		}	
		pBuf->pCurrBlock = pTempBlock;
	}

	pReturn = pBuf->pCurrBlock->base + pBuf->pCurrBlock->pos;
	pBuf->pCurrBlock->pos += size;

	return pReturn;
}

void SB_Free(SKYBUFFER *pBuf)
{
	if (!pBuf) return;

	SKYBUFFER_BASE_BLOCK *pBlock = pBuf->pHeadBlock;
	SKYBUFFER_BASE_BLOCK *pNextBlock;

	while (pBlock)
	{
		pNextBlock = pBlock->next;
		if (pBlock->base) free(pBlock->base);
		free(pBlock);
		pBlock = pNextBlock;
	}

	memset(pBuf, 0, sizeof(SKYBUFFER));
}

char* SB_String(SKYBUFFER *pBuf, char *src)
{
	if (!pBuf || !src) return NULL;

	char* pReturn = NULL;

	if (pReturn = (char*)SB_Alloc(pBuf, strlen(src)+2))	//r꦳j(0x0000)
	{
		strcpy(pReturn, src);
	}
	
	return pReturn;
}

char* SB_nString(SKYBUFFER *pBuf, char *src, DWORD nChar)
{
	if (!pBuf || !src) return NULL;

	char* pReturn = NULL;

	if (pReturn = (char*)SB_Alloc(pBuf, nChar+2))	//r꦳j(0x0000)
	{
		memcpy(pReturn, src, nChar);
	}

	return pReturn;
}

#endif
