#ifndef _SKY_INIT_HEADER_
#define _SKY_INIT_HEADER_
#ifdef LEADTEK
	#define CURRENT_VERSION "V1.1"
#endif
//------------------------------------------------------------------------------------------------
//moved up by bk@070412 - sysetup.h need to use (not hardcode)
#define MAX_NUM_DEV			24//16//11
#define MAX_NUM_BKIMG		24//20
#define MAX_NUM_MTICON		6
#if defined(KINGSTON)
  #define MAX_NUM_MISC_ICON	12
#else
  #define MAX_NUM_MISC_ICON	10
#endif
//------------------------------------------------------------------------------------------------
//071022 Reaction Icons
#define MAX_NUM_REACTION_ICON 52
//------------------------------------------------------------------------------------------------
#include "sysetup.h"
//------------------------------------------------------------------------------------------------
#define DESC_FILE_NAME_LCD				"/sky/Sys.setup.LCD"
#ifndef TV_SWITCH_MOD
	#define DESC_FILE_NAME_TV			"/sky/Sys.setup.TV"
	#define CAL_ALARM_DEFAULT_RING		"/sky/ring.mp3"
#else
	#define DESC_FILE_NAME_720X480		"/sky/Sys.setup.720x480"
	#define DESC_FILE_NAME_720X576		"/sky/Sys.setup.720x576"
	#define DESC_FILE_NAME_1920X1080	"/sky/Sys.setup.1920x1080"
	#define TV_OUT_MODE_FILE_NAME		"/tmp/conf/TVOut.setup"
	#define CAL_ALARM_DEFAULT_RING		"/sky_solid/ring.mp3"
#endif
#define USER_SETUP_FILE_NAME			"/sky/User.setup"//symbol link
#define USER_SETUP_REAL_FILE_NAME		"/tmp/User.setup"//abs path
#define USER_SETUP_DEFAULT_FILE_NAME	"/sky/User.setup.old"
#define USER_SETUP_SAVED_FILE_NAME		"/tmp/conf/User.setup"
#define USER_BRIGHTNESS_CONTRAST_FILE_NAME	"/tmp/conf/BC.setup"
#define FIRMWARE_VERSION_FILE_NAME		"/proc/versions"
#define BT_DEVICE_LIST_FILE_NAME		"/tmp/conf/btdvc.lst"
#define CAL_ALARM_USER_RING				"/mnt/sknand/alarm.mp3"
//------------------------------------------------------------------------------------------------
#define HD_PATH 		"/mnt/harddisk/"
#define SDMMC_PATH	"/mnt/sdmmc/"
#define MS_PATH		"/mnt/msx/"
#define XDSM_PATH	"/mnt/xdsm/"
#define CF_PATH		"/mnt/cf/"
#define USB_PATH		"/mnt/usb/"
#define FLASH_PATH	"/mnt/sknand/"
#define BT_PATH		"/mnt/sknand/My Received File/"
#define NET_PATH		"/mnt/net0/"
//------------------------------------------------------------------------------------------------
/*
///070820 SETUP
#define SETUP_BORDER_TOP			37
#define SETUP_BORDER_LR			2

#ifdef MEDIALINK
#define SETUP_BORDER_TOP_MEDIALINK		65
#define SETUP_BORDER_LR_MEDIALINK			18
#endif
///
*/
//------------------------------------------------------------------------------------------------
#define BORDER_THICK				4
#define BORDER_COLOR				YELLOW_1555
#define BORDER_WIDTH				2
#define MAIN_MENU_X				0
#define MAIN_MENU_Y				0
//------------------------------------------------------------------------------------------------
#define NUM_OF_IV_MATRIX			36
#define ROW_NUM_OF_IV_MATRIX	6
#define NUM_OF_AUDIO_LIST		24
#define NUM_OF_FRAME_MSG		50
//------------------------------------------------------------------------------------------------
#define NUM_OF_FOLDER_LIST		24
//------------------------------------------------------------------------------------------------
#define NUM_OF_FONT_FILE			8
//------------------------------------------------------------------------------------------------
#define NUM_OF_BT_DVC_LIST		24
#define NUM_OF_BT_FLDR_LIST	24
//------------------------------------------------------------------------------------------------
typedef enum
{
	bkg_blank = 0,
	bkg_photo = 2,
	bkg_music = 3,
	bkg_video = 4,

	bkg_cal = 5,
	bkg_cal_fi = 6,
	bkg_cal_hdtv = 13,

	bkg_setup = 8,
	bkg_usb2pconn = 9,
	bkg_nodevice = 10,
	bkg_mt = 1,
	bkg_folder = 7,
	bkg_confirm = 11,
	bkg_fwupgrade = 12,

	bkg_slideshow = 14,
	bkg_bt = 15,
	bkg_hdautocp = 16
	///080502 for WEB_APP_MOD
	,bkg_form = 17
	///
}BACKGROUND_IMAGE;

//------------------------------------------------------------------------------------------------
typedef enum
{
	ib_hd = 0,
	ib_cf = 1,
	ib_sdmmc = 2,
	ib_xdsm = 3,
	ib_ms = 4,
	ib_usb = 5,
	ib_usb2pconn = 6,
	ib_flash = 7,
	ib_bt = 8
}ICON_IMAGE_DS_ORIGINAL;
//------------------------------------------------------------------------------------------------
typedef enum
{
	ia_hd = 0,
	ia_cf = 1,
	ia_sdmmc = 2,
	ia_xdsm = 3,
	ia_ms = 4,
	ia_usb = 5,
	ia_usb2pconn = 6,
	ia_flash = 7,
	ia_bt = 8
}ICON_IMAGE_DS_FOCUSED;
//------------------------------------------------------------------------------------------------
typedef enum
{
	is_hd = 0,
	is_cf = 1,
	is_sdmmc = 2,
	is_xdsm = 3,
	is_ms = 4,
	is_usb = 5,
	is_flash = 7,
	is_bt = 8
}ICON_IMAGE_DS_STORAGE;
//------------------------------------------------------------------------------------------------
typedef enum
{
	ib_photo = 0,
	ib_music = 1,
	ib_video = 2,
	ib_cal = 3,
	ib_setup = 4,
	ib_folder = 5
}ICON_IMAGE_MT_ORIGINAL;
//------------------------------------------------------------------------------------------------
typedef enum
{
	ia_photo = 0,
	ia_music = 1,
	ia_video = 2,
	ia_cal = 3,
	ia_setup = 4,
	ia_folder = 5
}ICON_IMAGE_MT_FOCUSED;
//------------------------------------------------------------------------------------------------
typedef enum
{
	ie_photo = 0,
	ie_music = 1,
	ie_video = 2
}ICON_IMAGE_MT_ERROR;
//------------------------------------------------------------------------------------------------
typedef enum
{
	i_notsupport = 0,
	i_music = 1,
	i_musicplayed = 2,
	i_musicnotsupport = 3
}ICON_IMAGE_MISC;
//------------------------------------------------------------------------------------------------
enum
{
	USER_SETUP_LANGUAGE						= 0,
	USER_SETUP_POWERSAVING					= 1,
	USER_SETUP_SYS_ALPHA						= 2,
	USER_SETUP_HOMEPAGE						= 3,
	USER_SETUP_BRIGHTNESS						= 4,
	USER_SETUP_CONTRAST						= 5,
	USER_SETUP_CAL_ALPHA						= 6,
	USER_SETUP_ALARM							= 7,
	USER_SETUP_ALARM_HOUR					= 8,
	USER_SETUP_ALARM_MIN						= 9,
	USER_SETUP_SS_REPEAT						= 10,
	USER_SETUP_SS_INTERVAL						= 11,
	USER_SETUP_SS_EFFECT						= 12,
	USER_SETUP_AUDIO_REPEAT					= 13,
	USER_SETUP_VIDEO_REPEAT					= 14,
	USER_SETUP_VIDEO_TIME_DSPLY				= 15,
	USER_SETUP_ATOPWR							= 16,
	USER_SETUP_ATOPWR_ON_HOUR				= 17,
	USER_SETUP_ATOPWR_ON_MIN					= 18,
	USER_SETUP_ATOPWR_OFF_HOUR				= 19,
	USER_SETUP_ATOPWR_OFF_MIN				= 20,
	USER_SETUP_VOLUME							= 21,
	USER_SETUP_SORTING							= 22,
	USER_SETUP_AUTOPLAY_MODE					= 23,
	USER_SETUP_AUTOPLAY_SELECTED_MEDIA		= 24,
	///080325knD(L/R)
	USER_SETUP_AUDIO_CHANNEL					= 25,
	///
#if defined(WINGUI) && defined(GUI_STYLE_COMTEK)
	USER_SETUP_DISPLAY_SCREEN					= 26,
	USER_CAL_AUTOPWR_ON_HOUR				= 27,
	USER_CAL_AUTOPWR_ON_MIN					= 34,
	USER_CAL_PROGRAM_DOWNLOAD				= 41,
	USER_CAL_AUTOPWR_OFF_HOUR				= 48,
	USER_CAL_AUTOPWR_OFF_MIN					= 55,
	NUM_OF_USER_SETUP_ITEM					= 62, //Total numbers of items above
#elif defined(WINGUI) && !defined(GUI_STYLE_COMTEK)
	USER_SETUP_DISPLAY_SCREEN					= 26,
	NUM_OF_USER_SETUP_ITEM					= 27, //Total numbers of items above
#elif defined(GUI_STYLE_COMTEK) && !defined(WINGUI)
	USER_CAL_AUTOPWR_ON_HOUR				= 26,
	USER_CAL_AUTOPWR_ON_MIN					= 33,
	USER_CAL_PROGRAM_DOWNLOAD				= 40,
	USER_CAL_AUTOPWR_OFF_HOUR				= 47,
	USER_CAL_AUTOPWR_OFF_MIN					= 54,
	NUM_OF_USER_SETUP_ITEM					= 61, //Total numbers of items above
#else
	NUM_OF_USER_SETUP_ITEM					= 26, //Total numbers of items above
#endif
};
//------------------------------------------------------------------------------------------------
typedef struct
{
	// Skydemo Resolution
	Uint16 XRES;
	Uint16 YRES;
	// Background Image Filename Array
	char bkgrdImg[MAX_NUM_BKIMG][LEN_XL];
	// Background Image Coordinate Array
	COORD bkgrdCoord[MAX_NUM_BKIMG];
	// DS ICON Image Filename Array => 0: Original; 1: Focused; 2:Storage
	char HD[3][LEN_XL];
	char CF[3][LEN_XL];
	char SDMMC[3][LEN_XL];
	char XDSM[3][LEN_XL];
	char MS[3][LEN_XL];
	char USB[3][LEN_XL];
	char USB2PCONN[3][LEN_XL];
	char FLASH[3][LEN_XL];
	char BT[3][LEN_XL];
	char NET[3][LEN_XL];
	char RSS[3][LEN_XL];

	//rywu20080516++
    char rss_frame_channel[3][LEN_XL];
    char rss_picasa[3][LEN_XL];
    //rywu20080516--

	char NAS[3][LEN_XL];
	char IPCAM[3][LEN_XL];
///080429 WEB_APP
	char WEBAPP_WEATHER[3][LEN_XL];
	char WEBAPP_NEWS[3][LEN_XL];
	char WEBAPP_EZPEER[3][LEN_XL];
///

	// DS ICON Image and Text Coordinate Array
	//[3] => 0:Original; 1:Focused; 2:Storage;
	//[11] => 0:HD; 1:CF; 2:SDMMC; 3:XDSM; 4:MS; 5:USB; 6:USB2PCONN; 7:FLASH; 8:BLUETOOTH; 9:RSS; 10:NAS
	//[2] => 0: Image; 1:Text;
	COORD DSCoord[3][MAX_NUM_DEV][2];
	char ICONFilename4DS[3][MAX_NUM_DEV][LEN_XL];//record mounted device and enabled USB2PC connection
	// MT ICON Image Filename Array => 0: Original; 1: Focused; 2:Not found;
	char PHOTO[3][LEN_XL];
	char MUSIC[3][LEN_XL];
	char VIDEO[3][LEN_XL];
	char CALENDAR[3][LEN_XL];
	char SETUPMENU[3][LEN_XL];
	char FOLDER[3][LEN_XL];
	// MT ICON Image and Text Coordinate Array
	//[3] => 0: Original; 1: Focused; 2:Not found;
	//[6] => 0:PHOTO; 1:MUSIC; 2:VIDEO; 3:CALENDAR; 4:SETUPMENU; 5:FOLDER;
	//[2] => 0: Image; 1:Text;
	COORD MTCoord[3][MAX_NUM_MTICON][2];
	char ICONFilename4MT[3][MAX_NUM_MTICON][LEN_XL];
	// Misc ICON Filename
	char MiscICONIMG[MAX_NUM_MISC_ICON][LEN_XL];
	// Misc ICON Image Coordinate Array
	COORD MiscICONCoord[MAX_NUM_MISC_ICON];

	//071022 Reaction Icons
	char ReactionICONIMG[MAX_NUM_REACTION_ICON][LEN_XL];
	COORD ReactionICONCoord[MAX_NUM_REACTION_ICON];

	//070705 Font File
	char FontFileName[NUM_OF_FONT_FILE][LEN_XL];

	// PHOTO/VIDEO Display Matrix
	char ICONWidth[LEN_M];
	char ICONHeight[LEN_M];
	Uint8 ICONNumPerFrame;
	Uint8 ICONNumPerRow;
	COORD XbyYCoord[NUM_OF_IV_MATRIX];
	// MUSIC BAR Display
	Uint8 MusicBarNum;
	COORD MusicIconCoord[NUM_OF_AUDIO_LIST];
	COORD MusicBarCoord[NUM_OF_AUDIO_LIST];

	///070612 Folder Bar Display
	Uint8 FolderBarNum;
	COORD FolderIconCoord[NUM_OF_FOLDER_LIST];
	COORD FolderBarCoord[NUM_OF_FOLDER_LIST];
	///

	//070927 BT folder & Dvc Bar Display
	Uint8 BTFldrBarNum;
	COORD BTFldrIconCoord[NUM_OF_BT_FLDR_LIST];
	COORD BTFldrBarCoord[NUM_OF_BT_FLDR_LIST];
	Uint8 BTDvcBarNum;
	COORD BTDvcIconCoord[NUM_OF_BT_DVC_LIST];
	COORD BTDvcBarCoord[NUM_OF_BT_DVC_LIST];

	// MISC TEXT Coordinates
	Uint8 MiscTextNum;
	COORD MiscTextCoord[NUM_OF_FRAME_MSG];
}DESC;
//------------------------------------------------------------------------------------------------
int ParseDescriptor(DESC* pDesc, char *DescFileName);
//void ParseDescriptor(Uint8 output);
int InitSetupMenu();
void GetFirmwareInfo();
void LoadUserSetupFromMem();
void SaveUserSetupToMem();
int LoadUserSetup();
void SaveUserSetup();
Uint8 CompareUserBrightnessContrast();
void SaveUserBrightnessContrastSetup();
Uint8 LoadTVOutputMode();
void SaveUserTVOutModeSetup();
void SaveConf();
int checkUserSetupFile();
//------------------------------------------------------------------------------------------------
extern DESC descLCD, descTV, *desc;
extern SKY_SETUP *setup;
extern SKY_SETUP *allSetup[LANG_ITEM_NUM];
extern Uint8 SavedUserSetupItem[NUM_OF_USER_SETUP_ITEM];
#endif

