#include <sys/mount.h>
#include "skyutil.h"
#include "skyinit.h"
#include "FWUpgrade.h"

//#include "fs.h"
//------------------------------------------------------------------------------------------------
#define 	VFAT 				"vfat"
#define	NETSET_PROFILE		"/tmp/conf/rt73sta.dat"
//------------------------------------------------------------------------------------------------
char *MNT_HD2_ARGV[]		= {"/dev/hda2", 		HD_PATH, 		VFAT};
char *MNT_SDMMC5_ARGV[] 	= {"/dev/sdmmca5", 	SDMMC_PATH, 	VFAT};
char *MNT_MS5_ARGV[] 		= {"/dev/msxa5", 		MS_PATH, 		VFAT};
char *MNT_XDSM5_ARGV[] 	= {"/dev/xdsma5", 	XDSM_PATH, 		VFAT};
char *MNT_CF5_ARGV[] 		= {"/dev/cfa5", 		CF_PATH, 		VFAT};
char *MNT_USB5_ARGV[] 	= {"/dev/sda5", 		USB_PATH, 		VFAT};
//-----------------------------------------------------------------------------------------------
char *MNT_USB4_ARGV[] 	= {"/dev/sda4", 		USB_PATH, 		VFAT};
//-----------------------------------------------------------------------------------------------
char *MNT_HD1_ARGV[]		= {"/dev/hda1", 		HD_PATH, 		VFAT};
char *MNT_SDMMC1_ARGV[] 	= {"/dev/sdmmca1", 	SDMMC_PATH, 	VFAT};
char *MNT_MS1_ARGV[] 		= {"/dev/msxa1", 		MS_PATH, 		VFAT};
char *MNT_XDSM1_ARGV[] 	= {"/dev/xdsma1", 	XDSM_PATH,		VFAT};
char *MNT_CF1_ARGV[] 		= {"/dev/cfa1", 		CF_PATH, 		VFAT};
char *MNT_USB1_ARGV[] 	= {"/dev/sda1", 		USB_PATH, 		VFAT};
//------------------------------------------------------------------------------------------------
char *MNT_FLASH_ARGV[] 	= {"/dev/sknandb", 	FLASH_PATH, 		VFAT};
//------------------------------------------------------------------------------------------------
char *FDISK_ARGV[]			= {"fdisk", "-q", NULL};
//------------------------------------------------------------------------------------------------
pid_t dhcp_pid = 0;
pid_t net_socket_pid;
static unsigned int cifs_pass = 0;
extern unsigned int net_slideshow;
//nelly add 6/23/2008 for wps push button
static int net_vendor = NET_UNKNOWN;
#ifdef WPS_SUPPORT
static unsigned int wps_timer;
static time_t wps_sys_sec;
void ralink_wps_pbc(void);
void ralink_wps_stop(void);
void set_wps_timer(void);
void check_wps_timer(void);
void wps_run(void);
#endif
#if NET_DISABLE	//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
unsigned char wifi_down = 0;
unsigned char cifs_down = 0;

#endif
int dhcpsts, netskctsts;
Uint32 isSocketCreated = FALSE;
extern Uint8 isGWSet;		//0: none; bit_1(1): got mac; bit_2(2): wired; bit_3(4):wireless;

#ifdef ZYDAS_SUPPORT
	#include <stdarg.h>
	#ifdef WPA_SUPPLICANT_SUPPORT
		static const char *wpa_supplicant_conf_comment[] = {
			/* 0 */ "network={\n",
			/* 1 */ "  ssid=\"%s\"\n",
			/* 2 */ "  proto=%s\n",
			/* 3 */ "  key_mgmt=%s\n",
			/* 4 */ "  pairwise=%s\n",
			/* 5 */ "  group=%s\n",
			/* 6 */ "  psk=\"%s\"\n",
			/* 7 */ "  priority=2\n",
			/* 8 */ "}\n",
			0,
		};
		WPA_SUPPLICANT_CONF_CMD  *wpa_supplicant_start_pointer=NULL,*wpa_supplicant_next_pointer,*wpa_supplicant_head;
	#endif	
	int auth_wpa2 = 0;
	#ifdef WPS_SUPPORT
		static const char *wps_conf_comment[] = {
			/* 0 */ "CONFIG_MANUFACTURER=Atheros Communications\n",
			/* 1 */ "CONFIG_MODEL_NAME=IEEE 80211b/g WLAN Linux Driver\n",
			/* 2 */	"CONFIG_MODEL_NUMBER=3.0.0.13\n",
			/* 3 */	"CONFIG_DEVICE_NAME=Generic USB Wifi Dongle\n",
			/* 4 */	"CONFIG_DEVICE_UUID=00,11,22,33,44,55,66,77,88,99,aa,bb,cc,dd,ee,ff\n",
			/* 5 */	"CONFIG_PRIMARY_DEVICE_TYPE=00,10,00,50,F2,04,00,00\n",
			/* 6 */	"# 1=2.4G, 2=5G, 3=2.4+5G\n",
			/* 7 */	"CONFIG_RFBands=1\n\n",
			/* 8 */ "# Set the STA interface\n",
			/* 9 */ "wds_sta=rausb0\n\n",
			/*10 */ "# Set the method\n",
			/*11 */	"# 0: Push button\n",
			/*12 */ "# 1: Pin\n",
			/*13 */	"method=%d\n\n",
			/*14 */ "# Set the alive mode\n",
			/*15 */ "# 0: exit when handshake done\n",
			/*16 */ "# 1: always stay in memory\n",
			/*17 */	"alive=0\n\n",
			/*18 */ "# Set the daemon mode\n",
			/*19 */	"# 0: daemon mode\n",
			/*20 */	"# 1: normal application\n",
			/*21 */	"nodaemon=1\n\n",
			/*22 */ "# Set the deley between wsccmd and wpa_supplicant\n",
			/*23 */	"# default min is 3 seconds\n",
			/*24 */	"sup_delay=6\n\n",
			/*25 */ "# Set the policy\n",
			/*26 */	"# 0: recursive try\n",
			/*27 */ "# 1: detect pbc pattern\n",
			/*28 */ "policy=%d\n\n",
			/*29 */ "# Set the service type\n",
			/*30 */ "# 0x1: public; 0x2: data; 0x4: voice; 0x8: video\n",
		 	/*31 */ "service=1\n\n",
		 	/*32 */ "# Set the PIN number\n",
			/*33 */ "pin=%d\n",
			0,
		};
		WPS_CONF_CMD  *wps_start_pointer=NULL,*wps_next_pointer,*wps_head;
	#endif
#endif
#ifdef NET_MOD   //check if any eth ioctl
struct ethtool_cmd {
	Uint32	cmd;
	Uint32	supported;	/* Features this interface supports */
	Uint32	advertising;	/* Features this interface advertises */
	Uint16	speed;		/* The forced speed, 10Mb, 100Mb, gigabit */
	Uint8	duplex;		/* Duplex, half or full */
	Uint8	port;		/* Which connector port */
	Uint8	phy_address;
	Uint8	transceiver;	/* Which tranceiver to use */
	Uint8	autoneg;	/* Enable or disable autonegotiation */
	Uint32	maxtxpkt;	/* Tx pkts before generating tx int */
	Uint32	maxrxpkt;	/* Rx pkts before generating rx int */
	Uint32	reserved[4];
};
#define ETHTOOL_GSET		0x00000001 /* Get settings. */
#define SIOCETHTOOL	0x8946		/* Ethtool interface		*/
/*rywu20080516 move the below to skyutil.h and skydemo.h
//-1/0/1 = error/linked/no-link; if -1, we skip the check for asix ic(no such IOCTL)
static int detect_eth(void);
//-1/0/1/2 = error/linked/no-link(ralink)/no-link(atheros); if -1, we take as no wireless; 2/1/0=wireless on
static int detect_wifi(void);
#define     LINK_ERROR          -1
#define     LINK_DONE           0
#define     LINK_ETH_FAIL       1
#define     LINK_RALINK_FAIL    1
#define     LINK_ZYDAS_FAIL     2
static int wifi_check = LINK_ERROR;
*/
#endif
//------------------------------------------------------------------------------------------------
///080623 jM˸m
DeviceSearchSequence* NewDeviceSearchSequence(DeviceSearchTable DevTable)
{
	int i;
	DeviceSearchSequence *pSeq = NULL;
	MEMALLOC(pSeq, DeviceSearchSequence, 1);
	memcpy(&(pSeq->DevTable), &DevTable, sizeof(DeviceSearchTable));
	RenewDeviceSearchSequence(pSeq);
	return pSeq;
}

int SetDeviceSearchSequence(DeviceSearchSequence *pSeq, Uint8 dev_num, Uint8 seq)
{
	if (   !pSeq
		|| dev_num>=NUM_OF_SEARCH_DEV
		|| seq>=NUM_OF_SEARCH_DEV
	   )
	{
		return -1;
	}

	int i, j;
	DeviceLabel templabel = {0};
	for (i=0; i<NUM_OF_SEARCH_DEV; i++)
	{	//˸mm
		if (pSeq->DevTable.Labels[i].dev_num == dev_num) break;
	}

	if (seq < i)	//VW
	{
		templabel = pSeq->DevTable.Labels[i];
		for (j=i; j>seq; j--)
		{
			pSeq->DevTable.Labels[j] = pSeq->DevTable.Labels[j-1];
		}
		pSeq->DevTable.Labels[seq] = templabel;
	}
	else if (seq > i)	//VU
	{
		templabel = pSeq->DevTable.Labels[i];
		for (j=i; j<seq; j++)
		{
			pSeq->DevTable.Labels[j] = pSeq->DevTable.Labels[j+1];
		}
		pSeq->DevTable.Labels[seq] = templabel;
	}

	return RenewDeviceSearchSequence(pSeq);
}

int RenewDeviceSearchSequence(DeviceSearchSequence *pSeq)
{
	if (!pSeq) return -1;

	int i;
	Uint8 dev_num = 0;
	pSeq->nDevice = 0;
	for (i=0; i<NUM_OF_SEARCH_DEV; i++)
	{
		if (pSeq->DevTable.Labels[i].search_flag)
		{
			dev_num = pSeq->DevTable.Labels[i].dev_num;
			if (   (dev_num==SDMMC	&& dev_mnted_enbled_flags.sdmmc)
				|| (dev_num==CF		&& dev_mnted_enbled_flags.cf)
				|| (dev_num==USB	&& dev_mnted_enbled_flags.usb)
				|| (dev_num==XDSM	&& dev_mnted_enbled_flags.xdsm)
				|| (dev_num==MS		&& dev_mnted_enbled_flags.msx)
				|| (dev_num==HD		&& dev_mnted_enbled_flags.hd)
				|| (dev_num==FLASH	&& dev_mnted_enbled_flags.flash)
			   )
			{
				pSeq->Labels[pSeq->nDevice] = pSeq->DevTable.Labels + i;
				pSeq->nDevice++;
			}
		}
	}
	return 0;
}
///
//------------------------------------------------------------------------------------------------
void DisableReader()
{
	pid_t pid;
	int status;

	pid = fork();//080521
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DMSG("Disable Reader sysctl -w hostusb.switch=0 Fail!");
			break;
			//exit(1);
		case 0:
			execl("/sbin/sysctl", "sysctl", "-w", "hostusb.switch=0", NULL);
			_EXIT;
		default:
			waitpid(pid, &status, 0);
			if(WIFEXITED(status))
				dev_mnted_enbled_flags.usb2pconn = 0;//Card reader is not functioned
			break;
	}
}
//------------------------------------------------------------------------------------------------
void EnableReader()
{
	pid_t pid;
	int status;

	pid = fork();//080521
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DMSG("Enable Reader sysctl -w hostusb.switch=1 Fail!");
			break;
			//exit(1);
		case 0:
			execl("/sbin/sysctl", "sysctl", "-w", "hostusb.switch=1", NULL);
			_EXIT;
		default:
			waitpid(pid, &status, 0);
			if(WIFEXITED(status))
				dev_mnted_enbled_flags.usb2pconn = 1;//Card reader is functioned
			break;
	}
}
//------------------------------------------------------------------------------------------------
Uint8 IsCardChanged()
{
	Uint32 isCardInOut;

	isCardInOut = CAST32(LBase_CARD_USB[LBase_CARD_USB_idx]) & 0x00000001;
	if(isCardInOut)
	{
		//MSG("Card IN 0r OUT occurred!\n");
#ifdef NET_DISABLE
		net_slideshow = 0;
#endif
		CAST32(LBase_CARD_USB[LBase_CARD_USB_idx]) &= ~isCardInOut;
		return 1;
	}
	else
	{
		//MSG("No Card IN 0r OUT occurred!\n");
		return 0;
	}
}
//------------------------------------------------------------------------------------------------
void EnforceRenewPartitionInfo()
{
	pid_t pid;
	int status;
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("Fork failed!");
			DMSG("Fork to Enforce Renew Partition Info Fail");
			break;
			//exit(1);
		case 0:
			execvp(FDISK_ARGV[0], FDISK_ARGV);
			_EXIT;
		default:
#if 1		//tyhuang
			while(waitpid(pid, &status, 0)==0)	;
#else
			waitpid(pid, &status, 0);
#endif
			break;
	}
}
//------------------------------------------------------------------------------------------------
Uint8 CheckDevMntedSts(char *name)
{
	FILE *fp;
	char str[LEN_XL];

	if(!(fp = fopen("/proc/partitions", "r")))
	{
		DMSG("Failed to open file!\n");
		return ERRORCODE_FILE;
		//exit(1);
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		
		if(strstr(str, name))
		{
			//founded!
			//DPRINTF("Found %s\n", name);
			fclose(fp);
			return 1;
		}
	}
	//not founded!
	fclose(fp);
	//DPRINTF("Can't find %s\n", name);
	return ERRORCODE_SUCCESS;
}
//------------------------------------------------------------------------------------------------
void UmountDecive(DEV_NUM dev_num)
{
	pid_t pid;
	int status;
    int i=0;//rywu20080516

    //DBG_MSG("<skydemo> selected device is %s\n", SelectedDev);
	
	switch(dev_num)
	{
		case HD:
			if(dev_mnted_enbled_flags.hd)
			{
				while(1)
				{
					if(umount(HD_PATH) == 0)
					{
						//DMSG("UMOUNTING hd SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.hd = 0;
						break;
					}
					//DMSG("UMOUNTING hd FAILED!\n");
				}
			}
			break;
		case SDMMC:
			if(dev_mnted_enbled_flags.sdmmc)
			{
				while(1)
				{
					if(umount(SDMMC_PATH) == 0)
					{
						//DMSG("UMOUNTING sdmmc SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.sdmmc = 0;
						break;
					}
					//DMSG("UMOUNTING sdmmc FAILED!\n");
				}
			}
			break;
		case MS:
			if(dev_mnted_enbled_flags.msx)
			{
				while(1)
				{
					if(umount(MS_PATH) == 0)
					{
						//DMSG("UMOUNTING msx SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.msx = 0;
						break;
					}
					//DMSG("UMOUNTING msx FAILED!\n");
				}
			}
			break;
		case XDSM:
			if(dev_mnted_enbled_flags.xdsm)
			{
				while(1)
				{
					if(umount(XDSM_PATH) == 0)
					{
						//DMSG("UMOUNTING xdsm SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.xdsm = 0;
						break;
					}
					//DMSG("UMOUNTING xdsm FAILED!\n");
				}
			}
			break;
		case CF:
			if(dev_mnted_enbled_flags.cf)
			{
				while(1)
				{
					if(umount(CF_PATH) == 0)
					{
						//DMSG("UMOUNTING cf SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.cf = 0;
						break;
					}
					//DMSG("UMOUNTING cf FAILED!\n");
				}
			}
			break;
		case USB:
			if(dev_mnted_enbled_flags.usb)
			{
				while(1)
				{
					if(umount(USB_PATH) == 0)
					{
						//DMSG("UMOUNTING usb SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.usb = 0;
						break;
					}
					//DMSG("UMOUNTING usb FAILED!\n");
				}
			}
			break;
		case FLASH:
			if(dev_mnted_enbled_flags.flash)
			{
				while(1)
				{
					if(umount(FLASH_PATH) == 0)
					{
						//DMSG("UMOUNTING flash SUCCESSFULLY!\n");
						dev_mnted_enbled_flags.flash = 0;
						break;
					}
                    //rywu20080516++
                    //Just add the below to work-aroud.
                    //DO NOT foget to back here for debugging real cause ........
                    else
                    {
                        if (i++ > 10000) 
                        {
                            if (!strcmp(SelectedDev, DEVICE_CARD_READER_NAME))
                            {
                                system("mount -t vfat /dev/sknandb /mnt/sknand");
                            }
                        }
                    }
                    //rywu20080516--
					//DMSG("UMOUNTING flash FAILED!\n");
				}
			}
			break;
		case NET:
			if(dev_mnted_enbled_flags.nas)
			{
				while(1)
				{
					if(umount(NET_PATH) == 0)
					{
						dev_mnted_enbled_flags.nas = 0;
						break;
					}
				}
			}
			//dev_mnted_enbled_flags.rss = 0;
			break;
	}
}
//------------------------------------------------------------------------------------------------
void UmountAllDevices()
{
	umount(HD_PATH);
	umount(SDMMC_PATH);
	umount(MS_PATH);
	umount(XDSM_PATH);
	umount(CF_PATH);
	umount(USB_PATH);
	umount(FLASH_PATH);
#ifdef BLUETOOTH_MOD
	KillBTProcesses();
#endif
#ifdef NET_MOD
	umount(NET_PATH);
#endif
}
//------------------------------------------------------------------------------------------------
Uint8 MountDevice(Uint8 devNum, char **mnt_dev_argv)
{
	const char *specialfile;
	const char *dir;
	const char *filesystemtype;
	Uint32 rwflag;
	const void *data;

	specialfile = mnt_dev_argv[0];
	dir = mnt_dev_argv[1];
	filesystemtype = mnt_dev_argv[2];
	rwflag = MS_NOATIME | MS_NODIRATIME;
	data = NULL;
	
	switch(devNum)
	{
		case HD:
			if(!dev_mnted_enbled_flags.hd)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING hd SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.hd = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING hd FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("hd HAS BEEN MOUNTED!\n");
				return 1;
			}
		case SDMMC:
			if(!dev_mnted_enbled_flags.sdmmc)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING sdmmc SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.sdmmc = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING sdmmc FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("sdmmc HAS BEEN MOUNTED!\n");
				return 1;
			}
		case MS:
			if(!dev_mnted_enbled_flags.msx)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING msx SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.msx = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING msx FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("msx HAS BEEN MOUNTED!\n");
				return 1;
			}
		case XDSM:
			if(!dev_mnted_enbled_flags.xdsm)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING xdsm SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.xdsm = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING xdsm FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("xdsm HAS BEEN MOUNTED!\n");
				return 1;
			}
		case CF:
			if(!dev_mnted_enbled_flags.cf)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING cf SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.cf = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING cf FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("cf HAS BEEN MOUNTED!\n");
				return 1;
			}
		case USB:
			if(!dev_mnted_enbled_flags.usb)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING usb SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.usb = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING usb FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("usb HAS BEEN MOUNTED!\n");
				return 1;
			}
		case FLASH:
			if(!dev_mnted_enbled_flags.flash)
			{
				if(mount(specialfile, dir, filesystemtype, rwflag, data) == 0)
				{
					//DMSG("MOUNTING flash SUCCESSFULLY!\n");
					dev_mnted_enbled_flags.flash = 1;
					return 1;
				}
				else
				{
					//DMSG("MOUNTING flash FAILED!\n");
					return 0;
				}
			}
			else
			{
				//DMSG("flash HAS BEEN MOUNTED!\n");
				return 1;
			}
	}
}
//------------------------------------------------------------------------------------------------
Uint8 RenewDeviceMountedStatus(Uint8 NumMntDev)
{
	Uint8 ret = 0;

	if(IsCardChanged())
	{
		EnforceRenewPartitionInfo();
	}
	else
	{
		//DMSG("NO Card IN or OUT occurred!\n");
		return NumMntDev;
	}
	//HD------------------------------------------------------------------------------------------
	if(!CheckDevMntedSts("hda"))
		UmountDecive(HD);// hd may be unplugged!
	else if(CheckDevMntedSts("hda2"))
	{
		if(MountDevice(HD, MNT_HD2_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("hda1"))
	{
		if(MountDevice(HD, MNT_HD1_ARGV))
			ret++;
	}
	//else
		//DMSG("SOMETHING WRONG!!!\n");
	//SDMMC--------------------------------------------------------------------------------------
	if(!CheckDevMntedSts("sdmmca"))
		UmountDecive(SDMMC);
	else if(CheckDevMntedSts("sdmmca5"))
	{
		if(MountDevice(SDMMC, MNT_SDMMC5_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("sdmmca1"))
	{
		if(MountDevice(SDMMC, MNT_SDMMC1_ARGV))
			ret++;
	}
	//else
		//DMSG("SOMETHING WRONG!!!\n");
	//CF------------------------------------------------------------------------------------------
	if(!CheckDevMntedSts("cfa"))
		UmountDecive(CF);
	else if(CheckDevMntedSts("cfa5"))
	{
		if(MountDevice(CF, MNT_CF5_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("cfa1"))
	{
		if(MountDevice(CF, MNT_CF1_ARGV))
			ret++;
	}
	//else
		//DMSG("SOMETHING WRONG!!!\n");
	//USB-----------------------------------------------------------------------------------------
	if(!CheckDevMntedSts("sda"))
		UmountDecive(USB);
	else if(CheckDevMntedSts("sda5"))
	{
		if(MountDevice(USB, MNT_USB5_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("sda4"))
	{
		if(MountDevice(USB, MNT_USB4_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("sda1"))
	{
		if(MountDevice(USB, MNT_USB1_ARGV))
			ret++;
	}
	//else
		//DMSG("SOMETHING WRONG!!!\n");
	//XDSM---------------------------------------------------------------------------------------
	if(!CheckDevMntedSts("xdsma"))
		UmountDecive(XDSM);
	else if(CheckDevMntedSts("xdsma5"))
	{
		if(MountDevice(XDSM, MNT_XDSM5_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("xdsma1"))
	{
		if(MountDevice(XDSM, MNT_XDSM1_ARGV))
			ret++;
	}
	//else
		//DMSG("SOMETHING WRONG!!!\n");
	//MS------------------------------------------------------------------------------------------
	if(!CheckDevMntedSts("msxa"))
		UmountDecive(MS);
	else if(CheckDevMntedSts("msxa5"))
	{
		if(MountDevice(MS, MNT_MS5_ARGV))
			ret++;
	}
	else if(CheckDevMntedSts("msxa1"))
	{
		if(MountDevice(MS, MNT_MS1_ARGV))
			ret++;
	}
	//else
		//DMSG("SOMETHING WRONG!!!\n");
	//FLASH---------------------------------------------------------------------------------------
#if 1
	if(!dev_mnted_enbled_flags.flash);//flash may be unplugged!
	else
		ret++;//suppose that flash is always mounted successfully!
#else
	int fd, size;
	
	if((fd = open("/dev/sknandb", O_RDONLY, 0)) != -1)
	{
		ioctl(fd, BLKGETSIZE, &size);
		if(size > 0 && dev_mnted_enbled_flags.flash)
			ret ++;
		else
			UmountDecive(FLASH);
		close(fd);
	}
#endif
	return ret;
}
//------------------------------------------------------------------------------------------------
Uint8 RenewUSB2PCConn(Uint8 Num)
{
	Uint32 isUSB2PCOn;
	Uint8 ret;
	Sint8 IO = 0;//0: no change; 1: in; -1 out

	ret = Num;
	isUSB2PCOn = (CAST32(LBase_CARD_USB[LBase_CARD_USB_idx]) & 0x04) >> 2;
	if(isUSB2PCOn == 0x00000001)
	{
		dev_mnted_enbled_flags.usb2pconn = 1;
		ret++;
	}
	else
	{
		dev_mnted_enbled_flags.usb2pconn = 0;
	}
	IO = dev_mnted_enbled_flags.usb2pconn - dev_pre_mnted_enbled_flags.usb2pconn;
	if(IO == -1)
	{
		CloseSystem();
		InitSystem(INITSYS_CALL_BY_NORMAL);
	}
	else
	{
		return ret;
	}
}
//------------------------------------------------------------------------------------------------
Uint8 DetectDeviceMountedStatus()
{
	FILE *fp;
	char str[LEN_XL];
	int fd, size;
	Uint8 i, ret = 0;

	if(IsCardChanged())
		EnforceRenewPartitionInfo();
	
	if(!(fp = fopen("/proc/partitions", "r")))
	{
		DMSG("Failed to open file '/proc/partitions'!\n");
		return 0;
		//exit(1);
	}
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		//HD--------------------------------------------------------------------------------------
		if(strstr(str, "hda2") && !dev_mnted_enbled_flags.hd)
		{
			if(MountDevice(HD, MNT_HD2_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->HD[i]);
				IconTxtArr4DS[ret] = DEVICE_HD_NAME;
				ret += 1;
			}
			continue;
		}
		//SDMMC----------------------------------------------------------------------------------
		if(strstr(str, "sdmmca5") && !dev_mnted_enbled_flags.sdmmc)
		{
			if(MountDevice(SDMMC, MNT_SDMMC5_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->SDMMC[i]);
				IconTxtArr4DS[ret] = DEVICE_SDMMC_NAME;
				ret += 1;

				//FW Upgrade
				if (Detect_FW_Upgrade(SDMMC_PATH))
				{
					active_index = FW_UPGRADE_ACTIVE;
					ELMachines[FW_UPGRADE_ACTIVE].Init();
					ELMachines[FW_UPGRADE_ACTIVE].Display();
				}
			}
			continue;
		}
		//CF--------------------------------------------------------------------------------------
		if(strstr(str, "cfa5") && !dev_mnted_enbled_flags.cf)
		{
			if(MountDevice(CF, MNT_CF5_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->CF[i]);
				IconTxtArr4DS[ret] = DEVICE_CF_NAME;				
				ret += 1;
			}
			continue;
		}
		//USB-------------------------------------------------------------------------------------
		if(strstr(str, "sda5") && !dev_mnted_enbled_flags.usb)
		{
			if(MountDevice(USB, MNT_USB5_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->USB[i]);
				IconTxtArr4DS[ret] = DEVICE_USB_NAME;				
				ret += 1;

				///071101 FW Upgrade with USB
				if (Detect_FW_Upgrade(USB_PATH))
				{
					active_index = FW_UPGRADE_ACTIVE;
					ELMachines[FW_UPGRADE_ACTIVE].Init();
					ELMachines[FW_UPGRADE_ACTIVE].Display();
				}
				///
			}
			continue;
		}
		//XDSM-----------------------------------------------------------------------------------
		if(strstr(str, "xdsma5") && !dev_mnted_enbled_flags.xdsm)
		{
			if(MountDevice(XDSM, MNT_XDSM5_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->XDSM[i]);
				IconTxtArr4DS[ret] = DEVICE_xD_NAME;	
				ret += 1;
			}
			continue;
		}
		//MS--------------------------------------------------------------------------------------
		if(strstr(str, "msxa5") && !dev_mnted_enbled_flags.msx)
		{
			if(MountDevice(MS, MNT_MS5_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->MS[i]);
				IconTxtArr4DS[ret] = DEVICE_MS_NAME;
				ret += 1;
			}
			continue;
		}
	}
	//--------------------------------------------------------------------------------------------
	fseek(fp, 0, SEEK_SET);
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		//USB-------------------------------------------------------------------------------------
		if(strstr(str, "sda4") && !dev_mnted_enbled_flags.usb)
		{
			if(MountDevice(USB, MNT_USB4_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->USB[i]);
				IconTxtArr4DS[ret] = DEVICE_USB_NAME;				
				ret += 1;
			}
			continue;
		}
	}
	//--------------------------------------------------------------------------------------------
	fseek(fp, 0, SEEK_SET);
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		//HD--------------------------------------------------------------------------------------
		if(strstr(str, "hda1") && !dev_mnted_enbled_flags.hd)
		{
			if(MountDevice(HD, MNT_HD1_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->HD[i]);
				IconTxtArr4DS[ret] = DEVICE_HD_NAME;				
				ret += 1;
			}
			continue;
		}
		//SDMMC----------------------------------------------------------------------------------
		if(strstr(str, "sdmmca1") && !dev_mnted_enbled_flags.sdmmc)
		{
			if(MountDevice(SDMMC, MNT_SDMMC1_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->SDMMC[i]);
				IconTxtArr4DS[ret] = DEVICE_SDMMC_NAME;				
				ret += 1;

				//FW Upgrade
				if (Detect_FW_Upgrade(SDMMC_PATH))
				{
					active_index = FW_UPGRADE_ACTIVE;
					ELMachines[FW_UPGRADE_ACTIVE].Init();
					ELMachines[FW_UPGRADE_ACTIVE].Display();
				}
			}
			continue;
		}
		//CF--------------------------------------------------------------------------------------
		if(strstr(str, "cfa1") && !dev_mnted_enbled_flags.cf)
		{
			if(MountDevice(CF, MNT_CF1_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->CF[i]);
				IconTxtArr4DS[ret] = DEVICE_CF_NAME;				
				ret += 1;
			}
			continue;
		}
		//USB-------------------------------------------------------------------------------------
		if(strstr(str, "sda1") && !dev_mnted_enbled_flags.usb)
		{
			if(MountDevice(USB, MNT_USB1_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->USB[i]);
				IconTxtArr4DS[ret] = DEVICE_USB_NAME;				
				ret += 1;

				///071101 FW Upgrade with USB
				if (Detect_FW_Upgrade(USB_PATH))
				{
					active_index = FW_UPGRADE_ACTIVE;
					ELMachines[FW_UPGRADE_ACTIVE].Init();
					ELMachines[FW_UPGRADE_ACTIVE].Display();
				}
				///
			}
			continue;
		}
		//XDSM-----------------------------------------------------------------------------------
		if(strstr(str, "xdsma1") && !dev_mnted_enbled_flags.xdsm)
		{
			if(MountDevice(XDSM, MNT_XDSM1_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->XDSM[i]);
				IconTxtArr4DS[ret] = DEVICE_xD_NAME;	
				ret += 1;
			}
			continue;
		}
		//MS--------------------------------------------------------------------------------------
		if(strstr(str, "msxa1") && !dev_mnted_enbled_flags.msx)
		{
			if(MountDevice(MS, MNT_MS1_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->MS[i]);
				IconTxtArr4DS[ret] = DEVICE_MS_NAME;				
				ret += 1;
			}
			continue;
		}
	}
	fclose(fp);
	//FLASH---------------------------------------------------------------------------------------
	if((fd = open("/dev/sknanda", O_RDONLY, 0)) != -1)
	{
		ioctl(fd, BLKGETSIZE, &size);
		if(size > 0 && !dev_mnted_enbled_flags.flash)
		{
			if(MountDevice(FLASH, MNT_FLASH_ARGV))
			{
				for(i = 0; i < 2; i++)
					strcpy(desc->ICONFilename4DS[i][ret], desc->FLASH[i]);
				IconTxtArr4DS[ret] = DEVICE_FLASH_NAME;				
				ret += 1;
				///080414
				//FW Upgrade
				if (Detect_FW_Upgrade(FLASH_PATH))
				{
					close(fd);
					active_index = FW_UPGRADE_ACTIVE;
					ELMachines[FW_UPGRADE_ACTIVE].Init();
					ELMachines[FW_UPGRADE_ACTIVE].Display();
				}
				///
			}
		}
		close(fd);
	}
	return ret;
}
//------------------------------------------------------------------------------------------------
Uint8 DetectUSB2PCConnection(Uint8 num)
{
	Uint32 isUSB2PCOn;
	Uint8 i;
	
	isUSB2PCOn = (CAST32(LBase_CARD_USB[LBase_CARD_USB_idx]) & 0x04) >> 2;
	if(isUSB2PCOn == 0x00000001)
	{
		//DMSG("USB to PC Connection is ON\n");
		for(i = 0; i < 2; i++)
			strcpy(desc->ICONFilename4DS[i][num], desc->USB2PCONN[i]);
		IconTxtArr4DS[num] = DEVICE_CARD_READER_NAME;
		dev_mnted_enbled_flags.usb2pconn = 1;
		num++;
#ifdef USE_DESC_TV
  #ifndef TV_AUTO_CARDREADER_MODE_OFF
		isCardReaderOn = TRUE;
  #endif
  #ifdef FAKEPOWER
  		if(!isPowerOn)
			isCardReaderOn = FALSE;
  #endif
		//isCardReaderOn = FALSE;//TODO: used for debug
#endif
	}
	else
	{
#ifdef USE_DESC_TV
		isCardReaderOn = FALSE;
#endif
	}
	
	return num;
}

//------------------------------------------------------------------------------------------------
#ifdef BLUETOOTH_MOD
Uint8 DetectBTDongle(Uint8 num)
{
	Uint8 i;
	
	if(isBTDonglePlugged())
	{
		for(i = 0; i < 2; i++)
			strcpy(desc->ICONFilename4DS[i][num], desc->BT[i]);
		IconTxtArr4DS[num] = DEVICE_BT_NAME;
		dev_mnted_enbled_flags.bluetooth = 1;
		num++;
	}else
		dev_mnted_enbled_flags.bluetooth = 0;

	return num;
}
//------------------------------------------------------------------------------------------------
Uint8 isBTDonglePlugged()
{
#if 0 //wschen 2007-10-16
	FILE *fp;
	char str[LEN_XL], *dev = "Driver=hci_usb";

	if(!(fp = fopen("/proc/bus/usb/devices", "r")))
	{
		DMSG("Failed to open /proc/bus/usb/devices!\n");
		return FALSE;
		//exit(1);
	}
	
	while(!feof(fp))
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		
		if(strstr(str, dev))
		{
			//founded!
			//DPRINTF("Found %s\n", name);
			fclose(fp);
			return TRUE;
		}
	}
	
	//not founded!
	fclose(fp);
	//DPRINTF("Can't find %s\n", name);
	return FALSE;//function is worked, but the dongle is not plugged
#else
	FILE *fp = fopen("/proc/bt_adapter", "r");
	int yes = 0;
	if (fp) {
	  fread(&yes, sizeof(int), 1, fp);
	  fclose(fp);
	  if (yes) {
	    return TRUE;
	  } else {
	    return FALSE;
	  }
	} else {
	  return FALSE;
	}
#endif
}
#endif
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
//------------------------------------------------------------------------------------------------
Uint8 CheckNASMntedStatus()
{
	FILE *fp;
	//char str[LEN_XL];
	char *p_str=NULL;

	if(!(fp = fopen("/proc/mounts", "r")))
	{
		//printf("Failed to open /proc/mounts\n");
		return 0;
	}
	MEMALLOC(p_str, char, LEN_XL);
	while(!feof(fp))
	{
		memset(p_str, 0, sizeof(char) * LEN_XL);
		fgets(p_str, LEN_XL, fp);
		if(strstr(p_str, "/mnt/net0"))
		{
			FREEMEMORY(p_str);
			fclose(fp);
			return 1;
			//return 0;//simulate no mounting point of nas
		}
	}
	FREEMEMORY(p_str);
	fclose(fp);
	return 0;
}
Uint8 CheckCIFSStatus(void)
{
	FILE *fp;
	char *p_str=NULL;

	cifs_pass ++;
	if((cifs_pass%10)!=0)
	{		
		return 1;
	}
	if(!(fp = fopen("/proc/fs/cifs/DebugData", "r")))
	{
		return 0;
	}
	MEMALLOC(p_str, char, LEN_XL);
	while(!feof(fp))
	{
		memset(p_str, 0, sizeof(char) * LEN_XL);
		fgets(p_str, LEN_XL, fp);
		if(strstr(p_str, "DISCONNECTED"))
		{
			FREEMEMORY(p_str);
			fclose(fp);
			return 0;
		}
		else if(strstr(p_str, "WASCONNECTED"))
		{
			FREEMEMORY(p_str);
			fclose(fp);
			return 1;
		}		
	}
	FREEMEMORY(p_str);
	fclose(fp);
	return 1;
}
//------------------------------------------------------------------------------------------------
void KillNetSocket()
{
	//KILL(net_socket_pid);
	//while(waitpid(net_socket_pid, &netskctsts, 0) <= 0);
	if(net_socket_pid==0)
		return;
	netskctsts = 0;
	kill(net_socket_pid,9);
	waitpid(net_socket_pid, &netskctsts, WNOHANG);
	net_socket_pid = 0;
#if 1	//tyhuang: make sure kill all net socket: bad style
	system("killall netSocket");
#endif
	isSocketCreated = FALSE;
}
//------------------------------------------------------------------------------------------------
void RenewNetDongle(Uint8 *EnabledDevNum)
{
	FILE *fp;
	//char str[LEN_XL];
	ULint32 gatway_ip;
	char *p_str = NULL;
#if NET_DISABLE
	if(active_index == SETUP_L1_ACTIVE || 
	active_index == SETUP_L2_ACTIVE ||
	active_index == SETUP_L3_ACTIVE ||
	active_index == CONFIRM_ACTIVE)
	{
		goto skip_net_down;
	}
#endif
	if(active_index != DS_ACTIVE)
	{
		if(isSocketCreated)
		{
			//KILL SOCKET!!!
			KillNetSocket();
		}
#if NET_DISABLE	//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
	if(wifi_down == 0)
	{
		if((!strcmp(SelectedDev, DEVICE_CF_NAME) || 
		!strcmp(SelectedDev, DEVICE_xD_NAME) ||
		!strcmp(SelectedDev, DEVICE_AUTOSS_NAME) ||
		!strcmp(SelectedDev, DEVICE_USB_NAME) ||
		!strcmp(SelectedDev, DEVICE_HD_NAME) ||
		!strcmp(SelectedDev, DEVICE_MS_NAME) ||
		!strcmp(SelectedDev, DEVICE_SDMMC_NAME) ||
		!strcmp(SelectedDev, DEVICE_FLASH_NAME)))
		{
			net_slideshow = 0;
			wifi_down = 1;
			if (dhcp_pid > 0)
			{
				dhcpsts = 0;
				kill(dhcp_pid,9);
				waitpid(dhcp_pid, &dhcpsts, WNOHANG);
				dhcp_pid = 0;
			}
			if(CheckNASMntedStatus())
			{
				umount(NET_PATH);		//umount disk
				usleep(100);				//wait umount
				cifs_down = 1;
			}
			//call interface down
			if( (isGWSet & 2)!=0 )
				system("ifconfig eth0 down");
			if( (isGWSet & 4)!=0 )
				system("ifconfig rausb0 down");

			printf("\n ***** call interface down *****\n");
		}
	}
#else
	if((!strcmp(SelectedDev, DEVICE_CF_NAME) || 
		!strcmp(SelectedDev, DEVICE_xD_NAME) ||
		!strcmp(SelectedDev, DEVICE_AUTOSS_NAME) ||
		!strcmp(SelectedDev, DEVICE_USB_NAME) ||
		!strcmp(SelectedDev, DEVICE_HD_NAME) ||
		!strcmp(SelectedDev, DEVICE_MS_NAME) ||
		!strcmp(SelectedDev, DEVICE_SDMMC_NAME) ||
		!strcmp(SelectedDev, DEVICE_FLASH_NAME)))
		{
			net_slideshow = 0;
		}
#endif
	}
#if NET_DISABLE		//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
	else
	{
		wifi_down = 0;
		cifs_down = 0;
	}
#endif
#if NET_DISABLE
skip_net_down:
#endif
	if( (isGWSet & 2)!=0 )	//wired
	{
		//Detect if Net Dongle is plugged out or not
		if(!(fp = fopen("/proc/net/dev", "r")))
		{
			//printf("Failed to open file!\n");
			return;
		}
		MEMALLOC(p_str, char, LEN_XL);
		while(!feof(fp))
		{
			memset(p_str, 0, sizeof(char) * LEN_XL);
			fgets(p_str, LEN_XL, fp);
			if(strstr(p_str, "eth0"))
			{	
								net_vendor = ETH_GENERAL;
                if(detect_eth()==LINK_ETH_FAIL)      //no link
                {
                    FREEMEMORY(p_str);
                    fclose(fp);
                    if(isGWSet==3)
                    {
                        isGWSet = 2;
                        system("killall -SIGUSR2 udhcpc");
		                		dev_mnted_enbled_flags.nas = 0;
                        //dev_mnted_enbled_flags.rss = 0;
                        system("ifconfig eth0 down");
                    }
		            return;
		        }
				(*EnabledDevNum)++;

				///080530 ignore rss
				/*
				gatway_ip = CheckGWIP("eth0");
				if(((isGWSet & 1)!=0) || CheckGWMAC(&gatway_ip))
				//if((isGWSet & 1)!=0)
				{
					(*EnabledDevNum)++;
				}
				*/
				///

		    /* rywu20080526 
				if(active_index == RSS_ACTIVE
#ifdef IP_CAM_MOD
                   || active_index == IP_CAM_ACTIVE
#endif
				   )		//skip nas check if RSS is running
				{
					if(dev_mnted_enbled_flags.nas)
                    {
						(*EnabledDevNum)++;
				}
				}
			*/

				///080530
				if (0){}
				/*
	//rywu20080526++
	#ifdef IP_CAM_MOD
				if(active_index == IP_CAM_ACTIVE)
				{
					if(dev_mnted_enbled_flags.nas)
					{
						(*EnabledDevNum)++;
					}
				}
	#endif
	//rywu20080526--
				*/
				///
				
#if NET_DISABLE	//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
				else if(cifs_down ==1)
                {
					(*EnabledDevNum)++;
                }
#endif
				//check if mounting point is created!!!
				else if(CheckNASMntedStatus())
                {
					if(CheckCIFSStatus()==0)
					{
						if(dev_mnted_enbled_flags.nas)
						{
		    				umount(NET_PATH);
		    			}
		    		}
		    		else
		    		{
						(*EnabledDevNum)++;
					}
				}
				FREEMEMORY(p_str);
				fclose(fp);
				return;
			}
		}
		FREEMEMORY(p_str);
		fclose(fp);
		return;
	}
	else if( (isGWSet & 4)!=0 )	//wireless
	{
			int wifi;
	    wifi = detect_wifi();
#ifdef WPS_SUPPORT
			check_wps_timer();
#endif	    
	    if(wifi==LINK_RALINK_FAIL) //no link
	    {
	    		net_vendor = RALINK_WIRELESS;
	        if(wifi_check==wifi)        //detect result should be equal to renew check
            {
	            (*EnabledDevNum)++;
            }
	        else
		    {
		        wifi_check = wifi;  //link dies
		        system("killall -SIGUSR2 udhcpc");
		        isGWSet = 4;
#if NET_DISABLE	
		        if(wifi_down==1)	(*EnabledDevNum)++;
		        if(cifs_down==1)	(*EnabledDevNum)++;
#endif
		        dev_mnted_enbled_flags.nas = 0;
                //dev_mnted_enbled_flags.rss = 0;
		    }
	    }
#ifdef ZYDAS_SUPPORT
	    else if(wifi==LINK_ZYDAS_FAIL) //no link
	    {
	    		net_vendor = ZYDAS_WIRELESS;
	        if(wifi_check==wifi)        //detect result should be equal to renew check
	            (*EnabledDevNum)++;
	        else
		    	{
		        wifi_check = wifi;  //link dies
		        system("killall -SIGUSR2 udhcpc");
		        isGWSet = 4;
#if NET_DISABLE	
		        if(wifi_down==1)	(*EnabledDevNum)++;
		        if(cifs_down==1)	(*EnabledDevNum)++;
#endif
		        dev_mnted_enbled_flags.nas = 0;
            //dev_mnted_enbled_flags.rss = 0;
		    	}
	    }
#endif
	    else if(wifi==LINK_DONE) //link
	    {
	      if(wifi_check==wifi)        //detect result should be equal to renew check
            {
		    	(*EnabledDevNum)++;
            }
            else
            {
                wifi_check = wifi;//rywu20080721 //update it
            }
		    	

			///080530 ignore rss
			/*
		    //check if mounting point is created!!!
		    gatway_ip = CheckGWIP("rausb0");
		    if (((isGWSet & 1) != 0) || CheckGWMAC(&gatway_ip)) {
		      (*EnabledDevNum)++;
		    }
			*/
			///

		    /* rywu20080526 
		    if(active_index == RSS_ACTIVE
#ifdef IP_CAM_MOD
			   ||
			   active_index == IP_CAM_ACTIVE
#endif
			   )		//skip nas check if RSS is running
			{
					if(dev_mnted_enbled_flags.nas)
						(*EnabledDevNum)++;
			}*/

			///080530
		  	if (0){}
			/*
//rywu20080526++
#ifdef IP_CAM_MOD
			if(active_index == IP_CAM_ACTIVE)
			{
                if(dev_mnted_enbled_flags.nas)
                {
                    (*EnabledDevNum)++;
				}
			}
#endif
//rywu20080526--
			*/
			///
			
#if NET_DISABLE	//tyhuang: for interface down if playing interfaces excepting USB2PC, RSS and NAS
			else if(cifs_down ==1)
					(*EnabledDevNum)++;
#endif
		    else if(CheckNASMntedStatus()) 
            {
		    	if(CheckCIFSStatus()==0)
		    	{
						//printf("umount cifs disconnected\n");
		    			umount(NET_PATH);
		    	}
		    	else
		    	{
		    		(*EnabledDevNum)++;
		    	}
		    }
		    return;
        } 
        else 
            return;
	}
	else	//plug out?!
	{
		if(isGWSet==0)
		{
#if 1	//tyhuang: check device only
//printf("util isGWSet=%d\n",isGWSet);
			//Detect if Net Dongle is plugged out or not
			if(!(fp = fopen("/proc/net/dev", "r")))
			{
				DMSG("Failed to open file!\n");
				return;
			}
			MEMALLOC(p_str, char, LEN_XL);
			while(!feof(fp))
			{
				memset(p_str, 0, sizeof(char) * LEN_XL);
				fgets(p_str, LEN_XL, fp);
				if(strstr(p_str, "rausb0"))
				{
					FREEMEMORY(p_str);
					fclose(fp);
					(*EnabledDevNum)++;
					return;
				}
			}
			fseek(fp, 0, SEEK_SET);
			while(!feof(fp))
			{
				memset(p_str, 0, sizeof(char) * LEN_XL);
				fgets(p_str, LEN_XL, fp);
				if(strstr(p_str, "eth0"))
				{
					FREEMEMORY(p_str);
					fclose(fp);
					(*EnabledDevNum)++;
					return;
				}
			}
			FREEMEMORY(p_str);
			fclose(fp);
			return;
#endif
		}
		else
			isGWSet=0;
	}
	return;
}
//------------------------------------------------------------------------------------------------
Uint8 CheckGWMAC(ULint32 *gw_ip)
{
	char devname[64], sgw[4];
	char hw_flag[4],flags[4];
	char d[16];
	ULint32 ip, mac[6];
	FILE *fp;
	
	if(!(fp = fopen("/proc/net/arp", "r")))
	{
		DMSG("Failed to open /proc/net/arp\n");
		return 0;
	}
	if(fscanf(fp, "%*[^\n]\n") < 0)
	{
		fclose(fp);
		/* Skip the first line. */
		return 0;/* Empty or missing line, or read error. */
	}
	while(!feof(fp))
	{
		fscanf(fp, "%s%s%s%x:%x:%x:%x:%x:%x%s%63s\n",
				  d, hw_flag, flags, mac, mac+1, mac+2, mac+3, mac+4, mac+5, sgw, devname);
		//PRINTF("Gatway IP = %s\n", d);
		ip = (ULint32)inet_addr(d);
		//PRINTF("ip = %x; mac = %x:%x:%x:%x:%x:%x\n", ip, mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
		if(*gw_ip == ip)
		{
			if((mac[0] | mac[1] | mac[2] | mac[3] | mac[4] | mac[5]) != 0)
			{
				fclose(fp);
				return 1;
				//return 0;//simulate no gatway ip
			}
			else
			{
				fclose(fp);
				return 0;
			}
		}
	}
	fclose(fp);
	return 0;
}
//------------------------------------------------------------------------------------------------
void ForkNETSocket()
{
	if(isSocketCreated == TRUE)
		return;
	net_socket_pid = fork();
	switch(net_socket_pid)
	{
		case -1:
			perror("Fork failed!");
			//printf("Fork net-socket Fail!");
			break;
		case 0:
			//child process
			execl("/sky/netSocket", "netSocket", NULL);
			_EXIT;
		default:
			isSocketCreated = TRUE;
			signal(SIGCHLD,SIG_IGN);
			//DMSG("/sky/netSocket has been forked.\n");
			break;
	}

}
//------------------------------------------------------------------------------------------------
ULint32 CheckGWIP(char *ifname)
{
	char devname[64];
	ULint32 d, g, m;
	int flgs, ref, use, metric, mtu, win, ir;
	FILE *fp;
	int r;
	
	if(!(fp = fopen("/proc/net/route", "r")))
	{
		DMSG("Failed to open /proc/net/route\n");
		return 0;
	}
	if(fscanf(fp, "%*[^\n]\n") < 0)
	{
		fclose(fp);
		/* Skip the first line. */
		return 0;/* Empty or missing line, or read error. */
	}
	r = g = 0;
	
	while(!feof(fp))
	{
		r = fscanf(fp, "%63s%lx%lx%X%d%d%d%lx%d%d%d\n",
				  devname, &d, &g, &flgs, &ref, &use, &metric, &m, &mtu, &win, &ir);
		if(r!=11)	break;		
		if(g!=0)
		{
		    if(strstr(devname,ifname))
		    {
			    //printf("Gatway IP(%s) = %x\n",devname,g);
			    break;
			}
			else
			    g = 0;
		}
	}
	fclose(fp);
	return g;
}
//------------------------------------------------------------------------------------------------
void ForkGetDHCPIProcess(char *ifname)
{	
	if(dhcp_pid!=0)
	{
		return;
	}
	dhcp_pid = fork();
	switch(dhcp_pid)
	{
		case -1:
			//perror("Fork failed!");
			DMSG("Fork rausb0 hdcp Fail!");
			break;
		case 0:
			//child process
			execl("/sbin/udhcpc", "udhcpc", "-i", ifname, "-f", "-t", "6", "-p", "/tmp/udhcpc.pid", NULL);
			_EXIT;
		default:
			signal(SIGCHLD,SIG_IGN);
			//waitpid(dhcp_pid, &dhcpsts, 0);
			break;
	}
}
//------------------------------------------------------------------------------------------------
char *BasicFindSec(char *p_start)
{
	char *ptr;
	char *basic_set_id = "[Extra]";

	if((ptr = strstr(p_start, basic_set_id)) != NULL)	
		return (ptr + strlen("\n") + strlen(basic_set_id));
	else
		return NULL;
}
//------------------------------------------------------------------------------------------------
int GetKeyParameter(char *in, char *dest, int destsize, char *source)
{
	char *p_check;
	int len,i;

	len = strlen(in);
	p_check = strstr(source, in);
	if(p_check == NULL)
	{
		return -1;
	}
	if(*(p_check + len) != 61)//ascii "=" = 61
	{
		return -1;
	}
	memcpy(dest, p_check + len + 1, destsize);
	for(i = 0; i < destsize; i++)
	{
		if(dest[i] == 10)//line feed = 10
		{
			dest[i] = 0;
			break;
		}
	}
	//PRINTF("dest(%d)=%s",strlen(dest),dest);
	return 0;
}
//------------------------------------------------------------------------------------------------
void Get_rt73sta_Info(char *item_name, char *buff)
{
	FILE *fp;
	char *p_check = NULL;
	char *tmp_buffer = NULL;

	if(!(fp = fopen(NETSET_PROFILE, "r")))
	{
		DMSG("Failed to open /tmp/conf/rt73sta.dat\n");
		return;
	}
	memset(buff, 0, sizeof(char) * IPADDR_LEN);
	MEMALLOC(tmp_buffer, char, 1024);
	fread(tmp_buffer, 1023, sizeof(char),fp);			
	fclose(fp);
	tmp_buffer[1023] = 0;
	p_check = BasicFindSec(tmp_buffer);
	if(p_check == NULL)
	{

#if 1 //wschen 2007-12-19
	FREEMEMORY(tmp_buffer);
#endif
		return;
	}
	if(GetKeyParameter(item_name, buff, IPADDR_LEN, p_check) == -1)
	{

#if 1 //wschen 2007-12-19
	FREEMEMORY(tmp_buffer);
#endif
		return;
	}
	DPRINTF("[%s] = %s\n", item_name, buff);

#if 1 //wschen 2007-12-19
	FREEMEMORY(tmp_buffer);
#endif
}
#if 1 //wschen 2007-12-17
#include <net/route.h>
#include <linux/un.h>
#include <linux/if.h>
#define mask_in_addr(x) (((struct sockaddr_in *)&((x).rt_genmask))->sin_addr.s_addr)
#define RTACTION_ADD   1
#define RTACTION_DEL   2

int setroute(int action, int host, char *target, char *netmask, char *gateway, char *dev)
{
  struct rtentry rt;
  int skfd = -1;

  /* Clean out the RTREQ structure. */
  memset((char *) &rt, 0, sizeof(struct rtentry));

  /* Fill in the other fields. */
  rt.rt_flags = RTF_UP;
  if (host)
    rt.rt_flags |= RTF_HOST;

  /* target */
  rt.rt_dst.sa_family = AF_INET;
  if (!inet_aton(target,(struct in_addr*)&(((struct sockaddr_in*)&rt.rt_dst)->sin_addr)))
    return -1;

  /* netmask */
  rt.rt_genmask.sa_family = AF_INET;
  if (!inet_aton(netmask,(struct in_addr*)&(((struct sockaddr_in*)&rt.rt_genmask)->sin_addr)))
    return -1;

  /* gateway */
  rt.rt_gateway.sa_family = AF_INET;
  if (gateway != NULL) { //wschen
    if (!inet_aton(gateway, (struct in_addr*)&(((struct sockaddr_in*)&rt.rt_gateway)->sin_addr)))
      return -1;
    else
      rt.rt_flags |= RTF_GATEWAY;
  }

  rt.rt_dev = dev;

  /* Fill out netmask if still unset */
  if (rt.rt_flags & RTF_HOST)
    mask_in_addr(rt) = 0xffffffff;

  /* sanity checks.. */
  if (mask_in_addr(rt)) {
    __u32 mask = ~ntohl(mask_in_addr(rt));
    if ((rt.rt_flags & RTF_HOST) && mask != 0 )
      return -21;
    if (mask & (mask + 1))
      return -22;
    mask = ((struct sockaddr_in *) &rt.rt_dst)->sin_addr.s_addr;
    if (mask & ~mask_in_addr(rt))
      return -23;
  }

  /* Create a socket to the INET kernel. */
  if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    return -3;

  /* Tell the kernel to accept this route. */
  if (action == RTACTION_DEL) {
    if (ioctl(skfd, SIOCDELRT, &rt) < 0) {
      close(skfd);
      return -4;
    }
  } else {
    if (ioctl(skfd, SIOCADDRT, &rt) < 0) {
      close(skfd);
      return -4;
    }
  }

  /* Close the socket. */
  (void) close(skfd);
  return (0);
}

#if 0
void create_arp_record(char *dst)
{
  int s;
  char t[64];
  struct sockaddr_in addr;
  struct in_addr ina;

  inet_aton(dst, (struct in_addr *) &ina);

  if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    return;
  }

  memset(&dst, 0, sizeof(struct sockaddr_in));
  addr.sin_family = AF_INET;
  addr.sin_port = htons(1234);
  addr.sin_addr.s_addr = ina.s_addr;
  sendto(s, t, sizeof(t), 0, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));
  sendto(s, t, sizeof(t), 0, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));
  close(s);
}
#endif
#endif
//------------------------------------------------------------------------------------------------
void DetectNetDongle()
{
	FILE *fp,*fp1;
	char str[LEN_XL], getfixIPstr[LEN_XL], buff[IPADDR_LEN];
	Uint8 i, idx;
	ULint32 gatway_ip;
	
	if(!(fp = fopen("/proc/net/dev", "r")))
	{
		DMSG("Failed to open /proc/net/dev!\n");
		return;
	}
	//PRINTF("dev_mnted_enbled_flags.rss = %d\n", dev_mnted_enbled_flags.rss);
	//PRINTF("dev_mnted_enbled_flags.nas = %d\n", dev_mnted_enbled_flags.nas);
	while(!feof(fp) /*&& !dev_mnted_enbled_flags.rss*/ && !dev_mnted_enbled_flags.nas)
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		if(strstr(str, "eth0"))
		{
#if NET_DISABLE
			if(wifi_down == 1)
			{
				num_enabled_dev ++;
				//if((isGWSet & 1))
				//	num_enabled_dev ++;
				if(cifs_down==1)
					num_enabled_dev ++;
				return;
			}
#endif
			isGWSet |= 2;	//set wired
			if(detect_eth()==LINK_ETH_FAIL)      //no link
            {
                fclose(fp);
                if(isGWSet==3)
                {
                    isGWSet = 2;
                    system("ifconfig eth0 down");
                }
		        return;
		    }
			if(isGWSet==3)	//complete: just do one check
			{
				dev_mnted_enbled_flags.net = 1;
				idx = num_enabled_dev;
				num_enabled_dev++;

				///080321
				strcpy(desc->ICONFilename4DS[0][idx], desc->NET[0]);
				strcpy(desc->ICONFilename4DS[1][idx], desc->NET[1]);
				IconTxtArr4DS[idx] = DEVICE_NET_NAME;
				idx++;
				///

				gatway_ip = CheckGWIP("eth0");
				goto skip_eth0;
			}
			dev_mnted_enbled_flags.net = 1;
			idx = num_enabled_dev;
			num_enabled_dev++;

			///080321
			strcpy(desc->ICONFilename4DS[0][idx], desc->NET[0]);
			strcpy(desc->ICONFilename4DS[1][idx], desc->NET[1]);
			IconTxtArr4DS[idx] = DEVICE_NET_NAME;
			idx++;
			///

			//parse rt73sta.dat
			Get_rt73sta_Info("Dhcp", buff);
			if(buff != NULL && !strcmp("n", buff))//fixIP
			{
#if 1 //wschen 2007-12-17
			  int skfd = socket(PF_INET, SOCK_STREAM, 0);
			  struct ifreq ifreq;
			  struct sockaddr_in *sin;
			  
			  memset(&ifreq, 0, sizeof(struct ifreq));
			  sprintf(ifreq.ifr_name, "eth0");
			  ioctl(skfd, SIOCGIFFLAGS, &ifreq);
			  ifreq.ifr_flags |= IFF_UP;
			  ioctl(skfd, SIOCSIFFLAGS, &ifreq);
			  ifreq.ifr_qlen = 3;
			  ioctl(skfd, SIOCSIFTXQLEN, &ifreq);

			  Get_rt73sta_Info("IpAddr", buff);
			  memset(&ifreq, 0, sizeof(struct ifreq));
			  sprintf(ifreq.ifr_name, "eth0");
			  sin = (struct sockaddr_in *)&ifreq.ifr_addr;
			  sin->sin_family = AF_INET;
			  sin->sin_port = 0;
			  inet_aton(buff, &sin->sin_addr);
			  ioctl(skfd, SIOCSIFADDR, &ifreq);
#endif
#if 1	//save ip for fixed ip
				if(!(fp1 = fopen("/tmp/ip.txt", "w")))
				{
					DMSG("Failed to open ip.txt to write!\n");
					return;
				}
				fwrite(buff,sizeof(char),sizeof(buff)-1,fp1);
				fclose(fp1);
#endif

#if 1 //wschen 2007-12-17
			  Get_rt73sta_Info("Mask", buff);
			  memset(&ifreq, 0, sizeof(struct ifreq));
			  sprintf(ifreq.ifr_name, "eth0");
			  sin = (struct sockaddr_in *)&ifreq.ifr_addr;
			  sin->sin_family = AF_INET;
			  sin->sin_port = 0;
			  inet_aton(buff, &sin->sin_addr);
			  ioctl(skfd, SIOCSIFNETMASK, &ifreq);
			  close(skfd);
			  Get_rt73sta_Info("GwAddr", buff);
			  setroute(RTACTION_ADD, 0, "0.0.0.0", "0.0.0.0", buff, "eth0");
				Get_rt73sta_Info("DNS1", buff);
				if (strlen(buff)) {
				  FILE *dns = fopen("/tmp/conf/resolv.conf", "w+");
				  if (dns) {
				      fprintf(dns, "nameserver %s\n", buff);
				    Get_rt73sta_Info("DNS2", buff);
				    if (strlen(buff)) {
				      fprintf(dns, "nameserver %s\n", buff);
				    }
				    fclose(dns);
				  }
				}
#endif

#if 1	//still need to ping gateway, for GW is connected; since ping is easier, and less resource
				//exec
				memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
				strcat(getfixIPstr, "touch /tmp/conf/resolv.conf");
				system(getfixIPstr);
				sleep(3);	//wait for interface up
				memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
				strcat(getfixIPstr, "ping ");
				Get_rt73sta_Info("GwAddr", buff);
				strcat(getfixIPstr, buff);
				system(getfixIPstr);
#endif
#if 0
				Get_rt73sta_Info("GwAddr", buff);
				create_arp_record(buff);
#endif
			}
			else//DHCP
			{
				gatway_ip = CheckGWIP("eth0");
				if(gatway_ip)	//tyhuang: got ip already
				{
					goto skip_eth0;
				}
				else
				{
					system("ifconfig eth0 up");
					//Robert 2007-12-30
					if (dhcp_pid > 0)
					{
						//KILL(dhcp_pid);
						dhcpsts = 0;
						kill(dhcp_pid,9);
						waitpid(dhcp_pid, &dhcpsts, WNOHANG);
						dhcp_pid = 0;
					}
					ForkGetDHCPIProcess("eth0");
				}
			}
			gatway_ip = CheckGWIP("eth0");
			if(gatway_ip)
			{
				if(CheckGWMAC(&gatway_ip))
				{
skip_eth0:
					KillNetSocket();
					ForkNETSocket();
				}
			}
			else
			{
				//sleep(5);
				fclose(fp);
				return;
			}
			if(CheckNASMntedStatus())
			{
			 	DMSG("Mount succeeded!\n");
				dev_mnted_enbled_flags.nas = 1;
				num_enabled_dev++;
				for(i = 0; i < 2; i++)
				{
					strcpy(desc->ICONFilename4DS[i][idx], desc->NAS[i]);
				}
				IconTxtArr4DS[idx] = DEVICE_NAS_NAME;
				idx++;
			}
			else
			{
				DMSG("No Net Disk exists!!!\n");
			}
			///080530 ignore rss
			/*
			//confirm if packet-out-to-RSS server is OK!!!
			if(((isGWSet & 1)!=0) || CheckGWMAC(&gatway_ip))
			{
			 	isGWSet |= 1;	//set mac
				DMSG("The channel to RSS Server is OK!\n");
				dev_mnted_enbled_flags.rss = 1;
				num_enabled_dev++;
				for(i = 0; i < 2; i++)
				{
					strcpy(desc->ICONFilename4DS[i][idx], desc->RSS[i]);
				}
				IconTxtArr4DS[idx] = DEVICE_RSS_NAME;
			}
			else
			{
				DMSG("No Gateway exists!!!\n");
			}
			*/
			///
			fclose(fp);
			return;
		}
	}
	fseek(fp, 0, SEEK_SET);
	while(!feof(fp) /*&& !dev_mnted_enbled_flags.rss*/ && !dev_mnted_enbled_flags.nas)
	{
		memset(str, 0, sizeof(char) * LEN_XL);
		fgets(str, LEN_XL, fp);
		if(strstr(str, "rausb0"))
		{
			int wifi;
#ifdef WPS_SUPPORT
			check_wps_timer();
#endif
#if NET_DISABLE
			if(wifi_down == LINK_RALINK_FAIL)
			{
				num_enabled_dev ++;
				//if((isGWSet & 1))
				//	num_enabled_dev ++;
				if(cifs_down==1)
					num_enabled_dev ++;
				return;
			}
#endif
			if(isGWSet==5)	//complete: just do one check
			{
				dev_mnted_enbled_flags.net = 1;
				idx = num_enabled_dev;
				num_enabled_dev++;

				///080417
				strcpy(desc->ICONFilename4DS[0][idx], desc->NET[0]);
				strcpy(desc->ICONFilename4DS[1][idx], desc->NET[1]);
				IconTxtArr4DS[idx] = DEVICE_NET_NAME;
				idx++;
				///

				gatway_ip = CheckGWIP("rausb0");
				goto skip_wlan0;
			}
			system("ifconfig rausb0 up");
		  sleep(1);
		  wifi = detect_wifi();
#ifdef ZYDAS_SUPPORT
      if(wifi==LINK_ZYDAS_FAIL)
      {
      	FILE *f;
				f = fopen(NETSET_PROFILE, "r");
				if(f)
				{
					fclose(f);
					if(set_zydas_adapter()<0)
					{
						printf("set zydas adapter error!\n");
						return;
					}
					else
					{
				    system("ifconfig rausb0 up");
		        sleep(1);
		        wifi = detect_wifi();
			  	}
			  }    
		  }
#endif	
		  wifi_check = wifi;
		  
			isGWSet |= 4;	//set wireless
			dev_mnted_enbled_flags.net = 1;
			idx = num_enabled_dev;
			num_enabled_dev++;

			///080417
			strcpy(desc->ICONFilename4DS[0][idx], desc->NET[0]);
			strcpy(desc->ICONFilename4DS[1][idx], desc->NET[1]);
			IconTxtArr4DS[idx] = DEVICE_NET_NAME;
			idx++;
			///

			//parse rt73sta.dat
			Get_rt73sta_Info("Dhcp", buff);
			if(buff != NULL && !strcmp("n", buff))//fixIP
			{	
#if 1 //wschen 2007-12-17
			  int skfd = socket(PF_INET, SOCK_STREAM, 0);
			  struct ifreq ifreq;
			  struct sockaddr_in *sin;

			  memset(&ifreq, 0, sizeof(struct ifreq));
			  sprintf(ifreq.ifr_name, "rausb0");
			  ioctl(skfd, SIOCGIFFLAGS, &ifreq);
			  ifreq.ifr_flags |= IFF_UP;
			  ioctl(skfd, SIOCSIFFLAGS, &ifreq);
			  ifreq.ifr_qlen = 3;
			  ioctl(skfd, SIOCSIFTXQLEN, &ifreq);
				//setup net device
				memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
				strcat(getfixIPstr, "ifconfig rausb0 inet ");
#endif
			  Get_rt73sta_Info("IpAddr", buff);
#if 1 //wschen 2007-12-17
			  memset(&ifreq, 0, sizeof(struct ifreq));
			  sprintf(ifreq.ifr_name, "rausb0");
			  sin = (struct sockaddr_in *)&ifreq.ifr_addr;
			  sin->sin_family = AF_INET;
			  sin->sin_port = 0;
			  inet_aton(buff, &sin->sin_addr);
			  ioctl(skfd, SIOCSIFADDR, &ifreq);
#endif

#if 1		//save ip for fixed ip
				if(!(fp1 = fopen("/tmp/ip.txt", "w")))
				{
					DMSG("Failed to open ip.txt to write!\n");
					return;
				}
				fwrite(buff,sizeof(char),sizeof(buff)-1,fp1);		
				fclose(fp1);
#endif

#if 1 //wschen 2007-12-17
			  Get_rt73sta_Info("Mask", buff);
			  memset(&ifreq, 0, sizeof(struct ifreq));
			  sprintf(ifreq.ifr_name, "rausb0");
			  sin = (struct sockaddr_in *)&ifreq.ifr_addr;
			  sin->sin_family = AF_INET;
			  sin->sin_port = 0;
			  inet_aton(buff, &sin->sin_addr);
			  ioctl(skfd, SIOCSIFNETMASK, &ifreq);
			  close(skfd);
			  Get_rt73sta_Info("GwAddr", buff);
			  setroute(RTACTION_ADD, 0, "0.0.0.0", "0.0.0.0", buff, "rausb0");
			  Get_rt73sta_Info("DNS1", buff);
			  if (strlen(buff)) {
			  FILE *dns = fopen("/tmp/conf/resolv.conf", "w+");
			    if (dns) {
			      fprintf(dns, "nameserver %s\n", buff);
			      Get_rt73sta_Info("DNS2", buff);
			      if (strlen(buff)) {
			        fprintf(dns, "nameserver %s\n", buff);
			      }
			      fclose(dns);
			    }
			  }
#endif	
/*
#ifdef ZYDAS_SUPPORT
				if(detect_zydas_adapter())
				{
					if(set_zydas_adapter()<0)
					{
						printf("set zydas adapter error!\n");
						return;
					}	
				}
#endif			
*/
#if 1	//still need to ping gateway, for GW is connected; since ping is easier, and less resource
				//exec
				memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
				strcat(getfixIPstr, "touch /tmp/conf/resolv.conf");
				system(getfixIPstr);
				sleep(3);		//wait for interface up
				memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
				strcat(getfixIPstr, "ping ");
				Get_rt73sta_Info("GwAddr", buff);
				strcat(getfixIPstr, buff);
				system(getfixIPstr);
#endif
			}
			else//DHCP
			{
				gatway_ip = CheckGWIP("rausb0");
				if(gatway_ip)	//tyhuang: got ip already
					goto skip_wlan0;
				else
				{
/*					
					system("ifconfig rausb0 up");		
#ifdef ZYDAS_SUPPORT
				FILE *f;
				f = fopen(NETSET_PROFILE, "r");
				if(f)
				{
					fclose(f);
					if(detect_zydas_adapter())
					{
						if(set_zydas_adapter()<0)
						{
							printf("set zydas adapter error!\n");
							return;
						}	
					}
				}
#endif
*/							
					//Robert 2007-12-30
					if (dhcp_pid > 0)
					{
						//KILL(dhcp_pid);
						kill(dhcp_pid,9);
						dhcpsts = 0;
						waitpid(dhcp_pid, &dhcpsts, WNOHANG);
						dhcp_pid = 0;
					}
					if(wifi==0)    //link
					{
					    ForkGetDHCPIProcess("rausb0");
					}
					else
					{
					    fclose(fp);
				      return;
				  }						
				}
			}
			gatway_ip = CheckGWIP("rausb0");
			if(gatway_ip)
			{
				if(CheckGWMAC(&gatway_ip))
				{
skip_wlan0:
					KillNetSocket();
					if(wifi_check!=0)
					{
					   fclose(fp);
				     return;
				  }
				  else
				     ForkNETSocket();
				}
			}
			else
			{
				//sleep(5);
				fclose(fp);
				return;
			}
			if(CheckNASMntedStatus())
			{
			 	DMSG("Mount succeeded!\n");
				dev_mnted_enbled_flags.nas = 1;
				num_enabled_dev++;
				for(i = 0; i < 2; i++)
				{
					strcpy(desc->ICONFilename4DS[i][idx], desc->NAS[i]);
				}
				IconTxtArr4DS[idx] = DEVICE_NAS_NAME;
				idx++;
			}
			else
			{
				DMSG("No Net Disk exists!!!\n");
			}
			///080530 ignore rss
			/*
			//confirm if packet-out-to-RSS server is OK!!!
			if(((isGWSet & 1)!=0) || CheckGWMAC(&gatway_ip))
			{
				isGWSet |= 1;
				DMSG("The channel to RSS Server is OK!\n");
				dev_mnted_enbled_flags.rss = 1;
				num_enabled_dev++;
				for(i = 0; i < 2; i++)
				{
					strcpy(desc->ICONFilename4DS[i][idx], desc->RSS[i]);
				}
				IconTxtArr4DS[idx] = DEVICE_RSS_NAME;
			}
			else
			{
				DMSG("No Gateway exists!!!\n");
			}
			*/
			fclose(fp);
			return;
		}
	}
	
	/* todo : 
	//rywu20080529++
	//check ADSL modem
	fseek(fp, 0, SEEK_SET);
	while(!feof(fp))
	{
	    memset(str, 0, LEN_XL);
		fgets(str, LEN_XL, fp);
		
		//search adsl device
		if(strstr(str, "ppp0"))
		{
			
		}
	}
	//rywu20080529--
	*/
	
	fclose(fp);
}
#endif
//------------------------------------------------------------------------------------------------
/*080530
#ifdef IP_CAM_MOD
Uint8 DetectIPCam(Uint8 num)
{
	if (dev_mnted_enbled_flags.rss)
	{
		strcpy(desc->ICONFilename4DS[0][num], desc->IPCAM[0]);
		strcpy(desc->ICONFilename4DS[1][num], desc->IPCAM[1]);
		IconTxtArr4DS[num] = DEVICE_IPCAM_NAME;
		dev_mnted_enbled_flags.ipcam = 1;
		num++;
	}
	else
	{
		dev_mnted_enbled_flags.ipcam = 0;
	}
	return num;
}
Uint8 RenewIPCamStatus(Uint8 Num)
{
	if (dev_mnted_enbled_flags.rss)
		Num++;
	return Num;
}
#endif	//IP_CAM_MOD
*/
//------------------------------------------------------------------------------------------------
void SavePrevMountedDeviceStatus()
{
	dev_pre_mnted_enbled_flags.hd			= dev_mnted_enbled_flags.hd;
	dev_pre_mnted_enbled_flags.cf 			= dev_mnted_enbled_flags.cf;
	dev_pre_mnted_enbled_flags.sdmmc 		= dev_mnted_enbled_flags.sdmmc;
	dev_pre_mnted_enbled_flags.xdsm 		= dev_mnted_enbled_flags.xdsm;
	dev_pre_mnted_enbled_flags.msx 			= dev_mnted_enbled_flags.msx;
	dev_pre_mnted_enbled_flags.usb 			= dev_mnted_enbled_flags.usb;
	dev_pre_mnted_enbled_flags.usb2pconn 	= dev_mnted_enbled_flags.usb2pconn;
	dev_pre_mnted_enbled_flags.flash 		= dev_mnted_enbled_flags.flash;
	dev_pre_mnted_enbled_flags.bluetooth 	= dev_mnted_enbled_flags.bluetooth;
	dev_pre_mnted_enbled_flags.net 			= dev_mnted_enbled_flags.net;
	//dev_pre_mnted_enbled_flags.rss 			= dev_mnted_enbled_flags.rss;
	dev_pre_mnted_enbled_flags.nas 			= dev_mnted_enbled_flags.nas;
	//copy to the place u want to debug
#if 0
	PRINTF("\nHD CF SD XD MS USB PC FL\n%2d %2d %2d %2d %2d %3d %2d %2d\n", 
		dev_pre_mnted_enbled_flags.hd, dev_pre_mnted_enbled_flags.cf, dev_pre_mnted_enbled_flags.sdmmc, 
		dev_pre_mnted_enbled_flags.xdsm, dev_pre_mnted_enbled_flags.msx, dev_pre_mnted_enbled_flags.usb, 
		dev_pre_mnted_enbled_flags.usb2pconn, dev_pre_mnted_enbled_flags.flash
	);
	sleep(1);
#endif
}
//------------------------------------------------------------------------------------------------
void GetInOutDevice(Sint8 *inOut, Sint8 *whichDevice)
{
	Sint8 card = -1, isCardIO = 0;
	Sint8 dev_io[MAX_MOUNTED_DEV] = {0, 0, 0, 0, 0, 0, 0, 0};//0: no change; 1: card in; -1: card out
	
	//record card io
	dev_io[SDMMC]	 = dev_mnted_enbled_flags.sdmmc	- dev_pre_mnted_enbled_flags.sdmmc;
	dev_io[CF]		 = dev_mnted_enbled_flags.cf  	- dev_pre_mnted_enbled_flags.cf;
	dev_io[USB]		 = dev_mnted_enbled_flags.usb	- dev_pre_mnted_enbled_flags.usb;
	dev_io[XDSM]		 = dev_mnted_enbled_flags.xdsm	- dev_pre_mnted_enbled_flags.xdsm;
	dev_io[MS]		 = dev_mnted_enbled_flags.msx	- dev_pre_mnted_enbled_flags.msx;
	dev_io[HD]		 = dev_mnted_enbled_flags.hd	- dev_pre_mnted_enbled_flags.hd;
	dev_io[FLASH]	 = dev_mnted_enbled_flags.flash	- dev_pre_mnted_enbled_flags.flash;
	dev_io[NET]		 = dev_mnted_enbled_flags.net	- dev_pre_mnted_enbled_flags.net;
	
	//check card out
	if(dev_io[SDMMC] == -1)
	{
		card = SDMMC;
		isCardIO = -1;
	}
	else if(dev_io[CF] == -1)
	{
		card = CF;
		isCardIO = -1;
	}
	else if(dev_io[USB] == -1)
	{
		card = USB;
		isCardIO = -1;
	}
	else if(dev_io[XDSM] == -1)
	{
		card = XDSM;
		isCardIO = -1;
	}
	else if(dev_io[MS] == -1)
	{
		card = MS;
		isCardIO = -1;
	}
	else if(dev_io[HD] == -1)
	{
		card = HD;
		isCardIO = -1;
	}
	else if(dev_io[FLASH] == -1)
	{
		card = FLASH;
		isCardIO = -1;
	}
	else if(dev_io[NET] == -1)
	{
		card = NET;
		isCardIO = -1;
	}
	
	//check card in
	if(dev_io[SDMMC] == 1)
	{
		card = SDMMC;
		isCardIO = 1;
	}
	else if(dev_io[CF] == 1)
	{
		card = CF;
		isCardIO = 1;
	}
	else if(dev_io[USB] == 1)
	{
		card = USB;
		isCardIO = 1;
	}
	else if(dev_io[XDSM] == 1)
	{
		card = XDSM;
		isCardIO = 1;
	}
	else if(dev_io[MS] == 1)
	{
		card = MS;
		isCardIO = 1;
	}
	else if(dev_io[HD] == 1)
	{
		card = HD;
		isCardIO = 1;
	}
	else if(dev_io[FLASH] == 1)
	{
		card = FLASH;
		isCardIO = 1;
	}
	else if(dev_io[NET] == 1)
	{
		card = NET;
		isCardIO = 1;
	}
	
	*inOut = isCardIO;
	*whichDevice = card;
}

#ifdef ZYDAS_SUPPORT
int Zydas_GetKeyParameter(char *in, char *dest, int destsize, char *source)
{
	char *p_check;
	int len,i,j;

	len = strlen(in);
	p_check = strstr(source, in);
	if(p_check == NULL)
	{
		return -1;
	}
	
#ifdef WPA_SUPPLICANT_SUPPORT
	//special check "WPAPSK",because it appears twice in WPA-PSK(but not appears twice in WPA2-PSK)
	if((strcmp("WPAPSK",in)==0) && (auth_wpa2 == 0))
	{
		source = p_check + len;
		p_check = strstr(source, in);
		if(p_check == NULL)
			return -1;
			
		if(*(p_check + len) != 61)//ascii "=" = 61
			return -1;
	}
	else
	{
#endif	

	if(*(p_check + len) != 61)//ascii "=" = 61
	{
		return -1;
	}
#ifdef WPA_SUPPLICANT_SUPPORT
	}//else
#endif	
	
	memcpy(dest, p_check + len + 1, destsize);
	for(i = 0; i < destsize; i++)
	{
		if(dest[i] == 10)//line feed = 10
		{
			dest[i] = '\0';
			j = i;
			break;
		}
	}
	for(i=j;i<destsize;i++)
		dest[i] = '\0';
	return 0;
}

void Zydas_Get_rt73sta_Info(char *item_name, char *buff,int buff_len)
{
	FILE *fp;
	char *p_check = NULL;
	char *tmp_buffer = NULL;
	int i;

	if(!(fp = fopen(NETSET_PROFILE, "r")))
	{
		printf("Failed to open /tmp/conf/rt73sta.dat\n");
		return;
	}
	memset(buff, 0, sizeof(char) * buff_len);
	MEMALLOC(tmp_buffer, char, 1024);
	fread(tmp_buffer, 1023, sizeof(char),fp);			
	fclose(fp);
	tmp_buffer[1023] = 0;
	p_check = BasicFindSec(tmp_buffer);
	if(p_check == NULL)
	{
		FREEMEMORY(tmp_buffer);
		return;
	}
	if(Zydas_GetKeyParameter(item_name, buff, buff_len, p_check) == -1)
	{
		FREEMEMORY(tmp_buffer);
		return;
	}
	
	printf("[%s]:",item_name);
	for(i=0;i<buff_len;i++)
	{
		if(buff[i]=='\0')
			break;
		printf("%c",buff[i]);
	}
	printf("\n");
	
	FREEMEMORY(tmp_buffer);
}

int detect_zydas_adapter()
{
	FILE *fp;
	int zydas_adapter;
	
	if (!(fp = fopen("/proc/wifi_adapter_zydas", "r"))) 
	{				
		printf("Failed to open zydas wifi file!\n");
		return(-1);
	}
	else
	{
		fread(&zydas_adapter, sizeof(int), 1, fp);
		fclose(fp);
	}
	return(zydas_adapter);
}

static void check_interface_up()
{
	int skfd = socket(PF_INET, SOCK_STREAM, 0);
	struct ifreq ifreq;

	memset(&ifreq, 0, sizeof(struct ifreq));
	sprintf(ifreq.ifr_name, "rausb0");
	ioctl(skfd, SIOCGIFFLAGS, &ifreq);
	if (ifreq.ifr_flags & IFF_UP) 
		printf("rausb0 is up!\n");
	else
	{	
		printf("rausb0 is down!re-up it\n");
		ifreq.ifr_flags |= IFF_UP;
		ioctl(skfd, SIOCSIFFLAGS, &ifreq);
	}
	close(skfd);
}

int set_zydas_adapter()
{
	char 		wireless_mode[2];	
	char		essid[32];
	char 		auth_mode[20];
	char    key_id[2];
	char		key1_type[2],key2_type[2],key3_type[2],key4_type[2];
	char 		key1_str[100],key2_str[100],key3_str[100],key4_str[100];
	struct 	spawn_handle spawn;
	int 		status;
	int			use_key_id = 0;
	char		use_key_str[150];
	char		use_key_index_str[10];
	char		use_wireless_mode[5];
	int 		n;
	char 		set_mac_mode_buf[100];//for capture set mac mode err_msg
#ifdef	WPA_SUPPLICANT_SUPPORT
	char 		buffer [100];
	char 		encryp_type[10];
	char		wpa_psk[100];
	int			use_wpa_flag = 0;
	int			ret;
#endif		
	
	/* get WirelessMode */
	Zydas_Get_rt73sta_Info("WirelessMode", wireless_mode,sizeof(wireless_mode));
	
	/* get SSID */
	Zydas_Get_rt73sta_Info("SSID", essid,sizeof(essid));
	
	/* get AuthMode */
	Zydas_Get_rt73sta_Info("AuthMode", auth_mode,sizeof(auth_mode));
	
	/* get DefaultKeyID */
	Zydas_Get_rt73sta_Info("DefaultKeyID", key_id,sizeof(key_id));
	
	/* get Key1Type */
	Zydas_Get_rt73sta_Info("Key1Type", key1_type,sizeof(key1_type));

	/* get Key1Str */
	Zydas_Get_rt73sta_Info("Key1Str", key1_str,sizeof(key1_str));
		
	/* get Key2Type */
	Zydas_Get_rt73sta_Info("Key2Type", key2_type,sizeof(key2_type));
	
	/* get Key2Str */
	Zydas_Get_rt73sta_Info("Key2Str", key2_str,sizeof(key2_str));
	
	/* get Key3Type */
	Zydas_Get_rt73sta_Info("Key3Type", key3_type,sizeof(key3_type));
	
	/* get Key3Str */
	Zydas_Get_rt73sta_Info("Key3Str", key3_str,sizeof(key3_str));
	
	/* get Key4Type */
	Zydas_Get_rt73sta_Info("Key4Type", key4_type,sizeof(key4_type));
	
	/* get Key4Str */
	Zydas_Get_rt73sta_Info("Key4Str", key4_str,sizeof(key4_str));

	/* make sure interface is up */
	check_interface_up();
	
	/* set MAC mode */
	if(wireless_mode[0]=='0' || wireless_mode[0]=='3')//(11 b/g mixed) or (11 a/b/g mixed)
		sprintf(use_wireless_mode,"%d",1);
	else if(wireless_mode[0]=='1')//(11 b only)
		sprintf(use_wireless_mode,"%d",3);
	else if(wireless_mode[0]=='4')//(11 g only)	
		sprintf(use_wireless_mode,"%d",2);
	else if(wireless_mode[0]=='2')//(11 a only)	
		sprintf(use_wireless_mode,"%d",4);
	else
		{
			printf("No such MAC mode\n");
			return(-1);
		}	
	
	if(spawn_program(&spawn, SPAWN_INPUT_ONLY,
				IWPRIV_UTILITY, "iwpriv", "rausb0", "set_mac_mode" , use_wireless_mode , NULL)==0)
	{		
		printf("spawn_program iwpriv rausb0 set_mac_mode error!\n");	
		return(-1);
	}
	
	/* do set_mac_mode error process if wireless RF mode not support one of wireless mode*/ 
	if((n=read(SPAWN_INPUT(spawn), set_mac_mode_buf, sizeof(set_mac_mode_buf)-1))>0)
	{
		set_mac_mode_buf[n]='\0';
		printf("ERR_MSG(len:%d):%s",n,set_mac_mode_buf);
		terminate_spawn(&spawn);
	}
	else
	{
		cleanup_spawn(&spawn, NULL);
	}
		
	/* set AuthMode */
	if(strcmp(auth_mode,"WEPAUTO")==0 || strcmp(auth_mode,"SHARED")==0)
	{
		auth_wpa2 = 0;
		
		if(spawn_program(&spawn, SPAWN_NULL_IO,
				IWPRIV_UTILITY, "iwpriv", "rausb0", "set_auth" , "1" , NULL)==0)
		{		
			printf("spawn_program iwpriv rausb0 set_auth error!\n");	
			return(-1);
		}

		if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
		//if(cleanup_spawn(&spawn, &status)<0)
		{
			printf("cleanup_spawn iwpriv rausb0 set_auth error!\n");	
			return(-1);
		}
	}
	else if(strcmp(auth_mode,"OPEN")==0)
	{
		auth_wpa2 = 0;
		
		if(spawn_program(&spawn, SPAWN_NULL_IO,
				IWPRIV_UTILITY, "iwpriv", "rausb0", "set_auth" , "0" , NULL)==0)
		{		
			printf("spawn_program iwpriv rausb0 set_auth error!\n");	
			return(-1);
		}

		if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
		//if(cleanup_spawn(&spawn, &status)<0)
		{
			printf("cleanup_spawn iwpriv rausb0 set_auth error!\n");	
			return(-1);
		}
	}
#ifdef	WPA_SUPPLICANT_SUPPORT
	else if(strcmp(auth_mode,"WPAPSK")==0)
	{
		use_wpa_flag = 1;
		auth_wpa2 = 0;
		
		if(AddCmd((char *)wpa_supplicant_conf_comment[0])<0)
			return(-1);
		
		/* set essid to wpa_supplicant_psk.conf */
		if(essid[0]!='\0')
		{
			sprintf(buffer,wpa_supplicant_conf_comment[1],essid);		
			if(AddCmd(buffer)<0)
				return(-1);	
		}
		else
		{
			printf("essid is NULL\n");
			return(-1);	
		}
		
		/* set proro to wpa_supplicant_psk.conf */
		sprintf(buffer,wpa_supplicant_conf_comment[2],"WPA");		
		if(AddCmd(buffer)<0)
			return(-1);
	
		/* set key_mgmt to wpa_supplicant_psk.conf */	
		sprintf(buffer,wpa_supplicant_conf_comment[3],"WPA-PSK");		
		if(AddCmd(buffer)<0)
			return(-1);	
		
		/* set pairwise to wpa_supplicant_psk.conf */	
		/* get EncrypType */
		Zydas_Get_rt73sta_Info("EncrypType", encryp_type,sizeof(encryp_type));
		if(strcmp("AES",encryp_type)==0)
			sprintf(buffer,wpa_supplicant_conf_comment[4],"CCMP");		
		else	
			sprintf(buffer,wpa_supplicant_conf_comment[4],"TKIP");		
		if(AddCmd(buffer)<0)
			return(-1);	
			
		/* set psk to wpa_supplicant_psk.conf */	
		/* get WPAPSK */
		Zydas_Get_rt73sta_Info("WPAPSK", wpa_psk,sizeof(wpa_psk));
		sprintf(buffer,wpa_supplicant_conf_comment[6],wpa_psk);		
		if(AddCmd(buffer)<0)
			return(-1);
	
		if(AddCmd((char *)wpa_supplicant_conf_comment[7])<0)
			return(-1);
			
		if(AddCmd((char *)wpa_supplicant_conf_comment[8])<0)
			return(-1);
					
		if(WRITE_TO_CONF()<0)
			return(-1);	
		
		//wait for write command to wpa_supplicant_psk.conf
		sleep(1);
		
		/* kill old udhcpc process */	
		ret = program_pid("udhcpc");
		if(ret>0)
			kill_old_process("udhcpc","-SIGKILL");
		
		/* kill old wpa_supplicant process */
		ret = program_pid("wpa_supplicant");
		if(ret>0)
			kill_old_process("wpa_supplicant","-SIGKILL");
		
		/* make sure WPA state is ZYDAS_WPA_INACTIVE */
		zydas_set_param("rausb0", ZD_PARAM_SET_STATE, ZYDAS_WPA_INACTIVE);
	
		if(spawn_program(&spawn, SPAWN_NULL_IO,
				WPA_SUPPLICANT_UTILITY, "wpa_supplicant", "-i", "rausb0", "-c" , WPA_SUPPLICANT_CONF ,
				"-B" , "-D" , "zydas" , NULL)==0)
		{		
			printf("spawn_program wpa_supplicant error!\n");	
			FREE_WPA_SUPPLICANT_LIST();
			return(-1);
		}

		if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
		//if(cleanup_spawn(&spawn, &status)<0)
		{
			printf("cleanup_spawn wpa_supplicant error!\n");	
			FREE_WPA_SUPPLICANT_LIST();
			return(-1);
		}
		
		FREE_WPA_SUPPLICANT_LIST();	
			
	}
	else if(strcmp(auth_mode,"WPA2PSK")==0)
	{
		use_wpa_flag = 1;
		auth_wpa2 = 1;
		
		if(AddCmd((char *)wpa_supplicant_conf_comment[0])<0)
			return(-1);
		
		/* set essid to wpa_supplicant_psk.conf */
		if(essid[0]!='\0')
		{
			sprintf(buffer,wpa_supplicant_conf_comment[1],essid);		
			if(AddCmd(buffer)<0)
				return(-1);	
		}
		else
		{
			printf("essid is NULL\n");
			return(-1);	
		}
		
		/* set proro to wpa_supplicant_psk.conf */
		sprintf(buffer,wpa_supplicant_conf_comment[2],"WPA2");//also can set it to RSN
		if(AddCmd(buffer)<0)
			return(-1);
	
		/* set key_mgmt to wpa_supplicant_psk.conf */	
		sprintf(buffer,wpa_supplicant_conf_comment[3],"WPA-PSK");		
		if(AddCmd(buffer)<0)
			return(-1);	
		
		/* set pairwise to wpa_supplicant_psk.conf */	
		/* get EncrypType */
		Zydas_Get_rt73sta_Info("EncrypType", encryp_type,sizeof(encryp_type));
		if(strcmp("AES",encryp_type)==0)
			sprintf(buffer,wpa_supplicant_conf_comment[4],"CCMP");		
		else	
			sprintf(buffer,wpa_supplicant_conf_comment[4],"TKIP");		
		if(AddCmd(buffer)<0)
			return(-1);	
			
		/* set psk to wpa_supplicant_psk.conf */	
		/* get WPAPSK */
		Zydas_Get_rt73sta_Info("WPAPSK", wpa_psk,sizeof(wpa_psk));
		sprintf(buffer,wpa_supplicant_conf_comment[6],wpa_psk);		
		if(AddCmd(buffer)<0)
			return(-1);
	
		if(AddCmd((char *)wpa_supplicant_conf_comment[7])<0)
			return(-1);
			
		if(AddCmd((char *)wpa_supplicant_conf_comment[8])<0)
			return(-1);
					
		if(WRITE_TO_CONF()<0)
			return(-1);	
		
		//wait for write command to wpa_supplicant_psk.conf
		sleep(1);
		
		/* kill old udhcpc process */	
		ret = program_pid("udhcpc");
		if(ret>0)
			kill_old_process("udhcpc","-SIGKILL");
			
		/* kill old wpa_supplicant process */
		ret = program_pid("wpa_supplicant");
		if(ret>0)
			kill_old_process("wpa_supplicant","-SIGKILL");
		
		/* make sure WPA state is ZYDAS_WPA_INACTIVE */
		zydas_set_param("rausb0", ZD_PARAM_SET_STATE, ZYDAS_WPA_INACTIVE);
	
		if(spawn_program(&spawn, SPAWN_NULL_IO,
				WPA_SUPPLICANT_UTILITY, "wpa_supplicant", "-i", "rausb0", "-c" , WPA_SUPPLICANT_CONF ,
				"-B" , "-D" , "zydas" , NULL)==0)
		{		
			printf("spawn_program wpa_supplicant error!\n");	
			FREE_WPA_SUPPLICANT_LIST();
			return(-1);
		}

		if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
		//if(cleanup_spawn(&spawn, &status)<0)
		{
			printf("cleanup_spawn wpa_supplicant error!\n");	
			FREE_WPA_SUPPLICANT_LIST();
			return(-1);
		}
		
		FREE_WPA_SUPPLICANT_LIST();	
	}
#endif	
	else
		printf("Not support(%s) auth mode\n",auth_mode);

#ifdef	WPA_SUPPLICANT_SUPPORT
	if(use_wpa_flag==0)
	{
		/* kill old udhcpc process */	
		ret = program_pid("udhcpc");
		if(ret>0)
			kill_old_process("udhcpc","-SIGKILL");
		
		/* kill old wpa_supplicant process */
		ret = program_pid("wpa_supplicant");
		if(ret>0)
			kill_old_process("wpa_supplicant","-SIGKILL");
		
		/* make sure WPA state is ZYDAS_WPA_INACTIVE */
		zydas_set_param("rausb0", ZD_PARAM_SET_STATE, ZYDAS_WPA_INACTIVE);
	
		/* ensure driver "macp->cardSetting.ap_scan" value is zero */
		if (zydas_set_param("rausb0", ZD_PARAM_ROAMING, 0) < 0)
    {
      printf("set roaming error\n");
      return(-1);
    }	
#endif	
	
	/* set essid */
	if(essid[0]!='\0')
	{
		if(spawn_program(&spawn, SPAWN_NULL_IO,
				IWCONFIG_UTILITY, "iwconfig", "rausb0", "essid" , essid , NULL)==0)
		{		
			printf("spawn_program iwconfig rausb0 essid error!\n");	
			return(-1);
		}

		if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
		//if(cleanup_spawn(&spawn, &status)<0)
		{
			printf("cleanup_spawn iwconfig rausb0 essid error!\n");	
			return(-1);
		}
	}
	else
		printf("essid is NULL\n");

	/* set key */ 
  if(key_id[0]=='1')
  	use_key_id = 1;
  else if(key_id[0]=='2')
  	use_key_id = 2;
  else if(key_id[0]=='3')
  	use_key_id = 3;
  else if(key_id[0]=='4')
  	use_key_id = 4;			
  else
  {
  	printf("no such key_id!\n");
  	return(-1);	
  }
  
  sprintf(use_key_index_str,"[%d]",use_key_id);	 
  
  switch(use_key_id)
  {
  	case 1:
  		memset(use_key_str,0,sizeof(use_key_str));
  		if(key1_type[0]=='0')//hex
  			strcpy(use_key_str,key1_str);
  		else//ascii
  		{
  			sprintf(use_key_str,"s:%s",key1_str);
  	  }
  		break;
  	case 2:
  		memset(use_key_str,0,sizeof(use_key_str));
  		if(key2_type[0]=='0')//hex
  			strcpy(use_key_str,key2_str);
  		else//ascii
  		{
  			sprintf(use_key_str,"s:%s",key2_str);
  	  }
  		break;
  	case 3:
  		memset(use_key_str,0,sizeof(use_key_str));
  		if(key3_type[0]=='0')//hex
  			strcpy(use_key_str,key3_str);
  		else//ascii
  		{
  			sprintf(use_key_str,"s:%s",key3_str);
  	  }
  		break;
  	case 4:
  		memset(use_key_str,0,sizeof(use_key_str));
  		if(key4_type[0]=='0')//hex
  			strcpy(use_key_str,key4_str);
  		else//ascii
  		{
  			sprintf(use_key_str,"s:%s",key4_str);
  	  }
  		break;
  	default:
  		printf("use_key_id value error!\n");
  		return(-1);
  }
     
  printf("use_key_str=%s\n",use_key_str);
  printf("use_key_index_str=%s\n",use_key_index_str);

  if(use_key_str[0]!='\0') 
  {
  	if(spawn_program(&spawn, SPAWN_NULL_IO,
				IWCONFIG_UTILITY, "iwconfig", "rausb0", "key" , use_key_str , use_key_index_str, NULL)==0)
		{
			printf("spawn_program iwconfig rausb0 key error!\n");				
			return(-1);
		}

		if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
		//if(cleanup_spawn(&spawn, &status)<0)
		{
			printf("cleanup_spawn iwconfig rausb0 key error!\n");		
			return(-1);
		}
	}
	else
		printf("use_key_str is NULL\n");

#ifdef	WPA_SUPPLICANT_SUPPORT
	}//if(use_wpa_flag==0)
#endif
	
	printf("set_zydas_adapter ok\n");				
	return(0);
}

static int
vspawn_program_with_callback(struct spawn_handle *handle,
				void (*exec_callback)(const char *path, char *const argv[]),
				int iotype, const char *path, char *const argv[])
{
	struct spawn_handle sp;
	int			c2p[2], p2c[2], nullfd;

	if(path==NULL || argv==NULL)
		return(0);
/*
#ifdef NELLY_DEBUG_SIGNAL	
	signal(SIGCHLD,SIG_DFL);
#endif	
*/
	c2p[0]=-1;
	c2p[1]=-1;
	p2c[0]=-1;
	p2c[1]=-1;

	switch(iotype)
	{
	case SPAWN_NULL_IO:
		break;
	case SPAWN_INPUT_ONLY:
		if(pipe(c2p)<0)
			return(0);
		break;
	case SPAWN_OUTPUT_ONLY:
		if(pipe(p2c)<0)
			return(0);
		break;
	case SPAWN_BIDIRECTIONAL_IO:
		if(pipe(c2p)<0)
			return(0);
		if(pipe(p2c)<0)
		{
			close(c2p[0]);
			close(c2p[1]);
			return(0);
		}
		break;
	default:
		return(0);
	}

	sp.pid=fork();
	switch(sp.pid)
	{
	case -1:
		if(c2p[0]>=0)
			close(c2p[0]);
		if(c2p[1]>=0)
			close(c2p[1]);
		if(p2c[0]>=0)
			close(p2c[0]);
		if(p2c[1]>=0)
			close(p2c[1]);

		return(0);
	case 0:
		/* redirect terminal I/O */
		switch(iotype)
		{
		case SPAWN_NULL_IO:
			if((nullfd=open("/dev/null", O_RDWR))<0)
				exit(1);

			dup2(nullfd, 0);
			dup2(nullfd, 1);
			dup2(nullfd, 2);

			close(nullfd);
			break;
		case SPAWN_INPUT_ONLY:
			if((nullfd=open("/dev/null", O_RDONLY))<0)
				exit(1);

			dup2(nullfd, 0);
			dup2(c2p[1], 1);
			dup2(c2p[1], 2);

			close(nullfd);
			close(c2p[0]);
			close(c2p[1]);
			break;
		case SPAWN_OUTPUT_ONLY:
			if((nullfd=open("/dev/null", O_WRONLY))<0)
				exit(1);

			dup2(p2c[0], 0);
			dup2(nullfd, 1);
			dup2(nullfd, 2);

			close(p2c[0]);
			close(p2c[1]);
			close(nullfd);

			/*
			 * Should we close all unnecessary file descriptors?
			 */
			break;
		case SPAWN_BIDIRECTIONAL_IO:
			dup2(p2c[0], 0);
			dup2(c2p[1], 1);
			dup2(c2p[1], 2);

			close(p2c[0]);
			close(p2c[1]);
			close(c2p[0]);
			close(c2p[1]);
			break;
		}

		if(exec_callback)
			exec_callback(path, argv);

		execv(path, argv);
		exit(1);
		break;
	default:
		switch(iotype)
		{
		case SPAWN_NULL_IO:
			sp.pipe[0]=-1;
			sp.pipe[1]=-1;
			break;
		case SPAWN_INPUT_ONLY:
			sp.pipe[0]=c2p[0];
			close(c2p[1]);
			sp.pipe[1]=-1;
			break;
		case SPAWN_OUTPUT_ONLY:
			sp.pipe[0]=-1;
			sp.pipe[1]=p2c[1];
			close(p2c[0]);
			break;
		case SPAWN_BIDIRECTIONAL_IO:
			sp.pipe[0]=c2p[0];
			sp.pipe[1]=p2c[1];
			close(c2p[1]);
			close(p2c[0]);
			break;
		}

		*handle=sp;
		return(sp.pid);
	}
}

/* fork a process and execute the program specified. The function allows the
 * caller to do something before exec is called.
 * If the iotype specifies a pipe between the parent and child, the child
 * process's stdin is redirected to pipfd[0], and stdout and stderr are
 * redirected to pipefd[1].
 * Parameters:
 * 		struct spawn_handle *handle: handle for newly created child
 * 		void (*exec_callback)(): a callback function to do something before
 * 								exec is called.
 * 		int iotype:
 * 					SPAWN_NULL_IO -	No pipe is created between the parent and
 * 										child. Child's stdin/stdout/stderr are
 * 										redirected to /dev/null.
 * 					SPAWN_INPUT_ONLY - The parent process can only read output
 * 										from the spawned process.
 * 					SPAWN_OUTPUT_ONLY - The parent can only send data to
 * 										child's stdin.
 * 					SPAWN_BIDIRECTIONAL_IO	- A bidirectional pipe pair is
 * 												created.
 * 		const char *file: same as execl(const char *path, const char *arg, ...)
 * 		const char *arg: same as execl(const char *path, const char *arg, ...)
 * Return:
 * 		Child's process ID is returned when success, or zero is returned.
 */
int
spawn_program_with_callback(struct spawn_handle *handle,
				void (*exec_callback)(const char *path, char *const argv[]),
				int iotype, const char *path, const char *arg, ...)
{
	const char *argv[100];
	va_list		ap;
	int			i;

	if(path==NULL || arg==NULL)
		return(0);

	va_start(ap, arg);
	argv[0]=arg;
	for(i=1; i<sizeof(argv)/sizeof(argv[0]) && arg!=NULL; i++)
	{
		arg=va_arg(ap, char *);
		argv[i]=arg;
	}
	va_end(ap);

	if(i>=sizeof(argv)/sizeof(argv[0]))
		return(0);

	return(vspawn_program_with_callback(handle, exec_callback,
							iotype, path, (char **const)argv));
}

/* fork a process and execute the program specified.
 * If the iotype specifies a pipe between the parent and child, the child
 * process's stdin is redirected to pipfd[0], and stdout and stderr are
 * redirected to pipefd[1].
 * Parameters:
 * 		struct spawn_handle *handle: handle for newly created child
 * 		int iotype:
 * 					SPAWN_NULL_IO -	No pipe is created between the parent and
 * 										child. Child's stdin/stdout/stderr are
 * 										redirected to /dev/null.
 * 					SPAWN_INPUT_ONLY - The parent process can only read output
 * 										from the spawned process.
 * 					SPAWN_OUTPUT_ONLY - The parent can only send data to
 * 										child's stdin.
 * 					SPAWN_BIDIRECTIONAL_IO	- A bidirectional pipe pair is
 * 												created.
 * 		const char *file: same as execl(const char *path, const char *arg, ...)
 * 		const char *arg: same as execl(const char *path, const char *arg, ...)
 * Return:
 * 		Child's process ID is returned when success, or zero is returned.
 */
int
spawn_program(struct spawn_handle *handle, int iotype, const char *path, const char *arg, ...)
{
	const char *argv[100];
	va_list		ap;
	int			i;

	if(path==NULL || arg==NULL)
		return(0);

	va_start(ap, arg);
	argv[0]=arg;
	for(i=1; i<sizeof(argv)/sizeof(argv[0]) && arg!=NULL; i++)
	{
		arg=va_arg(ap, char *);
		argv[i]=arg;
	}
	va_end(ap);

	if(i>=sizeof(argv)/sizeof(argv[0]))
		return(0);

	return(vspawn_program_with_callback(handle, NULL,
							iotype, path, (char **const)argv));
}

/* Free resources occupied by a spawn handle without terminating the chlid.
 * Parameter:
 * 		struct spawn_handle *handle: the handle to destory
 */
void
destroy_spawn_handle(struct spawn_handle *handle)
{
	if(handle->pipe[0]>=0)
	{
		close(handle->pipe[0]);
		handle->pipe[0]=-1;
	}

	if(handle->pipe[1]>=0)
	{
		close(handle->pipe[1]);
		handle->pipe[1]=-1;
	}
}

/* Wait a spawned child to end and cleanup all resources occupied by the
 * handle.
 * Parameter:
 * 		struct spawn_handle *handle: spawn handle
 * 		int *status: buffer for return value of the child process
 * Return:
 * 		The return value of waitpid() is returned.
 */
int
cleanup_spawn(struct spawn_handle *handle, int *status)
{
	pid_t ret;

	ret=waitpid(handle->pid, status, 0);
	destroy_spawn_handle(handle);
/*	
#ifdef	NELLY_DEBUG_SIGNAL
	if(ret<0)
		syslog(LOG_DEBUG,"wait: %.100s", strerror(errno));
#endif
*/
	return(ret);
}

/* Terminate a spawned child immediately and cleanup all resources occupied by
 * the spawn.
 * Parameter:
 * 		struct spawn_handle *handle: spawn handle
 * Return:
 * 		0 - successed
 * 		-1 - failed. Even when the call fails, the handle will still be cleaned,
 * 					that implies after the call the spawn handle is nolonger
 * 					available.
 */
int
terminate_spawn(struct spawn_handle *handle)
{
	if(kill(handle->pid, SIGKILL)<0)
	{
		destroy_spawn_handle(handle);
		return(-1);
	}

	cleanup_spawn(handle, NULL);

	return(0);
}
#endif
#ifdef NET_MOD
int detect_eth(void)//rywu20080516 static int detect_eth(void)
{
    int skfd=-1;
    struct ifreq ifreq;
    struct ethtool_cmd edata;
    
     if (( skfd = socket( AF_INET, SOCK_DGRAM, 0 ) ) < 0 )
    {
        printf("socket error\n"); printf("socket error\n");
        return LINK_ERROR;
    }
    
    memset(&ifreq, 0, sizeof(struct ifreq));
    edata.cmd = ETHTOOL_GSET;

    strncpy(ifreq.ifr_name, "eth0", sizeof(ifreq.ifr_name)-1);
    ifreq.ifr_data = (char *) &edata;
    if (ioctl(skfd, SIOCETHTOOL, &ifreq) == -1)
    {
        printf("ETHTOOL_GSET failed: %s\n", strerror(errno));
        close(skfd); 
        return LINK_ERROR;
    }
    close(skfd);
    if(edata.speed==0)
        return LINK_ETH_FAIL;   //no link
    else
        return LINK_DONE;
}

int detect_wifi(void)//rywu20080516 static int detect_wifi(void)
{
    FILE *fp;
    char devname[64];
    unsigned int q_link,q_level,q_noice;
    unsigned int p_nwid,p_crypt,p_freq,p_retry,p_misc;
    unsigned int mb_bea;
	int wifi_status = LINK_ERROR;
	int i,r;
	
    if(!(fp = fopen("/proc/net/wireless", "r")))
    {
	    DMSG("Failed to open file!\n");
		return LINK_ERROR;
	}
    for(i=0;i<2;i++)    /* Skip the 1st two lines. */
    {
        if(fscanf(fp, "%*[^\n]\n") < 0)
	    {
		    fclose(fp);
		    return LINK_ERROR;/* Empty or missing line, or read error. */
	    }
	}
	i = 0;
	while(!feof(fp))
	{
	    i = fscanf(fp, "%63s%X%d.%d%d%d%d%d%d%d%d\n",
		    devname, &wifi_status, &q_link, &q_level, &q_noice,
		    &p_nwid, &p_crypt, &p_freq, &p_retry, &p_misc, &mb_bea);
		if(i!=11)	break;
    }
    //printf("%s%d=%d=%d=%d=%d=%d=%d=%d=%d=%d\n",
	//devname, wifi_status, q_link, q_level, q_noice,
	//p_nwid, p_crypt, p_freq, p_retry, p_misc, mb_bea);
    fclose(fp);
	return wifi_status;
}

//rywu20080529 added
int detect_adsl(void)
{
    FILE *fp;
    char ip_addr[16];
    char gateway[16];
    char netmask[16];
    char flags[8];
    char metric[8];
    char ref[8];
    char use[8];
    char interface[8];
    int i;
    int adsl_status;
    
    //DBG_MSG("<skydemo> detect_adsl -->\n");
    
	system("route > /tmp/adsl_analysis");
	
    if(!(fp = fopen("/tmp/adsl_analysis", "r")))
    {
        //DBG_MSG("<skydemo> detect_adsl(0) <--\n");
		return LINK_ERROR;
	}
	
	//Skip the 1st line
    for(i=0;i<1;i++)
    {
        if(fscanf(fp, "%*[^\n]\n") < 0)
	    {
		    fclose(fp);
		    //DBG_MSG("<skydemo> detect_adsl(1) <--\n");
		    
		    //Empty or missing line, or read error.
		    return LINK_ERROR;
	    }
	}
	
	//read 2nd line to get ppp0 information
	adsl_status = LINK_ERROR;
	while(!feof(fp))
	{
    	memset(ip_addr, 0x00, 16);
    	ip_addr[0] = '\0';
    	
    	i = fscanf(fp, "%16s%16s%16s%8s%8s%8s%8s%8s\n",
                   ip_addr, gateway, netmask, flags,
                   metric, ref, use, interface);
    	if (i == -1)
        {
            //DBG_MSG("<skydemo>    No ppp0\n");
            break;
        }
        else
        {
            /*DBG_MSG("<skydemo>    ppp0 informaion : \n");
            DBG_MSG("<skydemo>         ip = %s, gateway = %s, mask = %s,\n", ip_addr, gateway, netmask);
            DBG_MSG("<skydemo>         flags = %s, metric = %s, ref = %s, use = %s, interface = %s\n", 
                        flags, metric, ref, use, interface);*/
            if (!strcmp(interface, "ppp0"))
            {
                if (strlen(ip_addr)>8)
                {
                    //DBG_MSG("<skydemo>    Got ppp0 link-on\n");
                    adsl_status = LINK_DONE;
                    break;
                }
            }
        }
    }
    
    fclose(fp);
    
    unlink("/tmp/adsl_analysis");
    
    //DBG_MSG("<skydemo> detect_adsl <--\n");
	return adsl_status;
}

//rywu20080516 added
unsigned char detect_net_device(void)
{
	FILE *fp;
	char str[LEN_XL];
	unsigned char device_mask = 0;
	
	//DBG_MSG("<skydemo> detect_net_device -->\n");
	
	if(!(fp = fopen("/proc/net/dev", "r")))
	{
		DBG_MSG("<skydemo> detect_net_device(failed) <--\n");
		return NO_NETWORK_DEVICE;
	}
	
	while(!feof(fp))
	{
		memset(str, 0, LEN_XL);
		fgets(str, LEN_XL, fp);
		
		//search LAN device
		if(strstr(str, "eth0"))
		{
			device_mask |= NETWORK_DEVICE_LAN;
		}
                
		//search wireless device
		if(strstr(str, "rausb0"))
		{
			device_mask |= NETWORK_DEVICE_WIRELESS;
		}
		
		//rywu20080529++
		//search adsl device
		if(strstr(str, "ppp0"))
		{
			device_mask |= NETWORK_DEVICE_ADSL_MODEM;
		}
		//rywu20080529--
	}
	fclose(fp);
	
	//DBG_MSG("<skydemo> detect_net_device <--\n");
	return device_mask;
}

#ifdef SUPPORT_RSS
//rywu20080516 added
unsigned char set_network_on(unsigned char interface)
{
	FILE *fp,*fp1;
	FILE *dns;
	char str[LEN_XL], getfixIPstr[LEN_XL], buff[IPADDR_LEN];
	Uint8 i, idx;
	ULint32 gatway_ip;
	int skfd;
	struct ifreq ifreq;
	struct sockaddr_in *sin;
	char if_str[16];
	
	pid_t pid;//rywu20080721
	
	DBG_MSG("<skydemo> set_network_on(%d) -->\n", interface);
	
	/*
	if (interface == NETWORK_DEVICE_LAN)
	{
		strcpy(if_str, "eth0");
	}
	else if (interface == NETWORK_DEVICE_WIRELESS)
	{
		strcpy(if_str, "rausb0");
	}*/
	if (interface == NETWORK_DEVICE_LAN)
	{
	    DBG_MSG("<skydemo>   LAN settings ...\n");
	    
	    //rywu20080721 system("killall -SIGUSR2 udhcpc");
        system("/sbin/route del default");
        system("ifconfig eth0 up");
        
        //rywu20080721++ 
        system("killall -SIGUSR2 udhcpc");
	    sleep(1);
        pid = program_pid("udhcpc");
        DBG_MSG("<skydemo>  udhcp pid = %d\n", pid);
        if (pid >= 0)
        {
            kill_old_process("udhcpc", "-SIGKILL");
        }
        //rywu20080721--
        
		//parse rt73sta.dat
		Get_rt73sta_Info("Dhcp", buff);
		if(buff != NULL && !strcmp("n", buff))//fixIP
		{   
            Get_rt73sta_Info("IpAddr", buff);
            DBG_MSG("<skydemo>   ip = %s\n", buff);
            //save ip for fixed ip
			if(!(fp1 = fopen("/tmp/ip.txt", "w")))
			{
				DBG_MSG("<skydemo> Failed to open ip.txt to write!\n");
				DBG_MSG("<skydemo> set_network_on <--(1)\n");
				return;
			}
			fwrite(buff, sizeof(char),sizeof(buff)-1, fp1);
			fclose(fp1);
            sprintf(str, "ifconfig eth0 %s netmask ", buff);
            Get_rt73sta_Info("Mask", buff);
            DBG_MSG("<skydemo>   subnet mask = %s\n", buff);
            strcat(str, buff);
            DBG_MSG("<skydemo>  run %s\n", str);
            system(str);
			
			//set gateway
			Get_rt73sta_Info("GwAddr", buff);
			DBG_MSG("<skydemo>   gateway ip = %s\n", buff);
			//setroute(RTACTION_ADD, 0, "0.0.0.0", "0.0.0.0", buff, "eth0");
			sprintf(str, "route add eth0 default gw %s", buff);
			DBG_MSG("<skydemo>  run %s\n", str);
			system(str);

			/*
			system("ifconfig lo inet 127.0.0.1");
	        system("ifconfig lo inet loopback");
			*/

			//set DNS1
			Get_rt73sta_Info("DNS1", buff);
			if (strlen(buff)) 
			{
			    DBG_MSG("<skydemo>   dns1 ip = %s\n", buff);
				dns = fopen("/tmp/conf/resolv.conf", "w+");
				if (dns) 
				{
					fprintf(dns, "nameserver %s\n", buff);
					
					//set DNS2
					Get_rt73sta_Info("DNS2", buff);
					DBG_MSG("<skydemo>   dns2 ip = %s\n", buff);
					if (strlen(buff)) 
					{
						fprintf(dns, "nameserver %s\n", buff);
					}
					DBG_MSG("<skydemo>  write dns into /tmp/conf/resolv.conf\n");
					fclose(dns);
				}
			}
	
			//still need to ping gateway, for GW is connected; since ping is easier, and less resource
			/*memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
			strcat(getfixIPstr, "touch /tmp/conf/resolv.conf");
			system(getfixIPstr);
			sleep(3);	//wait for interface up
	        */
	        sprintf(str, "touch /tmp/conf/resolv.conf");
			DBG_MSG("<skydemo>  run %s\n", str);
			system(str);
			sleep(3);	//wait for interface up
	
	        /*
			memset(getfixIPstr, 0, sizeof(char) * LEN_XL);
			strcat(getfixIPstr, "ping ");
			Get_rt73sta_Info("GwAddr", buff);
			strcat(getfixIPstr, buff);
			system(getfixIPstr);
			*/
			Get_rt73sta_Info("GwAddr", buff);
			sprintf(str, "ping %s", buff);
			DBG_MSG("<skydemo>  run %s\n", str);
			system(str);
		}
		else//DHCP
		{
            system("/sbin/udhcpc -i eth0 -f -t 6 -p /tmp/udhcpc.pid &");
            
            //rywu20080526 add some delay to wait for getting IP address.
            sleep(3);
		}
	}
	else if (interface == NETWORK_DEVICE_WIRELESS)
	{
	    DBG_MSG("<skydemo>   wireless LAN settings ...\n");
	    
	    //rywu20080721 system("killall -SIGUSR2 udhcpc");
        system("/sbin/route del default");
        system("ifconfig rausb0 up");
        
        //rywu20080721++
        system("killall -SIGUSR2 udhcpc");
        sleep(1);
        pid = program_pid("udhcpc");
        DBG_MSG("<skydemo>  udhcp pid = %d\n", pid);
        if (pid >= 0)
        {
            kill_old_process("udhcpc", "-SIGKILL");
        }
        //rywu20080721--
        
        //parse rt73sta.dat
		Get_rt73sta_Info("Dhcp", buff);
		if(buff != NULL && !strcmp("n", buff))//fixIP
		{
			//set ip and subnet mask
			Get_rt73sta_Info("IpAddr", buff);
            DBG_MSG("<skydemo>   ip = %s\n", buff);
            //save ip for fixed ip
			if(!(fp1 = fopen("/tmp/ip.txt", "w")))
			{
				DBG_MSG("<skydemo> Failed to open ip.txt to write!\n");
				DBG_MSG("<skydemo> set_network_on <--(1)\n");
				return;
			}
			fwrite(buff, sizeof(char),sizeof(buff)-1, fp1);
			fclose(fp1);
            sprintf(str, "ifconfig rausb0 %s netmask ", buff);
            Get_rt73sta_Info("Mask", buff);
            DBG_MSG("<skydemo>   subnet mask = %s\n", buff);
            strcat(str, buff);
            DBG_MSG("<skydemo>  run %s\n", str);
            system(str);
			
			//set gateway
			Get_rt73sta_Info("GwAddr", buff);
			DBG_MSG("<skydemo>   gateway ip = %s\n", buff);
			sprintf(str, "route add rausb0 default gw %s", buff);
			DBG_MSG("<skydemo>  run %s\n", str);
			system(str);

			//set DNS
			Get_rt73sta_Info("DNS1", buff);
			if (strlen(buff)) 
			{
			    DBG_MSG("<skydemo>   dns1 ip = %s\n", buff);
				dns = fopen("/tmp/conf/resolv.conf", "w+");
				if (dns) 
				{
					fprintf(dns, "nameserver %s\n", buff);
					
					//set DNS2
					Get_rt73sta_Info("DNS2", buff);
					DBG_MSG("<skydemo>   dns2 ip = %s\n", buff);
					if (strlen(buff)) 
					{
						fprintf(dns, "nameserver %s\n", buff);
					}
					DBG_MSG("<skydemo>  write dns into /tmp/conf/resolv.conf\n");
					fclose(dns);
				}
			}
	
			//touch resolv.conf to run dns
			sprintf(str, "touch /tmp/conf/resolv.conf");
			DBG_MSG("<skydemo>  run %s\n", str);
			system(str);
			sleep(3);	//wait for interface up
	
	        //ping gateway
	        Get_rt73sta_Info("GwAddr", buff);
			sprintf(str, "ping %s", buff);
			DBG_MSG("<skydemo>  run %s\n", str);
			system(str);
		}
		else//DHCP
		{
            system("/sbin/udhcpc -i rausb0 -f -t 6 -p /tmp/udhcpc.pid &");
            
            //rywu20080526 add some delay to wait for getting IP address.
            sleep(5);
		}
	}
    //rywu20080529++
    else if (interface == NETWORK_DEVICE_ADSL_MODEM)
	{
	    DBG_MSG("<skydemo>   ADSL settings ...\n");
	    
	    //todo : we should have a config file to store all settings.
	    //right now, we just set dns to 168.95.1.1/168.95.192.1
	    dns = fopen("/tmp/conf/resolv.conf", "w+");
        if (dns) 
        {
            fputs("nameserver 168.95.1.1\n", dns);
            fputs("nameserver 168.95.192.1\n", dns);
            fclose(dns);
        }
	    /*
	    //parse rt73sta.dat
		Get_rt73sta_Info("Dhcp", buff);
		if(buff != NULL && !strcmp("n", buff))//fixIP
		{
			//set DNS
			Get_rt73sta_Info("DNS1", buff);
			if (strlen(buff)) 
			{
			    DBG_MSG("<skydemo>   dns1 ip = %s\n", buff);
				dns = fopen("/tmp/conf/resolv.conf", "w+");
				if (dns) 
				{
					fprintf(dns, "nameserver %s\n", buff);
					
					//set DNS2
					Get_rt73sta_Info("DNS2", buff);
					DBG_MSG("<skydemo>   dns2 ip = %s\n", buff);
					if (strlen(buff)) 
					{
						fprintf(dns, "nameserver %s\n", buff);
					}
					DBG_MSG("<skydemo>  write dns into /tmp/conf/resolv.conf\n");
					fclose(dns);
				}
			}
		}*/
        
        //touch resolv.conf to run dns
        system("cat /tmp/conf/resolv.conf");
        sprintf(str, "touch /tmp/conf/resolv.conf");
        DBG_MSG("<skydemo>  run %s\n", str);
        system(str);
	}
	//rywu20080529--
	
	DBG_MSG("<skydemo> set_network_on <--\n");
}

//rywu20080516 added
unsigned char set_network_off(unsigned char interface)
{
    pid_t pid;
    
	DBG_MSG("<skydemo> set_network_off -->\n");
	
	//rywu20080721 system("killall -SIGUSR2 udhcpc");

	switch(interface)	
	{
		case NETWORK_DEVICE_LAN:
			system("ifconfig eth0 down");
			break;
		case NETWORK_DEVICE_WIRELESS:
			system("ifconfig rausb0 down");
			break;
		default:
			system("ifconfig eth0 down");
			system("ifconfig rausb0 down");
			break;
	}
	/*rywu20080721
	//rywu20080709++
	pid = program_pid("udhcpc");
    DBG_MSG("<skydemo>  udhcp pid = %d\n", pid);
    //if (pid >= 0)
    {
        kill_old_process("udhcpc", "-SIGKILL");
    }
    //rywu20080709--*/
    
	DBG_MSG("<skydemo> set_network_off <--\n");
}
#endif //end #ifdef SUPPORT_RSS


#endif

#ifdef WPA_SUPPLICANT_SUPPORT
/* Find a running program's process ID.
 * Parameter:
 * 		const char *program: the name of the running program. The name should
 * 							be exactly same as the process's argv[0].
 * 							(Ex. If the the ping command is lauched by
 * 							shell command "/bin/ping", the caller should
 * 							apply "/bin/ping" to the function.)
 * Return:
 * 		0 - No process with the specified program name is running.
 * 		-1 - internale error
 * 		-2 - More than one process have the same program name.
 * 		>0 - The process ID of the running program
 */
int
program_pid(const char *program)
{
	struct dirent *entry;
	DIR *dir;
	int i, found=0, pid;
	char buffer[256];
	FILE *fp;

	dir = opendir("/proc");
	if(!dir)
		return(-1);

	while((entry=readdir(dir))!=NULL)
	{
		char *endptr;
		int id, c=-1;

		id=strtoul(entry->d_name, &endptr, 10);
		if(*endptr!='\0')
			continue;		/* this is not a process directory */

		snprintf(buffer, sizeof(buffer), "/proc/%s/cmdline", entry->d_name);
		if((fp=fopen(buffer, "r"))==NULL)
			continue;

		for(i=0; (c=fgetc(fp))!=EOF && program[i]; i++)
		{
			if(c!=program[i])
				break;
		}
		fclose(fp);

		if(c!='\0' || program[i]!='\0')
			continue;			/* does not match the program name */

		found++;
		pid=id;
	}
	closedir(dir);

	if(found==1)
		return(pid);

	if(found>1)
		return(-2);

	return(0);
}

int
kill_old_process(const char *proc_name,const char *signal)
{
	pid_t pid;
	int pipefd[2],rt = 0;
	const char *killall_process="/usr/bin/killall";
	
	if(pipe(pipefd)<0)
   		return(-1);

   	pid = fork();
   	switch(pid)
   	{
		case -1:
			close(pipefd[0]);
			close(pipefd[1]);
	   		return(-1);
		case 0:
			close(0); /*read*/
			close(1);
			close(2);
			//execl(killall_process, "killall", "-SIGKILL", proc_name, (char*)0);
			execl(killall_process, "killall", signal, proc_name, (char*)0);
			close(pipefd[0]);
			close(pipefd[1]);
	   		return(-1);
		default:
			do
			{
				rt=waitpid(pid,(int *)0,0);
			}while(!rt);
			close(pipefd[0]);
			close(pipefd[1]);
		   	return(0);
	}
}

static void 
write_data(char *cmd,FILE *wpa_supplicant_conf)
{
	fwrite(cmd,sizeof(char),strlen(cmd),wpa_supplicant_conf);
}

static int
write_to_conf(void (*pfun)(char *cmd,FILE *wpa_supplicant_conf))
{
	FILE *wpa_supplicant_conf;
	wpa_supplicant_head=wpa_supplicant_start_pointer;  
	
  if((wpa_supplicant_conf = fopen(WPA_SUPPLICANT_CONF,"w")) == NULL)
  {
     fclose(wpa_supplicant_conf);
     return(-1); 
  }
   
	while(wpa_supplicant_head!=NULL)
	{	
		(*pfun)(wpa_supplicant_head->wpa_supplicant_cmd,wpa_supplicant_conf);		
		wpa_supplicant_head = wpa_supplicant_head->next;
	}
	
	fclose(wpa_supplicant_conf);
	return(0);
}

int 
WRITE_TO_CONF()
{
	if(write_to_conf(write_data)<0)
	{
		return(-1);
	}
	return(0);
}

static int
AddCmd(char *cmd)
{
		if(wpa_supplicant_start_pointer==NULL)
    {
    	wpa_supplicant_start_pointer=(WPA_SUPPLICANT_CONF_CMD *) malloc (sizeof (WPA_SUPPLICANT_CONF_CMD));
    	if(wpa_supplicant_start_pointer==0)
    	{
    		return(-1);
    	}
    	memset(wpa_supplicant_start_pointer,'\0',sizeof(WPA_SUPPLICANT_CONF_CMD));
  		wpa_supplicant_next_pointer=wpa_supplicant_start_pointer;
    	memcpy(wpa_supplicant_next_pointer->wpa_supplicant_cmd, cmd,strlen(cmd));
    	//printf("%s",wpa_supplicant_next_pointer->wpa_supplicant_cmd);
  		wpa_supplicant_next_pointer->next=NULL;
    }
    else
    {
    	wpa_supplicant_next_pointer->next=(WPA_SUPPLICANT_CONF_CMD *) malloc (sizeof (WPA_SUPPLICANT_CONF_CMD));
    	wpa_supplicant_next_pointer=wpa_supplicant_next_pointer->next;
    	if(wpa_supplicant_next_pointer==0)
    	{
    		return(-1);
    	}
    	memset(wpa_supplicant_next_pointer,'\0',sizeof(WPA_SUPPLICANT_CONF_CMD));
    	memcpy(wpa_supplicant_next_pointer->wpa_supplicant_cmd, cmd,strlen(cmd));
    	//printf("%s",wpa_supplicant_next_pointer->wpa_supplicant_cmd);
    	wpa_supplicant_next_pointer->next=NULL;
    }
    return(0);
	
}

static void
FREE_WPA_SUPPLICANT_TABLE(WPA_SUPPLICANT_CONF_CMD  *wpa_supplicant_table)
{
	WPA_SUPPLICANT_CONF_CMD  *p,*q;
	for(p=wpa_supplicant_table;p!=NULL;p=q)
	{
		q = p->next;
		free(p);
	}
}

static void
FREE_WPA_SUPPLICANT_LIST()
{
	wpa_supplicant_head=wpa_supplicant_start_pointer; 
  FREE_WPA_SUPPLICANT_TABLE(wpa_supplicant_head);
  wpa_supplicant_start_pointer = NULL;
}

static int
zydas_set_param(char *ifname, int op, int arg)
{
	struct iwreq iwr;
	int *i, s, ret = 0;

	s = socket(PF_INET, SOCK_DGRAM, 0);
	if (s < 0) {
		perror("socket[PF_INET,SOCK_DGRAM]");
		return -1;
	}

	memset(&iwr, 0, sizeof(iwr));
	strncpy(iwr.ifr_name, ifname, IFNAMSIZ);
	i = (int *) iwr.u.name;
	*i++ = op;
	*i++ = arg;

	if (ioctl(s, ZD_IOCTL_PARAM, &iwr) < 0) {
		perror("ioctl[ZD_IOCTL_PARAM]");
		ret = -1;
	}
	close(s);

	return ret;
}

#endif

#ifdef WPS_SUPPORT
void ralink_wps_pbc(void)
{
	system("iwpriv rausb0 set WscMode=2");		//set to pbc mode
	sleep(1);
	system("iwpriv rausb0 set WscGetConf=1");
}

void ralink_wps_stop(void)
{
	system("iwpriv rausb0 set WscStop=1");		//set to pbc mode
	sleep(1);
	wps_timer = 0;
	wps_sys_sec = 0;
}

void set_wps_timer(void)
{	
	//if(wps_timer==0)
	{
		wps_timer = 120;	//120sec
		time(&wps_sys_sec);
	}
}

void check_wps_timer(void)
{
	time_t t;
	if(wps_timer>0)
	{
		time(&t);
		if(t>wps_sys_sec)
		{
			wps_timer--;
			wps_sys_sec = t;		//set to now sec
		}
	}
}

int start_wps_pbc()
{
	int ret = 0;
	if(wps_timer==0)
	{
		if(net_vendor == NET_UNKNOWN)
		{
			printf("net vendor unknow, try again!\n");
			return(0);
		}
		else
		{
			set_wps_timer();
			printf("WPS Negotiation Start(net_vendor=%d)...\n",net_vendor);
			if(net_vendor == RALINK_WIRELESS)
			{
				ralink_wps_stop();
				ralink_wps_pbc();
			}
			else if(net_vendor == ZYDAS_WIRELESS)
			{
				ret = start_zydas_wps_pbc();
			}
		}
	}
	else
	{
		printf("You can't push the button more than twice within 2 min.\n");
		printf("Need %d sec to restart.\n",wps_timer);
		//printf("one wps process is running(%d)\n",wps_timer);
	}
	
	return(ret);	
}

static void 
wps_write_data(char *cmd,FILE *wps_conf)
{
	fwrite(cmd,sizeof(char),strlen(cmd),wps_conf);
}

static int
wps_write_to_conf(void (*pfun)(char *cmd,FILE *wps_conf))
{
	FILE *wps_conf;
	wps_head=wps_start_pointer;  
	
  if((wps_conf = fopen(WPS_CONF,"w")) == NULL)
  {
     fclose(wps_conf);
     return(-1); 
  }
   
	while(wps_head!=NULL)
	{	
		(*pfun)(wps_head->wps_cmd,wps_conf);		
		wps_head = wps_head->next;
	}
	
	fclose(wps_conf);
	return(0);
}

int 
WPS_WRITE_TO_CONF()
{
	if(wps_write_to_conf(wps_write_data)<0)
	{
		return(-1);
	}
	return(0);
}

static int
WPS_AddCmd(char *cmd)
{
		if(wps_start_pointer==NULL)
    {
    	wps_start_pointer=(WPS_CONF_CMD *) malloc (sizeof (WPS_CONF_CMD));
    	if(wps_start_pointer==0)
    	{
    		return(-1);
    	}
    	memset(wps_start_pointer,'\0',sizeof(WPS_CONF_CMD));
  		wps_next_pointer=wps_start_pointer;
    	memcpy(wps_next_pointer->wps_cmd, cmd,strlen(cmd));
    	//printf("%s",wps_next_pointer->wps_cmd);
    	wps_next_pointer->next=NULL;
    }
    else
    {
    	wps_next_pointer->next=(WPS_CONF_CMD *) malloc (sizeof (WPS_CONF_CMD));
    	wps_next_pointer=wps_next_pointer->next;
    	if(wps_next_pointer==0)
    	{
    		return(-1);
    	}
    	memset(wps_next_pointer,'\0',sizeof(WPS_CONF_CMD));
    	memcpy(wps_next_pointer->wps_cmd, cmd,strlen(cmd));
    	//printf("%s",wps_next_pointer->wps_cmd);
    	wps_next_pointer->next=NULL;
    }
    return(0);
	
}

static void
FREE_WPS_TABLE(WPS_CONF_CMD  *wps_table)
{
	WPS_CONF_CMD  *p,*q;
	for(p=wps_table;p!=NULL;p=q)
	{
		q = p->next;
		free(p);
	}
}

static void
FREE_WPS_LIST()
{
	wps_head=wps_start_pointer; 
  FREE_WPS_TABLE(wps_head);
  wps_start_pointer = NULL;
}

int start_zydas_wps_pbc()
{
	int i;
	char tmp[100];
	struct 	spawn_handle spawn;
	int 		status,ret,total_entry;
	
	/* kill old udhcpc process */	
	ret = program_pid("udhcpc");
	if(ret>0)
		kill_old_process("udhcpc","-SIGKILL");
			
	/* kill old wpa_supplicant process */	
	ret = program_pid("wpa_supplicant");
	if(ret>0)
		kill_old_process("wpa_supplicant","-SIGKILL");
		
	/* make sure WPA state is ZYDAS_WPA_DISCONNECTED */
	zydas_set_param("rausb0", ZD_PARAM_SET_STATE, ZYDAS_WPA_DISCONNECTED);
		
	/* create wps.conf */
	total_entry = (sizeof(wps_conf_comment)/sizeof(wps_conf_comment[0]))-3;
	
	//printf("total entry=%d\n",total_entry);
	/* skip pin number comment */
	for(i=0;i<total_entry;i++)
	{
		/* set method(i==13) */
		if(i==13)
		{
			memset(tmp,0,sizeof(tmp));
			sprintf(tmp,wps_conf_comment[i],0);		
			//printf("%s\n",tmp);
			if(WPS_AddCmd(tmp)<0)
				return(-1);	
		}
		/* set policy(i==28) */
		else if(i==28)
		{
			memset(tmp,0,sizeof(tmp));
			sprintf(tmp,wps_conf_comment[i],1);		
			//printf("%s\n",tmp);
			if(WPS_AddCmd(tmp)<0)
				return(-1);	
		}
		else
		{
			if(WPS_AddCmd((char *)wps_conf_comment[i])<0)
				return(-1);
		}
	}
	if(WPS_WRITE_TO_CONF()<0)
			return(-1);	
	
	//wait for write command to wps.conf
	sleep(5);
			
	if(spawn_program(&spawn, SPAWN_NULL_IO,
		 WPS_UTILITY, "wps_enrollee", "pbc", WPS_CONF ,NULL)==0)
	{		
		printf("spawn_program wps_enrollee error!\n");	
		FREE_WPS_LIST();
		return(-1);
	}
	
	if(cleanup_spawn(&spawn, &status)<0 || WEXITSTATUS(status)!=0)
	//if(cleanup_spawn(&spawn, &status)<0)
	{
		printf("cleanup_spawn wps_enrollee error!\n");	
		FREE_WPS_LIST();
		return(-1);
	}
	
	FREE_WPS_LIST();	
	
	return(0);
}
#endif

