#ifndef _TEXT_UTIL_HEADER_
#define _TEXT_UTIL_HEADER_

#include "types.h"
#include "FontDB.h"
#include "iconv.h"
#include "fbutil.h"

//#ifdef USE_DESC_TV
//#define USE_FONTAA		//}ҦrϿ(tv~ݭn)
//#endif

///070726 r榡Ƽ
//#define DT_TOP              0x00000000
#define DT_LEFT             0x00000000
#define DT_CENTER           0x00000001
#define DT_RIGHT            0x00000002
//#define DT_VCENTER          0x00000004
//#define DT_BOTTOM           0x00000008
//#define DT_WORDBREAK        0x00000010
//#define DT_SINGLELINE       0x00000020
//#define DT_EXPANDTABS       0x00000040
//#define DT_TABSTOP          0x00000080
//#define DT_NOCLIP           0x00000100
//#define DT_EXTERNALLEADING  0x00000200
//#define DT_CALCRECT         0x00000400
//#define DT_NOPREFIX         0x00000800
//#define DT_INTERNAL         0x00001000
///
//------------------------------------------------------------------------------------------------

extern FONT_DB *g_pFontDB_Default;
extern FONT_DB *g_pFontDB_Local;
///080115 iconv
extern FONT_DB *g_pFontDB_Unicode;
extern iconv_t g_cd_utf8_2_local;
extern iconv_t g_cd_utf8_2_ucs2;
extern iconv_t g_cd_local_2_ucs2;
/// 

///080118
Uint16 GetFontStringWidth(FONT_DB *pFontDB, BYTE *str);
Uint16 GetFontStringWidthW(FONT_DB *pFontDB, BYTE *str, int UseUTF);
///
///080128
Uint16 strlenW(BYTE *str, int UseUTF);
///

#ifdef USE_FONTAA	//}ҦrϿ(tv~ݭn)
bool FillFontAAMap(BYTE* pImage, int width, int height, int nBPL);
#endif

Uint16 FontTextOutAlign(FONT_DB *pFontDB, Uint16 *RGBFrame, Uint16 FrameWidth, int x, int y, int MaxWidth, BYTE *str, Uint16 color);
Uint16 FontTextOut(FONT_DB *pFontDB, Uint16 *RGBFrame, int x, int y, BYTE *str, Uint16 color);
Uint16 FontTextOutFormat(FONT_DB *pFontDB, Uint16 *RGBFrame, int x, int y, BYTE *str, Uint16 color, Uint32 nFormat);

///080128
Uint16 FontTextOutFileName(FONT_DB *pFontDB, BYTE *str, 
						   int UseUTF,
						   Uint8 bShowPath,
						   Uint16 color,
						   Uint16 *RGBFrame, Uint16 FrameWidth,
						   Uint16 x, Uint16 y, Uint16 w, Uint16 h);
///
///080117
Uint16 FontTextOutW(FONT_DB *pFontDB, BYTE *str, 
					int UseUTF,
					Uint16 color,
					Uint16 *RGBFrame, Uint16 FrameWidth,
					Uint16 x, Uint16 y, Uint16 w, Uint16 h);
//UseUTF == 16		ϥUCS-2sX
//			8		ϥUTF-8sX
//			-8		qO_ϥUTF-8
//			0		ϥUTFsX
///

///080115 P_O_UTF-8r
int isUTF8(BYTE* str);
///

///080511 _rA^ByteƥءA-1ܿ~
int CutFontTextByWidth(FONT_DB *pFontDB, BYTE *str, int UseUTF, Uint16 width);
///
#endif
