#ifndef _FLIST_HEADER
#define _FLIST_HEADER

#include "types.h"

#define Mask_IsDir 0x80
#define Mask_IsListHead 0x40
#define Mask_IsListTail 0x20
#define Mask_IsChecked 0x01

///070606 Folder ViewΪListc
typedef struct _FLIST
{
	char fname[LEN_XL];
	Uint8 attribute;		//令ΦP@byteݩʡAbit opϤ
	struct _FLIST *prev;
	struct _FLIST *next;
}FLIST;
///

extern  FLIST *CurrFldrListPos;
extern COORD FldrRegion;

///070607 FolderΪoperation
FLIST* FolderList_Build(char* PathName);
Uint8 FolderList_AddTail(FLIST** ppFolderList, char* FileName, Uint8 IsDir);
void FolderList_Free(FLIST** ppFolderList);
///
//R
Uint8 FolderList_RemoveAt(FLIST** ppFolderList, FLIST* pRemoveNode);
FLIST* FolderList_GetHeadPos(FLIST* pFolderList);

#endif
