#include "events.h"
#include "FList.h"
#include "parser.h"

FLIST *CurrFldrListPos = NULL;
COORD FldrRegion = {0, 0, 0, 0};

///070604 FolderEvent
// Folder-------------------------------------------------------------------------------------------
void UpdateFLDR()
{
	FRAME *elmf;

	FLIST *pTempList;
	Uint16 x, y, maxw;
	int i;
	ICON* picFileSelect;

	if (!FolderList) return;

	elmf = &ELMachines[active_index].frame;

	//Mܽd
	///070814
	DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->rgbtemplate, FldrRegion.x, FldrRegion.y, FldrRegion.width, FldrRegion.height);
	//DuplicateBlockBitmap((Uint16*)elmf->rgbtemplate, (Uint16*)elmf->bkgrdbuff, FldrRegion.x, FldrRegion.y, FldrRegion.width, FldrRegion.height);
	///

	if(active_index == FLDR_ACTIVE)
		picFileSelect = elmf->icon_arr + (elmf->num_icon-3);
#ifdef IP_CAM_MOD
	else if (active_index == IP_CAM_ACTIVE)
		picFileSelect = elmf->icon_arr + (elmf->num_icon-1);
#endif

	//FLISTɦW
	i = 0;
	pTempList = FolderList;
	while (pTempList && i < FOLDER_BAR_NUM)
	{
		x = elmf->icon_arr[i].txtcoord.x;
		y = elmf->icon_arr[i].txtcoord.y;
		maxw = elmf->icon_arr[i].txtcoord.width;
		if (pTempList->attribute & Mask_IsDir)	//ؿ
		{
			///080131
			#ifdef LEADTEK
			FontTextOutFileName(g_pFontDB_Local,
								(BYTE*)(pTempList->fname),
								NLS_USE_UTF,
								TRUE,
								LTK_BLUE,
								(WORD*)RGB1, OUTPUT_XRES,
								x, y, maxw, 0);
			#else
			#ifdef WINGUI
			FontTextOutFileName(g_pFontDB_Local,
								(BYTE*)(pTempList->fname),
								NLS_USE_UTF,
								TRUE,
								BLACK_1555,
								(WORD*)RGB1, OUTPUT_XRES,
								x, y, maxw, 0);
			#else
			FontTextOutFileName(g_pFontDB_Local,
								(BYTE*)(pTempList->fname),
								NLS_USE_UTF,
								TRUE,
								#ifndef DARK_BLUE_DESIGN
								BLUE_1555,
								#else
								MUSIC_FILENAME,
								#endif
								(WORD*)RGB1, OUTPUT_XRES,
								x, y, maxw, 0);
			#endif
			#endif
			/*
			///070814
			#ifdef LEADTEK
			FontTextOutAlign(g_pFontDB_Local, (WORD*)RGB1, OUTPUT_XRES,
						x, y, maxw, (BYTE*)(pTempList->fname), LTK_BLUE);
			#else
			FontTextOutAlign(g_pFontDB_Local, (WORD*)RGB1, OUTPUT_XRES,
						x, y, maxw, (BYTE*)(pTempList->fname), BLUE_1555);
			#endif
			//FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES,
			//			x, y, maxw, (BYTE*)(pTempList->fname), BLUE_1555);
			///f
			*/
			///
		}
		else									//@ɮ
		{
			///080131
			#ifdef LEADTEK
			FontTextOutFileName(g_pFontDB_Local,
								(BYTE*)(pTempList->fname),
								NLS_USE_UTF,
								TRUE,
								LTK_BLACK,
								(WORD*)RGB1, OUTPUT_XRES,
								x, y, maxw, 0);
			#else
			FontTextOutFileName(g_pFontDB_Local,
								(BYTE*)(pTempList->fname),
								NLS_USE_UTF,
								TRUE,
								#ifndef DARK_BLUE_DESIGN
								BLACK_1555,
								#else
								MUSIC_FILENAME,
								#endif
								(WORD*)RGB1, OUTPUT_XRES,
								x, y, maxw, 0);
			#endif
			/*
			///070814
			FontTextOutAlign(g_pFontDB_Local, (WORD*)RGB1, OUTPUT_XRES,
						x, y, maxw, (BYTE*)(pTempList->fname), BLACK_1555);
			//FontTextOutAlign(g_pFontDB_Local, (WORD*)elmf->rgbtemplate, OUTPUT_XRES,
			//			x, y, maxw, (BYTE*)(pTempList->fname), BLACK_1555);
			///
			*/
			///
	
			//eQɮתХܰO
		}
		if (pTempList->attribute & Mask_IsChecked)
		{
			///070814
			DuplicateBitmap((Uint16*)RGB1, (Uint16*)(picFileSelect->iconbuff),
							elmf->icon_arr[i].icoord.x, elmf->icon_arr[i].icoord.y,
							elmf->icon_arr[i].icoord.width, elmf->icon_arr[i].icoord.height);
			//DuplicateBitmap((Uint16*)elmf->rgbtemplate, (Uint16*)(picFileSelect->iconbuff),
			//				elmf->icon_arr[i].icoord.x, elmf->icon_arr[i].icoord.y,
			//				elmf->icon_arr[i].icoord.width, elmf->icon_arr[i].icoord.height);
			///
		}

		//sեfocusm
		if (i == elmf->active_icon_index)
		{
			CurrFldrListPos = pTempList;
		}
		
		pTempList = pTempList->next;
		i++;
	}

	//եfocusm
	if (elmf->active_icon_index >= i)
	{
		elmf->active_icon_index = i - 1;
		CurrFldrListPos = FolderList;
		for (i=0; i<elmf->active_icon_index; i++)
		{
			CurrFldrListPos = CurrFldrListPos->next;
		}
	}

	//eQܪɮ([)
	///070814
	RGBlock2YUVBlock(RGB1, 1, FldrRegion.x, FldrRegion.y, FldrRegion.width, FldrRegion.height);
	DrawFolderBarFocus(RGB1, elmf->active_icon_index, CurrFldrListPos, 0);
	//RGBlock2YUVBlock(elmf->rgbtemplate, 1, FldrRegion.x, FldrRegion.y, FldrRegion.width, FldrRegion.height);
	//DrawFolderBarFocus(elmf->rgbtemplate, elmf->active_icon_index, CurrFldrListPos, 0);
	///
}
void FLDR_UpEvent()
{
	int i;
	FRAME *elmf;

	if (!FolderList) return;

	elmf = &ELMachines[active_index].frame;

	//Ywb}Y
	if (CurrFldrListPos->attribute & Mask_IsListHead)
	{
		if (!(CurrFldrListPos=CurrFldrListPos->prev))
			return;
		elmf->active_icon_index--;	//|ܦ-1
		for (i=0; i<FOLDER_BAR_NUM; i++)
		{
			elmf->active_icon_index++;
			if (!(FolderList=FolderList->prev))
				return;
			if (FolderList->attribute & Mask_IsListHead)
				break;
		}
		UpdateFLDR();
	}
	//wbe̤W
	else if (elmf->active_icon_index == 0)
	{
		FolderList = FolderList->prev;
		CurrFldrListPos = CurrFldrListPos->prev;
		UpdateFLDR();
	}
	//@s
	else
	{
		///070814
		DrawFolderBarFocus(RGB1, elmf->active_icon_index, CurrFldrListPos, 1);	//
		//DrawFolderBarFocus(elmf->rgbtemplate, elmf->active_icon_index, CurrFldrListPos, 1);	//
		///
		CurrFldrListPos = CurrFldrListPos->prev;
		elmf->active_icon_index--;
		///070814
		DrawFolderBarFocus(RGB1, elmf->active_icon_index, CurrFldrListPos, 0);	//e
		//DrawFolderBarFocus(elmf->rgbtemplate, elmf->active_icon_index, CurrFldrListPos, 0);	//e
		///
	}
	
}
void FLDR_DownEvent()
{
	FRAME *elmf;

	if (!FolderList) return;
	
	elmf = &ELMachines[active_index].frame;
	
	//Yw쵲
	if (CurrFldrListPos->attribute & Mask_IsListTail)
	{
		//^}Y
		while ((FolderList->attribute & Mask_IsListHead) == 0)
		{
			FolderList = FolderList->prev;
		}
		elmf->active_icon_index = 0;
		CurrFldrListPos = FolderList;
		UpdateFLDR();
	}
	//we̤U
	else if (elmf->active_icon_index == FOLDER_BAR_NUM-1)
	{
		FolderList = FolderList->next;
		CurrFldrListPos = CurrFldrListPos->next;
		UpdateFLDR();
	}
	//@s
	else
	{
		///070814
		DrawFolderBarFocus(RGB1, elmf->active_icon_index, CurrFldrListPos, 1);
		//DrawFolderBarFocus(elmf->rgbtemplate, elmf->active_icon_index, CurrFldrListPos, 1);
		///
		CurrFldrListPos = CurrFldrListPos->next;
		elmf->active_icon_index++;
		///070814
		DrawFolderBarFocus(RGB1, elmf->active_icon_index, CurrFldrListPos, 0);
		//DrawFolderBarFocus(elmf->rgbtemplate, elmf->active_icon_index, CurrFldrListPos, 0);
		///
	}
	
}
void FLDR_LeftEvent()
{
	char CurrentPath[LEN_XL];
	char RootPath[LEN_XL];
	FRAME *elmf;

	if (!FolderList) return;
	
	elmf = &ELMachines[active_index].frame;
	
	GetPath(RootPath);
	getcwd(CurrentPath, LEN_XL);

	//w̤WhNΰ
	if (strlen(CurrentPath) <= strlen(RootPath))
	{
		return;
	}
	else
	{
		FLDR_StopEvent();//for stop music by bk @ 071022
		//^W@h
		chdir("..");
		FolderList_Free(&FolderList);
		FolderList = FolderList_Build(".");
		elmf->active_icon_index = 0;
		CurrFldrListPos = FolderList;
		
		//integrated with BT by bk @ 070928
		//FldrDisplay();
		ELMachines[active_index].Display();
	}
}
void FLDR_RightEvent()
{
//	FLDR_EnterEvent();
	char CurrentPath[LEN_XL];
	char RootPath[LEN_XL];
	FRAME *elmf;

	if (!FolderList) return;

	elmf = &ELMachines[active_index].frame;	
	
	if (CurrFldrListPos->attribute & Mask_IsDir)
	{
		GetPath(RootPath);
		getcwd(CurrentPath, LEN_XL);
		
		//w̤WhNΰ
		if (  strcmp(CurrFldrListPos->fname, "..") == 0
		    &&
		      (strlen(CurrentPath) <= strlen(RootPath))
		   )
		{
			return;
		}
		else
		{
			FLDR_StopEvent();//for stop music by bk @ 071022
			//(iJ)@ؿ
			chdir(CurrFldrListPos->fname);
			FolderList_Free(&FolderList);
			FolderList = FolderList_Build(".");
			elmf->active_icon_index = 0;
			CurrFldrListPos = FolderList;
			
			//integrated with BT by bk @ 070928
			//FldrDisplay();
			ELMachines[active_index].Display();
		}
	}
}
void FLDR_NextEvent()
{
	FRAME *elmf;
	int i;
	
	if (!FolderList) return;
	
	elmf = &ELMachines[active_index].frame;

	for (i=0; i<FOLDER_BAR_NUM; i++)
	{
		if (CurrFldrListPos->attribute & Mask_IsListTail)	
			break;
		elmf->active_icon_index++;
		CurrFldrListPos = CurrFldrListPos->next;
	}

	if (elmf->active_icon_index >= FOLDER_BAR_NUM)
	{
		elmf->active_icon_index -= FOLDER_BAR_NUM;
		for (i=0; i<FOLDER_BAR_NUM; i++)
			FolderList = FolderList->next;
	}

	UpdateFLDR();
}
void FLDR_PrevEvent()
{
	FRAME *elmf;
	int i;

	if (!FolderList) return;
		
	elmf = &ELMachines[active_index].frame;

	for (i=0; i<FOLDER_BAR_NUM; i++)
	{
		if (CurrFldrListPos->attribute & Mask_IsListHead)
			break;
		CurrFldrListPos = CurrFldrListPos->prev;
		elmf->active_icon_index--;		
	}

	if (elmf->active_icon_index < 0)
	{
		for (i=0; i<FOLDER_BAR_NUM; i++)
		{
			if (FolderList->attribute & Mask_IsListHead)
				break;
			FolderList = FolderList->prev;
			elmf->active_icon_index++;
		}
	}

	UpdateFLDR();
}

void FLDR_PlayPauseEvent()
{
	if(!isFldrAudPrcsForked)
	{
		FLDR_EnterEvent();
	}
	else
	{
		set_ir_value((unsigned long)0x70);
	}
}
void FLDR_EnterEvent()
{
	Uint8 isImage = FALSE, isAudio = FALSE, isVideo = FALSE;
	int i = 0, prio;
	char *ext;
	struct bmp_state *bmp_h;
	struct tiff_hdr *tiff_h;
	FileInfo finfo;
//	FLIST *prevAudio = NULL;

	if (!FolderList) return;
	
	FLDR_StopEvent();

	//ؿ=>iJ
	if((CurrFldrListPos->attribute & Mask_IsDir) || !strcmp(CurrFldrListPos->fname, ".")  || !strcmp(CurrFldrListPos->fname, ".."))//dir, ., ..
	{
		return FLDR_RightEvent();
	}
	//LɦW=>
	else if((ext = strrchr(CurrFldrListPos->fname, '.')) == NULL)
	{
		return;
	}
	//check media type
	else if(IsSupportedJPG(ext))//jpg
	{
		isImage = TRUE;
	}
	else if(IsSupportedBMP(ext))//bmp
	{
		bmp_h = (struct bmp_state *)GetBmpHdr(CurrFldrListPos->fname);
		if (bmp_h != NULL)
		{
			isImage = TRUE;
			FreeBmpHdr(bmp_h);
		}else
			return;
	}
	else if(IsSupportedTIFF(ext))//tiff
	{
		tiff_h = (struct tiff_hdr *)GetTiffHdr(CurrFldrListPos->fname);
		if (tiff_h != NULL)
		{
			isImage = TRUE;
			FreeTiffHdr(tiff_h);
		}else
			return;
	}else if(IsSupportedAudio(ext))//audio
	{
		//check audio playable
		if(MediaParser(CurrFldrListPos->fname, &finfo) == PlayableMusic)
			isAudio = TRUE;
		else
		{
			DPRINTF("'%s' is not playable!\n", CurrFldrListPos->fname);
			return;
		}
	}else if(IsSupportedVideo(ext))//video
	{
		//bk @ 080129 - video is not playable when nas selected
#ifdef NET_MOD
		if(!strcmp(SelectedDev, DEVICE_NAS_NAME))
			return;
#endif
		
		//check video playable
		if(MediaParser(CurrFldrListPos->fname, &finfo) == PlayableVideo)
			isVideo = TRUE;
		else
		{
			DPRINTF("'%s' is not playable!\n", CurrFldrListPos->fname);
			return;
		}
	}else
		return;
	
	//switch to that active
	if(isImage)
	{
		prev_active_index = active_index;
		active_index = FLDR_FI_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	else if(isAudio)
	{
		if(!isFldrAudPrcsForked)//not playing
		{
//			prevAudio = CurrFldrListPos;
		}
		else//playing audio...
		{
//			if(prevAudio == CurrFldrListPos)//the same song is playing, stop it!!!
//			{
				//kill current process
				FLDR_StopEvent();
				
				return;
//			}else
//				prevAudio = CurrFldrListPos;
		}
		
		pid_fldr_aud = fork();
		switch(pid_fldr_aud)
		{
			case -1:
				perror("Fork failed!");
				DMSG("Fork to play audio Fail!");
				break;
			case 0:
				//child process
				execl("/sky/mplayer", "mplayer", "-arcdemo", "-really-quiet", "-novideo", CurrFldrListPos->fname, NULL);
				//execl("/sky/mplayer", "mplayer", "-acache", "-arcdemo", "-really-quiet", "-novideo", CurrFldrListPos->fname, NULL);
				_EXIT;
			default:
				//parent process
				isFldrAudPrcsForked = TRUE;
				prio = getpriority(PRIO_PROCESS, (int)pid_fldr_aud);
	  			setpriority(PRIO_PROCESS, (int)pid_fldr_aud, prio - 15);
				break;
		}
	}
	else if(isVideo)
	{
		prev_active_index = active_index;
		active_index = FLDR_FV_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
	
//	FLDR_RigthEvent();
/*
	char CurrentPath[LEN_XL];
	char RootPath[LEN_XL];
	FRAME *elmf;
	elmf = &ELMachines[active_index].frame;	

	if (CurrFldrListPos->attribute & Mask_IsDir)
	{
		GetPath(RootPath);
		getcwd(CurrentPath, LEN_XL);
	
		//w̤WhNΰ
		if (  strcmp(CurrFldrListPos->fname, "..") == 0
		    &&
		      (strlen(CurrentPath) <= strlen(RootPath))
		   )
		{
			return;
		}
		else
		{
			//(iJ)@ؿ
			chdir(CurrFldrListPos->fname);
			FolderList_Free(&FolderList);
			FolderList = FolderList_Build(".");
			elmf->active_icon_index = 0;
			CurrFldrListPos = FolderList;
			
			//integrated with BT by bk @ 070928
			//FldrDisplay();
			ELMachines[active_index].Display();
		}
	}
*/
}
void FLDR_EscEvent()
{
	//leave to DS when selected device is HD or NAS (performance issue) - bk @ 080108
	if(
			!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
		||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
	)
	{
		DetectEvent();
	}
	//original function
	else
	{
		ELMachines[active_index].Shutdown(0);
		active_index = MT_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
	}
}

void FLDR_RepeatEvent()
{
	ICON* picSelectFile;
	COORD* pcoIcon;
	FRAME *elmf;

	if (!FolderList) return;
	
	elmf = &ELMachines[active_index].frame;

	if (strcmp(CurrFldrListPos->fname, "..") == 0)
		return;

#ifdef IP_CAM_MOD
	if (active_index == IP_CAM_ACTIVE)
	{
		picSelectFile = elmf->icon_arr + (elmf->num_icon-1);
	}
	else
#endif
	picSelectFile = elmf->icon_arr + (elmf->num_icon-3);
	pcoIcon = &(elmf->icon_arr[elmf->active_icon_index].icoord);

	if (CurrFldrListPos->attribute & Mask_IsChecked)
	{
		CurrFldrListPos->attribute &= (~Mask_IsChecked);

		///070816
		DuplicateBlockBitmap((Uint16*)RGB1, (Uint16*)elmf->bkgrdbuff,
						pcoIcon->x, pcoIcon->y, pcoIcon->width, pcoIcon->height);
		//DuplicateBlockBitmap((Uint16*)elmf->rgbtemplate, (Uint16*)elmf->bkgrdbuff,
		//				pcoIcon->x, pcoIcon->y, pcoIcon->width, pcoIcon->height);	
		///
	}
	else
	{
		CurrFldrListPos->attribute |= Mask_IsChecked;

		///070816
		DuplicateBitmap((Uint16*)RGB1, (Uint16*)picSelectFile->iconbuff,
						pcoIcon->x, pcoIcon->y, pcoIcon->width, pcoIcon->height);
		//DuplicateBitmap((Uint16*)elmf->rgbtemplate, (Uint16*)picSelectFile->iconbuff,
		//				pcoIcon->x, pcoIcon->y, pcoIcon->width, pcoIcon->height);
		///
	}
	///070816
	RGBlock2YUVBlock(RGB1, 1, pcoIcon->x, pcoIcon->y, pcoIcon->width, pcoIcon->height);
	//RGBlock2YUVBlock(elmf->rgbtemplate, 1, pcoIcon->x, pcoIcon->y, pcoIcon->width, pcoIcon->height);
	///
}

void FLDR_StopEvent()//stop playing audio
{
	if(isFldrAudPrcsForked)
	{
		KillFldrAudioProcess();
		isFldrAudPrcsForked = FALSE;
	}
}
///

void FLDR_SSEvent()
{
	char RootPath[LEN_XL], CurrentPath[LEN_XL];
	FRAME *elmf;
	
	//init
	elmf = &ELMachines[active_index].frame;
	CurrPhotoIdx4SSCal = 0;
	
	//get cwd and search media files when selected device is HD or NAS
	if(
			!strcmp(SelectedDev, DEVICE_HD_NAME)
#ifdef NET_MOD
		||	!strcmp(SelectedDev, DEVICE_NAS_NAME)
#endif
	)
	{
		//reinit list
		FreeList(MT_PHOTO | MT_MUSIC);
		InitList(MT_PHOTO | MT_MUSIC);
		
		//get current path for stric search
		getcwd(CurrentPath, LEN_XL);//ends without '/'
		GetPath(RootPath);
		if(CurrentPath[strlen(CurrentPath) - 1] != '/')
			strcat(CurrentPath, "/");
		
		//search
		chdir(RootPath);
		
		SearchFileByTypeStrict(CurrentPath, MT_PHOTO | MT_MUSIC, FALSE, 1);
		chdir(CurrentPath);//change cwd back
	}
	
	SlideShowEvent();
}

int cmpModTimeDesc(const void *e1p, const void *e2p)
{
	const struct dirent **e1, **e2;
	struct stat buf1, buf2;
	
	e1 = (const struct dirent **)e1p;
	e2 = (const struct dirent **)e2p;
	lstat((*e1)->d_name, &buf1);
	lstat((*e2)->d_name, &buf2);
	
	if(buf1.st_mtime > buf2.st_mtime)
		return -1;
	else if(buf1.st_mtime == buf2.st_mtime)
		return 0;
	else
		return 1;
}

int cmpModTimeAsc(const void *e1p, const void *e2p)
{
	const struct dirent **e1, **e2;
	struct stat buf1, buf2;
	
	e1 = (const struct dirent **)e1p;
	e2 = (const struct dirent **)e2p;
	lstat((*e1)->d_name, &buf1);
	lstat((*e2)->d_name, &buf2);
	
	if(buf1.st_mtime < buf2.st_mtime)
		return -1;
	else if(buf1.st_mtime == buf2.st_mtime)
		return 0;
	else
		return 1;
}

int cmpFSizeDesc(const void *e1p, const void *e2p)
{
	const struct dirent **e1, **e2;
	struct stat buf1, buf2;
	
	e1 = (const struct dirent **)e1p;
	e2 = (const struct dirent **)e2p;
	lstat((*e1)->d_name, &buf1);
	lstat((*e2)->d_name, &buf2);
	
	if(buf1.st_size > buf2.st_size)
		return -1;
	else if(buf1.st_size == buf2.st_size)
		return 0;
	else
		return 1;
}

int cmpFSizeAsc(const void *e1p, const void *e2p)
{
	const struct dirent **e1, **e2;
	struct stat buf1, buf2;
	
	e1 = (const struct dirent **)e1p;
	e2 = (const struct dirent **)e2p;
	lstat((*e1)->d_name, &buf1);
	lstat((*e2)->d_name, &buf2);
	
	if(buf1.st_size < buf2.st_size)
		return -1;
	else if(buf1.st_size == buf2.st_size)
		return 0;
	else
		return 1;
}

int cmpAlphabetDesc(const void *e1p, const void *e2p)
{
	const struct dirent **e1, **e2;
	int cmp;
	
	e1 = (const struct dirent **)e1p;
	e2 = (const struct dirent **)e2p;
	cmp = strverscmp((*e1)->d_name, (*e2)->d_name);
	
	if(cmp > 0)
		return -1;
	else if(cmp == 0)
		return 0;
	else
		return 1;
}

int cmpAlphabetAsc(const void *e1p, const void *e2p)
{
	const struct dirent **e1, **e2;
	int cmp;
	
	e1 = (const struct dirent **)e1p;
	e2 = (const struct dirent **)e2p;
	cmp = strverscmp((*e1)->d_name, (*e2)->d_name);
	
	if(cmp < 0)
		return -1;
	else if(cmp == 0)
		return 0;
	else
		return 1;
}

void doSortingByFunction(struct dirent **namelist, unsigned long size)
{
	unsigned long i;
	int (*cmpFunc[SORTING_ITEM_NUM])(const void*, const void*) = 
	{
		NULL,
		cmpModTimeDesc,
		cmpModTimeAsc,
		cmpFSizeDesc,
		cmpFSizeAsc,
		cmpAlphabetDesc,
		cmpAlphabetAsc
	};
	
	//qsort
	if(setup->sorting_idx != 0)
		qsort(namelist, size, sizeof(struct dirent *), cmpFunc[setup->sorting_idx]);
	
#if 0
	printf("%d \n", setup->sorting_idx);
	struct stat buf;
	for(i = 0; i < size; i++)
	{
		lstat(namelist[i]->d_name, &buf);
		printf("'%s'", namelist[i]->d_name);
		if(setup->sorting_idx == ByDescendingTime || setup->sorting_idx == ByAscendingTime)
			printf(" = %d\n", buf.st_mtime);
		else if(setup->sorting_idx == ByDescendingSize || setup->sorting_idx == ByAscendingSize)
			printf(" = %d\n", buf.st_size);
		else
			printf("\n");
	}
#endif
}

FLIST* FolderList_Build(char* PathName)
{
	struct dirent **namelist;
	struct stat buf;
	FLIST *pDirList = NULL, *pRegFileList = NULL;
	FLIST *pDirTail, *pRegFileTail;
	int n, i;
	Uint8 bFail = FALSE;
	FLIST *pDir, *pNextDir;
	char RootPath[LEN_XL], CurrentPath[LEN_XL];

	if ((n=scandir(PathName, &namelist, 0, alphasort)) < 0)
	{
		DPRINTF("Opening Directory '%s' Fail!\n", PathName);
		return NULL;
		//exit(1);
	}
	
	doSortingByFunction(namelist, n);
	FolderList_AddTail(&pDirList, "..", 1);
	
	for (i=0; i<n; i++)
	{
		lstat(namelist[i]->d_name, &buf);
		if (S_ISDIR(buf.st_mode))
		{
			if(strcmp(namelist[i]->d_name, ".") && strcmp(namelist[i]->d_name, ".."))
			{
				if (!FolderList_AddTail(&pDirList, namelist[i]->d_name, 1))
				{
					bFail = TRUE;
					break;
				}
			}
		}
		else if (S_ISREG(buf.st_mode))
		{
			if (!FolderList_AddTail(&pRegFileList, namelist[i]->d_name, 0))
			{
				bFail = TRUE;
				break;
			}
		}
	}

	//Release namelist
	for (i=0; i<n; i++)
	{
		free(namelist[i]);
	}
	free(namelist);

	if (bFail)
	{
		FolderList_Free(&pDirList);
		FolderList_Free(&pRegFileList);
		DPRINTF("Build FolderList for '%s' Fail!\n", PathName);
		return NULL;
	}
/*
	//RW٬"."node
	pDirList = FolderList_GetHeadPos(pDirList);	//^}Y
	pDir = pDirList;
	while (pDir)
	{
		if (strcmp(pDir->fname, ".") == 0)// && (pDir->attribute & Mask_IsDir))
		{
			FolderList_RemoveAt(&pDirList, pDir);
			break;
		}
		pDir = pDir->next;
	}
*/
	///071017 ڥؿɧ..]R
	GetPath(RootPath);
	getcwd(CurrentPath, LEN_XL);
	if (strlen(CurrentPath) <= strlen(RootPath))
	{
		pDirList = FolderList_GetHeadPos(pDirList);	//^}Y
		pDir = pDirList;
		while (pDir)
		{
			pNextDir = pDir->next;
			if (  strcmp(pDir->fname, "..") == 0// && (pDir->attribute & Mask_IsDir))
			    ||
				strcmp(pDir->fname, "Recycled") == 0		//071102 귽^
			    ||
				strcmp(pDir->fname, "System Volume Information") == 0	//071102
			   )
			{
				FolderList_RemoveAt(&pDirList, pDir);
				//break;
			}
			pDir = pNextDir;
		}
	}
	///

	///071102 Lotɮ
	pRegFileList = FolderList_GetHeadPos(pRegFileList);	//^}Y
	pDir = pRegFileList;
	while (pDir)
	{
		pNextDir = pDir->next;
		if (  strcmp(pDir->fname, "Thumbs.db") == 0
		    ||
			strcmp(pDir->fname, "desktop.ini") == 0	
		    ||
			strcmp(pDir->fname, "Desktop.ini") == 0
		   )
		{
			FolderList_RemoveAt(&pRegFileList, pDir);
		}
		pDir = pNextDir;
	}
	///

	//ӦC(pFolderList, pRegFileList)_
	pDirList = FolderList_GetHeadPos(pDirList);
	pRegFileList = FolderList_GetHeadPos(pRegFileList);
	if (pDirList)
	{
		pDirTail = pDirList->prev;				//Dir
		if (pRegFileList)
		{
			///071102
			pDirList->prev->attribute &= (~Mask_IsListTail);
			pRegFileList->attribute &= (~Mask_IsListHead);
			///
			pRegFileTail = pRegFileList->prev;	//Regular File
			pDirTail->next = pRegFileList;
			pRegFileList->prev = pDirTail;
			pDirList->prev = pRegFileTail;		//}Y̧
		}

		//pDirList->attribute |= Mask_IsListHead;
		//pDirList->prev->attribute |= Mask_IsListTail;
	}
	///071102 SؿNuѤ@ɮ
	else
	{
		pDirList = pRegFileList;
	}
	///

	return pDirList;		//X
}

Uint8 FolderList_AddTail(FLIST** ppFolderList, char* FileName, Uint8 IsDir)
{
	FLIST *pTempList, *pTailList, *pNewList;
	if (!ppFolderList) return 0;

	pTempList = *ppFolderList;

	//YŦC
	if (pTempList == NULL)
	{
		//sWnode
		pNewList = (FLIST*)malloc(sizeof(FLIST));
		if (!pNewList) return 0;
		memset(pNewList, 0, sizeof(FLIST));
		strcpy(pNewList->fname, FileName);
		if (IsDir)
			pNewList->attribute |= Mask_IsDir;

		//]wݬĤ@node
		pNewList->prev = pNewList;	
		///071102 ]wYݩ
		pNewList->attribute |= Mask_IsListHead;
		pNewList->attribute |= Mask_IsListTail;
		///
		*ppFolderList = pNewList;
	}
	//YDŦCABpTempListC}Y
	else if (  pTempList->prev != NULL
		    &&
			pTempList->prev->next == NULL
		   )
	{
		//sWnode	
		pNewList = (FLIST*)malloc(sizeof(FLIST));
		if (!pNewList) return 0;
		memset(pNewList, 0, sizeof(FLIST));
		strcpy(pNewList->fname, FileName);
		if (IsDir)
			pNewList->attribute |= Mask_IsDir;

		pTailList = pTempList->prev;	//ݦsbĤ@nodeprev

		pTailList->next = pNewList;
		pNewList->prev = pTailList;
		///071102 ]wYݩ
		pTailList->attribute &= (~Mask_IsListTail);
		pNewList->attribute |= Mask_IsListTail;
		///		
		pTempList->prev = pNewList;	//s
	}
	//DŦCApTempListäbC}YAΤeإList~
	else	
	{
		//pTempListC}Y
		pTempList = FolderList_GetHeadPos(*ppFolderList);
		/*
		while (pTempList->prev!=NULL &&  pTempList->prev->next!=NULL)
		{
			pTempList = pTempList->prev;
		}
		*/

		//C
		pTailList = pTempList->prev;
		/*
		pTailList = pTempList;
		while (pTailList->next)
		{
			pTailList = pTailList->next;
		}
		*/
		
		//sWnode
		pNewList = (FLIST*)malloc(sizeof(FLIST));
		if (!pNewList) return 0;
		memset(pNewList, 0, sizeof(FLIST));
		strcpy(pNewList->fname, FileName);
		if (IsDir)
			pNewList->attribute |= Mask_IsDir;

		pTailList->next = pNewList;
		pNewList->prev = pTailList;
		///071102 ]wYݩ
		pTailList->attribute &= (~Mask_IsListTail);
		pNewList->attribute |= Mask_IsListTail;
		///	
		pTempList->prev = pNewList;	//s		
	}

	return 1;

}

Uint8 FolderList_RemoveAt(FLIST** ppFolderList, FLIST* pRemoveNode)
{
	Uint8 bListModified;
	FLIST *pFolderList;
	if (!ppFolderList || !(*ppFolderList)) return FALSE;

	//Ye̤W誺ɮ
	if (pRemoveNode == (*ppFolderList))
	{
		if ((*ppFolderList)->next)
			(*ppFolderList) = (*ppFolderList)->next;
		else if (((*ppFolderList)->attribute & Mask_IsListHead) == 0)
			(*ppFolderList) = (*ppFolderList)->prev;
	}

	bListModified = FALSE;
	if (pRemoveNode->attribute & Mask_IsListHead)
	{
		//Ylistu@node
		if (pRemoveNode->next == NULL || (pRemoveNode->attribute & Mask_IsListTail))
		{
			free(pRemoveNode);
			*ppFolderList = NULL;
			bListModified = TRUE;
		}
		//_h]wU@nodehead
		else
		{
			pFolderList = pRemoveNode->next;		//shead
			pFolderList->attribute |= Mask_IsListHead;
			pFolderList->prev = pRemoveNode->prev;
			free(pRemoveNode);
			bListModified = TRUE;
		}
	}
	else
	{
		pFolderList = pRemoveNode->prev;
		pFolderList->next = pRemoveNode->next;
		//᭱wgSnode
		if (pRemoveNode->next == NULL || (pRemoveNode->attribute & Mask_IsListTail))
		{
			///
			FLIST *pHead = FolderList_GetHeadPos(pFolderList);
			if (pHead) pHead->prev = pFolderList;
			///
			
			pFolderList->attribute |= Mask_IsListTail;
		}
		//᭱٦node
		else
		{
			pRemoveNode->next->prev = pFolderList;
		}
		free(pRemoveNode);
		bListModified = TRUE;
	}

	return bListModified;
}

FLIST* FolderList_GetHeadPos(FLIST* pFolderList)
{
	FLIST *pTempList;
	if (!pFolderList) return NULL;

	pTempList = pFolderList;
	//List Head
	while (  (pTempList->attribute & Mask_IsListHead) == 0
		   &&
		     (pTempList->prev != NULL)
		   &&
		     (pTempList->prev->next != NULL)
		  )
	{
		pTempList = pTempList->prev;
	}

	return pTempList;
}

void FolderList_Free(FLIST** ppFolderList)
{
	FLIST *pTempList, *pRemoveList;
	if (!ppFolderList || !(*ppFolderList)) return;

	pTempList = FolderList_GetHeadPos(*ppFolderList);
	/*
	pTempList = (*ppFolderList);

	//List Head
	while (  (pTempList->attribute & Mask_IsListHead) == 0
		   &&
		     (pTempList->prev != NULL)
		   &&
		     (pTempList->prev->next != NULL)
		  )
	{
		pTempList = pTempList->prev;
	}
	*/

	//`O
	while ((pRemoveList = pTempList) != NULL)
	{
		pTempList = pRemoveList->next;
		free(pRemoveList);
	}

	*ppFolderList = NULL;		//Listг]NULL
}

