#ifndef _COLOR_TABLE_HEADER_
#define _COLOR_TABLE_HEADER_
//------------------------------------------------------------------------------------------------
#include "pgu_lib.h"
//------------------------------------------------------------------------------------------------
#define SET_SKYDEMO_COLOR_RGBA5551(r, g, b)		ENCODE_RGBA5551(r, g, b, 1)
#define SET_SKYDEMO_COLOR_RGB555(r, g, b)		ENCODE_RGB555(r, g, b)

#define WHITE_1555			SET_SKYDEMO_COLOR_RGBA5551(255, 255, 255)
#define WHITE_555			SET_SKYDEMO_COLOR_RGB555(255, 255, 255)
#define BLACK_1555			SET_SKYDEMO_COLOR_RGBA5551(0, 0, 0)
#define BLACK_555				SET_SKYDEMO_COLOR_RGB555(0, 0, 0)
#define RED_1555				SET_SKYDEMO_COLOR_RGBA5551(255, 0, 0)
#define GREEN_1555			SET_SKYDEMO_COLOR_RGBA5551(0, 128, 0)
#define BLUE_1555				SET_SKYDEMO_COLOR_RGBA5551(0, 0, 255)
#define YELLOW_1555			SET_SKYDEMO_COLOR_RGBA5551(255, 255, 0)
#define LEMONCHIFFON_1555	SET_SKYDEMO_COLOR_RGBA5551(255, 250, 205)
#define LAVENDER_1555		SET_SKYDEMO_COLOR_RGBA5551(230, 230, 250)
#define ORANGE_1555			SET_SKYDEMO_COLOR_RGBA5551(255, 165, 0)
#define GREY40_1555			SET_SKYDEMO_COLOR_RGBA5551(102, 102, 102)
#define PURPLE_1555			SET_SKYDEMO_COLOR_RGBA5551(150, 100, 200)
#define HIGHTLIGHT_1555		SET_SKYDEMO_COLOR_RGBA5551(255, 255, 127)

// for Leadtek customization, by Xenia 02/2008
#define LTK_BLACK				SET_SKYDEMO_COLOR_RGBA5551(0, 0, 0)
#define LTK_YELLOW				SET_SKYDEMO_COLOR_RGBA5551(250, 220, 65)
#define LTK_WHITE				SET_SKYDEMO_COLOR_RGBA5551(255, 255, 255)
#define LTK_ORANGE				SET_SKYDEMO_COLOR_RGBA5551(255, 120, 0)
#define LTK_BLUE					SET_SKYDEMO_COLOR_RGBA5551(0, 55, 255)
#define LTK_GREY				SET_SKYDEMO_COLOR_RGBA5551(120, 120, 120)
#define LTK_GREEN				SET_SKYDEMO_COLOR_RGBA5551(30, 170, 50)
#define LTK_RED					SET_SKYDEMO_COLOR_RGBA5551(255, 0, 0)
#define LTK_BROWN				SET_SKYDEMO_COLOR_RGBA5551(65, 0, 0)

// for Dark Blue Design, by Xenia 07/2008
#define MEDIA_OPTIONS			SET_SKYDEMO_COLOR_RGBA5551(158, 227, 0)
#define MEDIA_FRAMEMESSAGE	SET_SKYDEMO_COLOR_RGBA5551(158, 227, 0)
#define SELECTED_FILENAME		SET_SKYDEMO_COLOR_RGBA5551(190, 190, 190)
#define SELECTED_FILEHEAD		SET_SKYDEMO_COLOR_RGBA5551(255, 191, 18)
#define SELECTED_FILENUM		SET_SKYDEMO_COLOR_RGBA5551(255, 191, 18)
#define SELECTED_CIRCLE			SET_SKYDEMO_COLOR_RGBA5551(64, 137, 177)
#define SELECTED_BAR			SET_SKYDEMO_COLOR_RGBA5551(127, 160, 37)
#define MUSIC_FILENAME			SET_SKYDEMO_COLOR_RGB555(190, 190, 190)
#define MUSIC_SELECTEDFILE		SET_SKYDEMO_COLOR_RGBA5551(255, 255, 255)
#define MUSIC_DURATION			SET_SKYDEMO_COLOR_RGBA5551(255, 191, 18)
#define REPEAT_MODE_COLOR		SET_SKYDEMO_COLOR_RGBA5551(255, 246, 0)
#define FOLDER_DATA			SET_SKYDEMO_COLOR_RGBA5551(190, 190, 190)
#define FOLDER_HEAD			SET_SKYDEMO_COLOR_RGBA5551(255, 191, 18)
#define SETUP_HIGHLIGHT_BAR	SET_SKYDEMO_COLOR_RGBA5551(127, 160, 37)
#define INFO_BACKGROUND		SET_SKYDEMO_COLOR_RGBA5551(72, 133, 190)
#define INFO_DATA_HEAD			SET_SKYDEMO_COLOR_RGBA5551(158, 227, 0)
#endif
