#ifndef _DRAW_UTIL_HEADER_
#define _DRAW_UTIL_HEADER_
//------------------------------------------------------------------------------------------------
#include "skydemo.h"
//------------------------------------------------------------------------------------------------
#ifdef DARK_BLUE_DESIGN
#define OSD_FOREGROUND_COLOR	WHITE_1555
#else
#define OSD_FOREGROUND_COLOR	BLACK_1555
#endif
#define OSD_BACKRGROUND_COLOR	WHITE_1555
#define OSD_HIGHLIGHT_COLOR		YELLOW_1555

//#define MUTE_ADDRESS_X				(0x10)
//#define MUTE_ADDRESS_Y				(0x10)
//#define VOL_ADDRESS_X				((1454 - (14*12)) / 2)
//#define VOL_ADDRESS_Y				(600 - (18 + 0x20))

///070610 OSDD
#define OSD_TITLE_COLOR		WHITE_1555
///

/*
#define ANALOG_CLOCK_RADIUS	100
#ifdef MEDIALINK
#define ANALOG_CLOCK_RADIUS_MEDIALINK	180
#endif
*/

//------------------------------------------------------------------------------------------------
void GetPath(char *s);

bool ConvertFileNameOnDisplay(char *Result, char *Source, /*Uint16 StartSourcePos,*/Uint8 bAppend);

void GetSuitableLengthString(char *result, char* src, char end, int len, int isShowingExtension);
void DrawDSICONFocus(Uint8 *rgbuff, Uint32 idx, int Mode);
void DrawMTICONFocus(Uint8 *rgbuff, Uint32 idx, int Mode);
void DrawImageThumbnailFcous(Uint8 *rgbuff, Uint32 idx, int Mode);
void DrawAudioBarFcous(Uint8 *rgbuff, Uint32 idx, int Mode);

void DrawRepeatMode();

void DrawVideoThumbnailFcous(Uint8 *rgbuff, Uint32 idx, int Mode);

///070617 Folder View Focus
void DrawFolderBarFocus(Uint8 *rgbuff, Uint32 idx,  FLIST *pFolder, Uint8 IsReverse);
///
///070627 Folder Viewɮ׸TMw
void DrawFolderFileInfo(Uint8 *rgbuff, FLIST *pFolder);
///

void DrawFocusedICON(Uint8 *rgbuff, int Mode);
void DrawConfirmButtonFocus();
#ifdef HD_AUTOCP_MOD
void DrawHDAutoCPSelectionFocus();
#endif
void DrawFrameBackground(Uint8 *rgbbuff);
void DrawFrameICON(Uint8 *rgbbuff);
void DrawFrameTextMessage(Uint8 *rgbbuff, Uint16 color);
int Calculate(int month, int day, int year);
void DrawDigitalClock(Uint8 *rgbbuff, struct tm tm);
void DrawAnalogClock(Uint8 *rgbbuff, struct tm tm, Uint16 radius);
///071003 ū׭p
#ifdef USE_THERMOMETER
void DrawTemperature(Uint8 *rgbbuff);
#endif
///
void DrawCalendar(Uint8 *rgbbuff, struct tm tm, Uint8 bDrawFocus);
void DrawCalImage(Uint8 *rgbbuff);
void DrawAlarmInfo(Uint8 *rgbbuff, Uint8 yuvNo);
void DrawCalendarTime(Uint8 *rgbbuff, Uint8 yuvNo, Sint8 pls_mns);//-1 for minus; 1 for plus; 0 for otherwise
void DrawStorageICON(Uint8 *rgbbuff);
void DrawStorageText(Uint8 *rgbbuff, Uint16 color);
void DrawThumbnail(Uint8 *rgbbuff, Uint8 n, Uint8 w, Uint8 h);
void DrawEXIF(char *str);
#ifdef BATTERY_MOD
Uint32 DrawBattery();
#endif
void DrawID3Tag(char *str);
void DrawVideoInfo(char *str);
void DrawL1Menu(int Mode);
void DrawL2Menu(int Mode);
void DrawL3Menu(int Mode);
void DrawReactionIcon(int KeyNum, int Mode);
void DrawVolume4WinaccordMusicPage();
void DrawVolume4KingstonMusicPage();
void DrawMute();
void DrawVolume();

#ifdef SUPPORT_RSS
//rywu20080516++
void draw_thumbnail_fcous_icon(Uint8 *rgbuff, unsigned char idx, unsigned char mode);
void draw_thumbnail_number(Uint8 *rgbuff, RSS_SESSION_INFO_ID rss_session);
void draw_thumbnail_filename(Uint8 *rgbuff, char *str);
//rywu20080516--
#endif //end #ifdef SUPPORT_RSS
void draw_text_message(Uint8 *rgbuff, COORD *area, char *str, Uint16 color, Uint8 yuv_no);

//------------------------------------------------------------------------------------------------
//extern pid_t pid_aud;
extern int /*sts_aud, */calImgIdx;
//extern Uint8 isOnlyAudPrcsForked;
extern Uint8 isUserConfirmed;
extern Uint32 isCalDrawedFirstTime;
extern int isExifAvailable;
extern Uint8 isCurrMusicPlayble[NUM_OF_AUDIO_LIST];
extern char musicDurationList[NUM_OF_AUDIO_LIST][LEN_M];
extern COORD posOfCalImage, posOfMute, posOfVol;
//extern char musicfilename[20][LEN_XL];
extern Uint8 SelectedBrightContrast;
extern Sint8 SelectedCalTime;
extern Uint8 SelectedAlarmTime;
extern Sint8 SelectedAutoPwrOnOffTime;
#if defined(GUI_STYLE_COMTEK)
extern Sint8 CalSelectedAutoPwrOnOffTime; //ronaldyang20080626
#endif
#endif

