#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/fb.h>
#include <errno.h>
#include <time.h>
#include <sys/time.h>
#include <string.h>
#include <sys/ioctl.h>

static long long begin_sec=0;
static long long begin_msec=0;
static int after_init=0;
static long long  g_diff=0;


int getsec(){
    struct timeval tv;
     struct timezone tz;
     gettimeofday(&tv, &tz);  

//	 printf("tv=%d,%d\n",tv.tv_sec,tv.tv_usec);

	if (after_init==0){
		after_init=1;
		begin_sec=tv.tv_sec;
		begin_msec=(tv.tv_sec*1000+tv.tv_usec/1000);
		return 0;
	}else{
		return (tv.tv_sec-begin_sec)+g_diff/1000;

	}
	return 0;
}
long long get_msec(){
	struct timeval tv;
     struct timezone tz;
     gettimeofday(&tv, &tz);  

//	 printf("tv=%d,%d\n",tv.tv_sec,tv.tv_usec);

	if (after_init==0){
		after_init=1;
		begin_sec=tv.tv_sec;
		begin_msec=(tv.tv_sec*1000+tv.tv_usec/1000);
		return 0;
	}else{
		return (tv.tv_sec*1000+tv.tv_usec/1000)-begin_msec+g_diff;

	}
	return 0;
}

int get_usec(){
	struct timeval tv;
	struct timezone tz;
	gettimeofday(&tv, &tz);  

	return tv.tv_usec;

}

void gettoday(int *sys_year, int *sys_month, int *sys_day, int *sys_hour, int *sys_min, int *sys_sec) // George get systemtime
{
     struct timeval tv;
     struct timezone tz;
     struct tm* tp;
     time_t now;

     gettimeofday(&tv, &tz);  
     
     now = tv.tv_sec - (60 * tz.tz_minuteswest);
     tp = gmtime(&now);

     *sys_year = tp->tm_year + 1900; // get system year
     *sys_month = tp->tm_mon + 1;  // get system month 0-11
     *sys_day = tp->tm_mday; // get system date: 1-31
     *sys_hour = tp->tm_hour;
     *sys_min = tp->tm_min;
     *sys_sec = tp->tm_sec;
     
     return;     
}     

    
int get_day(){
	time_t t;
	struct tm tm;
	time(&t);
	memcpy(&tm, localtime(&t), sizeof(tm));
	return tm.tm_mday;
	
};



