#ifndef _KEYMAP_HEADER_
#define _KEYMAP_HEADER_ 
//------------------------------------------------------------------------------------------------
#include "machineinit.h"
#include "events.h"
#include "FList.h"
#include "drawutil.h"
//------------------------------------------------------------------------------------------------
Uint8 Keys[][MAX_NUM_IR_EVENTS] = 
{
#ifdef NET_MOD
	//DS = 9
	{UP, DOWN, LEFT, RIGHT, ENTER, SETUP, PLUS, MINUS, ROTATE},//nelly modify(add ROTATE) 6/23/2008 for wps push button 
#else
	//DS = 8
	{UP, DOWN, LEFT, RIGHT, ENTER, SETUP, PLUS, MINUS},
#endif	
	//MT = 10
	{UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW, SETUP, ESC, PLUS, MINUS},
	//SETUP_L1 = 6
	{UP, DOWN, RIGHT, ENTER, SETUP, ESC},
	//SETUP_L2 = 6
	{UP, DOWN, LEFT, ENTER, SETUP, ESC},
	//SETUP_L3 = 7
	{UP, DOWN, LEFT, RIGHT, ENTER, SETUP, ESC},
	//I = 13
	{UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW, SETUP, ESC, PLUS, MINUS, KEYA, KEYB, KEYC},
	//FI = 14
	{UP, DOWN, LEFT, RIGHT, ROTATE, ZOOM, SLIDESHOW, SETUP, ESC, PLUS, MINUS, KEYA, KEYB, KEYC},
	//A = 13
	{UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW, PLUS, MINUS, SETUP, ESC, KEYA, KEYB, KEYC},
	//V = 12
	{UP, DOWN, LEFT, RIGHT, ENTER, SETUP, ESC, PLUS, MINUS, KEYA, KEYB, KEYC},
	//FV = 7
	{LEFT, RIGHT, PLUS, MINUS, ENTER, ESC, ZOOM},
	//SS = 6
	{UP, DOWN, PLUS, MINUS, ENTER, ESC},
	//PC_CONN = 1
//#ifdef USE_DESC_TV
#if defined(USE_DESC_TV) && !defined(TV_AUTO_CARDREADER_MODE_OFF)
	{},
#else
	{ESC},
#endif
	//NO_STORAGE = 0
	{},
	//CONFIRM = 3
	{LEFT, RIGHT, ENTER},
	//CAL = 8
	{UP, DOWN, LEFT, RIGHT, ENTER, ESC, PLUS, MINUS},
	//FLDR = 13
	{UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW, SETUP, ESC, PLUS, MINUS, KEYA, KEYB, KEYC},
	//FW_UPGRADE = 0
	{ },
	//BT = 19	//copy from FLDER_ACTIVE, SlideshowLimageɵe|áAҥHȮ
#ifdef BLUETOOTH_MOD
	{UP, DOWN, LEFT, RIGHT, NEXT, PREV, PLAYPAUSE, ENTER, /*SLIDESHOW,*/ DETECT/*, SETUP, REPEAT, CAL*/, ESC, BACKWARD, FORWARD, ROTATE, ZOOM, STOP, PLUS, MINUS, MUTE, INFO},
#endif
	//FLDR_FI = 1
	{ESC},
	//FLDR_FV = 4
	{ESC, PLUS, MINUS, ZOOM},
	
#ifdef NET_MOD
	//NET_DS = 8
	{UP, DOWN, LEFT, RIGHT, ENTER, ESC, SETUP},
//rywu20080516++
#ifdef SUPPORT_RSS
	//RSS = 8
	{ESC, INFO, UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW},
#endif
//rywu20080516--
#ifdef IP_CAM_MOD
	//IPCAM = 6
	{UP, DOWN, ESC, ENTER, REPEAT, ROTATE},
#endif
///080504
#ifdef WEB_APP_MOD
	{ESC, ENTER, UP, DOWN, LEFT, RIGHT, PREV, NEXT, PLAYPAUSE, STOP, SETUP, MUTE, PLUS, MINUS},
#endif
///

#endif
#ifdef HD_AUTOCP_MOD
	{LEFT, RIGHT, ENTER, ESC},
#endif

	{},

};
 pfEvent Values[][MAX_NUM_IR_EVENTS] =
{
#ifdef NET_MOD	
	//DS = 9
	{DS_UpEvent, DS_DownEvent, DS_LeftEvent, DS_RightEvent, DS_EnterEvent, SetupEvent, PlusEvent, MinusEvent, DS_RotateEvent},//nelly modify(add DS_RotateEvent) 6/23/2008 for wps push button 
#else
	//DS = 8
	{DS_UpEvent, DS_DownEvent, DS_LeftEvent, DS_RightEvent, DS_EnterEvent, SetupEvent, PlusEvent, MinusEvent},
#endif	
	//MT = 10
	{MT_LeftEvent, MT_RightEvent, MT_UpEvent, MT_DownEvent, MT_EnterEvent, SlideShowEvent, SetupEvent, MT_EscEvent, PlusEvent, MinusEvent},
	//SETUP_L1 = 6
	{SETUP_L1_UpEvent, SETUP_L1_DownEvent, SETUP_L1_RightEvent, SETUP_L1_EnterEvent, SetupEvent, SetupEscEvent},
	//SETUP_L2 = 6
	{SETUP_L2_UpEvent, SETUP_L2_DownEvent, SETUP_L2_LeftEvent, SETUP_L2_EnterEvent, SetupEvent, SetupEscEvent},
	//SETUP_L3 = 7
	{SETUP_L3_UpEvent, SETUP_L3_DownEvent, SETUP_L3_LeftEvent, SETUP_L3_RightEvent, SETUP_L3_EnterEvent, SetupEvent, SetupEscEvent},
	//I = 13
	{I_UpEvent, I_DownEvent, I_LeftEvent, I_RightEvent, I_EnterEvent, SlideShowEvent, SetupEvent, I_EscEvent, PlusEvent, MinusEvent, InfoEvent, I_PrevEvent, I_NextEvent},
	//FI = 14
	{FI_UpEvent, FI_DownEvent, FI_LeftEvent, FI_RightEvent, FI_RotateEvent, FI_ZoomEvent, SlideShowEvent, SetupEvent, FI_EscEvent, PlusEvent, MinusEvent, InfoEvent, FI_PrevEvent, FI_NextEvent},
	//A = 13
	{A_UpEvent, A_DownEvent, A_LeftEvent, A_RightEvent, A_PlayPauseEvent, SlideShowEvent, PlusEvent, MinusEvent, SetupEvent, A_EscEvent, InfoEvent, A_PrevEvent, A_NextEvent},
	//V = 12
	{V_UpEvent, V_DownEvent, V_LeftEvent, V_RightEvent, V_EnterEvent, SetupEvent, V_EscEvent, PlusEvent, MinusEvent, InfoEvent, V_PrevEvent, V_NextEvent},
	//FV = 7
	{FV_LeftEvent, FV_RightEvent, PlusEvent, MinusEvent, FV_PlayPauseEvent, FV_EscEvent, FLDR_FV_ZoomEvent},//take out SETUP by Richard @2007/06/18
	//SS = 6
	{SS_UpEvent, SS_DownEvent, PlusEvent, MinusEvent, SS_PlayPauseEvent, SS_EscEvent},
	//PC_CONN = 1
//#ifdef USE_DESC_TV
#if defined(USE_DESC_TV) && !defined(TV_AUTO_CARDREADER_MODE_OFF)
	{},
#else
	{USB2PC_CONN_EscEvent},
#endif
	//NO_STORAGE = 0
	{},
	//CONFIRM = 3
	{Confirm_LeftEvent, Confirm_RightEvent, Confirm_EnterEvent},
	//CAL = 8
	{Cal_UpEvent, Cal_DownEvent, Cal_LeftEvent, Cal_RightEvent, Cal_EnterEvent, Cal_EscEvent, PlusEvent, MinusEvent},
	//FLDR = 13
	{FLDR_UpEvent, FLDR_DownEvent, FLDR_LeftEvent, FLDR_RightEvent, FLDR_EnterEvent, FLDR_SSEvent, SetupEvent, FLDR_EscEvent, PlusEvent, MinusEvent, FLDR_RepeatEvent, FLDR_PrevEvent, FLDR_NextEvent},
	//FW_UPGRADE = 0
	{ },
	//BT = 19	//copy from FLDER_ACTIVE, SlideshowLimageɵe|áAҥHȮ
#ifdef BLUETOOTH_MOD
	{BT_UpEvent, BT_DownEvent, BT_LeftEvent, BT_RightEvent, BT_NextEvent, BT_PrevEvent, BT_PlayPauseEvent, BT_EnterEvent, /*SlideShowEvent,*/ DetectEvent/*, SetupEvent, BT_RepeatEvent, CalEvent*/, BT_EscEvent, BT_PrevDvcEvent, BT_NextDvcEvent, BT_ScanDvcEvent, BT_TxEvent, BT_StopEvent, PlusEvent, MinusEvent, MuteEvent, InfoEvent},
#endif
	//FLDR_FI = 1
	{FLDR_FI_EscEvent},
	//FLDR_FV = 4
	{FLDR_FV_EscEvent, PlusEvent, MinusEvent, FLDR_FV_ZoomEvent},

#ifdef NET_MOD
	//NET_DS
	{Net_DS_UpEvent, Net_DS_DownEvent, Net_DS_LeftEvent, Net_DS_RightEvent, Net_DS_EnterEvent, Net_DS_EscEvent, DetectEvent, SetupEvent},
//rywu20080516++
#ifdef SUPPORT_RSS
	//RSS = 8
	{RSS_EscEvent, InfoEvent, RSS_UpEvent, RSS_DownEvent, RSS_LeftEvent, RSS_RightEvent, RSS_EnterEvent, RSS_SlideShow},
#endif
//rywu20080516--
#ifdef IP_CAM_MOD
	//IPCAM = 6
	{IP_CAM_UpEvent, IP_CAM_DownEvent, IP_CAM_EscEvent, IP_CAM_EnterEvent, IP_CAM_RepeatEvent, IP_CAM_RotateEvent},
#endif

///080504
#ifdef WEB_APP_MOD
	//WEB_APP
	{WebApp_EscEvent, WebApp_EnterEvent, WebApp_UpEvent, WebApp_DownEvent, WebApp_LeftEvent, WebApp_RightEvent, WebApp_PrevEvent, WebApp_NextEvent, WebApp_PlayPauseEvent, WebApp_StopEvent, SetupEvent, MuteEvent, PlusEvent, MinusEvent},
#endif
///

#endif
#ifdef HD_AUTOCP_MOD
	{HDAutoCP_LeftEvent, HDAutoCP_RightEvent, HDAutoCP_EnterEvent, HDAutoCP_EscEvent, InfoEvent},
#endif
	{},
};
#endif




