#ifndef _KEYMAP_HEADER_
#define _KEYMAP_HEADER_ 
//------------------------------------------------------------------------------------------------
#include "machineinit.h"
#include "events.h"
#include "FList.h"
#include "drawutil.h"
//------------------------------------------------------------------------------------------------
Uint8 Keys[][MAX_NUM_IR_EVENTS] = 
{
#ifdef NET_MOD
	//DS = 13
	{UP, DOWN, LEFT, RIGHT, ENTER, DETECT, SETUP, CAL, PLUS, MINUS, SLIDESHOW, INFO, ROTATE},//nelly modify(add ROTATE) 6/23/2008 for wps push button 
#else
	//DS = 12
	{UP, DOWN, LEFT, RIGHT, ENTER, DETECT, SETUP, CAL, PLUS, MINUS, SLIDESHOW, INFO},
#endif	
	//MT = 13
	{UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW, DETECT, SETUP, ESC, CAL, PLUS, MINUS, INFO},
	//SETUP_L1 = 6
	{UP, DOWN, RIGHT, ENTER, SETUP, ESC},
	//SETUP_L2 = 6
	{UP, DOWN, LEFT, ENTER, SETUP, ESC},
	//SETUP_L3 = 7
	{UP, DOWN, LEFT, RIGHT, ENTER, SETUP, ESC},
	//I = 15
	{UP, DOWN, LEFT, RIGHT, NEXT, 	PREV, ENTER, SLIDESHOW, DETECT, INFO, SETUP, ESC, CAL, PLUS, MINUS},
	//FI = 17
	{UP, DOWN, LEFT, RIGHT, NEXT, PREV, ROTATE, ZOOM, SLIDESHOW, DETECT, INFO, SETUP, ESC, CAL, PLUS, MINUS, REPEAT},
	//A = 20
	{UP, DOWN, LEFT, RIGHT, NEXT, PREV, PLAYPAUSE, FORWARD, BACKWARD, STOP, ENTER, SLIDESHOW, MUTE, PLUS, MINUS, DETECT, SETUP, ESC, CAL, INFO},
	//V = 15
	{UP, DOWN, LEFT, RIGHT, NEXT, PREV, PLAYPAUSE, ENTER, DETECT, SETUP, ESC, CAL, PLUS, MINUS, INFO},
	//FV = 14
	{NEXT, PREV, LEFT, RIGHT, STOP, MUTE, PLUS, MINUS, PLAYPAUSE, FORWARD, BACKWARD, DETECT, ESC, INFO},//take out SETUP by Richard @2007/06/18
	//SS = 10
	{UP, DOWN, STOP, MUTE, PLUS, MINUS, PLAYPAUSE, DETECT, ESC, INFO},
	//PC_CONN = 2
//#ifdef USE_DESC_TV
#if defined(USE_DESC_TV) && !defined(TV_AUTO_CARDREADER_MODE_OFF)
	{},
#else
	{ESC, INFO},
#endif
	//NO_STORAGE = 2
	{CAL, INFO},
	//CONFIRM = 3
	{LEFT, RIGHT, ENTER},
	//CAL = 14
	{UP, DOWN, LEFT, RIGHT, STOP, ENTER, ESC, CAL, MUTE, PLUS, MINUS, DETECT, PLAYPAUSE, INFO},
	//FLDR = 19
	{UP, DOWN, LEFT, RIGHT, NEXT, PREV, PLAYPAUSE, ENTER, SLIDESHOW, DETECT, SETUP, REPEAT, CAL, ESC, STOP, PLUS, MINUS, MUTE, INFO},
	//FW_UPGRADE = 0
	{ },
	//BT = 19	//copy from FLDER_ACTIVE, SlideshowLimageɵe|áAҥHȮ
#ifdef BLUETOOTH_MOD
	{UP, DOWN, LEFT, RIGHT, NEXT, PREV, PLAYPAUSE, ENTER, /*SLIDESHOW,*/ DETECT/*, SETUP, REPEAT, CAL*/, ESC, BACKWARD, FORWARD, ROTATE, ZOOM, STOP, PLUS, MINUS, MUTE, INFO},
#endif
	//FLDR_FI = 3
	{ESC, REPEAT, INFO},
	//FLDR_FV = 5
	{ESC, PLUS, MINUS, MUTE, INFO,ZOOM},
	
#ifdef NET_MOD
	//NET_DS = 8
	{UP, DOWN, LEFT, RIGHT, ENTER, ESC, DETECT, SETUP},
//rywu20080516++
#ifdef SUPPORT_RSS
	//RSS = 8
	{ESC, INFO, UP, DOWN, LEFT, RIGHT, ENTER, SLIDESHOW},
#endif
//rywu20080516--
#ifdef IP_CAM_MOD
	//IPCAM = 6
	{UP, DOWN, ESC, ENTER, REPEAT, ROTATE},
#endif
///080504
#ifdef WEB_APP_MOD
	{ESC, ENTER, UP, DOWN, LEFT, RIGHT, PREV, NEXT, PLAYPAUSE, STOP, SETUP, MUTE, PLUS, MINUS},
#endif
///

#endif
#ifdef HD_AUTOCP_MOD
	{LEFT, RIGHT, ENTER, ESC, INFO},
#endif

	{},

};
 pfEvent Values[][MAX_NUM_IR_EVENTS] =
{
#ifdef NET_MOD	
	//DS = 13
	{DS_UpEvent, DS_DownEvent, DS_LeftEvent, DS_RightEvent, DS_EnterEvent, DetectEvent, SetupEvent, CalEvent, PlusEvent, MinusEvent, SlideShowEvent, InfoEvent, DS_RotateEvent},//nelly modify(add DS_RotateEvent) 6/23/2008 for wps push button 
#else
	//DS = 12
	{DS_UpEvent, DS_DownEvent, DS_LeftEvent, DS_RightEvent, DS_EnterEvent, DetectEvent, SetupEvent, CalEvent, PlusEvent, MinusEvent, SlideShowEvent, InfoEvent},
#endif	
	//MT = 13
	{MT_LeftEvent, MT_RightEvent, MT_UpEvent, MT_DownEvent, MT_EnterEvent, SlideShowEvent, DetectEvent, SetupEvent, MT_EscEvent, CalEvent, PlusEvent, MinusEvent, InfoEvent},
	//SETUP_L1 = 6
	{SETUP_L1_UpEvent, SETUP_L1_DownEvent, SETUP_L1_RightEvent, SETUP_L1_EnterEvent, SetupEvent, SetupEscEvent},
	//SETUP_L2 = 6
	{SETUP_L2_UpEvent, SETUP_L2_DownEvent, SETUP_L2_LeftEvent, SETUP_L2_EnterEvent, SetupEvent, SetupEscEvent},
	//SETUP_L3 = 7
	{SETUP_L3_UpEvent, SETUP_L3_DownEvent, SETUP_L3_LeftEvent, SETUP_L3_RightEvent, SETUP_L3_EnterEvent, SetupEvent, SetupEscEvent},
	//I = 15
	{I_UpEvent, I_DownEvent, I_LeftEvent, I_RightEvent, I_NextEvent, I_PrevEvent, I_EnterEvent, SlideShowEvent, DetectEvent, InfoEvent, SetupEvent, I_EscEvent, CalEvent, PlusEvent, MinusEvent},
	//FI = 17
	{FI_UpEvent, FI_DownEvent, FI_LeftEvent, FI_RightEvent, FI_NextEvent, FI_PrevEvent, FI_RotateEvent, FI_ZoomEvent, SlideShowEvent, DetectEvent, InfoEvent, SetupEvent, FI_EscEvent, CalEvent, PlusEvent, MinusEvent, FI_SwitchResolutionEvent},
	//A = 20
	{A_UpEvent, A_DownEvent, A_LeftEvent, A_RightEvent, A_NextEvent, A_PrevEvent, A_PlayPauseEvent, A_ForwardEvent, A_BackwardEvent, A_StopEvent, A_EnterEvent, SlideShowEvent, MuteEvent, PlusEvent, MinusEvent, DetectEvent, SetupEvent, A_EscEvent, CalEvent, InfoEvent},
	//V = 15
	{V_UpEvent, V_DownEvent, V_LeftEvent, V_RightEvent, V_NextEvent, V_PrevEvent, V_PlayPauseEvent, V_EnterEvent, DetectEvent, SetupEvent, V_EscEvent, CalEvent, PlusEvent, MinusEvent, InfoEvent},
	//FV = 14
	{FV_NextEvent, FV_PrevEvent, FV_LeftEvent, FV_RightEvent, FV_StopEvent, MuteEvent, PlusEvent, MinusEvent, FV_PlayPauseEvent, FV_ForwardEvent, FV_BackwardEvent, DetectEvent, FV_EscEvent, InfoEvent},//take out SETUP by Richard @2007/06/18
	//SS = 10
	{SS_UpEvent, SS_DownEvent, SS_StopEvent, MuteEvent, PlusEvent, MinusEvent, SS_PlayPauseEvent, DetectEvent, SS_EscEvent, InfoEvent},
	//PC_CONN = 2
//#ifdef USE_DESC_TV
#if defined(USE_DESC_TV) && !defined(TV_AUTO_CARDREADER_MODE_OFF)
	{},
#else
	{USB2PC_CONN_EscEvent, InfoEvent},
#endif
	//NO_STORAGE = 2
	{CalEvent, InfoEvent},
	//CONFIRM = 3
	{Confirm_LeftEvent, Confirm_RightEvent, Confirm_EnterEvent},
	//CAL = 14
	{Cal_UpEvent, Cal_DownEvent, Cal_LeftEvent, Cal_RightEvent, Cal_StopEvent, Cal_EnterEvent, Cal_EscEvent, CalEvent, MuteEvent, PlusEvent, MinusEvent, DetectEvent, Cal_PlayPuseEvent, InfoEvent},
	//FLDR = 19
	{FLDR_UpEvent, FLDR_DownEvent, FLDR_LeftEvent, FLDR_RightEvent, FLDR_NextEvent, FLDR_PrevEvent, FLDR_PlayPauseEvent, FLDR_EnterEvent, FLDR_SSEvent, DetectEvent, SetupEvent, FLDR_RepeatEvent, CalEvent, FLDR_EscEvent, FLDR_StopEvent, PlusEvent, MinusEvent, MuteEvent, InfoEvent},
	//FW_UPGRADE = 0
	{ },
	//BT = 19	//copy from FLDER_ACTIVE, SlideshowLimageɵe|áAҥHȮ
#ifdef BLUETOOTH_MOD
	{BT_UpEvent, BT_DownEvent, BT_LeftEvent, BT_RightEvent, BT_NextEvent, BT_PrevEvent, BT_PlayPauseEvent, BT_EnterEvent, /*SlideShowEvent,*/ DetectEvent/*, SetupEvent, BT_RepeatEvent, CalEvent*/, BT_EscEvent, BT_PrevDvcEvent, BT_NextDvcEvent, BT_ScanDvcEvent, BT_TxEvent, BT_StopEvent, PlusEvent, MinusEvent, MuteEvent, InfoEvent},
#endif
	//FLDR_FI = 3
	{FLDR_FI_EscEvent, FLDR_FI_SwitchResolutionEvent, InfoEvent},
	//FLDR_FV = 5
	{FLDR_FV_EscEvent, PlusEvent, MinusEvent, MuteEvent, InfoEvent,FLDR_FV_ZoomEvent},

#ifdef NET_MOD
	//NET_DS
	{Net_DS_UpEvent, Net_DS_DownEvent, Net_DS_LeftEvent, Net_DS_RightEvent, Net_DS_EnterEvent, Net_DS_EscEvent, DetectEvent, SetupEvent},
//rywu20080516++
#ifdef SUPPORT_RSS
	//RSS = 8
	{RSS_EscEvent, InfoEvent, RSS_UpEvent, RSS_DownEvent, RSS_LeftEvent, RSS_RightEvent, RSS_EnterEvent, RSS_SlideShow},
#endif
//rywu20080516--
#ifdef IP_CAM_MOD
	//IPCAM = 6
	{IP_CAM_UpEvent, IP_CAM_DownEvent, IP_CAM_EscEvent, IP_CAM_EnterEvent, IP_CAM_RepeatEvent, IP_CAM_RotateEvent},
#endif

///080504
#ifdef WEB_APP_MOD
	//WEB_APP
	{WebApp_EscEvent, WebApp_EnterEvent, WebApp_UpEvent, WebApp_DownEvent, WebApp_LeftEvent, WebApp_RightEvent, WebApp_PrevEvent, WebApp_NextEvent, WebApp_PlayPauseEvent, WebApp_StopEvent, SetupEvent, MuteEvent, PlusEvent, MinusEvent},
#endif
///

#endif
#ifdef HD_AUTOCP_MOD
	{HDAutoCP_LeftEvent, HDAutoCP_RightEvent, HDAutoCP_EnterEvent, HDAutoCP_EscEvent, InfoEvent},
#endif
	{},
};
#endif
