#ifndef _MACHINE_DISPLAY_HEADER_
#define _MACHINE_DISPLAY_HEADER_
//------------------------------------------------------------------------------------------------
#include "skydemo.h"
//------------------------------------------------------------------------------------------------
#ifdef NET_MOD
Uint8 GetLocalIP(char *ipaddr_buff);
Uint8 GetSharedDir(char *shdir_buff);
#endif
#ifdef USE_DESC_TV
	extern char dCropAfterScaling[LEN_L], panAfterScaling[LEN_L];
	extern int WidthOfScrBorder, HeightOfScrBorder, isLowPassMode;
#endif
void DSDisplay();
void MTDisplay();
void SetupL1Display();
void SetupL2Display();
void SetupL3Display();
void ImgDisplay();
void FImgDisplay();
void AudDisplay();
void VidDisplay();
void FVidDisplay();
void DecodeSSIMG();
void DecodeSSAUD();
void SSDisplay();
void USB2PConnDisplay();
void NoStorageDisplay();
void ConfirmDisplay();
void CalDisplay();
void FldrDisplay();
///070629 Firmware Upgrade
void FWUpgradeDisplay();
///
#ifdef BLUETOOTH_MOD
void BTDisplay();
#endif
void FldrFIDisplay();
void FldrFVDisplay();
#ifdef NET_MOD
///080321
void NetDSDisplay();

//rywu20080516++
#ifdef SUPPORT_RSS
void RSSDisplay();
#endif
void rss_thumbnail_image_update(char *file_name, unsigned char update_icon_index, unsigned char is_focus);
void rss_full_image_update(char *file_name);
//rywu20080516--

#endif
#ifdef HD_AUTOCP_MOD
void HDAutoCPDisplay();
#endif
#ifdef IP_CAM_MOD
void IPCamDisplay();
#endif
#if defined(GUI_STYLE_COMTEK)
void ProgDownloadDisplay();
#endif
void MachineDisplay();
//------------------------------------------------------------------------------------------------
#endif
