#ifndef _MONITOR_MISC_HEADER_
#define _MONITOR_MISC_HEADER_
//------------------------------------------------------------------------------------------------
#include "drawutil.h"
//------------------------------------------------------------------------------------------------
void RefreshCalDisplay(Sint8 mns);
void RefreshAudioPlayingTime();
void RefreshVideoPlayingTime();
Uint8 CheckIfOnPwrSavMode();
void BL_PGU_SignalHandler(int sig);
void MonitorPwrSavAlarm();
void MonitorCalTime();
void MonitorCalAlarm();
void MonitorAutoPwrOff();
void MonitorAudioTime();
void MonitorVideoTime();
#ifdef BLUETOOTH_MOD
void MonitorBTAction();
void MonitorScanningOPushDvcs();
#endif
#ifdef TV_SWITCH_MOD
Uint8 MonitorTVSwitch();
void SWTVSwitch();
#endif
#ifdef NET_MOD
void RSSReaderSignalHandler(int sig);

//rywu20080516++
#ifdef SUPPORT_RSS
int MonitorExtraInfo(EXTRA_CONTROL_ID extra_control);//rywu20080709 change to int
#endif
//rywu20080516--

void MonitorNetConfig();
#endif
#ifdef HD_AUTOCP_MOD
void MonitorHDCopyStatus();
#endif
#if defined(GUI_STYLE_COMTEK)
void RefreshProgDownDisplay(int filenum, char *file, Sint8 CurPercent);
#endif
//------------------------------------------------------------------------------------------------
extern volatile sig_atomic_t isBacklightPGUTurnedOn;
extern Uint8 prev_active_index;
extern int tv_switch_fd;
#endif
