#include "events.h"
#include "machinedisplay.h"
#include <sys/statfs.h>
#include <sys/mount.h>

Uint8 SelectedBrightContrast = Brightness;
Sint8 SelectedCalTime = dd;
Uint8 SelectedAlarmTime = min;
Sint8 SelectedAutoPwrOnOffTime = OnMin;
struct tm currTime;
#ifdef NET_MOD
extern Uint8 isGWSet;		//0: none; bit_1(1): got mac; bit_2(2): wired; bit_3(4):wireless;
#endif
extern char *MNT_FLASH_ARGV[];
//------------------------------------------------------------------------------------------------
/*
Sint16 ReadFromRTC(Uint8 time)
{
	int fd;
	struct rtc_time rtc_tm;
	Sint16 year;
	Sint8 month, day, hour, minute, second;

	if((fd = open("/dev/rtc", O_RDWR)) == -1)
	{
		perror("/dev/rtc");
		DMSG("Open RTC Fail!");
	}
	else if(ioctl(fd, RTC_RD_TIME, &rtc_tm) == -1)
	{
		perror("ioctl");
		DMSG("IOCTL RTC_RD_TIME Fail!");
		close(fd); return ERRORCODE_DEVICE;
		//exit(1);
	}
	year = rtc_tm.tm_year;
	month = rtc_tm.tm_mon;
	day = rtc_tm.tm_mday;
	hour = rtc_tm.tm_hour;
	minute = rtc_tm.tm_min;
	second = rtc_tm.tm_sec;
	close(fd);
	switch(time)
	{
		case dd:
			return day;
		case mm:
			return month;
		case yyyy:
			return year;
		case sec:
			return second;
		case min:
			return minute;
		case hr:
			return hour;
	}
}
*/
//------------------------------------------------------------------------------------------------
/*
void Write2RTC(Uint8 time)
{
	int fd;
	struct rtc_time rtc_tm;
	Sint16 year;
	Sint8 month, day, week, hour, minute, second;

	if((fd = open("/dev/rtc", O_RDWR)) == -1)
	{
		perror("/dev/rtc");
		DMSG("Open RTC Fail!");
		return;
		//exit(1);
	}
	if(ioctl(fd, RTC_RD_TIME, &rtc_tm) == -1)
	{
		perror("ioctl");
		DMSG("IOCTL RTC_RD_TIME Fail!");
		return;
		//exit(1);
	}
	year = rtc_tm.tm_year;
	month = rtc_tm.tm_mon;
	day = rtc_tm.tm_mday;
	week = rtc_tm.tm_wday;
	hour = rtc_tm.tm_hour;
	minute = rtc_tm.tm_min;
	second = rtc_tm.tm_sec;
#if 0
	PRINTF("%d\n",year);
	PRINTF("%d\n",month);
	PRINTF("%d\n",day);
	PRINTF("%d\n",week);
	PRINTF("%d\n",hour);
	PRINTF("%d\n",minute);
	PRINTF("%d\n",second);
#endif
	switch(time)
	{
		case yyyy://Year
			rtc_tm.tm_year = setup->year;
			rtc_tm.tm_mon = month;
			rtc_tm.tm_mday = day;
			rtc_tm.tm_wday = week;
			rtc_tm.tm_hour = hour;
			rtc_tm.tm_min = minute;
			rtc_tm.tm_sec = second;
			break;
		case mm://Month
			rtc_tm.tm_year = year;
			rtc_tm.tm_mon = setup->month;
			rtc_tm.tm_mday = day;
			rtc_tm.tm_wday = week;
			rtc_tm.tm_hour = hour;
			rtc_tm.tm_min = minute;
			rtc_tm.tm_sec = second;
			break;
		case dd://Day
			rtc_tm.tm_year = year;
			rtc_tm.tm_mon = month;
			rtc_tm.tm_mday = setup->day;
			rtc_tm.tm_wday = week;
			rtc_tm.tm_hour = hour;
			rtc_tm.tm_min = minute;
			rtc_tm.tm_sec = second;
			break;
		case hr://Hour
			rtc_tm.tm_year = year;
			rtc_tm.tm_mon = month;
			rtc_tm.tm_mday = day;
			rtc_tm.tm_wday = week;
			rtc_tm.tm_hour = setup->hour;
			rtc_tm.tm_min = minute;
			rtc_tm.tm_sec = second;
			break;
		case min://Minute
			rtc_tm.tm_year = year;
			rtc_tm.tm_mon = month;
			rtc_tm.tm_mday = day;
			rtc_tm.tm_wday = week;
			rtc_tm.tm_hour = hour;
			rtc_tm.tm_min = setup->minute;
			rtc_tm.tm_sec = second;
			break;
		case sec://Second
			rtc_tm.tm_year = year;
			rtc_tm.tm_mon = month;
			rtc_tm.tm_mday = day;
			rtc_tm.tm_wday = week;
			rtc_tm.tm_hour = hour;
			rtc_tm.tm_min = minute;
			rtc_tm.tm_sec = setup->second;
			break;
	}
	if(ioctl(fd, RTC_SET_TIME, &rtc_tm) == -1)
	{
		perror("ioctl");
		DMSG("IOCTL RTC_RD_TIME Fail!");
		//exit(1);
	}
	close(fd);
}
*/
//------------------------------------------------------------------------------------------------
void GetTime(struct tm *tm)//get time from system not rtc
{
	time_t t;
	time(&t);

	memcpy(tm, localtime(&t), sizeof(struct tm));
	//PRINTF("%d/%d/%d %02d:%02d:%02d\n\n", tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday, tm->tm_hour, tm->tm_min, tm->tm_sec);
}
//------------------------------------------------------------------------------------------------
void SetTime(Sint16 year, Sint8 month, Sint8 day, Sint8 hour, Sint8 minute, Sint8 second)
{
	int fd;
	struct rtc_time rtc_tm;

	if((fd = open("/dev/rtc", O_RDWR)) == -1)
	{
		perror("Open RTC Fail!");
		DMSG("Open RTC Fail!");
		return;
		//exit(1);
	}

	rtc_tm.tm_year = year;
	rtc_tm.tm_mon = month;
	rtc_tm.tm_mday = day;
	//rtc_tm.tm_wday = week;
	rtc_tm.tm_hour = hour;
	rtc_tm.tm_min = minute;
	rtc_tm.tm_sec = second;

	if(ioctl(fd, RTC_SET_TIME, &rtc_tm) == -1)
	{
		perror("IOCTL RTC_RD_TIME Fail!");
		DMSG("IOCTL RTC_RD_TIME Fail!");
		//exit(1);
	}
	close(fd);
}
//------------------------------------------------------------------------------------------------
void SaveAutoPwrSetupToRTC()
{
	int fd;
//	struct rtc_time sRtcTime;//Off
	struct rtc_wkalrm sRtcWkalrm;//On

	if((fd = open("/dev/rtc", O_RDWR)) == -1)
	{
		perror("/dev/rtc");
		return;
		//exit(1);
	}

	if(setup->autopwr_setup_idx == SETUP_OFF)
		ioctl(fd, RTC_AIE_OFF, NULL);//disable
	if(setup->autopwr_setup_idx == SETUP_ON)
	{
//		memset(&sRtcTime, 0x00, sizeof(sRtcTime));
		memset(&sRtcWkalrm, 0x00, sizeof(sRtcWkalrm));

//		//write off
//		sRtcTime.tm_hour = setup->autopwr_off_hour;
//		sRtcTime.tm_min = setup->autopwr_off_minute;
//		ioctl(fd, RTC_ALM_SET, &sRtcTime);
		//write on
		sRtcWkalrm.time.tm_hour = setup->autopwr_on_hour;
		sRtcWkalrm.time.tm_min = setup->autopwr_on_minute;
		ioctl(fd, RTC_WKALM_SET, &sRtcWkalrm);

		ioctl(fd, RTC_AIE_ON, NULL);//enable
	}

	close(fd);
}
//------------------------------------------------------------------------------------------------
/**
  * return nand flash free block size, the unit is byte
  */
long long GetFlashFreeSize()
{
	struct statfs disk_statfs;
	long long size = 0L;

	if(dev_mnted_enbled_flags.flash)
	{
		statfs(FLASH_PATH, &disk_statfs);
		size = (long long)disk_statfs.f_bavail * disk_statfs.f_bsize;
	}

	return size;
}
//------------------------------------------------------------------------------------------------
///071203
long GetPathFreeSize(char* PATH)
{
	struct statfs disk_statfs;
	long size = 0L;

	if (statfs(PATH, &disk_statfs) == 0)
    {
        size = disk_statfs.f_bavail;
    }

	///071212
	if (disk_statfs.f_bsize > 1024)
	{
		do
		{
			size <<= 1;
		}
		while ((disk_statfs.f_bsize>>=1) > 1024);
	}
	else if (disk_statfs.f_bsize < 1024)
	{
		do
		{
			size >>= 1;
		}
		while ((disk_statfs.f_bsize<<=1) < 1024);
	}
	///

	return size;
}
///
//------------------------------------------------------------------------------------------------
void CopyDefaultUserSetupFile()
{
	pid_t pid;
	int stat;

	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork failure!");
			DMSG("Fork to Reset Setup Fail!");
			break;
			//exit(1);
		case 0:
			//child process
			execl("/bin/cp", "cp", "-f", USER_SETUP_DEFAULT_FILE_NAME, USER_SETUP_REAL_FILE_NAME, NULL);
			_EXIT;
		default:
			//parent process
			waitpid(pid, &stat, 0);
			break;
	}
}
//------------------------------------------------------------------------------------------------
/**
 * Reset user setup config to default system setup value by copying User.setup to Replace previous file
 */
void Reset()
{
	CopyDefaultUserSetupFile();
	LoadUserSetup();//load to Default Setting for the following SaveUserSetup()
/*
	setup->lang_idx = 0;
	setup->pwrsav_idx = 0;
	setup->sys_alpha = 4;
	setup->sys_alpha = 4;
	setup->homepage_idx = 0;
	setup->brightness_idx = 2;
	setup->contrast_idx = 2;

	setup->ss_rpt_idx = 0;
	setup->ss_interval_idx = 0;
	setup->ss_effect_idx = 0;

	setup->aud_rpt_idx = 0;
	setup->vid_rpt_idx = 0;

	setup->cal_alpha = 4;
	setup->alarm_setup_idx = 0;
	setup->alarm_hour = 0;
	setup->alarm_minute = 0;

	volume = 3;
*/
	setup->cpy_idx = 0;
	setup->del_idx = 0;
	setup->reset_idx = 0;
	setup->flsh_fmt_idx = 0;
	isUserConfirmed = FALSE;
}
//------------------------------------------------------------------------------------------------
/**
 * it will just format customer partition on nand flash
 */
int formatFlash()
{
	pid_t pid;
	int stat, ret;
	const char *specialfile = MNT_FLASH_ARGV[0];
	const char *dir = MNT_FLASH_ARGV[1];
	const char *filesystemtype = MNT_FLASH_ARGV[2];
	Uint32 rwflag = MS_NOATIME | MS_NODIRATIME;
	const void *data = NULL;

	//umount to format
	ret = umount(FLASH_PATH);
	if(ret != 0)
		DMSG("UNMOUNTING flash FAILED!\n");
	//else
	//	DMSG("UNMOUNTING flash SUCCESSFULLY!\n");

	//format flash
	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork failure!");
			DMSG("Fork to format flash fail!");
			return;
			//_EXIT;
		case 0:
			//child process
			execl("/sky/mkdosfs", "mkdosfs", "/dev/sknandb", NULL);//TODO - hard code the mounted flash path first!!!
			_EXIT;
		default:
			//parent process
			waitpid(pid, &stat, 0);
			//PRINTF("format flash finished!!!\n");
			break;
	}

	//remount the flash
	ret = mount(specialfile, dir, filesystemtype, rwflag, data);
	if(ret == 0)
		DMSG("MOUNTING flash FAILED!\n");
	//else
	//	DMSG("MOUNTING flash SUCCESSFULLY!\n");

	return ret;
}
//------------------------------------------------------------------------------------------------
///071204
int isWriteProtected(const char *DeviceName)
{
	Uint32 isWriteProtected = FALSE;
    FILE* fpInfo = NULL;
    char buf[LEN_XL] = {0};
    char *fnInfo = buf;

    if (strcmp(DeviceName, DEVICE_SDMMC_NAME) == 0)
        strcpy(fnInfo, "/proc/bus/sdmmc_card_proc/sdmmc_card_info");
    else if (strcmp(DeviceName, DEVICE_CF_NAME) == 0)
        strcpy(fnInfo, "/proc/bus/cf_card_proc/cf_card_info");
    else if (strcmp(DeviceName, DEVICE_xD_NAME) == 0)
        strcpy(fnInfo, "/proc/bus/xdsm_card_proc/xdsm_card_info");
    else if (strcmp(DeviceName, DEVICE_MS_NAME) == 0)
        strcpy(fnInfo, "/proc/bus/msx_card_proc/msx_card_info");

    if (*fnInfo != '\0' && (fpInfo = fopen(fnInfo, "r")) != NULL)
    {
        while (fgets(buf, LEN_XL, fpInfo))
        {
            if (strncmp(buf, "WP:", 3) == 0)
            {
                int temp = 0;
                sscanf(buf+3, "%d", &temp);   //ŪѵFALSE
                isWriteProtected = (temp==0 ? FALSE : TRUE);
                break;
            }
        }
        fclose(fpInfo);
    }

    return isWriteProtected;
}
///
//------------------------------------------------------------------------------------------------
int isCopyAllowed()
{
	Uint32 isCopyAllowed = FALSE;
	//check if allowing copy
    ///071204
    if (  prev_active_index == I_ACTIVE
       ||
        prev_active_index == FI_ACTIVE
       ||
        prev_active_index == A_ACTIVE
       ||
        prev_active_index == V_ACTIVE
       ||
        prev_active_index == FLDR_ACTIVE
       )
    {
        if (  (dev_mnted_enbled_flags.sdmmc
               && 0 != strcmp(SelectedDev, DEVICE_SDMMC_NAME))
            ||
              (dev_mnted_enbled_flags.cf
               && 0 != strcmp(SelectedDev, DEVICE_CF_NAME))
            ||
              (dev_mnted_enbled_flags.usb
               && 0 != strcmp(SelectedDev, DEVICE_USB_NAME))
            ||
              (dev_mnted_enbled_flags.xdsm
               && 0 != strcmp(SelectedDev, DEVICE_xD_NAME))
            ||
              (dev_mnted_enbled_flags.msx
               && 0 != strcmp(SelectedDev, DEVICE_MS_NAME))
            ||
              (dev_mnted_enbled_flags.hd
               && 0 != strcmp(SelectedDev, DEVICE_HD_NAME))
            ||
              (dev_mnted_enbled_flags.flash
               && 0 != strcmp(SelectedDev, DEVICE_FLASH_NAME))
           )
        {
            isCopyAllowed = TRUE;
        }
    }
    /*
    if((!dev_mnted_enbled_flags.hd && !dev_mnted_enbled_flags.flash) || !strcmp(SelectedDev, DEVICE_HD_NAME) || !strcmp(SelectedDev, DEVICE_FLASH_NAME))
            isCopyAllowed = FALSE;
    else
    {
        isCopyAllowed = FALSE;
        if (  prev_active_index == I_ACTIVE
           ||
            prev_active_index == FI_ACTIVE
           ||
            prev_active_index == A_ACTIVE
           ||
            prev_active_index == V_ACTIVE
           ||
            prev_active_index == FLDR_ACTIVE
           )
        {
            isCopyAllowed = TRUE;
        }
    }
    */
    ///

	return isCopyAllowed;
}
//------------------------------------------------------------------------------------------------
int isDelAllowed()
{
	Uint32 isDelAllowed = FALSE;

	//check if allowing del
    ///071204
    if (  prev_active_index == I_ACTIVE
       ||
        prev_active_index == FI_ACTIVE
       ||
        prev_active_index == A_ACTIVE
       ||
        prev_active_index == V_ACTIVE
       ||
        prev_active_index == FLDR_ACTIVE
       )
    {
        if (!isWriteProtected(SelectedDev))
        {
            isDelAllowed = TRUE;
        }
    }
    /*
    if(strcmp(SelectedDev, DEVICE_HD_NAME) && strcmp(SelectedDev, DEVICE_FLASH_NAME))
        isDelAllowed = FALSE;
    else
    {
        isDelAllowed = FALSE;
        if (  prev_active_index == I_ACTIVE
           ||
            prev_active_index == FI_ACTIVE
           ||
            prev_active_index == A_ACTIVE
           ||
            prev_active_index == V_ACTIVE
           ||
            prev_active_index == FLDR_ACTIVE
           )
        {
            isDelAllowed = TRUE;
        }
    }
    */
    ///

	return isDelAllowed;
}
#ifdef NET_MOD
//------------------------------------------------------------------------------------------------
void Reload_Net()
{
	int nDevice = 0, nFile = 6;
	char DevicePath[8][LEN_L] = {0};
	char SrcFileName[8][LEN_L] =
			{
				"rt73sta.dat",
				"NAS.REC",
				"rss.xml",
				"fc_channels.xml",
				"flickr_channels.xml",
				"picasa_channels.xml",
				""
			};
	char DstFileName[8][LEN_L] =
			{
				"/tmp/conf/rt73sta.dat",
				"/tmp/conf/mountNet",
				"/tmp/conf/channels.xml",
				"/tmp/conf/fc_channels.xml",
				"/tmp/conf/flickr_channels.xml",
				"/tmp/conf/picasa_channels.xml",
				""
			};
	char tempSrcFileName[LEN_XL] = {0};
	char command[LEN_XL] = {0};

	if (dev_mnted_enbled_flags.sdmmc)
		strcpy(DevicePath[nDevice++], SDMMC_PATH);
	if (dev_mnted_enbled_flags.cf)
		strcpy(DevicePath[nDevice++], CF_PATH);
	if (dev_mnted_enbled_flags.flash)
		strcpy(DevicePath[nDevice++], FLASH_PATH);

	int i, j;
	for (i=0; i<nFile; i++)
	{
		for (j=0; j<nDevice; j++)
		{
			sprintf(tempSrcFileName, "%s%s", DevicePath[j], SrcFileName[i]);
			if (access(tempSrcFileName, R_OK) == 0)
			{
				sprintf(command, "/bin/cp -f %s %s", tempSrcFileName, DstFileName[i]);
				system(command);
				break;
			}
		}
	}
	system("sync");

}
#endif
//------------------------------------------------------------------------------------------------
///080325 knD(L/R)
void SetAudioChannel(Sint8 channel)
{
	pid_t pid;
	int status;

	pid = fork();
	switch(pid)
	{
		case -1:
			perror("fork failure!");
			DMSG("Fork to Set Audio Channel Fail!");
			break;
			//_EXIT;
		case 0:
			//child process
			switch (channel)
			{
			case Aud_Chnl_LR:
				execl("/sbin/sysctl", "sysctl", "-w", "ski2s.ch=3", NULL);
				break;
			case Aud_Chnl_LL:
				execl("/sbin/sysctl", "sysctl", "-w", "ski2s.ch=2", NULL);
				break;
			case Aud_Chnl_RR:
				execl("/sbin/sysctl", "sysctl", "-w", "ski2s.ch=1", NULL);
				break;
			default:
				break;
			}
			_EXIT;
		default:
			//parent process
			waitpid(pid, &status, 0);
			break;
	}
}
///
//------------------------------------------------------------------------------------------------
// Setup L1 Callbacks
//------------------------------------------------------------------------------------------------
void SETUP_L1_UpEvent()
{
	DrawL1Menu(-1);

	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
	pItem->curr_item--;
	if (pItem->curr_item < 0)
		pItem->curr_item += pItem->total_item;
	*((Sint8*)pItem->pvalue) = (Sint8)pItem->index[pItem->curr_item];

	DrawL1Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L1_DownEvent()
{
	DrawL1Menu(-1);

	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
	pItem->curr_item++;
	pItem->curr_item %= pItem->total_item;
	*((Sint8*)pItem->pvalue) = (Sint8)pItem->index[pItem->curr_item];

	DrawL1Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L1_RightEvent()//can be taken out because it's not a little bit reasonable!!!
{
	SETUP_L1_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void SETUP_L1_PlayPauseEvent()
{
	SETUP_L1_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void SETUP_L1_EnterEvent()
{
#ifdef NET_MOD
	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
	switch (*((Sint8*)pItem->pvalue))
	{
	case L1_Reload_Net:
		if(prev_active_index!=DS_ACTIVE)
		{
			Reload_Net();
			SetupEvent();
		}
		else
		{
			Reload_Net();
			SetupEvent();
			if( (isGWSet & 2)!=0 )
				system("ifconfig eth0 down");
			if( (isGWSet & 4)!=0 )
				system("ifconfig rausb0 down");
			sleep(5);
			CloseSystem();
			InitSystem(INITSYS_CALL_BY_NORMAL);
		}
		break;
	default:
		ELMachines[active_index].Shutdown(0);
		active_index = SETUP_L2_ACTIVE;
		ELMachines[active_index].Init();
		ELMachines[active_index].Display();
		break;
	}
#else
	ELMachines[active_index].Shutdown(0);
	active_index = SETUP_L2_ACTIVE;
	ELMachines[active_index].Init();
	ELMachines[active_index].Display();
#endif
}
//------------------------------------------------------------------------------------------------
// Setup L2 Callbacks
//------------------------------------------------------------------------------------------------
void SETUP_L2_UpEvent()
{
	DrawL2Menu(-1);

	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
	pItem->curr_item--;
	if (pItem->curr_item < 0)
		pItem->curr_item += pItem->total_item;
	*((Sint8*)pItem->pvalue) = (Sint8)pItem->index[pItem->curr_item];

	DrawL2Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L2_DownEvent()
{
	DrawL2Menu(-1);

	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
	pItem->curr_item++;
	pItem->curr_item %= pItem->total_item;
	*((Sint8*)pItem->pvalue) = (Sint8)pItem->index[pItem->curr_item];

	DrawL2Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L2_LeftEvent()//can be taken out because it's not a little bit reasonable!!!
{
	SetupEscEvent();
}
//------------------------------------------------------------------------------------------------
void SETUP_L2_PlayPauseEvent()
{
	SETUP_L2_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void SETUP_L2_EnterEvent()
{
    ///071205
	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
    if (pItem->status[pItem->curr_item] == 0)
    ///
    {
        ELMachines[active_index].Shutdown(0);
        active_index = SETUP_L3_ACTIVE;
        ELMachines[active_index].Init();
        ELMachines[active_index].Display();
    }
}
//------------------------------------------------------------------------------------------------
// Setup L3 Callbacks
//------------------------------------------------------------------------------------------------
void SETUP_L3_UpEvent()
{
    ///071130
	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);

//@
    if (pItem->total_item > 0)
    {
        pItem->curr_item--;
        if (pItem->curr_item < 0)
            pItem->curr_item += pItem->total_item;
        *((Sint8*)pItem->pvalue) = (Sint8)pItem->index[pItem->curr_item];

        if (pItem->curr_item < pItem->head_item)
        {
            //VW
            pItem->head_item--;
        }
        else if (pItem->curr_item >= pItem->head_item + pItem->items_per_page)
        {
            //^̤U
            pItem->head_item = pItem->curr_item - pItem->items_per_page + 1;
            if (pItem->head_item < 0) pItem->head_item = 0;
        }
    }
//S]w(ex.ɶ]w)
    else
    {
        //System Alpha
        if (pItem->pvalue == &setup->sys_alpha)
        {
            // xenia
            setup->sys_alpha++;
            setup->sys_alpha %= ALPHA_VALUE_ITEM_NUM;
            pgu_set_alpha(setup->sys_alpha);
        }
        //Brightness/Contrast
        else if (pItem->pvalue == &SelectedBrightContrast)
        {
            // xenia
            if(SelectedBrightContrast == Brightness)
            {
                setup->brightness_idx++;
                setup->brightness_idx %= BRTNSS_ITEM_NUM;
                pgu_set_backlight(SETUP_BRIGHTNESS[setup->brightness_idx]);
            }
            else if(SelectedBrightContrast == Contrast)
            {
                setup->contrast_idx++;
                setup->contrast_idx %= CNTRST_ITEM_NUM;
                pgu_set_contrast(SETUP_CONTRAST[setup->contrast_idx]);
            }
        }
        //Calendar Time
        else if (pItem->pvalue == &SelectedCalTime)
        {
            // xenia
            if(SelectedCalTime == dd)
            {
                setup->day++;
                if(setup->day == 32)
                    setup->day = 1;
            }
            else if(SelectedCalTime == mm)
            {
                setup->month++;
                if(setup->month == 13)
                    setup->month = 1;
            }
            else if(SelectedCalTime == yyyy)
            {
                setup->year++;
                ///071101 ɶu2038/1/19He
                if(setup->year > 2037)
                //if(setup->year == 2100)
                ///
                    setup->year = 2000;
            }
            else if(SelectedCalTime == sec)
            {
                setup->second++;
                if(setup->second == 60)
                    setup->second = 0;
            }
            else if(SelectedCalTime == min)
            {
                setup->minute++;
                if(setup->minute == 60)
                    setup->minute = 0;
            }
            else if(SelectedCalTime == hr)
            {
                setup->hour++;
                if(setup->hour == 24)
                    setup->hour = 0;
            }
        }
        else if (pItem->pvalue == &setup->cal_alpha)
        {
            setup->cal_alpha++;
            setup->cal_alpha %= ALPHA_VALUE_ITEM_NUM;
        }
        //Alarm Time
        else if (pItem->pvalue == &SelectedAlarmTime)
        {
            if(SelectedAlarmTime == min)
            {
                setup->alarm_minute++;
                setup->alarm_minute %= 60;
            }
            else if(SelectedAlarmTime == hr)
            {
                setup->alarm_hour++;
                setup->alarm_hour %= 24;
            }
        }
        //Auto Power Off Time
        else if (pItem->pvalue == &SelectedAutoPwrOnOffTime)
        {
            if(SelectedAutoPwrOnOffTime == OnMin)
            {
                setup->autopwr_on_minute++;
                setup->autopwr_on_minute %= 60;
            }
            else if(SelectedAutoPwrOnOffTime == OnHr)
            {
                setup->autopwr_on_hour++;
                setup->autopwr_on_hour %= 24;
            }
            else if(SelectedAutoPwrOnOffTime == OffMin)
            {
                setup->autopwr_off_minute++;
                setup->autopwr_off_minute %= 60;
            }
            else if(SelectedAutoPwrOnOffTime == OffHr)
            {
                setup->autopwr_off_hour++;
                setup->autopwr_off_hour %= 24;
            }
        }
    }
    ///

	DrawL3Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L3_DownEvent()
{

    ///071130
	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);

//@
    if (pItem->total_item > 0)
    {
    	pItem->curr_item++;
    	pItem->curr_item %= pItem->total_item;
        *((Sint8*)pItem->pvalue) = (Sint8)pItem->index[pItem->curr_item];

        if (pItem->curr_item < pItem->head_item)
        {
            //^̤W
            pItem->head_item = 0;
        }
        else if (pItem->curr_item >= pItem->head_item + pItem->items_per_page)
        {
            //VU
            pItem->head_item++;
        }
    }
//S]w(ex.ɶ]w)
    else
    {
        //System Alpha
        if (pItem->pvalue == &setup->sys_alpha)
        {
            // xenia
            setup->sys_alpha--;
            if(setup->sys_alpha < 0)
                setup->sys_alpha += ALPHA_VALUE_ITEM_NUM;
            pgu_set_alpha(setup->sys_alpha);
        }
        //Brightness/Contrast
        else if (pItem->pvalue == &SelectedBrightContrast)
        {
            // xenia
            if(SelectedBrightContrast == Brightness)
            {
                setup->brightness_idx--;
                if(setup->brightness_idx < 0)
                    setup->brightness_idx += BRTNSS_ITEM_NUM;
                pgu_set_backlight(SETUP_BRIGHTNESS[setup->brightness_idx]);
            }
            else if(SelectedBrightContrast == Contrast)
            {
                setup->contrast_idx--;
                if(setup->contrast_idx < 0)
                    setup->contrast_idx += CNTRST_ITEM_NUM;
                pgu_set_contrast(SETUP_CONTRAST[setup->contrast_idx]);
            }
        }
        //Calendar Time
        else if (pItem->pvalue == &SelectedCalTime)
        {
            // xenia
            if(SelectedCalTime == dd)
            {
                setup->day--;
                if(setup->day == 0)
                    setup->day = 31;
            }
            else if(SelectedCalTime == mm)
            {
                setup->month--;
                if(setup->month == 0)
                    setup->month = 12;
            }
            else if(SelectedCalTime == yyyy)
            {
                setup->year--;
                if(setup->year == 1999)
                    setup->year = 2000;
            }
            else if(SelectedCalTime == sec)
            {
                setup->second--;
                if(setup->second == -1)
                    setup->second = 59;
            }
            else if(SelectedCalTime == min)
            {
                setup->minute--;
                if(setup->minute == -1)
                    setup->minute = 59;
            }
            else if(SelectedCalTime == hr)
            {
                setup->hour--;
                if(setup->hour == -1)
                    setup->hour = 23;
            }
        }
        else if (pItem->pvalue == &setup->cal_alpha)
        {
            setup->cal_alpha--;
            if(setup->cal_alpha < 0)
                setup->cal_alpha += ALPHA_VALUE_ITEM_NUM;
        }
        //Alarm Time
        else if (pItem->pvalue == &SelectedAlarmTime)
        {
            if(SelectedAlarmTime == min)
            {
                setup->alarm_minute--;
                if(setup->alarm_minute == -1)
                    setup->alarm_minute = 59;
            }
            else if(SelectedAlarmTime == hr)
            {
                setup->alarm_hour--;
                if(setup->alarm_hour == -1)
                    setup->alarm_hour = 23;
            }
        }
        //Auto Power Off Time
        else if (pItem->pvalue == &SelectedAutoPwrOnOffTime)
        {
            if(SelectedAutoPwrOnOffTime == OnMin)
            {
                setup->autopwr_on_minute--;
                if(setup->autopwr_on_minute == -1)
                    setup->autopwr_on_minute = 59;
            }
            else if(SelectedAutoPwrOnOffTime == OnHr)
            {
                setup->autopwr_on_hour--;
                if(setup->autopwr_on_hour == -1)
                    setup->autopwr_on_hour = 23;
            }
            else if(SelectedAutoPwrOnOffTime == OffMin)
            {
                setup->autopwr_off_minute--;
                if(setup->autopwr_off_minute == -1)
                    setup->autopwr_off_minute = 59;
            }
            else if(SelectedAutoPwrOnOffTime == OffHr)
            {
                setup->autopwr_off_hour--;
                if(setup->autopwr_off_hour == -1)
                    setup->autopwr_off_hour = 23;
            }
        }
    }
    ///

	DrawL3Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L3_LeftEvent()
{
    ///071130
    ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);

    //Brightness/Contrast
    if (pItem->pvalue == &SelectedBrightContrast)
    {
        if(SelectedBrightContrast == Brightness)
        {
            SelectedBrightContrast = Contrast;
        }
        else if(SelectedBrightContrast == Contrast)
        {
            SelectedBrightContrast = Brightness;
        }
    }
    //Calendar Time
    else if (pItem->pvalue == &SelectedCalTime)
    {
        SelectedCalTime--;
        if(SelectedCalTime < dd)
            SelectedCalTime = hr;
    }
    //Alarm Time
    else if (pItem->pvalue == &SelectedAlarmTime)
    {
        if(SelectedAlarmTime == min)
        {
            SelectedAlarmTime = hr;
        }
        else if(SelectedAlarmTime == hr)
        {
            SelectedAlarmTime = min;
        }
    }
    //Auto Powwr OnOff Time
    else if (pItem->pvalue == &SelectedAutoPwrOnOffTime)
    {
        SelectedAutoPwrOnOffTime--;
        if(SelectedAutoPwrOnOffTime < OnMin)
            SelectedAutoPwrOnOffTime = OffHr;
    }

	DrawL3Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L3_RightEvent()
{
    ///071130
	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);

    //Brightness/Contrast
    if (pItem->pvalue == &SelectedBrightContrast)
    {
        if(SelectedBrightContrast == Brightness)
        {
            SelectedBrightContrast = Contrast;
        }
        else if(SelectedBrightContrast == Contrast)
        {
            SelectedBrightContrast = Brightness;
        }
    }
    //Calendar Time
    else if (pItem->pvalue == &SelectedCalTime)
    {
        SelectedCalTime++;
        if(SelectedCalTime > hr)
            SelectedCalTime = dd;
    }
    //Alarm Time
    else if (pItem->pvalue == &SelectedAlarmTime)
    {
        if(SelectedAlarmTime == min)
        {
            SelectedAlarmTime = hr;
        }
        else if(SelectedAlarmTime == hr)
        {
            SelectedAlarmTime = min;
        }
    }
    //Auto Powwr OnOff Time
    else if (pItem->pvalue == &SelectedAutoPwrOnOffTime)
    {
        SelectedAutoPwrOnOffTime++;
        if(SelectedAutoPwrOnOffTime > OffHr)
            SelectedAutoPwrOnOffTime = OnMin;
    }

	DrawL3Menu(1);
}
//------------------------------------------------------------------------------------------------
void SETUP_L3_PlayPauseEvent()
{
	SETUP_L2_EnterEvent();
}
//------------------------------------------------------------------------------------------------
void SETUP_L3_EnterEvent()
{
	///070608 rX
	Uint8 bChangeLanguage = 0;
	///
    ///071205
	ITEM_DATA *pItem = &(ELMachines[active_index].frame.item_data);
    Uint32 bReturn = TRUE;
    ///

	//save setting values and go back to L2 menu!!!
	switch(setup->main_menu_idx)
	{
		case L1_System_Setup:
			switch(setup->sys_idx)
			{
				case L2_System_Language:
					///070608 r
					if (setup->Language != SETUP_LANG[setup->lang_idx])
					{
						isLanguageChanged = TRUE;
						setup->Language = SETUP_LANG[setup->lang_idx];
						CloseFont();
						InitFont();
					}
					break;
				case L2_System_PowerSavingMode:
					setup->PowerSavingMode = SETUP_PWRSAV[setup->pwrsav_idx];
					break;
				case L2_System_DefaultSetting:
					switch(setup->reset_idx)
					{
						case SETUP_NO:
							break;
						case SETUP_YES:
							Reset();
							///070714 w]Ȯɳ]r
							isLanguageChanged = TRUE;
							CloseFont();
							InitFont();
							///
							///071019 sƦCɮ
							isSortingMethodChanged = TRUE;
							///
							break;
					}
					break;
				case L2_System_Status:
					break;
				case L2_System_AlphaValue:
					pgu_set_alpha(setup->sys_alpha);
					break;
				case L2_System_Homepage:
					setup->HomepageMode = SETUP_HOMEPAGE[setup->homepage_idx];
					break;
				case L2_System_BrightnessContrast:
					setup->BrightnessMode = SETUP_BRIGHTNESS[setup->brightness_idx];
					pgu_set_backlight(setup->BrightnessMode);
					setup->ContrastMode = SETUP_CONTRAST[setup->contrast_idx];
					pgu_set_contrast(setup->ContrastMode);
					break;
				case L2_System_FileSortingMehod:
					if(SavedUserSetupItem[USER_SETUP_SORTING] != setup->sorting_idx)
						isSortingMethodChanged = TRUE;
					else
						isSortingMethodChanged = FALSE;
					break;
				case L2_System_FlashFormat:
					switch(setup->flsh_fmt_idx)
					{
						//case SETUP_NO:
						//	break;
						case SETUP_YES:
							formatFlash();
							//enable isFlashFormatted to rebuild list, the flag is reset only when escape SETUP
							isFlashFormatted = TRUE;
							break;
					}
					break;
			}
			SaveUserSetupToMem();
			break;
		case L1_Slideshow_Setup:
			switch(setup->ss_idx)
			{
				case L2_Slideshow_RepeatMode:
					break;
				case L2_Slideshow_IntervalTime:
					setup->SSIntervalTime = SETUP_SS_INTERVAL_TIME[setup->ss_interval_idx];
					break;
				case L2_Slideshow_TransitionEffect:
					break;
			}
			SaveUserSetupToMem();
			break;
		case L1_AV_Setup:
			switch(setup->av_idx)
			{
				case L2_AV_AudioRepeatMode:
					///070801 Lצp󳣭ƼҦ
					isAudioRepeatModeChanged = TRUE;
					///
					break;
				case L2_AV_VideoRepeatMode:
					//Justin, please take good care of it!!!
					//setup->VideoRepeatMode = SETUP_AV_REPEAT[setup->vid_rpt_idx];
					break;
				case L2_AV_VidTimeDsplyMode:
                       #ifdef WINGUI
				case L2_Display_Full_Screen:
                       #endif
					break;
				///080325 knD(L/R)
				case L2_AV_AudioChannel:
					SetAudioChannel(setup->aud_chnl_idx);
					break;
				///
			}
			SaveUserSetupToMem();
			break;
		case L1_CalendarTimeAlarm_Setup:
			switch(setup->caltimealarm_idx)
			{
				case L2_CalTimeAlarm_CalendarTime:
					SetTime(setup->year, setup->month, setup->day, setup->hour, setup->minute, setup->second);
					isCalAlarmRinging = -1;//reset the alarm to not play when alarm interval
					break;
				case L2_CalTimeAlarm_AlphaValue:
					pgu_set_alpha(setup->cal_alpha);
					break;
				case L2_CalTimeAlarm_Alarm:
					isCalAlarmRinging = -1;
					break;
			}
			SaveUserSetupToMem();
			break;
		case L1_CopyDelete_Setup:
			switch(setup->cpydel_idx)
			{
                case L2_CopyDelete_Copy:
                    ///071205 Sg~iJ
                    if (pItem->status[pItem->curr_item] == 0)
                    ///
                    {
                        ///071203
                        ELMachines[active_index].Shutdown(0);//BK
                        active_index = CONFIRM_ACTIVE;
                        ConfirmText = FrameText[setup->Language][17];
                        ELMachines[active_index].Init();
                        ELMachines[active_index].Display();
                        /*
                        switch(setup->cpy_idx)
                        {
                            case SETUP_NO:
                                setup->cpy_idx = SETUP_NO;
                                break;
                            case SETUP_YES:
                                setup->cpy_idx = SETUP_YES;
                                ELMachines[active_index].Shutdown(0);//BK
                                active_index = CONFIRM_ACTIVE;
                                ConfirmText = FrameText[setup->Language][17];
                                ELMachines[active_index].Init();
                                ELMachines[active_index].Display();
                                break;
                        }
                        */
                        ///
                    }
                    ///071205 gFL,]^W@h
                    else
                    {
                        bReturn = FALSE;
                    }
                    ///
					break;
				case L2_CopyDelete_Delete:
					switch(setup->del_idx)
					{
						case SETUP_NO:
							setup->del_idx = SETUP_NO;
							break;
						case SETUP_YES:
							setup->del_idx = SETUP_YES;
							ELMachines[active_index].Shutdown(0);//BK
							active_index = CONFIRM_ACTIVE;
							ConfirmText = FrameText[setup->Language][18];
							ELMachines[active_index].Init();
							ELMachines[active_index].Display();
							break;
					}
					break;
			}
			break;
		case L1_AutoPower_Setup:
			isAutoPwrSttngChngd = TRUE;
			SaveUserSetupToMem();
			break;
		case L1_AutoPlay_Setup:
			SaveUserSetupToMem();
			break;
	}
	//go back to L2 menu
    ///071205
    if (bReturn)
    ///
    {
        SetupEscEvent();
    }
}
//------------------------------------------------------------------------------------------------
void SetupToMenuEvent()
{
	SetupEvent();
	DetectEvent();
}
